
{ DMIH 2001 - Drugi dan natjecanja       }
{ Srednjoskolska skupina - I. podskupina }
{ Zadatak IGRA                           }
{ Autor rjesenja Ante Djerek             }
{ Nesluzbeno rjesenje                    }

PROGRAM igra;
CONST
    maxn=100;
    maxk=100;
    nmoves=3;
    dirr:ARRAY[1..nmoves] OF integer=(1, 1 ,0);
    dirs:ARRAY[1..nmoves] OF integer=(1, 0, 1);
    no=32000;
VAR
    m, n, k:integer;
    tablica:ARRAY[1..maxn, 1..maxn] OF char;
    max:ARRAY[1..maxn, 1..maxn] OF integer;
    pocr:ARRAY[1..maxk] OF integer;
    pocs:ARRAY[1..maxk] OF integer;

FUNCTION bodova (c:char):integer;
BEGIN
    CASE c OF
        '.':bodova:=0;
        'C':bodova:=1;
        'S':bodova:=3;
        'B':bodova:=5;
    END;
END;

PROCEDURE citaj_ulaz;
VAR i, j:integer;
    fin:text;
BEGIN
    assign(fin, 'GAME.in');
    reset(fin);
    readln(fin, m, n);
    FOR i:=1 TO m DO
    BEGIN
        FOR j:=1 TO n DO
            read(fin, tablica[i, j]);
        readln(fin);
    END;
    readln(fin, k);
    FOR i:=1 TO k DO
        readln(fin, pocr[i], pocs[i]);
    close(fin);
END;

FUNCTION dobra (r, s:integer):boolean;
BEGIN
    dobra:=TRUE;
    IF (r<1) OR (r>m) THEN dobra:=FALSE;
    IF (s<1) OR (s>n) THEN dobra:=FALSE;
END;

PROCEDURE rijesi;
VAR r, s, k, rr, ss:integer;
    tmp:integer;
BEGIN
    FOR r:=m DOWNTO 1 DO
        FOR s:=n DOWNTO 1 DO
        BEGIN
            IF tablica[r, s]='#' THEN continue;
            max[r, s]:=no;
            FOR k:=1 TO nmoves DO
            BEGIN
                rr:=r+dirr[k];
                ss:=s+dirs[k];
                IF dobra(rr, ss) AND (tablica[rr, ss]<>'#') THEN
                BEGIN
                    tmp:=-max[rr, ss]+2*bodova(tablica[rr, ss]);
                    IF (max[r, s]=no) OR (tmp>max[r, s]) THEN
                        max[r, s]:=tmp;
                END;
            END;
            IF max[r, s]=no THEN max[r, s]:=-1;
        END;
END;

PROCEDURE ispisi_rjesenje;
VAR i:integer;
    fout:text;
BEGIN
    assign(fout, 'GAME.out');
    rewrite(fout);
    FOR i:=1 TO k DO
        IF max[pocr[i], pocs[i]]>0 THEN
            writeln(fout, 'HAL')
        ELSE
            writeln(fout, 'DAVE');
    close(fout);
END;

{ Glavni program }
BEGIN
    citaj_ulaz;
    rijesi;
    ispisi_rjesenje;
END.
