
{ DMIH 2001 - Prvi dan natjecanja         }
{ Srednjoskolska skupina - II. podskupina }
{ Zadatak KALK                            }
{ Autor rjesenja Ante Djerek              }
{ Nesluzbeno rjesenje                     }

{
    'on the fly' implementacija, generira rjesenje tokom parsinga

    Izvod(I) = niz naredbi tako da od stoga (B, A, ostatak) dobjem
               (B, A, I, ostatak) s tim da ostatak ostane nepromjenjen

    Izvod definiram rekurzivno po gradnji formule:
       Izvod('A') = SWAP DUP DUP ROT ROT DROP
       Izvod('B') = DUP DUP ROT ROT DROP SWAP
       Izvod('(t$s)') = Izvod(t) Izvod(s) ROT ROT DOLLAR DUP ROT ROT ROT DROP
       Izvod('(t$s)') = Izvod(t) Izvod(s) ROT ROT HASH DUP ROT ROT ROT DROP

    Rjesenje mi je Izvod(I) + ciscenje stoga
    Rjesenje(I) = Izvod(I) DROP DROP
}

const INFILE  = 'CALC.in';
      OUTFILE = 'CALC.out';
      MAXCHAR = 100;
      ROT     = 'ROT';
      SWAP    = 'SWAP';
      DUP     = 'DUP';
      DROP    = 'DROP';
      OP1     = 'HASH';
      C1      = '#';
      OP2     = 'DOLLAR';
      C2      = '$';
      VARC1   = 'A';
      VARC2   = 'B';

var input, output : text;
    ulaz : string[MAXCHAR];
    pos : integer;

procedure izvedi_A;
begin
  writeln(output, SWAP);
  writeln(output, DUP);
  writeln(output, DUP);
  writeln(output, ROT);
  writeln(output, ROT);
  writeln(output, DROP);
end;

procedure izvedi_B;
begin
  writeln(output, DUP);
  writeln(output, DUP);
  writeln(output, ROT);
  writeln(output, ROT);
  writeln(output, DROP);
  writeln(output, SWAP);
end;

procedure izvedi_op (opstring : string);
begin
  writeln(output, ROT);
  writeln(output, ROT);
  writeln(output, opstring);
  writeln(output, DUP);
  writeln(output, ROT);
  writeln(output, ROT);
  writeln(output, ROT);
  writeln(output, DROP);
end;

procedure ocisti;
begin
  writeln(output, DROP);
  writeln(output, DROP);
end;

procedure parse;
var op : char;
begin
  if (ulaz[pos]='(') then
     begin
     inc(pos);
     parse;
     op:=ulaz[pos];
     inc(pos);
     parse;
     if (op=C1) then izvedi_op(OP1);
     if (op=C2) then izvedi_op(OP2);
     inc(pos);
     exit;
     end;

  if (ulaz[pos]=VARC1) then izvedi_A;
  if (ulaz[pos]=VARC2) then izvedi_B;

  inc(pos);
end;

begin
  assign (input, INFILE); reset (input);
  assign (output, OUTFILE); rewrite (output);

  readln (input, ulaz);
  pos:=1;

  parse; ocisti;

  close(input); close(output);
end.
