
// DMIH 2001 - Prvi dan natjecanja
// Srednjoskolska skupina - II. podskupina
// Zadatak POLICE
// Autor rjesenja Milan Mesic
// Nesluzbeno rjesenje

#include <stdio.h>

#define NUTRA "SHELVES.in"
#define VAN "SHELVES.out"

#define SIRINA 3

#define MAXSTUPACA 100
int stupaca;
int maxvisina_u_stupcu[MAXSTUPACA+1];
int minukvisina;

void ucitaj(void)
{
	FILE *in;
	int i,r,n,si,vi;

	in=fopen(NUTRA,"r");
	fscanf(in,"%d%d%d",&stupaca,&r,&n);
	for (i=0;i<stupaca;i++) maxvisina_u_stupcu[i]=0;
	for (i=0;i<n;i++)
	{
		fscanf(in,"%d%d",&si,&vi);
		if (maxvisina_u_stupcu[si]<vi) maxvisina_u_stupcu[si]=vi;
	}
	maxvisina_u_stupcu[0]=0;
	fclose(in);
}

void radi(void)
{
	int min_visina_penjanja[MAXSTUPACA+1];
	int maxvisina;
	int i,j;
	min_visina_penjanja[0]=0;
	for (i=1;i<=stupaca;i++)
	{
		min_visina_penjanja[i]=10001;
		maxvisina=maxvisina_u_stupcu[i];
		if (min_visina_penjanja[i-1]+maxvisina<min_visina_penjanja[i])
			min_visina_penjanja[i]=min_visina_penjanja[i-1]+maxvisina;
		for (j=i-1;j>i-SIRINA&&j>0;j--)
		{
			if (maxvisina<maxvisina_u_stupcu[j]) maxvisina=maxvisina_u_stupcu[j];
			if (min_visina_penjanja[j-1]+maxvisina<min_visina_penjanja[i])
				min_visina_penjanja[i]=min_visina_penjanja[j-1]+maxvisina;
		}
	}
	minukvisina=min_visina_penjanja[stupaca];
}

void ispisi(void)
{
	FILE *out;
	out=fopen(VAN,"w");
	fprintf(out,"%d\n",minukvisina);
	printf("%d\n",minukvisina);
	fclose(out);
}

int main()
{
	ucitaj();
	radi();
	ispisi();
	return 0;
}
