
// DMIH 2001 - Drugi dan natjecanja
// Srednjoskolska skupina - II. podskupina
// Zadatak KARTE
// Autor rjesenja Milan mesic
// Nesluzbeno rjesenje

#define ULAZ "CARDS.in"
#define IZLAZ "CARDS.out"

#include <stdio.h>

#define MAXBOJA 4
#define MAXUNUTAR 4000
#define MAXKARTI (MAXBOJA*MAXUNUTAR)

int b,n;
struct karta
{
	int b,n;
} karte[MAXKARTI];

int redboja[MAXBOJA];

int koraka,minkoraka,bila;

void ucitaj(void)
{
	FILE *f;
	int i;
	f=fopen(ULAZ,"r");
	fscanf(f,"%d%d",&b,&n);
	for (i=0;i<b*n;i++)
	{
		fscanf(f,"%d%d",&karte[i].b,&karte[i].n);
		karte[i].b--;
		karte[i].n--;
	}
}

int broji(void)
{
	int rbr[MAXKARTI];
	int najduzi[MAXKARTI];
	int i,j,max;
	for (i=0;i<b*n;i++) rbr[i]=redboja[karte[i].b]*n+karte[i].n;
	najduzi[0]=1;
	max=1;
	for (i=1;i<b*n;i++)
	{
		najduzi[i]=1;
		for (j=0;j<i;j++) if (rbr[j]<rbr[i]&&najduzi[j]+1>najduzi[i]) najduzi[i]=najduzi[j]+1;
		if (max<najduzi[i]) max=najduzi[i];
	}
	return (b*n-max);
}

void permutiraj(int k)
{
	int i;
	if (k==b)
	{
		koraka=broji();
		if (koraka<minkoraka) minkoraka=koraka;
		return;
	}
	for (redboja[k]=0;redboja[k]<b;redboja[k]++)
	{
		bila=0;
		for (i=0;i<k;i++) if (redboja[i]==redboja[k]) bila=1;
		if (!bila) permutiraj(k+1);
	}

}

void ispisi(void)
{
	FILE *f;
	f=fopen(IZLAZ,"w");
	fprintf(f,"%d\n",minkoraka);
	fclose(f);
}

int main()
{
	ucitaj();
	minkoraka=MAXKARTI;
	permutiraj(0);
	ispisi();
	return 0;
}
