
{ Rjesenje napisali Kresimir Malnar, Ante Djerek i Bojan Antolovic }

program flauta;
const
  ispravne_znamenke : array [0..9] of string[15] = ( '####.##.##.####',
                                                     '..#..#..#..#..#',
                                                     '###..#####..###',
                                                     '###..####..####',
                                                     '#.##.####..#..#',
                                                     '####..###..####',
                                                     '####..####.####',
                                                     '###..#..#..#..#',
                                                     '####.#####.####',
                                                     '####.####..####' );
var
  brojke_na_satu : array [1..4] of string[15];
  rjesenje : record
               sati,minuta : integer;
             end;
  f : text;

procedure ucitaj_podatke;
var
  i,j : integer;
  niz_znakova : string[15];

begin
  assign(f,'CLOCK.IN');
  reset(f);

  for i := 1 to 4 do
    brojke_na_satu[i] := '';

  for i := 1 to 5 do
    begin
      readln(f,niz_znakova);
      for j := 1 to 4 do
        brojke_na_satu[j] := brojke_na_satu[j] + copy(niz_znakova,4 * (j - 1) + 1,3);
    end;

  close(f);
end;

procedure rijesi;
var
  i,j : integer;

function odgovara(koja_znamenka,broj : integer) : boolean;
var
  i : integer;

begin
  for i := 1 to 15 do
    if (brojke_na_satu[koja_znamenka][i] = '#') and
       (ispravne_znamenke[broj][i] = '.') then
      begin
        odgovara := false;
        exit;
      end;

  odgovara := true;
end;

begin
  for i := 0 to 23 do
    for j := 0 to 59 do
      if odgovara(1,i div 10) and odgovara(2,i mod 10) and
         odgovara(3,j div 10) and odgovara(4,j mod 10) then
        begin
          rjesenje.sati := i;
          rjesenje.minuta := j;

          exit;
        end;
end;

procedure ispisi_rjesenje;
begin
  assign(f,'CLOCK.OUT');
  rewrite(f);
  writeln(f,rjesenje.sati,':',rjesenje.minuta);
  close(f);
end;

begin
  ucitaj_podatke;
  rijesi;
  ispisi_rjesenje;
end.
