
{ Rjesenje napisali Kresimir Malnar, Ante Djerek i Bojan Antolovic }

program _domene;
const
  MAX_ADRESA = 100;
  MAX_ZNAKOVA = 50;
type
  t_string = string[3];
var
  i : integer;
  broj_adresa : integer;
  broj_domena : integer;
  adresa : string[MAX_ZNAKOVA];
  domena : t_string;
  domene : array [1..MAX_ADRESA] of record
                                      naziv : t_string;
                                      broj_posjeta : integer;
                                    end;
  max_posjeta : integer;
  f : text;

procedure odredi_domenu(adresa : string;var domena : t_string);
var
  i : integer;
  indeks,pocetak,kraj : integer;

begin
  indeks := 1;
  pocetak := 1;

  if copy(adresa,1,7) = 'http://' then
    delete(adresa,1,7);

  while true do
    begin
      if (indeks > length(adresa)) or (adresa[indeks] = '/') then
        begin
          kraj := indeks - 1;
          break;
        end;

      if adresa[indeks] = '.' then
        pocetak := indeks + 1;

      inc(indeks);
    end;

  domena := copy(adresa,pocetak,kraj - pocetak + 1);
end;

procedure azuriraj_listu_domena(domena : t_string);
var
  i : integer;
  ima : boolean;

begin
  ima := false;

  for i := 1 to broj_domena do
    if domene[i].naziv = domena then
      begin
        inc(domene[i].broj_posjeta);
        ima := true;
        break;
      end;

  if not ima then
    begin
      inc(broj_domena);
      domene[broj_domena].naziv := domena;
      domene[broj_domena].broj_posjeta := 1;
    end;
end;

begin
  assign(f,'DOMAINS.IN');
  reset(f);
  readln(f,broj_adresa);
  broj_domena := 0;
  for i := 1 to broj_adresa do
    begin
      readln(f,adresa);
      odredi_domenu(adresa,domena);
      azuriraj_listu_domena(domena);
    end;
  close(f);

  max_posjeta := 0;

  for i := 1 to broj_domena do
    if (max_posjeta = 0) or (domene[i].broj_posjeta > max_posjeta) then
      max_posjeta := domene[i].broj_posjeta;

  assign(f,'DOMAINS.OUT');
  rewrite(f);
  writeln(f,max_posjeta);
  for i := 1 to broj_domena do
    if domene[i].broj_posjeta = max_posjeta then
      write(f,domene[i].naziv,' ');
  writeln(f);
  close(f);
end.
