
// Rjesenje napisali Kresimir Malnar, Ante Djerek i Bojan Antolovic

/*

Potrebno je odrediti brojeve A i B takve da je umnozak brojeva A i B veci ili
jednak od broja N (broja ikona) i da je zbroj brojeva A i B sto manji.

Isprobavamo potencijalne parove takvih brojeva tako da za broj A uzimamo po
redu brojeve 1, 2, 3, ..., a za broj B uzimamo najmanji broj takav
da je A*B>=N.

*/

#include <stdio.h>
#include <math.h>

//

int main(void)
{
  int i,j;
  int broj_ikona;
  int a,b;

  FILE *file;

  //

  file = fopen("ICONS.IN","rt");

  fscanf(file,"%d",&broj_ikona);

  fclose(file);

  //

  a = 1;
  b = broj_ikona;

  for (i = 2;i <= sqrt(broj_ikona);++i)
  {
    j = broj_ikona / i;

    if (i * j < broj_ikona)
      ++j;

    if (i + j < a + b)
    {
      a = i;
      b = j;
    }
  }

  //

  file = fopen("ICONS.OUT","wt");

  fprintf(file,"%d %d\n",a,b);

  fclose(file);

  //

  return 0;
}
