
// Rjesenje napisali Kresimir Malnar, Ante Djerek i Bojan Antolovic

/*

Program prati dvije stvari: poredak karata ('poredak') i da li je
odredjena karta jos uvijek kandidat ('kandidati').

Svaki put kada se odabere neki stupac, karte koje nisu u tom stupcu
se izbace iz liste kandidata u polju 'kandidati', a elementi u
polju 'poredak' promijene svoje pozicije u polju sukladno pravilima
iz teksta zadatka.

*/

#include <stdio.h>

//

#define MAX_KARATA 999

//

int main(void)
{
  int i,j,k;
  int broj_karata,broj_dijeljenja;
  char oznaka_stupca[6];
  int broj_stupca;
  int brojac;
  int poredak[MAX_KARATA],stari_poredak[MAX_KARATA],kandidati[MAX_KARATA];

  FILE *file;

  //

  file = fopen("CARDS.IN","rt");

  fscanf(file,"%d%d",&broj_karata,&broj_dijeljenja);

  for (i = 0;i < broj_karata;++i)
  {
    poredak[i] = i;
    kandidati[i] = 1;
  }

  //

  for (i = 0;i < broj_dijeljenja;++i)
  {
    fscanf(file,"%s",oznaka_stupca);

    switch (oznaka_stupca[0])
    {
      case 'p' : broj_stupca = 0;
                 break;
      case 'd' : broj_stupca = 1;
                 break;
      case 't' : broj_stupca = 2;
    }

    for (j = 0;j < broj_karata;++j)
      if (j % 3 != broj_stupca)
        kandidati[poredak[j]] = 0;

    for (j = 0;j < broj_karata;++j)
      stari_poredak[j] = poredak[j];

    brojac = 0;

    for (j = 0;j < 3;++j)
      for (k = 0;k < broj_karata / 3;++k)
        poredak[brojac++] = stari_poredak[3 * k + j];
  }

  fclose(file);

  //

  file = fopen("CARDS.OUT","wt");

  for (i = 0;i < broj_karata;++i)
    if (kandidati[i])
      fprintf(file,"%d ",i + 1);

  fprintf(file,"\n");

  fclose(file);

  //

  return 0;
}
