
{ Rjesenje napisali Kresimir Malnar, Ante Djerek i Bojan Antolovic }

program t9;
const
  MAX_RIJECI = 100;
  MAX_DULJINA_RIJECI = 100;
  MAX_DULJINA_PORUKE = 100;
  raspored : string[26] = '22233344455566677778889999';
var
  broj_rijeci : integer;
  rijeci : array [1..MAX_RIJECI] of string[MAX_DULJINA_RIJECI];
  duljina_poruke : integer;
  poruka : array [1..MAX_DULJINA_PORUKE] of integer;
  f : text;

procedure ucitaj_podatke;
var
  i : integer;

begin
  assign(f,'T9.IN');
  reset(f);

  readln(f,broj_rijeci);
  for i := 1 to broj_rijeci do
    readln(f,rijeci[i]);

  readln(f,duljina_poruke);
  for i := 1 to duljina_poruke do
    read(f,poruka[i]);

  close(f);
end;

procedure rijesi_i_ispisi;
var
  brojac : integer;
  rijec : string[MAX_DULJINA_RIJECI];

procedure nadji(rijec : string);
var
  i,j : integer;
  ima,dobra : boolean;

begin
  ima := false;

  for i := 1 to broj_rijeci do
    begin
      if length(rijec) <> length(rijeci[i]) then
        continue;

      dobra := true;

      for j := 1 to length(rijec) do
        if ord(rijec[j]) - 48 <> ord(raspored[ord(rijeci[i][j]) - 64]) - 48 then
          begin
            dobra := false;
            break;
          end;

      if dobra then
        begin
          write(f,rijeci[i],' ');
          ima := true;
          break;
        end;
    end;

  if not ima then
    begin
      for i := 1 to length(rijec) do
        write(f,'*');

      write(f,' ');
    end;
end;

begin
  assign(f,'T9.OUT');
  rewrite(f);

  brojac := 1;
  rijec := '';

  while true do
    begin
      rijec := rijec + chr(48 + poruka[brojac]);
      inc(brojac);

      if (brojac > duljina_poruke) or (poruka[brojac] = 1) then
        begin
          nadji(rijec);
          inc(brojac);
          rijec := '';
        end;

      if brojac > duljina_poruke then
        break;
    end;

  writeln(f);
  close(f);
end;

begin
  ucitaj_podatke;
  rijesi_i_ispisi;
end.
