
/*
HIO 2002
Zadatak KOLA, Programski jezik C
*/

#include <stdio.h>
#define MAXBOCA 10005
#define MAXLJUDI 10005
#define MAXCOLE 3000
#define MAXINT 10000000
#define INFILE "cola.in"
#define OUTFILE "cola.out"

int red[MAXLJUDI];
int stanje[MAXBOCA];
int start[MAXBOCA];
int end[MAXBOCA];
int potez[MAXLJUDI];

int perm[MAXBOCA], bio[MAXBOCA];

int boce, ljudi, poc;

FILE *fin, *fout;
void ispis( void )
{
	int i;
	fout = fopen( OUTFILE, "wt" );
    for( i = 1; i <= ljudi; i++ )
    	fprintf( fout, "%d ", perm[potez[i]] );
    fclose( fout );
}
int main( void )
{
	int i, j, m, koji;
    char s[MAXLJUDI+1];
    fin = fopen( INFILE, "rt" );
    fscanf( fin, "%d %d %d", &ljudi, &boce, &poc );
    for( i = 1; i <= boce; i++ )
    {
        start[i] = poc;
        stanje[i] = poc;
    }
    fscanf( fin, "%s", s );
    for( i = 0; i < ljudi; i++ )
    {
    	if( s[i] == 'R' )
        red[i+1] = 1; else red[i+1] = 0;
    }

    for( i = 1; i <= boce; i++ ) fscanf( fin,"%d", &end[i] );
    fclose( fin );

    for( i = 1; i <= ljudi; i++ )
    {
    	if( red[i] == 1)
        {
	        m = -1;
        	for( j = 1; j <= boce; j++ ) if( stanje[j] > m )
            {
            	m = stanje[j];
                koji = j;
            }
            potez[i] = koji;
            stanje[koji]--;
        }
        else
        {
            m = MAXINT;
            for( j = 1; j <= boce; j++) if( ( stanje[j] < m ) && ( stanje[j] > 0 ) )
            {
            	m = stanje[j];
                koji = j;
            }
            potez[i] = koji;
            stanje[koji]--;
        }
    }
    for( i = 1; i <= ljudi; i++ )
    {
    	j = 1;
        while( ( end[i] != stanje[j] ) || ( bio[j] == 1 ) || ( start[i] != start[j])) j++;
        perm[j] = i;
        bio[j] = 1;
    }
    ispis();

	return 0;
}
