
/*
DMIH 2002, Prvi dan natjecanja
Srednjoskolska skupina, I. podskupina
Zadatak UTJEHA, Programski jezik C
*/

#include <stdio.h>

#define INPUT_FILE  "comfort.in"
#define OUTPUT_FILE "comfort.out"

#define MAX_POLJA 1000

int broj_polja,zadano_polje;
int broj_prepreka,prepreke[MAX_POLJA - 2];
int rjesenje;
FILE *file;

void ucitaj_podatke(void)
{
  int i;
  int broj;

  file = fopen(INPUT_FILE,"r");

  fscanf(file,"%d%d%d",&broj_polja,&zadano_polje,&broj_prepreka);
  --zadano_polje;

  for (i = 0;i < broj_polja;++i)
    prepreke[i] = 0;

  for (i = 0;i < broj_prepreka;++i)
  {
    fscanf(file,"%d",&broj);
    prepreke[broj - 1] = 1;
  }

  fclose(file);
}

void rijesi(void)
{
  int i;
  int k,trenutno_polje;
  int bio[MAX_POLJA];

  for (k = 1;k <= zadano_polje;++k)
  {
    for (i = 0;i < broj_polja;++i)
      bio[i] = 0;
    bio[0] = 1;

    trenutno_polje = 0;
    while (1)
    {
      trenutno_polje += k;
      trenutno_polje %= broj_polja;

      if (trenutno_polje == zadano_polje)
      {
        rjesenje = k;
        return;
      }
      if (bio[trenutno_polje] || prepreke[trenutno_polje])
        break;
    }
  }
}

void ispisi_rjesenje(void)
{
  file = fopen(OUTPUT_FILE,"w");
  fprintf(file,"%d\n",rjesenje);
  fclose(file);
}

int main(void)
{
  ucitaj_podatke();
  rijesi();
  ispisi_rjesenje();

  return 0;
}
