
/*
DMIH 2002, Prvi dan natjecanja
Srednjoskolska skupina, I. podskupina
Zadatak LJUDI, Programski jezik C
*/

#include <stdio.h>
#include <stdlib.h>

#define INPUT_FILE  "people.in"
#define OUTPUT_FILE "people.out"

#define MAX_LJUDI 20

int broj_ljudi;
int izjave[MAX_LJUDI][MAX_LJUDI];
int rjesenje[MAX_LJUDI];
FILE *file;

void ucitaj_podatke(void)
{
  int i,j;
  int broj_tvrdnji,broj;

  file = fopen(INPUT_FILE,"r");
  fscanf(file,"%d",&broj_ljudi);

  for (i = 0;i < broj_ljudi;++i)
    for (j = 0;j < broj_ljudi;++j)
      izjave[i][j] = 0;

  for (i = 0;i < broj_ljudi;++i)
  {
    fscanf(file,"%d",&broj_tvrdnji);
    for (j = 0;j < broj_tvrdnji;++j)
    {
      fscanf(file,"%d",&broj);
      izjave[i][broj - 1] = 1;
    }

    fscanf(file,"%d",&broj_tvrdnji);
    for (j = 0;j < broj_tvrdnji;++j)
    {
      fscanf(file,"%d",&broj);
      izjave[i][broj - 1] = -1;
    }
  }

  fclose(file);
}

int provjeri(void)
{
  int i,j;
  int ima_laz;

  for (i = 0;i < broj_ljudi;++i)
    if (rjesenje[i])
    {
      for (j = 0;j < broj_ljudi;++j)
        if ((izjave[i][j] == 1 && !rjesenje[j]) ||
            (izjave[i][j] == -1 && rjesenje[j]))
          return 0;
    }
    else
    {
      ima_laz = 0;

      for (j = 0;j < broj_ljudi;++j)
        if ((izjave[i][j] == 1 && !rjesenje[j]) ||
            (izjave[i][j] == -1 && rjesenje[j]))
        {
          ima_laz = 1;
          break;
        }

      if (!ima_laz)
        return 0;
    }

  return 1;
}

void ispisi(void)
{
  int i;

  file = fopen(OUTPUT_FILE,"w");
  for (i = 0;i < broj_ljudi;++i)
    fprintf(file,rjesenje[i] ? "istina\n" : "neistina\n");
  fclose(file);
}

void rijesi(int broj)
{
  if (broj == broj_ljudi)
  {
    if (provjeri())
    {
      ispisi();
      exit(0);
    }

    return;
  }

  rjesenje[broj] = 1;
  rijesi(broj + 1);

  rjesenje[broj] = 0;
  rijesi(broj + 1);
}

int main(void)
{
  ucitaj_podatke();
  rijesi(0);

  return 0;
}
