
/*
DMIH 2002, Prvi dan natjecanja
Srednjoskolska skupina, I. podskupina
Zadatak EKIPE, Programski jezik C
*/

#include <stdio.h>
#define MAXN 1004

int n;

int dominoX[MAXN], dominoY[MAXN];
int komp = 0;

int suma[MAXN];
int rek[MAXN][MAXN];
int rje[MAXN];

int necu[MAXN][MAXN];
int koliko[MAXN];

int gdje[MAXN] = {0};

int queue[MAXN];
int top, down;

int NEMOGUCE = 0;

FILE *fin, *fout;

void init_queue( void )
{
	top = 0;
    down = 0;
}
void put( int x )
{
	queue[top++] = x;
}
int get( void )
{
	return queue[down++];
}
void ispis( void )
{
	int i, j;
  fout = fopen( "teams.out", "wt" );
    if( NEMOGUCE == 1 ) fprintf( fout, "ne postoji\n" );
    else
    {
    	for( i = 1; i <= n; i++ )
        {
        	j = gdje[i];
			if( (( j > 0 ) && ( rje[j] == 1 )) || (( j < 0 ) && ( rje[-j] == -1 )) )
             fprintf( fout, "%d ", i );
        }
    }
    fprintf(fout,"\n");
    fclose( fout );
}
int main( void )
{
	int i, j, k;
  fin = fopen( "teams.in", "rt" );
    fscanf( fin, "%d", &n );
    for( i = 1; i <= n; i++ )
    {
    	fscanf( fin, "%d", &koliko[i] );
        for(j = 1; j <= koliko[i]; j++ )
         {
        	fscanf( fin, "%d", &necu[i][j] );
         }
    }
    for( i = 1; i <= n; i++ )
    	for( j = 1; j <= koliko[i]; j++ )
        {
        	koliko[necu[i][j]]++;
            necu[necu[i][j]][koliko[necu[i][j]]] = i;
        }
    fclose( fin );

    for( i = 1; i <= n; i++ )
	if( gdje[i] == 0 )
    {
    	komp++;
        gdje[i] = komp;
        init_queue();
        put( i );
        while( top != down )
        {
        	j = get();
            for( k = 1; k <= koliko[j]; k++ )
            {
            	if( gdje[necu[j][k]] == gdje[j] )
                {
                	NEMOGUCE = 1;
                    goto kraj;
                }
                else
                if( gdje[necu[j][k]] == 0 )
                {
                	gdje[necu[j][k]] = - gdje[j];
                    put( necu[j][k] );
                }
            }
        }
    }
    for( i = 1; i <= n; i++ )
    {
    	if( gdje[i] < 0 ) dominoY[-gdje[i]]++;
        else dominoX[gdje[i]]++;
    }
    kraj:
    if( NEMOGUCE == 0 )
    {
    	for( i = 1; i <= n; i++ ) suma[i] = 0;
    	suma[0] = 1;
        for( i = 1; i <= komp; i++ )
        {
        	for( j = n; j >= 0; j-- )
            {
            	if( suma[j] == 1 )
                {
                	suma[j] = 0;
                    suma[j + dominoX[i]] = 1;
                    rek[i][j + dominoX[i]] = 1;
                    suma[j + dominoY[i]] = 1;
                    rek[i][j + dominoY[i]] = -1;
                }
            }
        }
    }
    if( suma[n / 2] != 1 ) NEMOGUCE = 1;
    else
    {
    	int temp = n / 2;
    	for( i = komp; i >= 1; i-- )
        {
        	rje[i] = rek[i][temp];
            if( rje[i] == 1 )
            {
            	temp = temp - dominoX[i];
            }
            else
            {
            	temp = temp - dominoY[i];
            }
        }
    }
    ispis();
	return 0;
}
