
/*
DMIH 2002, Drugi dan natjecanja
Srednjoskolska skupina, I. podskupina
Zadatak RALICA, Programski jezik C
*/

#include <stdio.h>
#include <stdlib.h>

#define MAXV 100010
#define INFILE "one.in"
#define OUTFILE "one.out"

typedef struct lista
{
	int v, w;
    struct lista* next;
}link;

int v;
link* graf[MAXV];
int bio[MAXV];

int queue[MAXV];
int top, down;
int suma = 0, sol;
FILE *fin, *fout;
int start;

void ispis( void )
{
	fout = fopen( OUTFILE, "wt" );
    fprintf( fout, "%d\n", 2 * suma - sol );
    fclose( fout );
}
void init_queue( void )
{
	top = down = 0;
}
int get( void )
{
	return queue[down++];
}
void put( int i )
{
	queue[top++] = i;
}

int main( void )
{
	int i, x, y, z;
    link* l;

 	fin = fopen( INFILE, "rt" );
  fscanf( fin, "%d%d", &v , &start);
    for( i = 1; i <= v; i++ ) graf[i] = NULL;
    for( i = 1; i <= v - 1; i++ )
    {
    	fscanf( fin, "%d %d %d", &x, &y, &z );
        suma += z;
        l = (link * ) malloc( sizeof( link ) );
        l -> v = x;
        l -> w = z;
        l -> next = graf[y];
        graf[y] = l;
        l = (link * ) malloc( sizeof( link ) );
        l -> v = y;
        l -> w = z;
        l -> next = graf[x];
        graf[x] = l;
    }
 	fclose( fin );

    init_queue();
    put( start );
    bio[start] = 1;
    i = start;
    while( top != down )
    {
    	i = get();
        l = graf[i];
        while( l != NULL )
        {
            if( !bio[l -> v ] )
            {
              bio[l -> v ] = bio[i] + l -> w;
              put( l -> v );
            }
            l = l -> next;
        }
    }
    sol = -1;
    for( i = 1; i <= v; i++ ) if (bio[i] > sol ) sol = bio[i];
    sol = sol - 1;
    ispis();

 	return 0;
}
