
/*
DMIH 2002, Prvi dan natjecanja
Srednjoskolska skupina, II. podskupina
Zadatak TORANJ, Programski jezik C
*/

#include <stdio.h>
#include <stdlib.h>

#define MAXN 10001
#define MAXM 100001
#define INFILE "tower.in"
#define OUTFILE "tower.out"

struct vezica
{
	int v;
    struct vezica* next;
};
typedef struct vezica lista;

lista* graf[MAXN];
int n, m;

int queue[MAXN];
int bio[MAXN];
int top, down;
int max1, max2, gdje1, gdje2;
int komp;

FILE *fin, *fout;

void init_m( void )
{
 	max1 = -1;
    max2 = -1;
    gdje1 = -1;
    gdje2 = -1;
}
void init_queue( void )
{
	top = down = 0;
}
void put( int i )
{
	queue[top++] = i;
}
int get( void )
{
	return queue[down++];
}

void ispis( void )
{
	fout = fopen( OUTFILE, "wt" );
    if( max2 == -1 ) fprintf( fout, "%d %d\n", gdje1, gdje1 );
    else fprintf( fout, "%d %d\n", gdje1, gdje2 );
    fclose( fout );
}
int main( void )
{
	int i, x, y, j;
    int broj;
    lista* l;

    fin = fopen( INFILE, "rt" );
    fscanf( fin, "%d %d", &n, &m );
    for( i = 1; i <= n; i++ ) graf[i] = NULL;
    for( i = 1; i <= m; i++ )
    {
    	fscanf( fin, "%d %d", &x, &y );
        l = (lista*)malloc( sizeof( lista ) );
        l ->v = x;
        l ->next = graf[y];
        graf[y] = l;
        l = (lista*)malloc( sizeof( lista ) );
        l ->v = y;
        l ->next = graf[x];
        graf[x] = l;
    }
    fclose( fin );

    init_m();
    for( i = 1; i <= n; i++ )
    if( !bio[i] )
    {
        init_queue();
        komp++;
        broj = 1;
        put( i );
        bio[i] = komp;
        while( top != down )
        {
        	j = get();
            l = graf[j];
            while( l != NULL )
            {
            	if( !bio[l ->v] )
                {
                	bio[l ->v] = komp;
                    broj++;
                    put( l ->v );
                }
                l = l -> next;

            }
        }
        if( broj > max1 )
        {
            x = max1; y = gdje1;
        	max1 = broj;
            gdje1 = j;
            max2 = x; gdje2 = y;
        }
        else if( broj > max2 )
        {
            max2 = broj;
            gdje2 = j;
        }
    }
    ispis();
	return 0;
}
