
/*
DMIH 2002, Prvi dan natjecanja
Srednjoskolska skupina, II. podskupina
Zadatak TUNEL, Programski jezik C
*/

#include <stdio.h>
#include <string.h>

#define INPUT_FILE  "tunnel.in"
#define OUTPUT_FILE "tunnel.out"

#define MAX_AUTA 1000
#define MAX_ZNAKOVA 8

int broj_auta;
char registracije[MAX_AUTA][MAX_ZNAKOVA + 1];
int poredak[MAX_AUTA];
int rjesenje;
FILE *file;

void ucitaj_podatke(void)
{
  int i,j;
  char string[MAX_ZNAKOVA + 1];

  file = fopen(INPUT_FILE,"r");

  fscanf(file,"%d",&broj_auta);
  for (i = 0;i < broj_auta;++i)
    fscanf(file,"%s",registracije[i]);

  for (i = 0;i < broj_auta;++i)
  {
    fscanf(file,"%s",string);
    for (j = 0;j < broj_auta;++j)
      if (!strcmp(string,registracije[j]))
      {
        poredak[i] = j;
        break;
      }
  }

  fclose(file);
}

void rijesi(void)
{
  int i,j;

  rjesenje = 0;

  for (i = 0;i < broj_auta;++i)
    for (j = i + 1;j < broj_auta;++j)
      if (poredak[j] < poredak[i])
      {
        ++rjesenje;
        break;
      }
}

void ispisi_rjesenje(void)
{
  file = fopen(OUTPUT_FILE,"w");
  fprintf(file,"%d\n",rjesenje);
  fclose(file);
}

int main(void)
{
  ucitaj_podatke();
  rijesi();
  ispisi_rjesenje();

  return 0;
}
