
/*
DMIH 2002, Drugi dan natjecanja
Srednjoskolska skupina, II. podskupina
Zadatak BROJEVI, Programski jezik C
*/

#include <stdio.h>

#define INFILE    "numbers.in"
#define OUTFILE   "numbers.out"
#define MAXN            100000

int b[MAXN+1], sol[MAXN+1], nesmijem[MAXN+1];
int n, broj_mora;

void load_data ( void )
{
	int i, temp, temp1;
	FILE *f=fopen (INFILE, "rt");

	fscanf (f, "%d %d", &n, &broj_mora);
	for (i=1; i<=n; i++)
		fscanf (f, "%d", b+i);

	for (i=0; i<broj_mora; i++)
	{
		fscanf (f, "%d %d", &temp, &temp1);
		sol[temp]=temp1;
		nesmijem[temp1]=1;
	}

	fclose (f);
}

int solve ( void )
{
	int current=1, donji, w,  j;

	while (current<=n)
	{
		donji=current;
		while (!b[current] && current<=n) current++;
   		if (current>n) return 0;

		w=donji;
		for (j=current; j>=donji; j--)
			if (!nesmijem[j])
			{
				while (sol[w]) w++;
				sol[w]=j;
			}

		current++;
	}

	return 1;
}

int check ( void )
{
	int max=0, i;
	for (i=1; i<=n; i++)
	{
		if (sol[i]>max) max=sol[i];
		if (b[i] && max!=i) return 0;
		if (!b[i] && max==i) return 0;
	}

	return 1;
}

void write_solution (int ok)
{
	FILE *fout=fopen (OUTFILE, "wt");

	if (ok)
	{
		int i;
		for (i=1; i<n; i++) fprintf (fout,  "%d ", sol[i]);
		fprintf (fout,  "%d\n", sol[n]);
	}
	else
        fprintf (fout, "ne postoji\n");

	fclose (fout);
}

int main ( void )
{
	load_data();
	if (!solve()) write_solution (0);
			 else write_solution (check());

	return 0;
}
