
(*
Regional Competition 2002, Juniors
Problem LETTERS, Solution in Pascal
*)

program letters;
const
  INPUT_FILE  = 'letters.in';
  OUTPUT_FILE = 'letters.out';
  MAX_REDAKA  = 20;
  MAX_STUPACA = 20;
var
  broj_redaka,broj_stupaca : integer;
  ploca : array [1..MAX_REDAKA] of string[MAX_STUPACA];
  bilo : array ['A'..'Z'] of boolean;
  broj_poteza,max_poteza : integer;
  f : text;

procedure ucitaj_podatke;
var
  i : integer;
begin
  assign(f,INPUT_FILE);
  reset(f);
  readln(f,broj_redaka,broj_stupaca);
  for i := 1 to broj_redaka do
    readln(f,ploca[i]);
  close(f);
end;

procedure rekurzija(a,b : integer);
begin
  if (a < 1) or (a > broj_redaka) or (b < 1) or (b > broj_stupaca) then
    exit;
  if bilo[ploca[a][b]] then
    exit;

  bilo[ploca[a][b]] := true;
  inc(broj_poteza);
  if broj_poteza > max_poteza then
    max_poteza := broj_poteza;

  rekurzija(a - 1,b);
  rekurzija(a + 1,b);
  rekurzija(a,b - 1);
  rekurzija(a,b + 1);

  bilo[ploca[a][b]] := false;
  dec(broj_poteza);
end;

procedure rijesi;
var
  c : char;
begin
  for c := 'A' to 'Z' do
    bilo[c] := false;
  broj_poteza := 0;
  max_poteza := 0;
  rekurzija(1,1);
end;

procedure ispisi_rjesenje;
begin
  assign(f,OUTPUT_FILE);
  rewrite(f);
  writeln(f,max_poteza);
  close(f);
end;

begin
  ucitaj_podatke;
  rijesi;
  ispisi_rjesenje;
end.
