
(*
Regional Competition 2002, Seniors
Problem ELBOW, Solution in Pascal
*)

program elbow;
const
  INPUT_FILE  = 'elbow.in';
  OUTPUT_FILE = 'elbow.out';
  MAX_ZNAKOVA = 150;
var
  prva_rijec,druga_rijec : string[MAX_ZNAKOVA];
  treca_rijec : array [1..2*MAX_ZNAKOVA] of char;
  duljina1,duljina2 : integer;
  tablica : array [0..MAX_ZNAKOVA,0..MAX_ZNAKOVA] of integer;
  f : text;

procedure ucitaj_podatke;
begin
  assign(f,INPUT_FILE);
  reset(f);
  readln(f,prva_rijec);
  readln(f,druga_rijec);
  readln(f,treca_rijec);
  duljina1 := length(prva_rijec);
  duljina2 := length(druga_rijec);
  close(f);
end;

procedure rijesi;
var
  i,j : integer;
begin
  for i := 0 to duljina1 do
    for j := 0 to duljina2 do
      tablica[i,j] := 0;
  tablica[0,0] := 999;

  for i := 0 to duljina1 do
    for j := 0 to duljina2 do
      begin
        if (i <> 0) and (tablica[i - 1,j] <> 0) and
           (prva_rijec[i] = treca_rijec[i + j]) then
          tablica[i,j] := 1;
        if (j <> 0) and (tablica[i,j - 1] <> 0) and
           (druga_rijec[j] = treca_rijec[i + j]) then
          tablica[i,j] := 2;
      end;
end;

procedure ispisi_rjesenje;
var
  i : integer;
  a,b : integer;
  rjesenje : array [1..2*MAX_ZNAKOVA] of integer;
begin
  a := duljina1;
  b := duljina2;
  for i := 1 to duljina1 + duljina2 do
    begin
      rjesenje[a + b] := tablica[a][b];
      if tablica[a][b] = 1 then
        dec(a)
      else
        dec(b);
    end;

  assign(f,OUTPUT_FILE);
  rewrite(f);
  for i := 1 to duljina1 + duljina2 do
    write(f,rjesenje[i]);
  writeln(f);
  close(f);
end;

begin
  ucitaj_podatke;
  rijesi;
  ispisi_rjesenje;
end.
