
/*
Regional Competition 2002, Seniors
Problem WINDOWS, Solution in C
*/

#include <stdio.h>

#define INPUT_FILE  "windows.in"
#define OUTPUT_FILE "windows.out"
#define MAX_PROZORA 100

int broj_prozora;
struct {
         int gornji_red,donji_red;
         int lijevi_stupac,desni_stupac;
       } prozori[MAX_PROZORA];
int zatvoren[MAX_PROZORA];
int rjesenje;
FILE *file;

void ucitaj_podatke(void)
{
  int i;

  file = fopen(INPUT_FILE,"r");
  fscanf(file,"%d",&broj_prozora);
  for (i = 0;i < broj_prozora;++i)
    fscanf(file,"%d%d%d%d",&prozori[i].gornji_red,&prozori[i].lijevi_stupac,
                           &prozori[i].donji_red,&prozori[i].desni_stupac);
  fclose(file);
}

int preklapa(int a,int b)
{
  if (prozori[a].gornji_red <= prozori[b].gornji_red &&
      prozori[a].donji_red >= prozori[b].gornji_red &&
      prozori[a].lijevi_stupac <= prozori[b].desni_stupac &&
      prozori[a].desni_stupac >= prozori[b].desni_stupac)
    return 1;
  return 0;
}

void zatvori(int broj)
{
  int i;

  for (i = broj_prozora - 1;i >= broj + 1;--i)
    if (!zatvoren[i] && preklapa(i,broj))
      zatvori(i);
  zatvoren[broj] = 1;
  ++rjesenje;
}

void rijesi(void)
{
  int i;

  for (i = 0;i < broj_prozora;++i)
    zatvoren[i] = 0;
  rjesenje = 0;
  zatvori(0);
}

void ispisi_rjesenje(void)
{
  file = fopen(OUTPUT_FILE,"w");
  fprintf(file,"%d\n",rjesenje);
  fclose(file);
}

int main(void)
{
  ucitaj_podatke();
  rijesi();
  ispisi_rjesenje();

  return 0;
}
