
(*
Regional Competition 2002, Seniors
Problem WINDOWS, Solution in Pascal
*)

program _windows;
const
  INPUT_FILE  = 'windows.in';
  OUTPUT_FILE = 'windows.out';
  MAX_PROZORA = 100;
var
  broj_prozora : integer;
  prozori : array [1..MAX_PROZORA] of record
                                        gornji_red,donji_red : integer;
                                        lijevi_stupac,desni_stupac : integer;
                                      end;
  zatvoren : array [1..MAX_PROZORA] of boolean;
  rjesenje : integer;
  f : text;

procedure ucitaj_podatke;
var
  i : integer;
begin
  assign(f,INPUT_FILE);
  reset(f);
  readln(f,broj_prozora);
  for i := 1 to broj_prozora do
    readln(f,prozori[i].gornji_red,prozori[i].lijevi_stupac,
             prozori[i].donji_red,prozori[i].desni_stupac);
  close(f);
end;

function preklapa(a,b : integer) : boolean;
begin
  if (prozori[a].gornji_red <= prozori[b].gornji_red) and
     (prozori[a].donji_red >= prozori[b].gornji_red) and
     (prozori[a].lijevi_stupac <= prozori[b].desni_stupac) and
     (prozori[a].desni_stupac >= prozori[b].desni_stupac) then
    preklapa := true
  else
    preklapa := false;
end;

procedure zatvori(broj : integer);
var
  i : integer;
begin
  for i := broj_prozora downto broj + 1 do
    if not zatvoren[i] and preklapa(i,broj) then
      zatvori(i);
  zatvoren[broj] := true;
  inc(rjesenje);
end;

procedure rijesi;
var
  i : integer;
begin
  for i := 1 to broj_prozora do
    zatvoren[i] := false;
  rjesenje := 0;
  zatvori(1);
end;

procedure ispisi_rjesenje;
begin
  assign(f,OUTPUT_FILE);
  rewrite(f);
  writeln(f,rjesenje);
  close(f);
end;

begin
  ucitaj_podatke;
  rijesi;
  ispisi_rjesenje;
end.
