
(*
Croatia 2003
Croatian Olympiad in Informatics
Problem SLALOM, Programming language Pascal
*)

program slalom;
var
 inn,out:text;
 i,n,xs,xc:longint;
 x1,x2,y:array[0..5001] of longint;
 d:real;

function rad (a,b,xa,xb:longint):real;
var
 i,p:longint;
 u,ml:real;
begin
 p:=-1;
 ml:=0;
 for i:=a+1 to b-1 do
    begin
     u:=xb-x2[i]+(xa-xb)*(y[i]-y[b])/(y[a]-y[b]);
     if (u>ml) then
        begin
         ml:=u;
         p:=i
        end;
    end;
 if p<>-1 then rad:=rad(a,p,xa,x2[p])+rad(p,b,x2[p],xb) else
    begin
     p:=-1;
     ml:=0;
     for i:=a+1 to b-1 do
        begin
         u:=xb-x1[i]+(xa-xb)*(y[i]-y[b])/(y[a]-y[b]);
         if (u<ml) then
            begin
             ml:=u;
             p:=i
            end;
        end;
     if p<>-1 then rad:=rad(a,p,xa,x1[p])+rad(p,b,x1[p],xb) else
                   rad:=sqrt((xa-xb)*(xa-xb)+(y[a]-y[b])*(y[a]-y[b]));
    end;
end;

begin
 assign (inn,'slalom.in');
 assign (out,'slalom.out');
 reset (inn);
 readln (inn,n);
 readln (inn,xs,y[0]);
 for i:=1 to n do readln (inn,x1[i],x2[i],y[i]);
 readln (inn,xc,y[n+1]);
 close (inn);

 d:=rad(0,n+1,xs,xc);

 rewrite (out);
 writeln (out,d:4:4);
 close (out);
end.
