
/*
Croatia 2003
Final Exam - First day
Problem JOZO, Programming language C
*/

#include <stdio.h>

#define ULAZ            "jozo.in"
#define IZLAZ           "jozo.out"

#define STANICA         2000
#define VLAKOVA         2000
#define STANUVLA        2000
#define DULJSTA         650

int pruge[STANICA+1][STANICA+1];
int matrica[DULJSTA][STANICA];

typedef struct
{
        int nst;
        int kretanje;
        int tren;
        int st[STANUVLA];
} vlakovi;

int tt[2*DULJSTA+100];
vlakovi v[VLAKOVA];

int main ( void )
{
        FILE *in, *out;
        int nst, npr, nvl;
        int pr, vl, st, i;
        int fr, to, dulj;
        int pocdol, krajdol;
        int vrijeme;
        int grad, *tren;
        int min=100000000;

        in=fopen (ULAZ, "r");
        fscanf (in, "%d %d %d %d %d", &nst, &npr, &nvl, &pocdol, &krajdol);
        for (pr=0; pr<npr; pr++)
        {
                fscanf (in, "%d %d %d", &fr, &to, &dulj);
                pruge[fr][to]=dulj;
                pruge[to][fr]=dulj;
        }

        for (vl=0; vl<nvl; vl++)
        {
                fscanf (in, "%d%d", &v[vl].kretanje, &v[vl].nst);
                v[vl].tren=0;
                for (st=0; st<v[vl].nst; st++)
                        fscanf (in, "%d", v[vl].st+st);
        }

        fclose(in);

        for (i=0; i<2*DULJSTA+100; i++) /* Ne pitaj cemu */
                tt[i]=i%DULJSTA;

        for (i=0; i<DULJSTA; i++)
                for (grad=1; grad<=nst; grad++)
                        matrica[i][grad]=-1;
        matrica[0][1]=0;

        for (vrijeme=1, tren=tt; vrijeme<=krajdol; vrijeme++)
        {
                /* Ispitaj je li ovo dobro vrijeme, ako je, onda provijeri */
                if (vrijeme>=pocdol)
                        if (matrica[*tren][1]<min)
                                min=matrica[*tren][1];

                /* Ako se isplati ostani u gradu na pivi jos sekundu */
                for (grad=1; grad<=nst; grad++)
                {
                        if (matrica[*tren][grad]>=0)
                                if (matrica[tren[1]][grad]==-1 ||
                                matrica[*tren][grad]+1<matrica[tren[1]][grad])
                                        matrica[tren[1]][grad]=matrica[*tren][grad]+1;
                }

                /* Takodjer, ako se isplati skoci u vlak jednu stanicu.
                Usput pomakni vlak. */
                for (vl=0; vl<nvl; vl++)
                        if (v[vl].kretanje==vrijeme)
                        {
                                fr=v[vl].st[v[vl].tren];
                                to=v[vl].st[v[vl].tren+1];
                                dulj=pruge[fr][to];
                                if (++v[vl].tren < v[vl].nst-1)
                                        v[vl].kretanje+=dulj;
                                else
                                        v[vl].kretanje=100000000;

                                if (matrica[*tren][fr]==-1)
                                        continue;
                                if (matrica[tren[dulj]][to]==-1 ||
                                matrica[*tren][fr]<matrica[tren[dulj]][to])
                                        matrica[tren[dulj]][to]=matrica[*tren][fr];
                        }

                /* Zbrisi trenutno vrijeme, buduci da ga se reciklira */
                for (grad=1; grad<=nst; grad++)
                        matrica[*tren][grad]=-1;

                if (++tren-tt==DULJSTA)
                        tren=tt; /* Pomakni se u vremenskoj matrici */
        }

        out=fopen (IZLAZ, "w");
        fprintf (out, "%d\n", min);
        fclose (out);

        return 0;
}
