
/*
Croatia 2003
National Competition - First day - Juniors
Problem TELEPORT, Programming language C
*/

#include <stdio.h>

#define fin             "teleport.in"
#define fout            "teleport.out"

#define MAX_N           1001
#define MAX_U           (MAX_N*MAX_N)

int g[MAX_N][MAX_N];
int vx[MAX_U], vy[MAX_U], vz[MAX_U];
int i, j, k, z, x, y, n, m, mm;

int min(int x, int y)
{
        return (x < y) ? x : y;
}

int main ( void )
{
        FILE *in=fopen (fin, "r"), *out=fopen (fout, "w");

        fscanf (in, "%d%d", &n, &m);
        for (i=0; i<m; ++i)
	{
                fscanf (in, "%d%d%d", &x, &y, &z);
                g[x-1][y-1]=g[y-1][x-1]=z;
	}

        for (k=0; k<n; ++k)
                for (i=0; i<n; ++i)
                        if (g[i][k])
                                for (j=0; j<n; ++j)
                                        if (g[k][j] && (g[i][j] > g[i][k] + g[k][j] || !g[i][j]))
                                                g[i][j]=g[i][k]+g[k][j];

        for (i=0; i<n; ++i)
                g[i][i] = 0;

        fscanf (in, "%d", &m);
        for (i=0; i<m; ++i)
	{
                fscanf (in, "%d%d%d", vx+i, vy+i, vz+i);
	}

        for (i=0; i<m; ++i)
	{
		vx[i]--;
		vy[i]--;
	}

        for (i=0; i<n; ++i)
                for (j=i+1; j<n; ++j)
		{
                        for (k=0; k<m; ++k)
	 		{
                                mm=min (g[vx[k]][i] + g[j][vy[k]], g[vx[k]][j] + g[i][vy[k]]);
                                mm=min (mm, g[vx[k]][vy[k]]);
                                if (mm != vz[k])
                                        break;
 			}
                        if (k==m)
                                goto van;
 		}

van:
        fprintf (out, "%d %d\n", i+1, j+1);
        fclose (in); fclose (out);

	return 0;
}
