
(*
Croatia 2003
National Competition - Second day - Juniors
Problem JOKER, Programming language Pascal
*)

const
   MAX = 100000;

var n, k: integer;
    left, right: array[1..MAX] of integer;

procedure load;
   var x: Text;
       i: integer;
begin
   assign(x, 'joker.in');
   reset(x);
   readln(x, n, k);
   for i := 1 to k do
      readln(x, left[i], right[i]);
   close(x);
end;

procedure QSort(l, r: Integer);
var
  i, j, x, y: integer;
begin
  i := l; j := r; x := left[(l+r) DIV 2];
  repeat
    while left[i] > x do i := i + 1;
    while x > left[j] do j := j - 1;
    if i <= j then
    begin
      y := left[i]; left[i] := left[j]; left[j] := y;
      y := right[i]; right[i] := right[j]; right[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then QSort(l, j);
  if i < r then QSort(i, r);
end;

procedure output(ok: integer);
var i:integer;
    x: Text;
begin
   assign(x, 'joker.out');
   rewrite(x);
   if (ok = 1) then begin
      for i := 1 to k do
         writeln(x, left[i], ' ', right[i]);
   end
   else writeln(x, -1);
   close(x);
end;

function test: integer;
var i, j, s: integer;
begin
   j := n;
   s := 1;
   for i := 1 to k do begin
      if (right[i] > j) then s := 0;
      j := j - (right[i] - left[i] + 1);
   end;
   if (j <> 1) then s := 0;
   test := s;
end;

begin
load;
QSort(1, k);
output(test);
end.
