
(*
Croatia 2003
National Competition - Second day - Seniors
Problem JEZIK, Programming language Pascal
*)

const max_n = 10010;
var
         n: integer;
         was, queue: array[0..max_n] of integer;
         adj: array[0..max_n,0..max_n] of integer;
         h, t: integer;

procedure dodaj (l, v: integer);
begin
        inc(adj[l][0]);
        adj[l][adj[l][0]] := v;
end;

procedure read_input;
var
        s, ss: string;
        fp: text;
        p, v, code: integer;
begin

        assign(fp, 'jezik.in');
        reset(fp);

        n:=0;
        while (true) do
	begin
                readln(fp, s);
                if (s[1]='.') then break;

                p :=pos ('IDI', s);
                while (p <> 0) do
		begin
                        delete(s,1,p-1);
                        delete(s,1,4);
                        p := pos ('ILI', s);
                        if p<>0 then
                                ss := copy(s, 1, p - 2)
                        else
                                ss := s;
                        val(ss, v, code);
                        dodaj (n, v-1);
                end;

                if (pos ('RADI', s) <> 0) then
                        dodaj (n, n+1);
		inc(n);
	end;

        close (fp);
end;

procedure bfs;
var
    l, i: integer;
begin

        queue[h]:=0; inc(h); was[0]:=1;
	repeat
                l:=queue[t]; inc(t);
                for i := 1 to adj[l,0] do
		begin
                        if (was[adj[l,i]]=0) then
			begin
                                queue[h]:=adj[l,i]; inc(h);
                                was[adj[l,i]]:=1;
			end;
		end;
         until (h=t);
end;

function count:integer;
var
   c, i: integer;
begin
        c:=0;

        for i:=0 to n-1 do
                if (was[i]=0) then inc(c);
        count:=c;
end;

procedure write_output (c:integer);
var
        fp : text;
begin
        assign(fp, 'jezik.out');
        rewrite(fp);
        writeln(fp, c);
        close (fp);
end;

begin

	read_input;
	bfs;
	write_output(count);
end.
