
/*
Croatia 2003
Regional Competition - Juniors
Problem MO, Programming language C++
*/

#include <fstream>
#include <vector>

#define INFILE  "mo.in"
#define OUTFILE "mo.out"

using namespace std;

ifstream input(INFILE);
ofstream output(OUTFILE);

int n, m;
vector<int> ploca;

void igraj (int potez, int boja)
{
        /* postavlja se novi zeton */
        ploca[potez]=boja;

        /* uklanja se grupa lijevo od novog zetona (ako postoji) */
        int i=potez-1;
        while (i>=0 && ploca[i]==1-boja) i--;
        if (i>=0 && ploca[i]==boja)
           for (int j=i+1; j<potez; j++) ploca[j]=-1;

        /* uklanja se grupa desno od novog zetona (ako postoji) */
        i=potez+1;
        while (i<n && ploca[i]==1-boja) i++;
        if (i<n && ploca[i]==boja)
           for (int j=i-1; j>potez; j--) ploca[j]=-1;
}

int main (void)
{
        input >> n >> m;
        ploca=vector<int>(n, -1);

        for (int i=0; i<m; i++)
        {
                int potez;
                input >> potez;
                igraj(potez-1, i%2);
        }

        int bijeli=0;
        int crni=0;

        for (int i=0; i<n; i++)
            if (ploca[i]==0) bijeli++;
            else if (ploca[i]==1) crni++;

        output << bijeli << " " << crni << endl;

        input.close();
        output.close();
        return 0;
}
