
/*
Croatia 2003
Regional Competition - Juniors
Problem SPOJ, Programming language C
*/

#include <stdio.h>

#define INPUT_FILE  "spoj.in"
#define OUTPUT_FILE "spoj.out"

#define SEDAM_UJUTRO    7*60
#define SEDAM_NAVECER  19*60
#define SKUPA_MINUTA      10
#define JEFTINA_MINUTA     5

int main(void)
{
  int i;
  int broj_spajanja;
  int sat,minuta,trajanje;
  int pocetak,kraj;
  int broj_skupih_minuta,broj_jeftinih_minuta;
  FILE *file;

  file = fopen(INPUT_FILE,"r");
  fscanf(file,"%d",&broj_spajanja);
  broj_skupih_minuta = broj_jeftinih_minuta = 0;

  for (i = 0;i < broj_spajanja;++i)
  {
    fscanf(file,"%d:%d %d",&sat,&minuta,&trajanje);
    pocetak = 60 * sat + minuta;
    kraj = pocetak + trajanje;

    if (kraj <= SEDAM_UJUTRO)
    {
      broj_jeftinih_minuta += trajanje;
      continue;
    }
    if (pocetak < SEDAM_UJUTRO && kraj > SEDAM_UJUTRO)
    {
      broj_jeftinih_minuta += SEDAM_UJUTRO - pocetak;
      broj_skupih_minuta += kraj - SEDAM_UJUTRO;
      continue;
    }
    if (pocetak >= SEDAM_UJUTRO && kraj <= SEDAM_NAVECER)
    {
      broj_skupih_minuta += trajanje;
      continue;
    }
    if (pocetak < SEDAM_NAVECER && kraj > SEDAM_NAVECER)
    {
      broj_skupih_minuta += SEDAM_NAVECER - pocetak;
      broj_jeftinih_minuta += kraj - SEDAM_NAVECER;
      continue;
    }
    if (pocetak >= SEDAM_NAVECER)
    {
      broj_jeftinih_minuta += trajanje;
      continue;
    }
  }

  fclose(file);

  file = fopen(OUTPUT_FILE,"w");
  fprintf(file,"%d\n",broj_skupih_minuta * SKUPA_MINUTA +
                      broj_jeftinih_minuta * JEFTINA_MINUTA);
  fclose(file);

  return 0;
}
