
{
DMIH 2004 - Drugi dan natjecanja
Srednjoskolska skupina - II. podskupina
Zadatak MARS
}

{
   Ovaj zadatak rjesavamo dinamickim programiranjem.
   Dakle imamo dvije matrice N*N, pri cemu je N broj
   znakova koji ucitamo. Neka je prva matrica opt, a
   druga how. opt[i, j] nam govori koliko nam treba
   minimalno znakova za prikazati sve znakove izmedu
   i i j.how nam govori na koji nacin smo dobili taj
   minimalni broj znakova. Takoder imamo matricu a.
   Polje a[j, k] nam govori da li se niz od k znakova
   ponavlja do j polja( s="abbaabbaabba", sada ce na
   a[8, 4] biti 1 zato jer se ponavlja "abba").
   Pomocu matrice a i opt mozemo dobiti rjesenje te
   na kraju to rekonstruiramo i ispisemo rjesenje.
   Slozenost ovog algoritma je nesto vise od N*N, dakle
   O(N*N).
}

var n, i, j, k: integer;
    c: char;
    s: array[1..1000] of char;
    opt, a, how: array[1..1000, 1..1000] of integer;
    log10: array[1..1000] of integer;

procedure init;
var i, j, k, l: integer;
begin
   a[1, 1] := 1;
   for i := 2 to n do begin
       for j := 1 to i do begin
           l := 0;
           for k := i-j+1 to i do if (s[k] <> s[k-j]) then begin l := 1; break; end;
           if (l = 0) then a[i, j] := a[i-j, j] + 1 else a[i, j] := 1;
       end;
   end;
   for i := 1 to 9 do log10[i] := 1;
   for i := 10 to 99 do log10[i] := 2;
   for i := 100 to 999 do log10[i] := 3;
   log10[1000] := 4;
end;

procedure reconstruct(poc, kraj: integer);
var i: integer;
begin
   if (opt[poc, kraj] = kraj-poc+1) then begin
      for i := poc to kraj do write(s[i]);
   end else
   if (how[poc, kraj] > 1000) then begin
      write('(');
      reconstruct(poc, poc + how[poc, kraj]-1001);
      write(')', (kraj-poc+1) div (how[poc, kraj]-1000) );
   end else begin
       reconstruct(poc, how[poc, kraj]);
       reconstruct(how[poc, kraj]+1, kraj);
   end;
end;

begin

    n := 0;
    while ( not(eoln(input)) ) do begin
       read(c); n := n+1; s[n] := c;
    end;

    init;
    opt[1, 1] := 1;
    for i := 2 to n do begin
       opt[i, i] := 1;
       for j := i-1 downto 1 do begin
          opt[j, i] := i-j+1;
          for k := j to i-1 do
             if (opt[j, k] + opt[k+1, i] < opt[j, i]) then begin
                opt[j, i] := opt[j, k] + opt[k+1, i];
                how[j, i] := k;
             end;
          for k := 1 to ((i-j+1) div 2) do begin
              if ((k*a[i, k] >= i-j+1) and ((i-j+1) mod k = 0)) then

                if (opt[j, i] > opt[i-k+1, i]+2+log10[(i-j+1) div k]) then begin
                   opt[j, i] := opt[i-k+1, i]+2+log10[(i-j+1) div k];
                   how[j, i] := 1000 + k;
                end;

          end;
       end;
    end;

    reconstruct(1, n); writeln;

end.
