
/*
DMIH 2004 - Drugi dan natjecanja
Srednjoskolska skupina - II. podskupina
Zadatak NOVCI
*/

#include <cstdio>
#include <cstring>
#include <vector>

using namespace std;

int N, M;
vector<int> E[2000];

void input() {
  scanf( "%d%d", &N, &M );
  for( int t = 0; t < M; ++t ) {
    int i, j; char X[5], Y[5];
    scanf( "%d%s%d%s", &i, X, &j, Y );

    int a = (i-1)*2 + (X[0]=='P');
    int b = (j-1)*2 + (Y[0]=='P');

    E[a^1].push_back( b );
    E[b^1].push_back( a );
  }
}

char novci[1001], backup[1001];

bool kontradikcija( int x ) {
  int i = x >> 1;
  char c = (x&1)?'P':'G';
  if( novci[i] ) return novci[i] != c;
  novci[i] = c;

  for( vector<int>::iterator j = E[x].begin(); j != E[x].end(); ++j )
    if( kontradikcija( (*j) ) ) return true;
  return false;
}

int rijesi() {
  for( int i = 0; i < N; ++i ) {
    if( novci[i] ) continue;
    memcpy( backup, novci, N );
    if( !kontradikcija( (i<<1)   ) ) continue;
    memcpy( novci, backup, N );
    if( !kontradikcija( (i<<1)+1 ) ) continue;
    return 0;
  }
  return 1;
}

int main( void ) {
  input();
  if( !rijesi() ) printf( "-1\n" );
  else printf( "%s\n", novci );
  return 0;
}
