
/*
Zupanijsko natjecanje 2004
Srednjoskolska skupina - I. podskupina
Zadatak FUSNOTE - Programski jezik C
*/

#include <stdio.h>

#define MAX_REDAKA 1000
#define MAX_FUSNOTA 100

int redaka_u_knjizi,redaka_na_stranici;
int broj_fusnota;
struct {
         int broj_retka,duljina_fusnote;
       } fusnote[MAX_FUSNOTA];
int rjesenje;

void ucitaj(void)
{
  int i;

  scanf("%d%d%d",&redaka_u_knjizi,&redaka_na_stranici,&broj_fusnota);
  for (i = 0;i < broj_fusnota;++i)
    scanf("%d%d",&fusnote[i].broj_retka,&fusnote[i].duljina_fusnote);
}

void rijesi(void)
{
  int i;
  int na_strani;
  int reci[MAX_REDAKA];

  for (i = 0;i < redaka_u_knjizi;++i)
    reci[i] = 1;
  for (i = 0;i < broj_fusnota;++i)
    reci[fusnote[i].broj_retka - 1] += fusnote[i].duljina_fusnote;

  rjesenje = 1;
  na_strani = 0;

  for (i = 0;i < redaka_u_knjizi;++i)
    if (na_strani + reci[i] <= redaka_na_stranici)
      na_strani += reci[i];
    else
    {
      ++rjesenje;
      na_strani = reci[i];
    }
}

void ispisi(void)
{
  printf("%d\n",rjesenje);
}

int main(void)
{
  ucitaj();
  rijesi();
  ispisi();

  return 0;
}
