
(*
    Zupanijsko natjecanje 2004 / 1. podskupina
    3. zadatak - HAKER
    Rjesenje napisao Ivan Sikiric (isikiric@hotmail.com)

Opis algoritma:
Kako je broj simpatija najvise 5, broj razlicitih redaka je 5*5=25.
Retke koji se ponavljaju ne moramo promatrati.
Do rjesenja dolazimo isprobavanjem svih mogucnosti.
*)

program haker;
const MAX = 100;
type rijec = string[16];
var sifre  : array[1..MAX] of rijec;
    ime    : array[1..5] of rijec;
    rj_ime : array[1..5] of rijec;
    ime1, ime2 : rijec;
    n, i, num, rj_num : longint;

// po potrebi dodaje ime1 i ime2 na popis simpatija
// i vraca broj dodanih simpatija. ako nije moguce dodati
// neko ime, onda funkcija vraca -1
function dodaj : longint;
var i, p1, p2 : longint;
begin
    if ime1=ime2 then dodaj:=-1 else
    if (length(ime1)<3)or(length(ime1)>8)or(length(ime2)<3)or(length(ime2)>8)
    then dodaj:=-1 else
    begin
        p1:=1; p2:=1;
        for i := 1 to num do if ime[i]=ime1 then p1:=0;
        for i := 1 to num do if ime[i]=ime2 then p2:=0;
        if ime1=ime2 then p2:=0;
        if num+p1+p2 > 5 then dodaj:=-1 else
        begin
            if p1=1 then
            begin
                num:=num+1;
                ime[num]:=ime1;
            end;
            if p2=1 then
            begin
                num:=num+1;
                ime[num]:=ime2;
            end;
            dodaj:=p1+p2;
        end;
    end;
end;

procedure rek(r : longint);
var i, j : longint;
begin
    if num>=rj_num then exit;
    if (r>n) then
    begin
        if num>1 then
        begin
            rj_num:=num;
            for i:=1 to num do rj_ime[i]:=ime[i];
        end;
        exit;
    end;
    for i:=1 to r-1 do if sifre[i]=sifre[r] then
    begin
        rek(r+1);
        exit;
    end;
    for i:=1 to length(sifre[r]) do
    begin
        ime1 := copy(sifre[r], 1, i);
        ime2 := copy(sifre[r], i+1, length(sifre[r]));
        j:=dodaj;
        if j>=0 then
        begin
            rek(r+1);
            num:=num-j;
        end;
    end;
end;

procedure sortiraj;
var i, j : longint;
begin
    for i:=1 to rj_num-1 do
        for j:=i+1 to rj_num do
        begin
            if rj_ime[i]>rj_ime[j] then
            begin
                ime1:=rj_ime[i];
                rj_ime[i]:=rj_ime[j];
                rj_ime[j]:=ime1;
            end;
        end;
end;

begin
    readln(n);
    for i:=1 to n do readln(sifre[i]);
    rj_num := 6;
    num := 0;
    rek(1);
    sortiraj;
    writeln(rj_num);
    for i:=1 to rj_num do writeln(rj_ime[i]);
end.
