
/*
    Zupanijsko natjecanje 2004. / 1. podskupina
    4. zadatak - HUGO
    Rjesenje napisao Luka Kalinovcic (kalinov@mioc.hr)
*/

#include <cstdio>
#include <queue>
#include <vector>
#define INF 1000000000

using namespace std;

int n, rez = 0;
vector< queue<int> > jabuke;
int zadnja = 0;

int main( void ) {
  scanf( "%d", &n );
  jabuke.resize(n+1);

  for( int i = 1; i <= n; ++i ) {
    int m; scanf( "%d", &m );
    for( int j = 0; j < m; ++j ) {
      int x; scanf( "%d", &x );
      jabuke[i].push( x );
      zadnja >?= x;
    }
    jabuke[i].push( INF );
  }

  vector<int> curr_sec = vector<int>( n+2, -INF );
  curr_sec[(n+1)/2] = 0;

  for( int sec = 1; sec <= zadnja; ++sec ) {

    vector<int> next_sec = vector<int>( n+2, -INF );

    for( int i = 1; i <= n; ++i ) {
      if( jabuke[i].front() == sec ) { curr_sec[i]++; jabuke[i].pop(); }
      next_sec[i-1] >?= curr_sec[i];
      next_sec[i  ] >?= curr_sec[i];
      next_sec[i+1] >?= curr_sec[i];
      rez >?= curr_sec[i];
    }
    curr_sec = next_sec;
  }

  printf( "%d\n", rez );
  return 0;
}
