
(*
    Zupanijsko natjecanje 2004 / 2. podskupina
    1. zadatak - GUSJENICA
    Rjesenje napisao Ivan Sikiric (isikiric@hotmail.com)

Opis algoritma:
Gusjenica jede naizmjenice jedan redak pa jedan stupac i pri tome mora
skretati. Pojela je cijelu cokoladu ako je pojela sve retke ili sve stupce.
Mozemo smanjivati broj redaka i stupaca za jedan i brojati skretanja dok ne
pojedemo cijelu cokoladu, ali postoji bolje rjesenje:
1) Ako je broj redaka manji ili jednak broju stupaca, znaci da ce retke
pojesti prije od stupaca. Izmedju svaka dva pojedena retka, ona ce
skrenuti 2 puta.
Broj skretanja je: (m-1)*2
2) Ako je broj redaka veci od broja stupaca, znaci da ce stupce pojesti prije
od redaka. Nakon sto pojede prvi redak, ona mora skrenuti, a nakon toga
izmedju svaka dva pojedena stupca skrene 2 puta.
Broj skretanja je: 1+(n-1)*2
*)

program gus;
var m, n, rj : longint;

begin
    readln(m, n);

    if m<=n then rj:=(m-1)*2 else rj:=1+(n-1)*2;

    writeln(rj);

(*  RJESENJE POSTUPNIM BROJANJEM:
    rj:=0;
    repeat
       m:=m-1;
       if m=0 then break;
       rj:=rj+1;
       n:=n-1;
       if n=0 then break;
       rj:=rj+1;
    until false;
    writeln(rj);
*)

end.
