
(*
    Zupanijsko natjecanje 2004 / 2. podskupina
    2. zadatak - NIZ
    Rjesenje napisao Ivan Sikiric (isikiric@hotmail.com)

Opis algoritma:
Prvo generiramo dio niza za prvih n prirodnih brojeva.
Broj n se sigurno nalazi na kraju tog niza, pitanje je da li se pojavljuje
i ranije. Jednostavnim pretrazivanjem cijelog dijela niza nalazimo
trazenu poziciju prvog pojavljivanja.
*)

program brojniz;
const MAX = 100000;
var n, rj, i : longint;
    niz  : array[1..5*MAX] of byte;     //niz[i]=i-ti clan niza
    broj : array[1..6] of byte;         //broj[i]=i-ta znamenka broja n
    lniz, lbroj : longint;              //duljine niza i broja

//dodaj broj "br" na poziciju "pos" u nizu "nz"
//i povecaj "pos" za broj znamenki od "br"
procedure dodaj(br : longint; var pos : longint; var nz : array of byte);
var k : longint;
begin
    k := MAX;
    while k>=1 do
    begin
        if (br>=k)or(k=1) then
        begin
           (* bitno je uociti da nz pocinje od nule, tj. niz[1]=nz[0] *)
           nz[pos] := (br div k) mod 10;
           pos := pos + 1;
        end;
        k:=k div 10;
    end;
end;

//da li se broj n nalazi na poziciji "p" u nizu
function nasao(p : longint) : boolean;
var i : longint;
begin
    nasao := false;
    for i:=p to p+lbroj-1 do
       if niz[i]<>broj[i-p+1] then exit;
    nasao := true;
end;

begin
    readln(n);

    //generiramo dio niza:
    lniz := 0;
    for i:=1 to n do dodaj(i, lniz, niz);
    //rastavimo broj n na znamenke:
    lbroj := 0;
    dodaj(n, lbroj, broj);

    //pretrazivanje:
    for i:=1 to lniz-lbroj+1 do
        if nasao(i) then
        begin
            rj := i;
            break;
        end;

    writeln(rj);
end.
