
(*
  Croatia 2005 / National Competition #2 / Juniors
  Problem NOGOMET

  Definiramo rekurzivnu funkciju za sortiranje jedne podlige, po pravilima u
  zadatku (vidi funkciju moj_sort sa komentarima).
  Rjesenje dobijemo pozivanjem te funkcije za cijelu ligu.
*)

program nogomet;

const MAXN = 100;
      MAXM = 1000;

type Tutakmica = record
         a, b, c, d : longint;
     end;
type Tmomcad = record
         liga, bodovi, golraz, golovi, pobjede : longint;
     end;

var n, m, next : longint;
    poredak    : array[1..MAXN] of longint;
    momcad     : array[1..MAXN] of Tmomcad;
    u          : array[1..MAXM] of Tutakmica;

procedure rijesi(lu, ru, lp, rp, liga : longint);
var i, j, ma, mb, boda, bodb, max, ukupno : longint;
    nova : boolean;
procedure swap(var a, b : Tutakmica);
var temp : Tutakmica;
begin
   temp:=a;
   a:=b;
   b:=temp;
end;
begin
   next:=liga+1;
   for i:=lu to ru do
   begin
      ma:=u[i].a;
      mb:=u[i].b;
      if u[i].c>u[i].d then
      begin
         boda:=3; bodb:=0;
      end else
      if u[i].c<u[i].d then
      begin
         boda:=0; bodb:=3;
      end else
      begin
         boda:=1; bodb:=1;
      end;
      momcad[ma].bodovi:=momcad[ma].bodovi+boda;
      momcad[mb].bodovi:=momcad[mb].bodovi+bodb;
   end;
   max:=-1;
   for i:=1 to n do if (momcad[i].liga=liga)and(momcad[i].bodovi>max)
      then max:=momcad[i].bodovi;
   nova:=false;
   for i:=1 to n do if (momcad[i].liga=liga)and(momcad[i].bodovi<>max)
      then nova:=true;
   if nova then repeat
      max:=-1;
      for i:=1 to n do if (momcad[i].liga=liga)and(momcad[i].bodovi>max)
         then max:=momcad[i].bodovi;
      if max=-1 then break;
      ukupno:=0;
      for i:=1 to n do if (momcad[i].liga=liga)and(momcad[i].bodovi=max) then
      begin
          ukupno:=ukupno+1;
          j:=i;
          momcad[i].liga:=next;
          momcad[i].bodovi:=0;
      end;
      if ukupno=1 then
      begin
         poredak[lp]:=j;
         momcad[j].liga:=-1;
      end else
      begin
         j:=lu;
         for i:=lu to ru do
            if (momcad[u[i].a].liga=next)and(momcad[u[i].b].liga=next) then
            begin
               swap(u[i], u[j]);
               j:=j+1;
            end;
         rijesi(lu, j-1, lp, lp+ukupno-1, next);
         lu:=j;
      end;
      lp:=lp+ukupno;
   until false else while lp<=rp do
   begin
      max:=-1;
      for i:=1 to n do if momcad[i].liga=liga then
      begin
         if max=-1 then max:=i;
         if momcad[i].bodovi>momcad[max].bodovi then max:=i;
         if momcad[i].bodovi<momcad[max].bodovi then continue;
         if momcad[i].golraz>momcad[max].golraz then max:=i;
         if momcad[i].golraz<momcad[max].golraz then continue;
         if momcad[i].golovi>momcad[max].golovi then max:=i;
         if momcad[i].golovi<momcad[max].golovi then continue;
         if momcad[i].pobjede>momcad[max].pobjede then max:=i;
      end;
      poredak[lp]:=max;
      momcad[max].liga:=-1;
      lp:=lp+1;
   end;
end;

procedure ucitaj;
var i, a, b : longint;
    c, d, z : char;
begin
   readln(n, m);
   for i:=1 to n do
   begin
      momcad[i].liga:=1;
      momcad[i].bodovi:=0;
      momcad[i].golraz:=0;
      momcad[i].golovi:=0;
      momcad[i].pobjede:=0;
   end;
   for i:=1 to m do
   begin
      readln(a, b, z, c, z, d);
      u[i].a:=a;
      u[i].b:=b;
      u[i].c:=ord(c)-ord('0');
      u[i].d:=ord(d)-ord('0');
      momcad[a].golraz:=momcad[a].golraz+u[i].c-u[i].d;
      momcad[b].golraz:=momcad[b].golraz+u[i].d-u[i].c;
      momcad[a].golovi:=momcad[a].golovi+u[i].c;
      momcad[b].golovi:=momcad[b].golovi+u[i].d;
      if c>d then momcad[a].pobjede:=momcad[a].pobjede+1;
      if d>c then momcad[b].pobjede:=momcad[b].pobjede+1;
   end;
end;
procedure zapisi;
var i : longint;
begin
   for i:=1 to n-1 do write(poredak[i], ' ');
   writeln(poredak[n]);
end;
begin
   ucitaj;
   rijesi(1, m, 1, n, 1);
   zapisi;
end.
