
{
  DMIH 2006 - Prvi dan natjecanja
  Srednjoskolska skupina - I. podskupina
  Zadatak TURBO

  Zadatak mozemo rijesiti eksplicitnom konstrukcijom ciklusa u pomocni
  niz pri svakom prvom pritisku tipke T u nizu. Daljnjim pritiscima na
  T ispisuju se brojevi iz konstruiranog ciklusa.

  Vremenska slozenost je O(N^2), jer konstrukcija ciklusa traje O(N).
}

program turbo;

const MAXK = 100;
const MAXN = 10000;

var
   buff : string;
   vec_bio : array[1..MAXK] of boolean;
   n, i, j : integer;
   niz : array[1..MAXN+1] of integer;
   sad : integer;
   ciklus : array[1..MAXN] of integer;
   nciklus : integer;
   gdje : integer;
   errcode : integer;

begin
   readln( n );

   i := 1;
   while i <= n do begin
      readln( buff );

      if buff = 'T' then begin
         { ulazimo u turbo-salt mod, nadi zadnje pojavljivanje kanala
           niz[i-1], ili postavi pocetak ciklusa na prvi odabran program }

         sad := i-1;
         while (sad > 1) and (niz[sad-1] <> niz[i-1]) do sad := sad - 1;

         for j := 1 to MAXK do vec_bio[j] := false;

         { konstruiraj ciklus }
         nciklus := 0;
         while sad < i do begin
            if vec_bio[ niz[sad] ] = false then begin

               nciklus := nciklus + 1;
               ciklus[nciklus] := niz[sad];

            end;

            vec_bio[ niz[sad] ] := true;

            sad := sad + 1;
         end;

         { dok se ucitava T, ispisuj brojeve iz konstruiranog ciklusa }
         gdje := 1;
         while buff = 'T' do begin

            niz[i] := ciklus[gdje];
            writeln( ciklus[gdje] );

            gdje := gdje + 1;
            if gdje > nciklus then gdje := 1;

            i := i + 1;
            if i > n then break;
            readln( buff );
         end;
      end;

      val( buff, niz[i], errcode );
      i := i + 1;
   end;

end.
