
/*
  DMIH 2006 - Prvi dan natjecanja
  Srednjoskolska skupina - II. podskupina
  Zadatak PETICE

  Iduci s desna na lijevo povecavamo odgovarajucu znamenku za 1 sve dok ne
  postignemo dovoljan broj petica u broju. Kada trenutna znamenka postane petica
  prelazimo na slijedecu znamenku.
*/

#include <cstdio>

using namespace std;

typedef long long llint;

int petica( llint x ) {
   if( x == 0 ) return 0;
   return (x%10==5) + petica(x/10);
}

int main( void ) {
   llint n;
   int k;
   scanf( "%lld%d", &n, &k );
   ++n;

   llint potencija = 1;
   for( ;; ) {
      if( petica(n) >= k ) break;
      while( (n/potencija)%10 == 5 ) potencija *= 10;
      n += potencija;
   }
   printf( "%lld\n", n );

   return 0;
}
