
{
  DMIH 2006 - Prvi dan natjecanja
  Srednjoskolska skupina - II. podskupina
  Zadatak PRUGE

  Zadatak se moze rjesiti na puno nacina, ovdje cemo opisati vjerojatno
  najjednostavnije koje radi unutar zadanih ogranicenja.

  Uzorak na slici mozemo rastaviti na 3 jednostavna djela:

  A) Dio ispod dijagonale ( x > y )
  B) Dio iznad dijagonale ( y > x )
  C) Dijagonala ( x = y )

  Kako je ogranicenje na koordinate pravokutnika dovoljno malo dio ispod
  dijagonale mozemo izracunati tako da za svaku neparnu x koodrinatu izmedju
  x1 i x2 izracunamo visinu stupca.
  Analogno racunamo dio iznad dijagonale, dok je dio na samoj dijagonali
  trivijalno izracunati.
}

program pruge;

var
   x1, y1, x2, y2 : longint;
   x, y, i : longint;
   broj : int64;

function min( a, b : longint ) : longint;
begin
   if a < b then min := a else min := b;
end;
function max( a, b : longint ) : longint;
begin
   if a > b then max := a else max := b;
end;

begin
   readln( x1, y1, x2, y2 );

   broj := 0;

   { Racunamo dio ispod dijagonale }
   for x := x1 to x2-1 do
      if x mod 2 = 1 then
         broj := broj + min(y2, x) - min(y1, x);

   { Racunamo dio iznad dijagonale }
   for y := y1 to y2-1 do
      if y mod 2 = 1 then
         broj := broj + min(x2, y) - min(x1, y);


   { Racunamo dio na dijagonali }
   for i := max(x1, y1) to min(x2, y2)-1 do
      if i mod 2 = 1 then
         broj := broj + 1;

   writeln( broj );
end.
