
/*
  Zupanijsko natjecanje 2006 - Srednjoskolska skupina - I. podskupina
  Zadatak TUNEL
  Rjesenje napisali: Ante Derek, Luka Kalinovcic, Lovro Puzar

  Opis algoritma:

  Ako postoji put kroz tunel, onda za svaki vodoravni brid mora
  vrijediti da je njegova y koordinata manja od y koordinata
  prethodnog, trenutnog i sljedeceg segmenta stropa, odnosno veca
  od y koordinata prethodnog, trenutnog i sljedeceg segmenta poda.
  Kako bi dobili najkraci put, potrebno je u svakom koraku izabrati
  y koji zadovoljava gornji kriterij i koji je sto je manje moguce
  udaljen od y-a prethodnog segmenta na putu.
*/

#include <stdio.h>

#define MAX 100000

int n;
int ys[MAX];
int yp[MAX];

void citaj_ulaz (void)
{
        int i;

        scanf("%d", &n);
        for (i=0; i<n; i++)
                scanf("%d", &ys[i]);
        for (i=0; i<n; i++)
                scanf("%d", &yp[i]);
}

void rijesi (void)
{
        int i;
        int y=0;

        for (i=0; i<n-1; i++)
        {
                if (y>=ys[i+1]) y=ys[i+1]-1;
                if (y<=yp[i+1]) y=yp[i+1]+1;
                printf("%d ", y);
        }
        printf("0\n");
}

int main (void)
{
        citaj_ulaz();
        rijesi();

        return 0;
}
