(*
  Drzavno natjecanje 2007, srednjoskolska skupina - 1. podskupina
  1. dan natjecanja
  Zadatak GULIVER
*)

const
   MAXR   = 1000;
   MAXS   = 1000;
   MAXQ   = MAXR * MAXS;
   PRAZNO = '#';
   PUNO   = '.';

var
   mapa   : array[1..MAXR, 1..MAXS] of char;
   dalj   : array[1..MAXR, 1..MAXS] of longint;
   r, s   : longint;
   qr, qs : array[0..MAXQ] of longint;
   qp, qk : longint;
   
procedure push(r, s : longint);
begin
   qr[qp] := r;
   qs[qp] := s;
   qp := (qp + 1) mod MAXQ;
end;
procedure push_front(r, s : longint);
begin
   qk := (qk + MAXQ - 1) mod MAXQ;
   qr[qk]:=r;
   qs[qk]:=s;
end;
procedure pop(var r, s : longint);
begin
   r := qr[qk];
   s := qs[qk];
   qk := (qk + 1) mod MAXQ;
end;

function bfs : longint;
const
   dx : array[1..8] of longint = (1, 1, 1, 0, -1, -1, -1, 0);
   dy : array[1..8] of longint = (-1, 0, 1, 1, 1, 0, -1, -1);
var
   x, y, i, j, ret : longint; 
   procedure put(yn, xn: longint);
   begin
      if (xn<1)or(xn>s)or(yn<=1)or(yn>=r) then exit;
      if dalj[yn, xn]>=0 then exit;   
      if mapa[yn, xn]=PUNO then
      begin
         dalj[yn, xn] := dalj[y, x] + 1;
         push(yn, xn);
      end else
      begin
         dalj[yn, xn] := dalj[y, x];
         push_front(yn, xn);
      end;
   end;
begin
   qk := 0;
   qp := 0;
   for i:=1 to r do 
      for j:=1 to s do dalj[i, j] := -1;
   for i:=2 to r-1 do
      if mapa[i, 1]=PRAZNO then
      begin
         dalj[i, 1]:=0;
         push_front(i, 1);
      end else
      begin
         dalj[i, 1]:=1;
         push(i, 1);
      end;
   while qp<>qk do
   begin
      pop(y, x);
      for i:=1 to 8 do put(y+dy[i], x+dx[i]);
   end;
   ret := dalj[2, s];
   for i:=3 to r-1 do if dalj[i, s]<ret then ret:=dalj[i, s];
   bfs := ret;
end;

procedure ucitaj;
var i, j : longint;
begin
   readln(r, s);
   for i:=1 to r do
   begin
      for j:=1 to s do read(mapa[i, j]);
      readln;
   end;
end;

begin
   ucitaj;
   writeln(bfs);
end.
