/*
  Drzavno natjecanje 2007, srednjoskolska skupina - 2. podskupina
  1. dan natjecanja
  Zadatak OGRADA
*/

#include <algorithm>
#include <cstdio>
#include <set>
using namespace std;

#define MAXN 100005

static int h1[MAXN+1];
static int h2[MAXN], c2[MAXN];

struct cmp1 {
   bool operator()( int a, int b ) const {
      if ( h1[a] != h1[b] ) return h1[a] < h1[b];
      return a < b;
   }
};

struct cmp2 {
   bool operator()( int a, int b ) const {
      if ( c2[a] != c2[b] ) return c2[a] > c2[b];
      return a < b;
   }
};

int main()
{
   int n;

   set<int, cmp1> p1;
   static int p2[MAXN];
   scanf( "%d", &n );
   for ( int i=0; i<n; ++i ) {
      scanf( "%d", &h1[i] );
      p1.insert( i );
   }

   for ( int i=0; i<n; ++i ) {
      scanf( "%d%d", &h2[i], &c2[i] );
      p2[i] = i;
   }

   sort( p2, p2+n, cmp2() );

   int ret = 0;
   static int perm[MAXN];
   for ( int i=0; i<n; ++i ) {
      h1[n] = h2[ p2[i] ];
      set<int, cmp1>::const_iterator p = p1.upper_bound( n );
      
      // Pokusavam naci dasku nizu od trenutne Leine
      if ( p != p1.begin() ) {
         // Uspio sam, zaradujem
         --p;
         perm[*p] = p2[i]+1;
         p1.erase( p );
         ret += c2[ p2[i] ];
      }
      else {
         // Nisam uspio, stavljam ispred najvise Slavkove
         p = p1.end();
         --p;
         perm[*p] = p2[i]+1;
         p1.erase( p );
      }
   }

   printf( "%d\n", ret );
   for ( int i=0; i<n; ++i ) {
      if ( i > 0 ) printf( " " );
      printf( "%d", perm[i] );
   }
   printf( "\n" );

   return 0;
}
