(*
  Drzavno natjecanje 2007, srednjoskolska skupina - 2. podskupina
  2. dan natjecanja
  Zadatak LIJEN
*)

const
	inf = 1000000000;

type
	rijec = record duljina, binarniZapis : longint; end;

var
	brojJedinica : array[0..4095] of longint;
	vrijeme : array[0..12, 0..4095] of longint;
	dvaNa : array[0..12] of longint;
	N, L, i, cost, rjesenje, razlika, best_razlika, best_koji, best_koliko : longint;
	rjecnik : array[0..2000] of rijec;
	p : rijec;
	buff : string;

begin
	dvaNa[0] := 1;
	for i := 1 to 12 do
		dvaNa[i] := 2 * dvaNa[i-1];

	brojJedinica[0] := 0;
	for i := 0 to 4095 do
		if (i mod 2 = 1) then
			brojJedinica[i] := 1 + brojJedinica[i div 2]
		else
			brojJedinica[i] := brojJedinica[i div 2];

	readln (N);

	{ ucitavanje i spremanje rijeci u rjecnik }
	for i := 0 to N-1 do
	begin
		readln (buff);
		p.duljina := 0; p.binarniZapis := 0;

		while (p.duljina < length(buff)) do
		begin
			if (buff[p.duljina+1] = '.') then
				p.binarniZapis := 2 * p.binarniZapis
			else
				p.binarniZapis := 2 * p.binarniZapis + 1;

			inc (p.duljina);
		end;

		vrijeme[p.duljina, p.binarniZapis] := inf;
		rjecnik[i] := p;
	end;

	{ gledamo sve moguce rijeci p (tj. njihove bin.zapise) duljine <=12 znakova }
	for p.duljina := 1 to 12 do
		for p.binarniZapis := 0 to dvaNa[p.duljina] - 1 do
		begin
			{ cijena samo rijeci p }
			cost := p.duljina + brojJedinica[p.binarniZapis];

			best_razlika := inf; best_koji := -1; best_koliko := 0;
			for i := 0 to N-1 do { gledamo sve rijeci iz rjecnika }
			begin
				if (p.duljina <> rjecnik[i].duljina) then continue;

				{ u koliko se bin. znamenki razlikuje rjecnik[i] od p? }
				razlika := brojJedinica[p.binarniZapis xor rjecnik[i].binarniZapis];
				if (razlika < best_razlika) then
				begin
					best_razlika := razlika;
					best_koji := i;
					best_koliko := 1;
				end
				else if (razlika = best_razlika) then
					inc(best_koliko); // koliko ima rijeci koje se razlikuju u tocno toliko bin.znamenki
			end;

			// moze li se p jednoznacno dekodirati u neku rijec iz rjecnika i je li p najbolja dosad za tu rijec?
			if ((best_koliko = 1) and (cost < vrijeme[rjecnik[best_koji].duljina, rjecnik[best_koji].binarniZapis])) then
				vrijeme[rjecnik[best_koji].duljina, rjecnik[best_koji].binarniZapis] := cost;
		end;

	{ duljina trajanja slanja poruke = suma duljine trajanja slanja svake njezine rijeci }
	rjesenje := 0;
	readln (L);
	for i := 0 to L-1 do
	begin
		readln (buff);

		p.duljina := 0; p.binarniZapis := 0;

		while (p.duljina < length(buff)) do
		begin
			if (buff[p.duljina+1] = '.') then
				p.binarniZapis := 2 * p.binarniZapis
			else
				p.binarniZapis := 2 * p.binarniZapis + 1;

			inc (p.duljina);
		end;

		rjesenje := rjesenje + vrijeme[p.duljina, p.binarniZapis];
	end;

	writeln (rjesenje);
end.
