(*
  Drzavno natjecanje 2007, srednjoskolska skupina - 2. podskupina
  2. dan natjecanja
  Zadatak MRAVOGRAD
*)

program mravograd;

const MAX = 10;
const POW2MAX = 1024;

var
   R, S, n : longint;
   rr, ss  : array[0..MAX-1] of longint;
   bitova  : array[0..POW2MAX-1]  of longint;
   i, mask : longint;

function dist( r1, s1, r2, s2 : longint ) : longint;
begin
   dist := abs(r1-r2) + abs(s1-s2);
end;

function f( r, s : longint ) : longint;
var
   mini, mask, i, d : longint;
begin
   mini := 1000000000;
   mask := 0;
   for i := 0 to n-1 do begin
      d := dist( r, s, rr[i], ss[i] );
      if d < mini then begin
         mini := d;
         mask := 0;
      end;
      if d = mini then begin
         mask := mask + (1 shl i);
      end;
   end;
   f := mask;
end;

function rec( r1, s1, r2, s2 : longint ) : longint;
var
   mask, r, s : longint;
begin
   if (r1 > r2) or (s1 > s2) then begin
      rec := 0;
   end else begin

      mask := f(r1,s1);
      if ((r1=r2) and (s1=s2)) or (mask=f(r2,s2)) and (mask=f(r1,s2)) and (mask=f(r2,s1)) then begin
         if bitova[mask] > 1 then
            rec := (r2-r1+1)*(s2-s1+1)
         else
            rec := 0;
      end else begin
         r := (r1+r2) div 2;
         s := (s1+s2) div 2;
         rec := rec(r1,s1,r,s) + rec(r+1,s1,r2,s) + rec(r1,s+1,r,s2) + rec(r+1,s+1,r2,s2);
      end;
   end;
end;

begin
   readln( R, S );
   readln( n );
   for i := 0 to n-1 do readln( rr[i], ss[i] );

   bitova[0] := 0;
   for mask := 1 to (1 shl n) do begin
      bitova[mask] := bitova[mask shr 1];
      if mask mod 2 = 1 then bitova[mask] := bitova[mask] + 1;
   end;

   writeln( rec( 1, 1, R, S ) );
end.
