
/*
  Zupanijsko natjecanje 2007
  Srednjoskolska skupina - 1. podskupina
  Zadatak CRTALO
  Programski jezik C++
*/

#include <cstdio>

using namespace std;

char znak[4] = { '.', '-', '|', '+' };

int a[10][10];

int main( void ) {
   int n;
   scanf( "%d", &n );
   for( int r = 0; r < n; ++r )
      for( int s = 0; s < n; ++s )
         a[r][s] = 0;

   int r = 0, s = 0;
   char c;

   while( scanf( "%c", &c ) == 1 ) {
      int r2 = r, s2 = s, x = 0;

      if( c == 'L' ) { s2--; x = 1; }
      if( c == 'R' ) { s2++; x = 1; }
      if( c == 'U' ) { r2--; x = 2; }
      if( c == 'D' ) { r2++; x = 2; }

      if( r2 < 0 || r2 >= n || s2 < 0 || s2 >= n ) continue;

      a[r][s] |= x;
      a[r2][s2] |= x;

      r = r2; s = s2;
   }

   for( int r = 0; r < n; ++r ) {
      for( int s = 0; s < n; ++s )
         printf( "%c", znak[a[r][s]] );
      printf( "\n" );
   }

   return 0;
}
