#include <cstdio>

int n, m;
char znamenke[10];
int lijevo[1000000];
int desno[1000000];

void generiraj( int i, int ostatak ) {
   if( 2*i < n ) {
      for( znamenke[i] = 0; znamenke[i] < 10; ++znamenke[i] )
         generiraj( i+1, (ostatak*10 + znamenke[i]) % m );
   } else if( i < n ) {
      znamenke[i] = znamenke[n-i-1];
      generiraj( i+1, (ostatak*10 + znamenke[i]) % m );
   } else {
      if( znamenke[0] != 0 ) lijevo[ostatak] += 1;
      desno[ostatak] += 1;
   }
}

int main( void ) {
   scanf( "%d%d", &n, &m ); n /= 2;
   
   generiraj( 0, 0 );

   long long ret = 0;
   for( int L = 0; L < m; ++L ) {
      int D = m-L;
      for( int i = 0; i < n; ++i ) D = (D*10) % m;

      ret += (long long)lijevo[L] * desno[D];
   }
   
   printf( "%lld\n", ret );

   return 0;
}
