#include <cstdio>
#include <cstring>

int n, m;
char kod[1024];
char dio[1024];
char kljuc[1024];
char original[1024];

char encode( char a, char b ) { return (a + b) % 26; }
char decode( char c, char b ) { return (c - b + 26) % 26; }

int main( void ) {
   gets( kod ); n = strlen( kod ); for( int i = 0; i < n; ++i ) kod[i] -= 'a';
   gets( dio ); m = strlen( dio ); for( int i = 0; i < m; ++i ) dio[i] -= 'a';

   for( int start = 0; start + m <= n; ++start ) {
      for( int i = 0; i < m; ++i ) {
         original[start+i] = dio[i];
         kljuc[start+i] = decode( kod[start+i], original[start+i] );
      }
      
      for( int k = 1; 2*k <= m; ++k ) {
         int ok = 1;
         for( int i = start; i+k < start + m; ++i )
            if( kljuc[i] != kljuc[i+k] )
               ok = 0;
         
         if( !ok ) continue;

         for( int i = start; i < start+k; ++i )
            for( int j = i%k; j < n; j += k )
               kljuc[j] = kljuc[i];
         
         for( int i = 0; i < n; ++i )
            original[i] = decode( kod[i], kljuc[i] ) + 'a';

         printf( "%s\n", original );
         return 0;
      }
   }

   printf( "???\n" );
   return 0;
}
