#include <cstdio>

int broj_slova;
char postoji[26];
char recenica[101];

int najbolje;
char rjesenje[27];

int next( int i ) { return i == 25 ? 0 : i+1; }
int prev( int i ) { return i == 0 ? 25 : i-1; }

int main( void ) {
   gets( recenica );
   for( char *c = recenica; *c; ++c ) 
      if( *c >= 'A' && *c <= 'Z' ) postoji[*c-'A'] = 1;   

   broj_slova = 0;
   for( int i = 0; i < 26; ++i ) broj_slova += postoji[i];

   najbolje = 100;

   for( int A = 0, B; A < 26; ++A ) {
      if( !postoji[A] ) continue;
      for( B = next(A); !postoji[B]; B = next(B) );
      
      int naprijed, nazad;
      if( A < B ) {
         naprijed = 26-B + 26-(B-A) + broj_slova;
         nazad = A + 26-(B-A) + broj_slova;
      } else {
         naprijed = A + broj_slova;
         nazad = 26-B + broj_slova;
      }

      if( naprijed < najbolje ) {
         najbolje = naprijed;
         int k = 0, i = prev(B);
         do {
            i = next(i);
            if( postoji[i] ) rjesenje[k++] = i + 'A';
         } while( i != A );
      }         

      if( nazad < najbolje ) {
         najbolje = nazad;
         int k = 0, i = next(A);
         do {
            i = prev(i);
            if( postoji[i] ) rjesenje[k++] = i + 'A';
         } while( i != B );
      }
   }
   printf( "%d\n", najbolje );
   printf( "%s\n", rjesenje );
   
   return 0;
}
