#include <cstdio>

#define MAXR 10000
#define MAXS 500
#define BLOK 'x'

int R, S;
char mreza[MAXR][MAXS+1];

int proguraj( int red, int stupac ) {
   if( red < 0 || red >= R ) return 0;
   if( mreza[red][stupac] == BLOK ) return 0;
   mreza[red][stupac] = BLOK;
   if( stupac == S-1 ) return 1;

   if( proguraj( red-1, stupac+1 ) ) return 1;
   if( proguraj( red  , stupac+1 ) ) return 1;
   if( proguraj( red+1, stupac+1 ) ) return 1;
   return 0;
}

int main( void ) {
   scanf( "%d%d", &R, &S );
   for( int r = 0; r < R; ++r ) scanf( "%s", mreza[r] );
   
   int rez = 0;
   for( int r = 0; r < R; ++r ) rez += proguraj( r, 0 );
   printf( "%d\n", rez );
   
   return 0;
}
