program bager;

const
   MAXN = 1500;

var
   rows, columns, r, s, apples, bananas : longint;
   f, sum_apples, sum_bananas           : array[0..MAXN, 0..MAXN] of longint;
   tip                                    : char;

function max(a, b : longint) : longint; begin if a >= b then max := a else max := b; end;

begin
   read(rows, columns);
   for r:=1 to rows do begin
      for s:=1 to columns do begin
         repeat
            read(tip);
         until tip in ['A', 'B'];

         apples := 0; bananas := 0;
         if tip = 'A' then read(apples) else read(bananas);

         sum_apples[r, s] := sum_apples[r, s-1] + apples;
         sum_bananas[r, s] := sum_bananas[r-1, s] + bananas;
      end;
   end;

   for r:=rows downto 1 do begin
      for s:=columns downto 1 do begin
         f[r, s] := 0;
         if s < columns then
            f[r, s] := max(f[r, s], f[r, s+1] + sum_bananas[r-1, s+1]);
         if r < rows then
            f[r, s] := max(f[r, s], f[r+1, s] + sum_apples[r+1, s-1]);
         if (s < columns) and (r < rows) then
            f[r, s] := max(f[r, s], f[r+1, s+1] + sum_bananas[r, s+1] + sum_apples[r+1, s]);
      end;
   end;
   writeln(f[1, 1]);
end.
