#include <algorithm>
#include <cstdio>
#include <functional>
#include <map>
#include <vector>

using namespace std;

int n, m;

struct potencije {
   vector<int> p;
   potencije() { p = vector<int>( n, 0 ); }
};

map<int, potencije> rastav;

bool cmp( vector<int>::iterator a, vector<int>::iterator b ) { return *a > *b; }

void rijesi( vector<int> &a ) {
   vector< vector<int>::iterator > order;
   for( vector<int>::iterator it = a.begin(); it != a.end(); ++it ) order.push_back( it );

   for( ;; ) {
      sort( order.begin(), order.end(), cmp );
      if( *order[0] == 0 ) break;
      
      printf( "CLONE" );
      for( int i = 0; i < m; ++i ) 
         if( *order[i] > 0 ) {
            printf( " %d", order[i] - a.begin() + 1 );
            --*order[i];
         }
      printf( "\n" );
   }
}

int main( void ) {
   scanf( "%d", &n );
   for( int i = 0; i < n; ++i ) {
      int x;
      scanf( "%d", &x );
      
      for( int d = 2; d*d <= x; ++d ) 
         for( ; x%d == 0; x /= d ) 
            ++rastav[d].p[i];
      if( x > 1 ) ++rastav[x].p[i];
   }
   scanf( "%d", &m );
   
   for( map<int, potencije>::iterator it = rastav.begin(); it != rastav.end(); ++it ) {
      printf( "ENTER %d\n", it->first );
      rijesi( it->second.p );
   }

   return 0;
}
