{$H+}

program cenzura;

const
   MAXT = 300000;
   MAXA = 25;

type stack = object
   w    : string;
   lenw : longint;
   top  : longint;
   x    : array[1..MAXT+1] of char;

   procedure init(s : string);
   function push(c : char) : boolean;
   function pop : char;
end;                 

procedure stack.init(s : string);
begin
   w := s;
   lenw := length(w);
   top := 1;
end;

function stack.push(c : char) : boolean;
var
   ret : boolean;
   i   : longint;
begin
   ret := false;
   x[top] := c;
   top := top+1;
   if top > lenw then begin
      ret := true;
      for i:=1 to lenw do begin
         if x[top-lenw+i-1] <> w[i] then
            ret := false;
      end;
      if ret then top := top - lenw;
   end;
   push := ret;
end;

function stack.pop() : char;
begin
   top := top-1;
   pop := x[top];
end;

var
   T, A, rev           : string;
   L, D                : stack;
   i, turn, lpos, dpos : longint;

begin
   readln(A);
   readln(T);

   L.init(A);
   rev := A;
   for i:=1 to length(A) do rev[i] := A[length(A)-i+1];
   D.init(rev);

   turn := 0; lpos := 1; dpos := length(T);
   while lpos <= dpos do begin
      if turn = 0 then begin
         if L.push(T[lpos]) then
            turn := 1;
         lpos := lpos+1;
      end else begin
         if D.push(T[dpos]) then
            turn := 0;
         dpos := dpos-1;
      end;
   end;

   while L.top > 1 do D.push(L.pop);

   while D.top > 1 do write(D.pop);
   writeln;
end.
