//problema mexc
#include <stdio.h>
#include <string.h>
#define MAXC 900
#define MAXCAR 110000
#define MAXCOADA 1000000

typedef struct{ long x,y;} coor;
typedef coor coad[MAXCOADA];

FILE *f,*g;
long m,n,d;
long a[MAXC][MAXC],b[MAXC][MAXC],c[MAXC][MAXC];
long car[MAXCAR];
coad coada;


void citire(void)
{
	long i,j;
	fscanf(f,"%ld %ld %ld\n",&n,&m,&d);
	for(i=1;i<=n;i++)
		for(j=1;j<=m;j++)
			{
				fscanf(f,"%ld",&a[i][j]);
				b[i][j]=a[i][j]-d;
			}
	fscanf(f,"\n");
}

void seteaza(long x, long y)
{
	long i,j;
	for(i=1;i<=n;i++)
		for(j=1;j<=m;j++)
			if((i!=x)||(j!=y))
				{
					if(b[x][y]<=a[i][j])
						c[i][j]=1;
				}
}

long verifica(long x,long y)
{
	long i,j,contor=0,ic,sc;
	coor temp;
	ic=sc=1;
	memset(coada,0,MAXCOADA);
	coada[ic].x=x;
	coada[ic].y=y;
	while(ic<=sc)
		{
			temp=coada[ic];
			ic++;
			if((c[temp.x][temp.y]!=0)&&(a[temp.x][temp.y]>=a[x][y]))
				{
					contor++;
					c[temp.x][temp.y]=0;
				}
			if(c[temp.x-1][temp.y]==1)
				{
					coada[++sc].x=temp.x-1;
					coada[sc].y=temp.y;
				}
			if(c[temp.x][temp.y-1]==1)
				{
					coada[++sc].x=temp.x;
					coada[sc].y=temp.y-1;
				}
			if(c[temp.x+1][temp.y]==1)
				{
					coada[++sc].x=temp.x+1;
					coada[sc].y=temp.y;
				}
			if(c[temp.x][temp.y+1]==1)
				{
					coada[++sc].x=temp.x;
					coada[sc].y=temp.y+1;
				}
		}
	return contor;
}


void executa(void)
{
	long i,j;
	for(i=1;i<=n;i++)
		for(j=1;j<=m;j++)
			if(car[a[i][j]]==0)
				{
					memset(c,0,(MAXC+1)*(MAXC+1));
					c[i][j]=1;
					seteaza(i,j);
					car[a[i][j]]=verifica(i,j);
				}
}

void afiseaza(void)
{
	long i,j;
	for(i=1;i<=n;i++)
		{
			for(j=1;j<=m;j++)
				fprintf(g,"%ld ",car[a[i][j]]);
			fprintf(g,"\n");
		}
}

int main()
{
	f=fopen("mexc.in","r");
	g=fopen("mexc.out","w");
	citire();
	executa();
	afiseaza();
	fclose(f);   fclose(g);
	return 0;
}
