#include <stdio.h>
#include <vector>

using namespace std;

const int N_MAX = 2010;
const int T_MAX = 1010;

vector <int> G[N_MAX];

char a[N_MAX][T_MAX];
int timp[N_MAX], viz[N_MAX], mmsub[N_MAX][T_MAX], nrf[N_MAX];
short int mm[N_MAX][T_MAX];

int N, T;

void DF(int nod)
{
	vector <int>::iterator it;
	viz[nod] = 1;

	for (int pr = 1, tp = timp[nod]; pr <= G[nod].size(); ++ tp) {
		if (!a[nod][tp]) {

			int MAX = 0, MAXF = 0, care = 0, caref = 0;
			for (it = G[nod].begin(); it != G[nod].end(); ++ it) {
			
				if (!viz[*it] && mmsub[*it][tp + 1] > MAX) {
					MAX = mmsub[*it][tp + 1];
					care = *it;
				} else {
					if (!viz[*it] && mmsub[*it][tp + 1] == 0) {
						if (nrf[*it] > MAXF) {
							MAXF = nrf[*it];
							caref = *it;
						}
					}
				}
			}

			if (MAX) {
				pr ++;
				timp[care] = tp + 1;
				DF(care);
			} else {
				pr ++;
				timp[caref] = tp + 1;
				DF(caref);
			}
		}
	}
}			

void constr(int nod)
{
	viz[nod] = 1;
	vector <int>::iterator it;
	nrf[nod] = 1;

	for (int i = 0; i < T; i ++) {
		mmsub[nod][i] = mm[nod][i];
		for (it = G[nod].begin(); it != G[nod].end(); ++ it) {
			if (!viz[*it]) {
				constr(*it);
				mmsub[nod][i] += mmsub[*it][i];
				if (nrf[*it] > nrf[nod]) nrf[nod] = *it;
			}
		}
	}
}

int main()
{
	freopen("tcast.in", "r", stdin);
#ifndef _SCREEN_
	freopen("tcast.out", "w", stdout);
#endif

	int x, y;
	scanf("%d %d\n", &N, &T);
	for (int i = 1; i < N; i ++) {
		scanf("%d %d\n", &x, &y);
		G[x].push_back(y);
		G[y].push_back(x);
	}

	for (int i = 1; i <= N; i ++) {
		scanf("%d ", &a[i][0]);
		mm[i][0] = a[i][0];
		for (int j = 1; j < T; j ++) {
			scanf("%d ", &a[i][j]);
		}
	}

	for (int i = 1; i <= N; i ++) {
		for (int j = T - 1; j >= 0; j --) {
			mm[i][j] = mm[i][j + 1] + a[i][j];
		}
	}

	constr(1);
	memset(viz, 0, sizeof(viz));
	DF(1);

	int MAX = 0;
	
	if (N == 1) printf("%d\n", timp[1]);
	for (int i = 1; i <= N; i ++) {
		if (G[i].size() == 1 && i != 1) {
		   if (timp[i] > MAX) MAX = timp[i];	
		}
	}

	printf("%d\n", MAX);
		
	return 0;
}
