#include <stdio.h>
#include <algorithm>
using namespace std;

#define NMAX 110

int N;

int u1, u2;

int a[NMAX];

void findu2()
{
	while (a[u2] == 0) u2--;
}
void findu1()
{
	while (a[u1] == 0 || u1 == u2) u1--;
}

void muta(int x, int y, int z)
{
	a[x]--; a[y]--; a[z] += 2;
	printf("%d %d %d\n", x, y, z);
}

int baga_mutare(int a1, int a2, int p1, int p2)
{
	if (a[a1] + a[a2] == 0) return 0;

	if (a[a1] == a[a2]) {
		muta(a1, a2, p1);
		return 1;
	}

	if (a[a1] > a[a2]) {
		muta(a1, a2, p1);
		muta(a1, a2, p2);
		muta(p1, p2, a1);
		muta(a1, p2, a2);

		return 1;
	}

	muta(a1, a2, p1);
	muta(a1, a2, p2);
	muta(p1, p2, a2);
	muta(a2, p2, a1);

	return 1;
}
/*
void check()
{
	fclose(stdin);
	freopen("borcane.in", "r", stdin);

	int N, a[110], i, x, y, z;

	scanf("%d", &N);

	for (i = 1; i <= N; i++) scanf("%d", &a[i]);

	fclose(stdin);

	fclose(stdout);

	freopen("borcane.ok", "w", stdout);

	freopen("borcane.out", "r", stdin);

	while (scanf("%d %d %d", &x, &y, &z) != EOF) {
		if (x == y || x == z || y == z) printf("borcane egale!!!!\n");

		if (!a[x] || !a[y]) printf("muti din borcane goale!!!!\n");

		a[x]--; a[y]--; a[z] += 2;
	}

	int e = 0;
	for (i = 1; i <= N; i++) if (a[i]) e++;

	if (e > 1) printf("ai mai multe borcane cu bomboane la sf!!!!\n");

	printf("terminat\n");
}

int gen(int N)
{
	freopen("borcane.in", "w", stdout);

	printf("%d\n", N);

	int i;
	for (i = 1; i <= N; i++) printf("%d ", rand() % 3);
	printf("\n");

	fclose(stdout);

	return 0;
}
*/
int main()
{
//	srand(666013);
//	gen(100);
	
	int i, x, p1, p2, a1, a2;
	
	freopen("borcane.in", "r", stdin);
	freopen("borcane.out", "w", stdout);

	scanf("%d", &N);

	for (i = 1; i <= N; i++) scanf("%d", &a[i]);

	u2 = N; u1 = N; i = 0;
	while (1) {
		findu2();
		findu1();

		if (u1 <= 2 || u2 <= 2) break;

		i++;

		x = (i & 1) + 1;

		printf("%d %d %d\n", u1, u2, x);

		a[u1]--; a[u2]--; a[x] += 2;
	}

	for (i = 1; i <= N; i++) {
		if (!a[i]) continue;
		a1 = i; break;
	}

	for (i = 1; i <= N; i++) {
		if (!a[i]) continue;
		if (i == a1) continue;
		a2 = i; break;
	}

	if (i == N + 1) return 0;

	for (i = 1; i <= N; i++) {
		if (!a[i]) continue;
		if (i == a1 || i == a2) continue;
		p1 = i; break;
	}

	if (i == N + 1) {
		for (i = 1; i <= N; i++) {
			if (i == a1 || i == a2) continue;
			p1 = i; break;
		}
	}

	p2 = 0;
	for (i = 1; i <= N; i++) {
		if (i == a1 || i == a2 || i == p1) continue;
		p2 = i; break;
	}


	// ar trebui sa fiu intr-o stare buna

	if (a[p1] > a[a1]) swap(a1, p1);
	if (a[a2] > a[a1]) swap(a1, a2);
	while (a[p1]) muta(p1, a1, a2);

	if (!a[p1] && !a[a1]) return 0;



	// acum bag strategia

	if (!a[a1]) swap(p1, a1);
	if (!a[a2]) swap(p1, a2);


	if (a[a1] + a[a2] == 4) {
		if (a[a1] == 1) {
			muta(a1, a2, p1);
			swap(a1, p1);
		} else if (a[a2] == 1) {
			muta(a1, a2, p1);
			swap(a2, p1);
		}
	} else {
		if (a[a1] == 1) {
			muta(a1, a2, p1);
			muta(a2, p1, a1);
//			muta(a2, p1, a1);
		} else if (a[a2] == 1) {
			muta(a1, a2, p1);
			muta(a1, p1, a2);
//			muta(a1, p1, a2);
		}
	}

/*	for (i = 1; i <= N; i++) printf("%d ", a[i]);
	printf("\n");
	printf("%d %d %d %d\n", a1, a2, p1, p2);
	return 0;
*/

//	printf("\n");
	while (baga_mutare(a1, a2, p1, p2)) {
//		printf("\n");	
	}

//	check();

return 0;
}

