#include <stdio.h>
#include <vector>
#include <algorithm>
#include <bitset>
using namespace std;

#define NMAX 2010

int N, T, TT;

vector <int> leg[NMAX];
vector <int> leg1[NMAX];

char viz[NMAX];

bitset <NMAX> tmp[NMAX];

int beg[NMAX];

vector <int> tfiu[NMAX];

void back(int x)
{
	viz[x] = 1;

	vector <int> :: iterator it;
	for (it = leg[x].begin(); it != leg[x].end(); ++it) {
		if (viz[*it]) continue;

		leg1[x].push_back(*it);
		back(*it);
	}
}

int merge(int x)
{
	if (leg1[x].size() == 0) { beg[x] = TT; return 1; }
	
	tfiu[x].clear();

	vector <int> :: iterator it;

	for (it = leg1[x].begin(); it != leg1[x].end(); ++it) {
		if (!merge(*it)) return 0;

		tfiu[x].push_back(beg[*it]);
	}

	sort(tfiu[x].begin(), tfiu[x].end());

	int step = 1 << 12, y = -1, tc, e, q = tfiu[x].size(), i, ttc, ee = 0;

	for (; step; step >>= 1) {
		tc = y + step; e = 1;

		ttc = tc;

		for (i = 0; i < q && e; i++) {
			// gasesc timpu de transmisie

			ttc++;
			while (ttc < T && tmp[x][ttc - 1] == 1) ttc++;

			if (ttc > tfiu[x][i]) e = 0;
		}

		if (e) y += step, ee = 1;
	}

	beg[x] = y;

	return ee;
}

int main()
{
	int i, x, y, j;
	
	freopen("tcast.in", "r", stdin);
	freopen("tcast.out", "w", stdout);

	scanf("%d %d", &N, &T);

	for (i = 1; i < N; i++) {
		scanf("%d %d", &x, &y);

		leg[x].push_back(y);
		leg[y].push_back(x);
	}

	for (i = 1; i < N; i++) {
		for (j = 0; j < T; j++) {
			scanf("%d", &x);
			tmp[i][j] = x;
		}
	}

	back(1);

	int step = 1 << 12;

	for (x = -1; step; step >>= 1) {
		TT = x + step;
		if (!merge(1)) x += step;
	}

	printf("%d\n", x + 1);

return 0;
}

