#include <iostream>
#include <algorithm>
#include <cstring>

using namespace std;

int N;
int b[101];
int bb[101];
int trad[101]; // [0..101] -> [0..101]
int tot(0);

void printb()
{
	for (int i(0); i < N; ++i)
		cout << b[i] << " ";
	cout << endl;
}

void afis_in_ordine(FILE *fo, int x, int y, int z)
{
	if (x > y)
		swap(x, y);
	fprintf(fo, "%d %d %d\n", x, y, z);
}

int main(int argc, char *argv[])
{
	FILE *fi = fopen("borcane.in", "r");
	fscanf(fi, "%d", &N);
	for (int i(0); i < N; ++i) {
		fscanf(fi, "%d", b+i);
		tot += b[i];
		trad[i] = i;
	}
	fclose(fi);

	memcpy(bb, b, sizeof(b));

	FILE *fo = fopen("borcane.out", "w");
	for (int m(0); m < N; ++m) {
		swap(b[m], b[0]);
		
		trad[0] = m;
		trad[m] = 0;

		int x, y;
		while (b[0] < tot) {
			//printb();
			
			x = y = -1;
			for (int i(1); i < N; ++i)
				if (b[i] > 0)
					if ((x == -1) || (b[i] > b[x]))
						x = i;
			for (int i(1); i < N; ++i)
				if ((i != x) && (b[i] > 0))
					if ((y == -1) || (b[i] > b[y]))
						y = i;

			if (x * y < 0) {
				//cout << "vah" << endl;
				break;
			}

			afis_in_ordine(fo, trad[x] + 1, trad[y] + 1, trad[0] + 1);
			
			b[0] += 2;
			--b[x];
			--b[y];
		}
		//printb();

		if (b[0] == tot)
			break;
		
		memcpy(b, bb, sizeof(bb));
		fclose(fo);
		fo = fopen("borcane.out", "w");

		trad[m] = m;
		trad[0] = 0;
	}
	fclose(fo);
	
	return 0;
}

