#include <stdio.h>
#include <queue>

using namespace std;

#define N 800
#define M 800

int n, m, d;
int r[N+1][M+1];
int viz[N+1][M+1];
int a[N+1][M+1];
struct punct { int l, c; };
queue<punct> q;
int dl[4] = { 0, 0, 1, -1 };
int dc[4] = { 1, -1, 0, 0 };

int vecini[N*M+1][5];

void citeste()
{
	freopen("mexc.in", "r", stdin);
	scanf("%d%d%d\n", &n, &m, &d);
	int i,j;
	for(i=1;i<=n;++i)
    	for(j=1;j<=m;++j)
        	scanf("%d", &a[i][j]);
    fclose(stdin);
}


void init_viz() //probabil poate fi optimizata cu un memset
{
	int i,j;
	for(i=1;i<=n;++i)
    	for(j=1;j<=m;++j)
        	viz[i][j] = 0;
}

int e_valid(punct x)
{
	int xl = x.l, xc = x.c;
	if(xl < 1 || xl > n || xc < 1 || xc > m) return 0;
	return 1;
}

int parcurge(punct sursa)
{
	init_viz();
	int c = 0, i, xl, xc, vals;
	vals = a[sursa.l][sursa.c];
	punct x,e;
	q.push(sursa);
	while(!q.empty())
	{
    	x = q.front();
		xl = x.l;
		xc = x.c;
		q.pop();
		if(viz[xl][xc]) continue;
		//in cazul in care nu am vizitat punctul respectiv
		viz[xl][xc] = 1;//il marchez ca fiind vizitat

		//verific daca ma pot opri aici
		if(a[xl][xc] >= vals) ++c;

		//verific daca pot sa trec mai departe prin acest punct
		if(a[xl][xc] >= vals - d)
		{
        	//bag toti vecinii in coada
			for(i=0;i<4;++i)
			{
				e.l = xl + dl[i];
				e.c = xc + dc[i];
				if(e_valid(e)) q.push(e);
			}
		}
    }
	return c;
}

void afisaza()
{
	freopen("mexc.out", "w", stdout);
    int i,j;
	for(i=1;i<=n;++i)
	{
	 	for(j=1;j<=m;++j) printf("%d ", r[i][j]);
		printf("\n");
	}
	fclose(stdout);
}

int main()
{
	citeste();
	/*
	-> aleg fiecare nod din cele n*m
	
	
	*/
	punct x;
	int i,j;
	for(i=1;i<=n;++i)
	{
    	for(j=1;j<=m;++j)
		{
        	x.l = i;
			x.c = j;
			r[i][j] = parcurge(x);
		}
	}

	afisaza();
	
	return 0;
}
