#include <cstdio>

#include <list>
#include <vector>
#include <map>
using namespace std;

const int NMAX = 2005;
const int TMAX = 1005;

int n, t;
vector<int> Neighb[NMAX];
bool Check[NMAX][TMAX * 2];

bool UsedTime[NMAX][2 * TMAX];
int Sons[NMAX];
//list<int> Usable[NMAX];

struct compare {
	bool operator()(int a, int b) {
		return (a > b);
	}
};

/*bool compare(int a, int b) {
	return a > b;
}*/

map<int, int, compare> Dest[NMAX];
#define nsons first
#define id second

int allSons(int lroot) {
	Sons[lroot] = 1;
	int i, nn = Neighb[lroot].size();
	if (nn == 0)
		return 1;
	for (i = 0; i < nn; ++ i)
		Sons[lroot] += allSons(Neighb[lroot][i]);
	return Sons[lroot];
}

int maxT = 0;

int send(int t, int lroot) {
	//fprintf(stderr, "%d %d\n", t, lroot);
	
	int ans, nn = Neighb[lroot].size(), add = 0, i;
	
	if (nn == 0) {
		maxT = max(maxT, t);
		return 0;
	}
	
	for (i = 1; i <= nn; ++ i)
		Dest[lroot].insert(make_pair(Sons[Neighb[lroot][i - 1]], Neighb[lroot][i - 1]));
	
	map<int, int>::iterator curr, next;
	
	/*for (curr = Dest[lroot].begin(); curr != Dest[lroot].end(); ++ curr)
		fprintf(stderr, "%d %d\n", curr->nsons, curr->id);
	fprintf(stderr, "\n");*/
	
	curr = Dest[lroot].begin(), next = curr, ++ next;
	int sendTime, nw = 0;
	
	for (sendTime = t + 1, ans = 0; Dest[lroot].size() > 0; curr = next, ++ next) {
		if (next == Dest[lroot].end())
			next = Dest[lroot].begin();
		
		while (Check[lroot][sendTime] == true)
			++ sendTime;
			
		if (sendTime + 1 >= ::t || Check[curr->id][sendTime + 1] == false) {
			ans = max(ans, sendTime + send(sendTime, curr->id));
			Dest[lroot].erase(curr);
			++ sendTime;
			//add += sendTime;
			nw = 0;
		} else {
			++ nw;
			if (nw >= nn) {
				++ sendTime;
				nw = 0;
			}
		}
	}
	return ans;
}

int main() {
	freopen("tcast.in", "r", stdin);
	freopen("tcast.out", "w", stdout);
	
	scanf("%d %d", &n, &t);
	int i, v1, v2;
	for (i = 0; i < n - 1; ++ i) {
		scanf("%d %d", &v1, &v2);
		Neighb[v1].push_back(v2);
	}
	int j, v;
	for (i = 0; i < n; ++ i)
		for (j = 0; j < t; ++ j) {
			scanf("%d", &v);
			Check[i][j] = (v == 1);
		}
	allSons(1);
	send(0, 1);
	printf("%d\n", maxT);

	return 0;
}

