#include<cstdio>

#define INPUT "borcane.in"
#define OUTPUT "borcane.out"
#define MIN(x, y) ((x < y) ? x : y)
#define NMAX 102

int N, last, Nod1, Nod2, NodMobil1, NodMobil2, NodFinal, NOD;
int A[ NMAX ];

void ReadValues()
{
  int i;

  scanf("%d", &N);

  for(i = 1; i <= N; ++i)
    scanf("%d", A+i);
}

int Impar()
{
  int i, cont;
  last = -1;

  for(i = 1, cont = 0; i <= N; ++i)
  {
    cont = (A[ i ] % 2 == 1) ? cont + 1 : cont;
    last = (A[ i ] % 2 == 1) ? i : last;
  }

  return (cont % 2 != 0);
}

void GetVariations()
{
  int V, i;

  if(A[ Nod1 ] % 2 == 0 || A[ NodFinal ] % 2 == 0)
  {
    NOD = (A[ Nod1 ] % 2 == 0) ? Nod1 : Nod2;

    V = A[ NOD ] / 2;
    
    for(i = 0; i < V; ++i)
      printf("%d %d %d\n", Nod1, NodFinal, NodMobil1);

    for(i = 0; i < V; ++i)
      printf("%d %d %d\n", Nod1, NodFinal, NodMobil2);

    A[ NodMobil1 ] = 2 * V;
    A[ NodMobil2 ] = 2 * V;
    
    if(NOD == Nod1) A[ NodFinal ] -= A[ NOD ];
    else A[ Nod1 ] -= A[ NOD ];

    A[ NOD ] = 0;

    if(NOD == Nod1) NOD = NodFinal;
    else NOD = Nod1;

    for(i = 0; i < 2 * V; ++i)
      printf("%d %d %d\n", NodMobil1, NodMobil2, NOD);

    A[ NOD ] += A[ NodMobil1 ] + A[ NodMobil2 ];
    A[ NodMobil1 ] = A[ NodMobil2 ] = 0;
  }
  else
  {
    printf("%d %d %d\n", Nod1, NodFinal, NodMobil1);
    --A[ Nod1 ];
    --A[ NodFinal ];
    A[ NodMobil1 ] += 2;

    if(A[ Nod1 ] || A[ Nod2 ]){
    printf("%d %d %d\n", NodMobil1, Nod1, NodFinal);
    printf("%d %d %d\n", NodMobil1, Nod1, NodFinal);
    A[ NodMobil1 ] = 0;
    A[ Nod1 ] -= 2;
    A[ NodFinal ] += 4;

    GetVariations();
    }
  }
}

void SolveFunction()
{
  int NodFix, i, OK = 0, V;

  NodFix = Impar() ? 1 : 0;

  NodFinal = 0;

  if(NodFix) NodFinal = last;
  else
    for(i = N; i > 0 && !NodFinal; --i)
      NodFinal = (A[ i ] != 0) ? i : 0;

  for(i = 1, Nod1 = 0; i <= N && !Nod1; ++i)
    Nod1 = (A[ i ] != 0 && i != NodFinal) ? i : 0;

  while(!OK)
  {
    OK = 1;
  
    for(i = Nod1 + 1, Nod2 = 0; i <= N && !Nod2; ++i)
    {
      Nod2 = (A[ i ] != 0 && i != NodFinal) ? i : 0;
      OK = (Nod2 == i) ? 0 : OK;
    }

    if(OK) break;

    V = MIN( A[ Nod1 ], A[ Nod2 ]);

    for(i = 0; i < V; ++i)
      printf("%d %d %d\n", Nod1, Nod2, NodFinal);

    A[ Nod1 ] -= V, A[ Nod2 ] -= V;
    A[ NodFinal ] += 2 * V;

    Nod1 = (A[ Nod1 ] == 0 ) ? Nod2 : Nod1;
  }

  NodMobil1 = 0, NodMobil2 = 0;

  for(i = 1; i <= N; ++i)
  {
    if(NodMobil1 && !NodMobil2 && !A[ i ])
    {
      NodMobil2 = i;
      break;
    }
    
    if(!NodMobil1 && !A[ i ]) NodMobil1 = i;
  }

  GetVariations();
}

int main()
{
  freopen(INPUT, "r", stdin); freopen(OUTPUT, "w", stdout);

  ReadValues();

  SolveFunction();

  fclose(stdin); fclose(stdout);

  return 0;
}
