#include<cstdio>
#include<cstring>

#define INPUT "tcast.in"
#define OUTPUT "tcast.out"
#define CL(x) memset(x, 0, sizeof(x));
#define NMAX 2003
#define TMAX 1003

typedef struct Graph
{
  long node;
  Graph *next;
};

Graph *List[ NMAX ];
int Verif[ NMAX ][ TMAX ], Util[ NMAX ], Used[ NMAX ];
int N, T;

void ReadValues()
{
  int V1, V2, i, j;
  Graph *adr;

  scanf("%d %d", &N, &T);

  for(i = 1; i < N; ++i)
  {
    scanf("%d %d", &V1, &V2);

    adr = new Graph;
    adr -> node = V2;
    adr -> next = List[ V1 ];
    List[ V1 ] = adr;

    adr = new Graph;
    adr -> node = V1;
    adr -> next = List[ V2 ];
    List[ V2 ] = adr;
  }

  for(i = 1; i <= N; ++i)
    for(j = 1; j <= T; ++j)
      scanf("%d", &Verif[ i ][ j ]);
}

void SolveFunction()
{
  int OK, Critic, Timp, i, j, Valid = 0;
  Graph *adr;

  Util[ 1 ] = 1;

  OK = 0;
  Timp = 1;

  while(!OK)
  {
    OK = 1;

    for(i = 1; i <= N; ++i)
      if(Util[ i ] == 0)
        OK = 0;
  
    if(Timp <= T)
    {
      for(i = 1; i <= N; ++i)
      {
        Valid = 1;
        if(Util[ i ] == 1 && !Used[ i ] && Verif[ i ][ Timp ] != 1)
        {
          Critic = 0;
          adr = List[ i ];
          while(adr != NULL)
          {
            if(!Util [adr -> node ] && Verif[ adr -> node ][ Timp ] == 0 && !Critic)
              Critic = adr -> node;

            if(!Util[ adr -> node ] && Verif[ adr -> node ][ Timp ] == 0 && Verif[ adr -> node ][ Timp + 1 ] == 1)
            {
              Critic = adr -> node;
              break;
            }

            adr = adr -> next;
          }
          if(Critic){
          Used[ Critic ] = 1;
          Util[ Critic ] = 1;
          Valid = 0;
          }
          Util[ i ] = (Valid) ? 2 : Util[ i ];
        }
      }
    }
    else
    {
      for(i = 1; i <= N; ++i)
      {
        Valid = 1;
        if(Util[ i ] == 1 && !Used[ i ])
        {
          Critic = 0;
          adr = List[ i ];
          while(adr != NULL)
          {
            if(!Util [adr -> node ] && !Critic)
            {
              Critic = adr -> node;
              break;
            }

            adr = adr -> next;
          }
          if(Critic){
          Used[ Critic ] = 1;
          Util[ Critic ] = 1;
          Valid = 0;
          }
          Util[ i ] = (Valid) ? 2 : Util[ i ];
        }
        Util[ i ] = 2;
      }
    }
    ++Timp;
    CL(Used);
  }

  printf("%d\n", Timp - 2);
}

int main()
{
  freopen(INPUT, "r", stdin); freopen(OUTPUT, "w", stdout);

  ReadValues();

  SolveFunction();

  fclose(stdin); fclose(stdout);

  return 0;
}
