#include <cstdio>
#include <cstring>
#include <algorithm>
#include <iostream>
using namespace std;

#define _name_ "tcast"
#define FIN _name_".in"
#define FOUT _name_".out"
#define MAXN 2001
#define INF 0x3f3f3f3f
#define mp make_pair
#define ft first
#define sd second

int n, t;

int L[MAXN][MAXN];
int H[MAXN], T[MAXN];
int Used[MAXN], nfii[MAXN];
int A[MAXN][1001], Bloc[MAXN][1001], nextfr[MAXN][1001];
int Tliber[MAXN];
pair<int, int> fii[MAXN][MAXN]; // uh, timpii fiilor + fiii
int cand[MAXN]; // doar pt nodul curent, 
  // these are timpii la care trimit fiecare fiu
pair<int, int> B[MAXN][1001];

inline int max(int a, int b) {
	return a < b ? b : a;
}

void df(int s)
{
	int i;
	Used[s] = 1;
	Tliber[s] = 0;
	for (i = 1; i <= L[s][0]; ++i) {
		int fiu = L[s][i];
		if (!Used[fiu]) {
			H[fiu] = H[s] + 1;
			T[fiu] = s;
			df(fiu);
			fii[s][nfii[s]++] = make_pair(Tliber[fiu] + 1, fiu);
			// pt toti timpii de la t la t + n, vreau sa vad
			// timpul "liber" (fara blocaje) de propagare
			// evident, ia fiii in ordinea descresc a timp_fiu
		}
	}
	if (!nfii[s]) {
       memset(A[s], 0, sizeof(A[s]));
       return;
   }
	
	sort(fii[s], fii[s] + nfii[s], greater<pair<int,int> >());
	// in fiul cu timpul tfii[s][i] ma duc la momentul i
	for (i = 0; i < nfii[s]; ++i) {
		if (fii[s][i].ft + i > Tliber[s])
			Tliber[s] = fii[s][i].ft + i;
		cand[i] = t+i;
	}
	A[s][t] = Tliber[s];
	nextfr[s][t] = t;
	int j, maximp = 0, tmp, nodbagat;
	// j are the potential update times for node s
	for (j = t-1; j >= 0; --j) {
		A[s][j] = A[s][j+1];
		nextfr[s][j] = j;
		if (Bloc[s][j] == 1) {
			nextfr[s][j] = nextfr[s][j+1];
			continue; 
		}
		// s-a deschis o potentiala 'portita' in care as putea trimite
		// unul din fiii pe care-i trimiteam mai tarziu
		// acum, ar trebui sa iau timpii fiilor dupa 
			// fii[s][i].ft - A[fiu][t_liber] = improvement
		/*
		for (i = 0; i < nfii[s]; ++i) {
			int fiu = fii[s][i].sd;
			if ((tmp = A[ fiu ][cand[i] > t ? t : cand[i]] -
					A[fiu][j] + cand[i] - j) > maximp) 
				maximp = tmp, nodbagat = i;
		}
		if (maximp == 0) continue; // degeaba!
		cand[nodbagat] = j; // l-am reprofilat p`ala
		A[s][j] -= maximp;
		*/
		for (i = 0; i < nfii[s]; ++i) {
			int fiu = fii[s][i].sd;
			fii[s][i].ft = A[fiu][j] + 1;
		}
		sort(fii[s], fii[s] + nfii[s], greater<pair<int,int> >());
		int delta = 0;
		A[s][j] = 0;
		for (i = 0; i < nfii[s]; ++i, 
				delta = nextfr[s][j+delta+1>t?t:j+delta+1]) {
			if (fii[s][i].ft + delta > A[s][j]) {
				A[s][j] = fii[s][i].ft + delta;
				cand[i] = j+delta;
			}
		}
	}
	// voi sorta lista A[s] dupa valoare + timp, ca sa o am
	//for (i = 0; i <= t; ++i)
	//	B[s][i] = mp(A[s][i] + i, i);
	//sort(B[s], B[s] + t + 1);
}

void solveala()
{
	int i;
	if (n == 1) {
		printf("0\n");
		return;
	}
	if (n == 2) {
		for (i = 0; i < t; ++i)
			if (Bloc[1][i] == 0) break;
		printf("%d\n", i+1);
		return;
	}
	/* caz general */
	memset(A, INF, sizeof(A));
	H[1] = 1;
	df(1);
	for (i = 0; i < t; ++i)
		if (Bloc[1][i] == 0) break;
	// HACK
	printf("%d\n", A[1][i] + 1);
}

inline void add(int x, int y)
{
	L[x][ ++L[x][0] ] = y;
}

void citeala()
{
	freopen(FIN, "r", stdin);
	freopen(FOUT,"w",stdout);
	scanf("%d %d", &n, &t);
	for (int i = 0; i < n-1; ++i) {
		int x, y;
		scanf("%d %d", &x, &y);
		add(x, y); add(y, x);
	}
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j < t; ++j) {
			scanf("%d", &Bloc[i][j]);
		}
	}
}

int main()
{
	citeala();
	solveala();
	return 0;
}
