#include <cstdio>
#include <cstring>

#define FIN "borcane.in"
#define FOUT "borcane.out"
#define MAX_N 105
#define INF 1 << 20

int A[MAX_N];
int V[MAX_N];
int N;
int Ttarget;

        int init ()
        {
            int m = 0, p, i;
            for (i = 1; i <= N; ++i)
                if (A[i] > m)  m = A[i], p = i;
            return p;
        }

        inline int get0 ()
        {
              for (int i = 1; i <= N; ++i) if (!V[i]) return i;
        }

        void solvestand (int xsource)
        {
             if (!V[xsource]) return;
        
             int i;
             int cant = (int) V[xsource] / 3;
             int auxtarg;

             auxtarg = get0();
             for (i = 1; i <= cant; ++i)
                        printf ("%d %d %d\n", Ttarget, xsource, auxtarg);

             for (i = 1; i <= cant << 1; ++i)
                        printf ("%d %d %d\n", auxtarg, xsource, Ttarget);
        }

        void solver1 (int xsource)
        {
             if (!V[xsource]) return;
        
             --V[xsource];
             int b1, b2, b3;
             b1 = get0(), V[b1] = -1;
             b2 = get0(), V[b2] = -1;
             b3 = get0(), V[b3] = -1;

             printf ("%d %d %d\n", xsource, Ttarget, b1);
             printf ("%d %d %d\n", Ttarget, b1, b2);
             printf ("%d %d %d\n", Ttarget, b2, b3);
             printf ("%d %d %d\n", b1, b3, Ttarget);
             printf ("%d %d %d\n", b2, b3, Ttarget);
             V[b1] = V[b2] = V[b3] = 0;
             if (V[xsource]) solvestand (xsource);
        }

        void solve ()
        {
             int i;
             int m1, m2;
             int stack = 0;

             Ttarget = init ();

             memcpy (V, A, sizeof (A));
             while (stack < N - 2)
             {
                  int p1, p2;
                  
                  m1 = m2 = 0;
                  p1 = p2 = 0;
                  
                  for (i = 1; i <= N; ++i)
                     if (i != Ttarget)
                     {
                           if (V[i] > m1) m2 = m1, p2 = p1, m1 = V[i], p1 = i;
                           if (V[i] > m2 && p1 != i) m2 = V[i], p2 = i;
                     }
                  --V[p1], --V[p2], V[Ttarget] += 2;

                  printf ("%d %d %d\n", p1, p2, Ttarget);

                  if (!V[p1]) ++stack;
                  if (!V[p2]) ++stack;
             }
             int xsource = 0;
             for (i = 1; i <= N; ++i)
                if (V[i] && i != Ttarget) xsource = i;
         //    V[xsource = 2] = 5; V[Ttarget] = 10;

             if (!xsource) return;

             if (V[xsource] % 3 == 0) solvestand (xsource);
             if (V[xsource] % 3 == 1) solver1 (xsource);
             if (V[xsource] % 3 == 2)
             {
                V[xsource] -= 2;
                V[Ttarget] -= 2;

                int b1, b2, b3;
                b1 = get0(), V[b1] = 4;

                printf ("%d %d %d\n", xsource, Ttarget, b1);
                printf ("%d %d %d\n", xsource, Ttarget, b1);
                solver1(b1);
                solvestand(xsource);
             }
        }

        int main ()
        {
            freopen (FIN, "r", stdin);
            freopen (FOUT, "w", stdout);

            scanf ("%d", &N);
            int i;
            for (i = 1; i <= N; ++i) scanf ("%d", A + i);

            solve ();
        //    printf ("-1\n");
            return 0;
        }
