#include <cstdio>
#include <cstdlib>

using namespace std;

#define MAX 805

const int dx[4] = {-1, 0, 1, 0};
const int dy[4] = { 0, 1, 0, -1};

int N, M, D, a[MAX][MAX], c[MAX][MAX], cnt, viz[MAX][MAX], vx[MAX*MAX], vy[MAX*MAX], nrviz;

inline int ok_vec( int x, int y, int k)
{
        return  x + dx[k] >= 0 && x+dx[k] <N && y+dy[k] >= 0 &&y+dy[k] < M ? 1 : 0;
}

void fill( int x, int y, int &xs, int &ys)
{
        if ( viz[x][y] )
                return;
        if (a[x][y] < a[xs][ys]-D)
                return;
        viz[x][y] = 1;
        vx[nrviz] = x;
        vy[nrviz] = y;
        nrviz++;
        if ( a[x][y] >= a[xs][ys] )
                cnt++;

        for (int k = 0; k<4;k++)
                if ( ok_vec(x,y,k) )
                      fill(x+dx[k], y+dy[k], xs, ys);

}

void calc()
{
        for (int i = 0; i<N; i++)
                for (int j = 0; j<M; j++)
                {
                        cnt = 0;
                        for ( int k = 0; k<4; k++)
                                if ( ok_vec(i,j,k) && a[i][j] == a[i+dx[k]][j+dy[k]] )
                                        cnt = c[i+dx[k]][j+dy[k]];
                        if ( !cnt )
                        {
                                fill(i,j, i,j);
                                for (int l = 0; l<nrviz; l++)
                                        viz[vx[l]][vy[l]] = 0;
                        }
                        c[i][j] = cnt;
                }
}
                        

void afis()
{
        for ( int i =0;i <N; i++)
        {
                for( int j =0; j<M; j++)
                        printf("%d ", c[i][j]);
                printf("\n");
        }
}


int main()
{
        freopen("mexc.in", "r", stdin);
        freopen("mexc.out", "w", stdout);

        scanf("%d %d %d", &N, &M, &D);
        for (int i = 0;i <N; i++)
                for (int j = 0; j<M; j++)
                        scanf("%d", &a[i][j]);
        calc();
        afis();


        return 0;
}


