#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>

using namespace std;

#define NMAX 2048
#define TMAX 1024
#define INF 0x3f3f3f3f

int tmin[NMAX], N,T, tata[NMAX], ad[NMAX];
int t[NMAX][TMAX], sum, uz, bst;
vector <int> G[NMAX];
int temp[NMAX];

char ok[NMAX][TMAX];
char viz[NMAX];

void read()
{
        for (int i = 1; i<N; i++)
        {
                int a,b;
                scanf("%d %d", &a, &b);
                G[a].push_back(b);
                G[b].push_back(a);
        }
        for (int i = 1; i<=N; i++)
        {
                for (int j = 0; j<T; j++)
                        scanf("%d", &ok[i][j]);
        }
}

void df(int nod, int h )
{
        if (viz[nod] ) return;
        viz[nod] = 1;
        ad[nod] = h;
        tmin[nod] = 0;

        int nr=0;

        for ( vector < int > :: iterator it = G[nod].begin(); it!= G[nod].end(); it++)
        {
                if ( !viz[*it])
                        tata[*it] = nod;
                df(*it, h+1);
        };
        for ( vector < int > :: iterator it = G[nod].begin(); it != G[nod].end() ;it++)
        {
                if ( tata[nod] != *it)
                        temp[nr++] = tmin[*it];
        }
        if ( !nr ) return;
        sort( temp, temp+nr);
        reverse(temp, temp+nr);
        for (int i = 0; i<nr; i++)
                if ( i+temp[i] +1 > tmin[nod] )
                        tmin[nod] = i + temp[i]+1;
}

void df2(int nod )
{
        if ( viz[nod] ) return;
        viz[nod] = 1;

        for ( vector < int > :: iterator it = G[nod].begin(); it!= G[nod].end(); it++)
             df2(*it);

        for (int i = T-1; i>=ad[nod]; i--)
        {
                int nr = 0;
                if ( ok[nod][i] )
                {
                        t[nod][i] = t[nod][i+1]+1;
                        continue;
                }

                for ( vector < int > :: iterator it = G[nod].begin(); it != G[nod].end() ;it++)
                {
                if ( tata[nod] != *it)
                        temp[nr++] = t[*it][i+1];
                }

                if ( !nr ) { t[nod][i] = 0; return; }
                
                sort( temp, temp+nr);
                reverse(temp, temp+nr);
                for (int j = 0; j<nr; j++)
                        if ( j+temp[j] +1 > t[nod][i] )
                                t[nod][i] = j + temp[j]+1;
        }

}

void calc()
{
        //for (int i = 0; i<=N; i++)
          ///      for (int j = 0; j<=T; j++)
             //           t[i][j] = INF;
        for (int i = 1; i<=N; i++)
                t[i][T] = tmin[i];
        memset(viz,0,sizeof(viz));

       df2(1);
}


int main()
{
        freopen("tcast.in", "r", stdin);
        freopen("tcast.out", "w", stdout);

        scanf("%d %d", &N, &T);

        read();
        df(1,0);
        calc();
        int k = 0;
        for ( int i =0; i<T; i++)
               if (ok[1][i])
                        k++;
               else
                break;

        printf("%d\n", t[1][0]+k);

        return 0;
}
