using namespace std;

#include <cstdio>
#include <algorithm>
#include <vector>

#define nmax 2048
#define vmax 1024

int timp, dfsuri, N, ans, T;

int viz[nmax], primire[nmax];

int verif[nmax][vmax];

vector<int> L[nmax];

void dfs(int nod)
{
  vector<int>::iterator it;

  vector<int> primiri;

  int v, k, j, ok, t, ultimult;

  viz[nod] = dfsuri;

  primiri.clear();

  for (k = 0, it = L[nod].begin(); it != L[nod].end(); ++it)
  {
    v = *it;
    if (viz[v] != dfsuri)
    {
      ++k;
      dfs(v);

      primiri.push_back(primire[v]-1);
    }
  }

  if (k == 0)
    primire[nod] = timp;
  else
  {
//    for (it = primiri.begin(); it != primiri.end(); ++it)
//    {
//      v = *it;
//      while (v < T && verif[nod][v] && v > 0)
//        v--;
//    }

    sort(primiri.begin(), primiri.end());

    ultimult = -1;

    for (j = k-1, ok = 1, t = primiri[j]; t >= 0 && j >= 0 && ok; t--)
    {
      if (t >= T || (t < T && verif[nod][t] == 0))
      {
        if (t <= primiri[j])
        {
          if (j == 0)
            ultimult = t;
          
          j--;
        }
        else
          ok = 0;
      }
    }

    primire[nod] = ultimult;
  }
}

int esteok()
{
  int i;

  ++dfsuri;

  dfs(1);

  if (primire[1] >= 0)
    return 1;
  else
    return 0;
}

void search(int l, int r)
{
  if (l > r)
    return;

  timp = (l+r)>>1;

  if (esteok())
  {
    ans = timp;
    search(l, timp-1);
  }
  else
    search(timp+1, r);
}

int main()
{
  int i, x, y, t;

  freopen("tcast.in", "r", stdin);
  freopen("tcast.out", "w", stdout);

  scanf("%d%d", &N, &T);

  for (i = 1; i < N; ++i)
  {
    scanf("%d%d", &x, &y);
    L[x].push_back(y);
    L[y].push_back(x);
  }

  for (i = 1; i <= N; ++i)
    for (t = 1; t <= T; ++t)
      scanf("%d", &verif[i][t-1]);

  search(1, 5*N+T+10);

  printf("%d\n", ans);

  return 0;
}

