#include <stdio.h>
#include <vector>
#include <algorithm>
#include <iostream>
#include <queue>

using namespace std;

#define PB(x) push_back(x)
#define SZ(x) (x).size()
#define MP(a,b) make_pair((a), (b))
#define ii pair<int, int>
#define vi vector<int>
#define vii vector< ii >
#define ALL(x) (x).begin(), (x).end()
#define SORT(x) sort(ALL(x))

#define FOR(i,N) for (int (i) = 0; (i)<(N); ++(i))
#define FORE(i,N) for (int (i) = 0; (i)<=(N); ++(i))
#define FORIE(i,j,N) for (int (i) = (j); (i)<=(N); ++(i))
#define FORI(i,j,N) for (int (i) = (j); (i)<(N); ++(i))

#define FORV(i,V) for (int (i) = 0; (i)<SZ(V); ++(i))
#define FORIT(i, C) for (typeof((C).begin()) i = (C).begin(); i != (C).end(); ++(i))

#define PRINT(V) FORV(i,V) cerr << V[i] << " "; cerr << "\n";
#define PRINTV(V, i, j) FORIE(tz, i, j) cerr << V[tz] << " "; cerr << "\n";
#define PRINTC(C) FORIT(tz,C) cerr << *tz << " "; cerr << "\n";

#define OK(x,y) (x >= 0 && x < N && y >= 0 && y < M && !viz[x][y])

#define NMAX 800

int N,M,D;
int A[NMAX][NMAX], S[NMAX][NMAX];
bool viz[NMAX][NMAX];
int dx[] = {0,0,-1,1};
int dy[] = {-1,1,0,0};

void flood(int xx, int yy)
{
    memset(viz, 0, sizeof(viz));

    queue< ii > Q;

    Q.push( MP(xx, yy) );
    viz[xx][yy] = true;

    int tot = 0;

    vii vec;
    vec.PB( MP(xx,yy) );

    while (!Q.empty())
    {
        ii per = Q.front();
        Q.pop();

        int x = per.first;
        int y = per.second;

        if (A[x][y] >= A[xx][yy])
        {
            ++tot;
            if (A[x][y] == A[xx][yy])
                vec.PB( MP(x,y) );
        }

        FOR(i,4)
        {
            if (OK(x+dx[i], y+dy[i]) && A[x+dx[i]][y+dy[i]] >= A[xx][yy] - D)
            {
                Q.push( MP(x+dx[i], y+dy[i]) );
                viz[ x+dx[i] ][ y+dy[i] ] = true;
            }
        }

    }

    FORV(i,vec)
    {
        S[vec[i].first][vec[i].second] = tot;
    }
}

int main()
{
    freopen("mexc.in", "r", stdin);
    freopen("mexc.out", "w", stdout);

    scanf("%d %d %d", &N, &M, &D);

    FOR(i,N)
        FOR(j,M)
        {
            scanf("%d", &A[i][j]);
        }

    FOR(i,N)
    {
        FOR(j,M)
        {
            if (!S[i][j])
            {
                flood(i,j);
            }
            printf("%d ", S[i][j]);

        }

        printf("\n");
    }

    return 0;
}
