#include<stdio.h>
#include<fstream>
using namespace std;

int A[820][820];
struct nod{int x,y;} Q[64060];
char viz[820][820],viz2[820][820];
int rez,N,M,D;

void bfs(int is,int js){
    rez = 0;
    int i,j;

    memset(viz,0,sizeof viz);
    int li,lf;
    li=lf=1;
    Q[li].x = is;
    Q[li].y = js;
    viz[is][js] = 1;

    while(li<=lf){

        i = Q[li].x;
        j = Q[li].y;

        if(i-1 > 0 && viz[i-1][j]==0 && A[i-1][j] >= A[is][js] - D){
            lf++;
            Q[lf].x = i-1;
            Q[lf].y = j;
            viz[i-1][j] = 1;
        }

        if(i+1 <= N && viz[i+1][j]==0 && A[i+1][j] >= A[is][js] - D){
            lf++;
            Q[lf].x = i+1;
            Q[lf].y = j;
            viz[i+1][j] = 1;
        }

        if(j-1 > 0 && viz[i][j-1]==0 && A[i][j-1] >= A[is][js] - D){
            lf++;
            Q[lf].x = i;
            Q[lf].y = j-1;
            viz[i][j-1] = 1;
        }

        if(j+1 <= M && viz[i][j+1]==0 && A[i][j+1] >= A[is][js] - D){
            lf++;
            Q[lf].x = i;
            Q[lf].y = j+1;
            viz[i][j+1] = 1;
        }

        li++;

    }

    memset(viz2,0,sizeof viz2);
    for(int k=1;k<=lf;k++){
        i = Q[k].x;
        j = Q[k].y;

        if(i-1 > 0 && A[i-1][j] >= A[is][js])
            viz2[i-1][j] = 1;
        if(i+1 <= N && A[i+1][j] >= A[is][js])
            viz2[i+1][j] = 1;
        if(j-1 > 0 && A[i][j-1] >= A[is][js])
            viz2[i][j-1] = 1;
        if(j+1 <= M && A[i][j+1] >= A[is][js])
            viz2[i][j+1] = 1;
    }

    if(lf == 1)
        rez = 1;

    for(int i=1;i<=N;i++)
        for(int j=1;j<=M;j++)
            if(viz2[i][j])
                rez++;

}

int main(){

    FILE *fin = fopen("mexc.in","r");
    FILE *fout = fopen("mexc.out","w");

    fscanf(fin,"%d%d%d",&N,&M,&D);

    for(int i=1;i<=N;i++)
        for(int j=1;j<=M;j++)
            fscanf(fin,"%d",&A[i][j]);

     for(int i=1;i<=N;i++){
        for(int j=1;j<=M;j++){
            bfs(i,j);
            fprintf(fout,"%d ",rez);
        }
        fprintf(fout,"\n");
     }

     fclose(fin);
     fclose(fout);
     return 0;

}

