#include <stdio.h>
#include <set>

using namespace std;

#define maxn 110
#define pas 101

int n, sum;
int c[maxn];
int h[maxn], p[maxn];
int h2[maxn], p2[maxn];

void popmax(int x)
{
	int aux;
	
	while (x>1 && c[h[x]]>c[h[x/2]])
	{
		aux = h[x];
		h[x] = h[x/2];
		h[x/2] = aux;

		p[h[x]] = x;
		p[h[x/2]] = x/2;

		x = x/2;
	}
}

void popmin(int x)
{
	int aux;

	while (x>1 && c[h2[x]]<c[h2[x/2]])
	{
		aux = h2[x];
		h2[x] = h2[x/2];
		h2[x/2] = aux;
		
		p2[h2[x]] = x;
		p2[h2[x/2]] = x/2;

		x = x/2;
	}
}

void pushmax(int x)
{
	int aux, y = 0;

	while (x != y)
	{
		y = x;
		if (y*2<=n && c[h[x]]<c[h[y*2]]) x = y*2;
		if (y*2+1<=n && c[h[x]]<c[h[y*2+1]]) x = y*2+1;

		aux = h[x];
		h[x] = h[y];
		h[y] = aux;

		p[h[x]] = x;
		p[h[y]] = y;
	}
}

void pushmin(int x)
{
	int aux, y = 0;

	while (x != y)
	{
		y = x;
		if (y*2<=n && c[h2[x]]>c[h2[y*2]]) x = y*2;
		if (y*2+1<=n && c[h2[x]]>c[h2[y*2+1]]) x = y*2+1;

		aux = h2[x];
		h2[x] = h2[y];
		h2[y] = aux;

		p2[h2[x]] = x;
		p2[h2[y]] = y;
	}
}

int ready()
{
	int i, max=0,  max2=0, pos = 1;

	pos = h[1];
	max = c[h[1]];
	if (c[h[2]] > c[h[3]]) max2 = c[h[2]];
	else max2 = c[h[3]];

	for (i=1; i<=n; i++) 
		if (!((sum-c[i])&1))
		{
			if (pos == i && sum-c[i]-max2 >= max2) return i;
			if (pos != i && sum-c[i]-max >= max) return i;
		}

	return 0;
}

int main()
{
	freopen("borcane.in", "r", stdin);
	freopen("borcane.out", "w", stdout);

	int i, x, dest;

	scanf("%d ", &n);

	for (i=1; i<=n; i++) scanf("%d ",&c[i]);

	for (i=1; i<=n; i++)
	{
		h[i] = p[i] = i;
		popmax(i);

		h2[i] = p2[i] = i;
		popmin(i);
	}

	for (i=1; i<=n; i++) sum += c[i];

	dest = ready();

	while (!dest)
	{
	    for (i=1; i<=pas; i++) 
	    {
	  		if (c[h[2]] > c[h[3]]) x = 2;
		 	else x = 3;

		 	if (h[1]!=h2[1] && h[x]!=h2[1] && h[1]!=h[x]) 
		 	{
  				printf("%d %d %d\n",h[1], h[x], h2[1]);
			 	c[h[x]]--;
				popmin(p2[h[x]]);
			 	pushmax(x);

				c[h[1]]--;
				popmin(p2[h[1]]);
			 	pushmax(1);
		 	
		 	 	c[h2[1]] += 2;
				popmax(p[h2[1]]);
			 	pushmin(1);
		 	}
		 	else break;
		}

		dest = ready();
	}

	sum -= c[dest];
	
	c[dest] = 0;
	pushmax(p[dest]);

	for (i=1; i<=sum/2; i++)
	{
		if (c[h[2]] > c[h[3]]) x = 2;
		else x = 3;

		printf("%d %d %d\n", h[1], h[x], dest);

		c[h[x]]--;
		pushmax(x);

		c[h[1]]--;
		pushmax(1);
	}

	return 0;
}
