#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

#define maxn 2010
#define maxt 1010
#define pb push_back

int n, m, sol, t, l;
int c[maxn], g[maxn];
int v[maxn];
int s[maxn][maxt];
vector <int> a[maxn];

void DFS(int nod, int tata)
{
	int i, aux;

	for (i=0; i<g[nod]; i++)
		if (a[nod][i] != tata) DFS(a[nod][i], nod);

	if (t<=m) c[nod] = t - s[nod][t];
	else c[nod] = t;

	l = 0;
	for (i=0; i<g[nod]; i++) 
	  if (a[nod][i] != tata) v[++l] = c[a[nod][i]];

	sort(v+1, v+l+1);

	for (i=1; i<=l; i++)
	{
		if (v[i]-i<=m) aux = v[i]-i-s[nod][v[i]-i];
		else aux = v[i]-i;
		c[nod] = min(c[nod], aux);
	}
}

int main()
{
	freopen("tcast.in", "r", stdin);
	freopen("tcast.out", "w", stdout);

	scanf("%d %d ",&n ,&m);

	int i, j, x, y;

	for (i=1; i<n; i++) 
	{
		scanf("%d %d ",&x, &y);
		a[x].pb(y);
		a[y].pb(x);
	}

	for (i=1; i<=n; i++) g[i] = a[i].size();

	int front = 0, middle, back = n+m;
	sol = n+m;

	for (i=1; i<=n; i++) 
		for (j=1; j<=m; j++) scanf("%d ",&s[i][j]);

	for (i=1; i<=n; i++)
		for (j=1; j<=m; j++) 
			if (s[i][j]!=0) s[i][j] += s[i][j-1];

	while (front <= back)
	{
		middle = t =  (front+back)/2;

		DFS(1, -1);
		
		if (c[1] > 0) 
		{
			sol = middle;
			back = middle-1;
		}
		else front = middle+1;
	}

	printf("%d\n", sol-1);

	return 0;
}
