#include <cstdio>

const int NMAX = 128;

int N, B[NMAX];

void read(void) {
	FILE *fin = fopen("borcane.in", "rt");
	int i;

	fscanf(fin, " %d", &N);

	for (i = 1; i <= N; ++i)
		fscanf(fin, " %d", B + i);

	fclose(fin);
}

inline void work(FILE *fout, int i, int j, int D) {
	fprintf(fout, "%d %d %d\n", i, j, D);
	--B[i]; --B[j]; B[D] += 2;
}

void write(void) {
	FILE *fout = fopen("borcane.out", "wt");
	int i, j, k, D;

	for (D = 1; B[D] == 0; ++D);

	i = D + 1;
	while (1) {
		for (; i <= N && B[i] == 0; ++i);
		for (j = i + 1; j <= N && B[j] == 0; ++j);
		if (j > N) {
			if (i <= N) {
				for (j = 1; j <= N && B[j] != 0; ++j);
				while (B[i] >= 3) {
					work(fout, D, i, j);
					work(fout, i, j, D);
					work(fout, i, j, D);
				}

				if (B[i] == 1) {
					work(fout, D, i, j);
					k = i; i = j; j = k;
				}
				if (B[i] == 2) {
					work(fout, D, i, j);

					for (k = 1; k <= N && B[k] != 0; ++k);
					
					work(fout, D, j, k);
					work(fout, i, k, D);
					work(fout, j, k, D);
				}
			}
			break;
		}

		while (B[i] && B[j]) work(fout, i, j, D);
	}
 
	fclose(fout);
}

int main(void) {

	read();

	write();

	return 0;
}
