#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

#define nm 805
#define mm 640010

const int dx[4] = {0, -1, 0, 1};
const int dy[4] = {1, 0, -1, 0};

int n, m, diff, a[nm][nm], used[nm][nm], r[mm], sol[nm][nm];
vector< pair< int, pair<int, int> > > v;
vector<int> mat[nm];

int bs(int crt, int val)
{
	int len = mat[crt].size(), rez = -1, step = 1 << 17;

	for (; step; step /= 2)
		if (rez + step < len && mat[crt][rez + step] < val)
			rez += step;

	//printf("debug: %d %d %d %d\n", crt, val, len, rez);

	return len - rez - 1;
}

int f(int a)
{
	if (r[a] != r[r[a]])
		r[a] = f(r[a]);

	return r[a];
}

int main()
{
	freopen("mexc.in", "r", stdin);
	freopen("mexc.out", "w", stdout);

	scanf("%d%d%d", &n, &m, &diff);

	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j) {
			scanf("%d", &a[i][j]);

			v.push_back(make_pair(a[i][j], make_pair(i, j)));
		}

	sort(v.begin(), v.end());

	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= m; ++j) {
			int p1 = (i - 1) * m + j;

			r[p1] = p1;
			mat[p1].push_back(a[i][j]);
		}

	int pos = n * m - 1;

	for (int i = n * m - 1; i >= 0; --i) {
		for (; pos >= 0 && v[pos].first >= v[i].first - diff; --pos) {
			int x = v[pos].second.first, y = v[pos].second.second, p1 = (x - 1) * m + y;

			for (int d = 0; d < 4; ++d)
				if (x + dx[d] > 0 && x + dx[d] <= n && y + dy[d] > 0 && y + dy[d] <= m && a[x + dx[d]][y + dy[d]] >= a[v[i].second.first][v[i].second.second] - diff) {
					int p2 = (x + dx[d] - 1) * m + (y + dy[d]);

					if (f(p1) != f(p2)) {
						vector<int> aux;

						for (int len1 = mat[r[p1]].size(), len2 = mat[r[p2]].size(), pos1 = 0, pos2 = 0; pos1 < len1 || pos2 < len2;)
							if (pos2 >= len2 || (pos1 < len1 && mat[r[p1]][pos1] < mat[r[p2]][pos2]))
								aux.push_back(mat[r[p1]][pos1++]);
							else
								aux.push_back(mat[r[p2]][pos2++]);

						mat[r[p1]] = aux;

						vector<int> ().swap(mat[r[p2]]);
				
						r[r[p2]] = r[p1];
					}
				}
		}
	
		int x = v[i].second.first, y = v[i].second.second, p1 = (x - 1) * m + y;
	
		f(p1);

		sol[v[i].second.first][v[i].second.second] = bs(r[p1], v[i].first);
/*	
		printf("%d  %d   ", pos, p1);
		for (int len = mat[r[p1]].size(), j = 0; j < len; ++j)
			printf("%d ", mat[r[p1]][j]);
		printf("\n");
*/
	}

	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j)
			printf("%d ", sol[i][j]);
		printf("\n");
	}

	return 0;
}
