#include <stdio.h>
#include <algorithm>
#include <vector>

#define nmax 805
#define vmax 100005
#define bmax 80000
#define pb push_back

using namespace std;
typedef pair<int, int> ii;
typedef pair<int, ii> iii;

int vx[] = {0, 0, 1, -1};
int vy[] = {1, -1, 0, 0};
int cx, cy;
int n, m, d, px, py, last, cnt = 0, ultim, bostan;
int a[nmax][nmax], c[nmax][nmax], sol[nmax][nmax];
short dx[nmax][nmax], dy[nmax][nmax], rang[nmax][nmax];
ii aux, aux1, aux2;
char s[bmax];
vector <iii> v;
vector <ii> e[vmax];

inline void create(int x, int y)
{
	dx[x][y] = x, dy[x][y] = y;
}

inline ii tata(int x, int y)
{
	if(dx[x][y] == x && dy[x][y] == y) ;
	else 
	{
		ii aux = tata(dx[x][y], dy[x][y]);
		dx[x][y] = aux.first, dy[x][y] = aux.second;
	}
	return ii(dx[x][y], dy[x][y]);
}

inline void uneste(int x1, int y1, int x2, int y2)
{
	aux1 = tata(x1, y1);
	aux2 = tata(x2, y2);
	if(aux1 == aux2) return ;

	if(rang[aux1.first][aux1.second] >= rang[aux2.first][aux2.second])
	{
		dx[aux2.first][aux2.second] = aux1.first;
		dy[aux2.first][aux2.second] = aux1.second;
		c[aux1.first][aux1.second] += c[aux2.first][aux2.second];
		if(rang[aux1.first][aux1.second] == rang[aux2.first][aux2.second])
			rang[aux1.first][aux1.second]++;
	}
	else
	{
		dx[aux1.first][aux1.second] = aux2.first;
		dy[aux1.first][aux1.second] = aux2.second;
		c[aux2.first][aux2.second] += c[aux1.first][aux1.second];
	}
}

inline void extinde(int val)
{
	cnt++;
	bostan = e[val].size();
	for(int i = 0; i < bostan; i++)
		for(int j = 0; j < 4; j++)
		{
			cx = e[val][i].first, cy = e[val][i].second;
			if(a[cx + vx[j]][cy + vy[j]] >= a[cx][cy]) uneste(cx, cy, cx + vx[j], cy + vy[j]);
		}
}

int main()
{
	freopen("mexc.in", "r", stdin);
	freopen("mexc.out", "w", stdout);

	scanf("%d%d%d", &n, &m, &d); last = 0;
	for(int i = 1; i <= n; i++)
		for(int j = 1; j <= m; j++) 
		{
			scanf("%d", &a[i][j]);
			last = max(last, a[i][j]);
			e[a[i][j]].pb(ii(i, j));
		}

	last++;
	v.reserve(n * m + 5);
	for(int i = 0; i <= last; i++)
		for(int j = 0; j < (int)e[i].size(); j++)
			v.pb(iii(i, e[i][j]));

	for(int i = 1; i <= n; i++)
		for(int j = 1; j <= m; j++) 
			create(i, j);

	ultim = last + 1; 
	int leng = v.size() - 1, l1, val;
	for(int i = leng; i >= 0; i--)
	{
		l1 = e[v[i].first].size(), val = v[i].first;
		if(v[i].first != ultim)
			for(int j = 0; j < l1; j++)
			{
				aux = tata(e[val][j].first, e[val][j].second);
				c[aux.first][aux.second]++;
			}
		ultim = val;

		while(last - 1 >= val - d && last >= 0)
		{
			last--;
			extinde(last);
		}

		aux = tata(v[i].second.first, v[i].second.second);
		sol[v[i].second.first][v[i].second.second] = c[aux.first][aux.second];
	}

	for(int i = 1; i <= n; i++)
	{
		for(int j = 1; j <= m; j++) printf("%d ", sol[i][j]);
		printf("\n");
	}

	return 0;
}
