#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;

#define pb push_back
#define np next_permutation

#define N 2048
#define T 1024

#define INF 0x3f3f3f3f


vector<short int> graf[N];
short int sol[N][T], timp[N][N], cost[N][N], perm[N];
struct Adanc { short int pos, val; } adanc[N], coada[N];


inline int maxim(int a, int b) {
if (a<b) return b;
return a; }


int comp(const void *a, const void *b) {
Adanc *x=(Adanc*)a;
Adanc *y=(Adanc*)b;
return y->val-x->val; }


void fill(int nod, int v) {
if (adanc[nod].val) return;

adanc[nod].val=v;
for (int i=0; i<(int)graf[nod].size(); i++)
   fill(graf[nod][i], v+1); }


int main() {
freopen("tcast.in", "rt", stdin);
freopen("tcast.out", "wt", stdout);

int n, t;
scanf("%d%d", &n, &t);

for (int x, y, i=1; i<n; i++) {
   scanf("%d%d", &x, &y);
   graf[x].pb(y);
   graf[y].pb(x); }

for (int i=1; i<=n; i++) {
   adanc[i].pos=i;
   for (int j=0; j<t; j++)
      scanf("%d", &timp[i][j]); }
   

fill(1, 1);
for (int i=1; i<=n; i++) adanc[i].val--;
memcpy(coada, adanc, (n+1)*sizeof(Adanc));
qsort(&coada[1], n, sizeof(Adanc), comp);


for (int i=1; i<=n; i++) {
   int nod=coada[i].pos;
   int adi=coada[i].val;

   vector<int> fiu, baga;
   for (int j=0; j<(int)graf[nod].size(); j++)
      if (adanc[graf[nod][j]].val > adi)
         fiu.pb(graf[nod][j]);

   int fii=fiu.size();
   if (fii==0)
      for (int j=adi; j<=t; j++)
         sol[nod][j]=j;
   else {
      for (int j=0; j<fii; j++)
         baga.pb(sol[fiu[j]][t]);
      sort(baga.begin(), baga.end());

      int min=INF, tmp;
      for (int j=0; j<fii; j++) {
         tmp=baga[j]+fii-j;
         if (min>tmp)
            min=tmp;
            }
      sol[nod][t]=min;

      for (int j=t-1; j>=adi; j--)
         if (timp[nod][j])
            sol[nod][j]=sol[nod][j+1];
         else {
            for (int k=0; k<fii; k++)
               for (int w, l=0; l<fii; l++) {
                  w=j+1+l;
                  if (w>t)
                     cost[k][l]=sol[fiu[k]][t]+w-t;
                  else
                     cost[k][l]=sol[fiu[k]][w]; }

            for (int k=0; k<fii; k++) perm[k]=k;

            min=INF;
            do {
               tmp=0;
               for (int k=0; k<fii; k++)
                  tmp=maxim(tmp, cost[k][perm[k]]);
               if (min>tmp)
                  min=tmp; }
            while (np(perm, perm+fii));

            sol[nod][j]=min; } } }

printf("%d\n", sol[1][0]);
return 0; }

