#include <cstdio>
#include <algorithm>

using namespace std;

#define Nmax 815
#define pii pair<int, int>
#define str pair<int, pii>
#define mp make_pair
#define cost first
#define x second.first
#define y second.second

int n, m, d, ct;
int mat[Nmax][Nmax];
str muc[2 * Nmax * Nmax];
int t[Nmax * Nmax];
int h[Nmax * Nmax];
int nr[Nmax * Nmax];
int sir[Nmax * Nmax];
int sol[Nmax][Nmax];

void citire()
{
	int i, j;

	scanf("%d %d %d\n", &n, &m, &d);
	for (i = 0; i < n; ++i)
		for (j = 0; j < m; ++j)
			scanf("%d", &mat[i][j]);
}

int cmp(const int a, const int b)
{
	int x1 = a / m;
	int y1 = a % m;
    int x2 = b / m;
	int y2 = b % m;
	
	return mat[x1][y1] > mat[x2][y2];
}

void uneste(int a, int b)
{
	if (h[a] < h[b])
	{
		t[a] = b;
		nr[b] += nr[a];
	}
	else
	{
		t[b] = a;
		nr[a] += nr[b];
	}
	if (h[a] == h[b]) ++h[a];
}

int find(int a)
{
	if (t[a] != a) t[a] = find(t[a]);
	return t[a];
}

void solve()
{
	int i, j, ind = 1, x0, y0, ind0 = 0;

	for (i = 0; i < n; ++i)
		for (j = 0; j < m; ++j)
		{
			if (j + 1 < m) muc[++ct] = mp(min(mat[i][j], mat[i][j + 1]), mp(i * m + j, i * m + j + 1));
			if (i + 1 < n) muc[++ct] = mp(min(mat[i][j], mat[i + 1][j]), mp(i * m + j, (i + 1) * m + j));
		}
	sort(muc+1, muc+ct+1);
	reverse(muc+1, muc+ct+1);
	
	for (i = 0; i < n * m; ++i)
	{
		sir[i] = i;
		t[i] = i;
		h[i] = 1;
	}
	sort(sir, sir + n * m, cmp);

	for (i = 0; i < n * m; ++i)
	{
		x0 = sir[i] / m;
		y0 = sir[i] % m;
		
		while (ind < ct && muc[ind].cost >= mat[x0][y0] - d)
		{
			if (find(muc[ind].x) != find(muc[ind].y))
				uneste(find(muc[ind].x), find(muc[ind].y));
			++ind;
		}

		while (ind0 < n * m && mat[sir[ind0] / m][sir[ind0] % m] == mat[x0][y0])
			++nr[find(sir[ind0++])];

		sol[x0][y0] = nr[find(sir[i])];
	}

	for (i = 0; i < n; ++i)
	{
		for (j = 0; j < m; ++j)
			printf("%d ", sol[i][j]);
		printf("\n");
	}
}

int main()
{
	freopen("mexc.in", "r", stdin);
	freopen("mexc.out", "w", stdout);

	citire();
	solve();

	return 0;
}
