#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

#define Nmax 2048
#define Tmax 3015
#define pb push_back
#define sz(a) (int)((a).size())

int n, t, ct;
int mat[Nmax][Tmax];
int D[Nmax][Tmax];
int list[Nmax];
int tata[Nmax];
int sir[Nmax];
int last[Nmax];
int prev[Tmax];
vector<int> lv[Nmax];
char s[Tmax], *buf;

int get()
{
	int ret = 0;
	
	while (*buf == ' ') ++buf;
	ret = *buf - '0';
	++buf;

	return ret;
}

void citire()
{
	int i, j, a, b;

	scanf("%d %d\n", &n, &t);
	for (i = 1; i < n; ++i)
	{
		scanf("%d %d\n", &a, &b);
		lv[a].pb(b);
		lv[b].pb(a);
	}
	for (i = 1; i <= n; ++i)
	{
		fgets(s, Tmax, stdin);
		buf = s;
		for (j = 0; j < t; ++j)
			mat[i][j] = get();
	}
}

void DF(int nod)
{
	int i;

	for (i = 0; i < sz(lv[nod]); ++i)
		if (tata[nod] != lv[nod][i])
		{
			tata[lv[nod][i]] = nod;
			DF(lv[nod][i]);
		}

	list[++ct] = nod;
}

int cmp(const int a, const int b)
{
	return last[a] > last[b];
}

void solve()
{
	int i, j, k, nod, ok, timp, dr;

	DF(1);

	for (i = 1; i <= n; ++i)
	{
		nod = list[i];

		ct = 0;
		for (j = 0; j < sz(lv[nod]); ++j)
			if (lv[nod][j] != tata[nod])
				sir[++ct] = lv[nod][j];
		for (j = 1; j <= ct; ++j)
			last[sir[j]] = 3005;
		
		if (mat[nod][0]) prev[0] = -10;
		else prev[0] = 0;
		for (j = 1; j <= 3005; ++j)
			if (mat[nod][j]) prev[j] = prev[j - 1];
		    else prev[j] = j;

		timp = 3005;

		D[nod][3006] = 3006;
		for (j = 3005; j >= 0; --j)
		{
			D[nod][j] = D[nod][j + 1];
			
			ok = 1;
			while (timp >= ct && ok)
			{
 				for (k = 1; k <= ct; ++k)
				{
					while (last[sir[k]] >= 0 && D[sir[k]][last[sir[k]]] > timp) --last[sir[k]];
					if (last[sir[k]] < 0) ok = 0;
				}
				sort(sir+1, sir+ct+1, cmp);
    	             
				dr = timp;
				if (ok)
				{
					for (k = 1; k <= ct && dr > 0; ++k)
						dr = min(prev[dr - 1], prev[last[sir[k]] - 1]);
					if (dr <= 0 && k <= ct) ok = 0;
				}

				for (k = 1; k <= ct; ++k)
					if (last[sir[k]] < 0) ok = 0;
				
				if (!ok || timp < j || dr < j) ok = 0;
				else D[nod][j] = timp--;
			}
		}
	}

	printf("%d\n", D[1][0]);
}

int main()
{
	freopen("tcast.in", "r", stdin);
	freopen("tcast.out", "w", stdout);

	citire();
	solve();

	return 0;
}
