#include <stdio.h>
#define NMAX 128
#define INF 666000666

int V[NMAX], U[NMAX], N;
int T[2*NMAX], T2[2*NMAX];

void read()
{
        int i;

        scanf("%d", &N);

        for (i = 0; i < N; i++)
                scanf("%d", &U[i]);
}

void update(int x)
{
        int nod = NMAX+x, l;

        T[nod] = x;

        while (nod>1)
        {
                nod = nod>>1;
                l = nod<<1;
                T[nod] = T[l];
                if (V[ T[l] ]>V[ T[l+1] ]) T[nod] = T[l+1];
        }
}

int u[NMAX];

int bulan(int a, int b)
{
        int i, j, x, y, aux, t;

        for (i = 0; i < N; i++) V[i] = U[i], u[i] = U[i];
        V[a] = V[b] = INF;
        for (i = 0; i < N; i++) update(i);

        while (1)
        {
                i = T[1];
                aux = V[i]; V[i] = INF;
                update(i);
                j = T[1];
                V[i] = aux;

                if (V[j]==INF) break;

                x = a; y = b;
                if (u[x]<u[y]) aux = x, x = y, y = aux;

                if (V[i]>=(u[x]-u[y]))
                {
                        V[i] -= (u[x]-u[y]);
                        u[y] = u[x];
                        t = V[i]/2;
                        u[x] += (2*t);
                        u[y] += 2*(V[i]-t);
                        V[j] -= V[i];
                        V[i] = INF;
                        if (!V[j]) V[j] = INF;
                }
                else
                {
                        u[y] += V[i];
                        V[j] -= V[i];
                        V[i] = INF;
                        if (!V[j]) V[j] = INF;
                }

                update(i); update(j);
        }

        j = 0;
        for (i = 0; i < N; i++)
                if (V[i]==INF) j++;

        if ((j==N) && (u[a]==u[b])) return 1;
        return 0;
}

int ccc;

int bulan2(int a, int b)
{
        int i;
        if (u[a]==u[b])
        {
                for (i = 0; i < N; i++)
                        if (V[i]<INF) ccc = i;
                return 1;
        }

        return 0;
}

void write(int a, int b)
{
        int i, j, n, m, min;

        while (1)
        {
                n = m = -1;
                for (i = 0; i < N; i++)
                        if (U[i]>0 && i!=a && i!=b)
                                if (m<0) m = i;
                                else
                                {
                                        n = i;
                                        break;
                                }
                if (m<0) break;

                min = a;
                if (U[a]>U[b]) min = b;
                printf("%d %d %d\n", m+1, n+1, min+1);
                U[m]--; U[n]--; U[min]+=2;
        }

        for (i = 0; i < N; i++)
                if (U[i]==0) break;

        while (U[a])
        {
                printf("%d %d %d\n", a+1, b+1, i+1);
                U[a]--; U[b]--; U[i] += 2;
        }
}

void write2(int a, int b)
{
        int i, j, n, m, min, nr;

        while (1)
        {
                n = m = -1;
                for (i = 0; i < N; i++)
                        if (U[i]>0 && i!=a && i!=b)
                                if (m<0) m = i;
                                else
                                {
                                        n = i;
                                        break;
                                }
                if (U[a]==U[b])
                {
                        for (i = nr = 0; i < N; i++)
                                if (U[i]>0) nr++;
                        if (nr<=3) break;
                }

                min = a;
                if (U[a]>U[b]) min = b;
                printf("%d %d %d\n", m+1, n+1, min+1);
                U[m]--; U[n]--; U[min]+=2;
        }

        i = ccc;
        while (U[a])
        {
                printf("%d %d %d\n", a+1, b+1, i+1);
                U[a]--; U[b]--; U[i] += 2;
        }
}

void solve()
{
        int i, j, ok=0, x, y;

        for (i = 0; !ok && i < N; i++)
                for (j = i+1; !ok && j < N; j++)
                        if ((U[i]&1)==(U[j]&1))
                             if (bulan(i,j))
                             {
                                ok = 1;
                                write(i,j);
                             }
                             else
                                if (bulan2(i,j))
                                {
                                        ok = 1;
                                        write2(i,j);
                                }
}

int main()
{
        freopen("borcane.in", "r", stdin);
        freopen("borcane.out", "w", stdout);

        read();
        solve();
        
        return 0;
        
}


