#include <cstdio>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;

const char iname[] = "borcane.in";
const char oname[] = "borcane.out";

#define FOR(i, a, b)  for (int i = (int)(a); i < (int)(b); ++ i)
#define FORI(i, V) for (__typeof(V.begin()) i = V.begin(); i != V.end(); ++ i)

int n;   vector <int> V;

FILE *fo;

struct classcomp {
    bool operator () (pair <int, int> a, pair <int, int> b) const {
         return a.first > b.first;
    }
};

multiset <pair <int, int>, classcomp > myset;

void work(vector <int> &V, int sink)
{
    int sum = 0;

    FOR (i, 0, V.size()) {
        myset.insert(make_pair(V[i], i));
        sum += V[i];
    }

    FOR (pas, 0, sum / 2) {
        pair <int, int> p = *myset.begin();
        myset.erase(myset.begin());
        int a = p.second + 1;
        pair <int, int> q = *myset.begin();
        myset.erase(myset.begin());
        int b = q.second + 1;

        p.first --, myset.insert(p);
        q.first --, myset.insert(q);
        fprintf(fo, "%d %d %d\n", a, b, sink);
    }
}

int main(void)
{
    FILE *fi = fopen(iname, "r");
    fscanf(fi, "%d", &n);
    V.resize(n);
    FOR (i, 0, n)  fscanf(fi, "%d", &V[i]);

    fo = fopen(oname, "w");
    
    int sum = 0;
    FORI (i, V)  sum += *i;
    FOR (i, 0, V.size()) if (((sum - V[i]) & 1) == 0)
    {
        V[i] = 0;
        work(V, i+1);
        break ;
    }

    fcloseall();
    return 0;
}
