program mexc;
  const
    fin='mexc.in';
    fout='mexc.out';
    nmax=803;
    inf=maxlongint shr 1;

var
  h,nr,nrf:array[0..nmax,0..nmax] of longint;
  a:array[0..nmax,0..nmax] of longint;
  tatax,tatay:array[0..nmax,0..nmax] of longint;
  viz:array[0..nmax,0..nmax] of boolean;
  start,stop,lg,d,m,n,i,j,k,x,y,tmp,tx,ty:longint;
  stx,sty:array[1..nmax*nmax] of longint;
  sx,sy:array[0..nmax*nmax] of longint;

procedure find(x,y:longint;var tx,ty:longint);
  var
    ist,i:longint;
  begin
    ist:=1;
    stx[1]:=x;sty[1]:=y;
    while stx[ist]<>0 do
      begin
        inc(ist);
        stx[ist]:=tatax[stx[ist-1],sty[ist-1]];
        sty[ist]:=tatay[stx[ist-1],sty[ist-1]];
      end;
    dec(ist);
    tx:=stx[ist];ty:=sty[ist];
    for i:=ist-1 downto 1 do
      begin
        tatax[stx[i],sty[i]]:=tx;tatay[stx[i],sty[i]]:=ty;
      end;
  end;

procedure uneste(x,y,xx,yy:longint);
  var
    x1,y1,x2,y2:longint;
  begin
    find(x,y,x1,y1);
    find(xx,yy,x2,y2);
    if (x1<>x2)or(y1<>y2) then
      begin
        if h[x1,y1]=h[x2,y2] then
          begin
            tatax[x1,y1]:=x2;
            tatay[x1,y1]:=y2;
            inc(h[x2,y2]);
            inc(nr[x2,y2],nr[x1,y1]);
          end
        else if h[x1,y1]>h[x2,y2] then
          begin
            tatax[x2,y2]:=x1;
            tatay[x2,y2]:=y1;
            inc(nr[x1,y1],nr[x2,y2]);
          end
        else
          begin
            tatax[x1,y1]:=x2;
            tatay[x1,y1]:=y2;
            inc(nr[x2,y2],nr[x1,y1]);
          end;
      end;
  end;

procedure sort(st,dr:longint);
  var
    i,j,m,tmp:longint;
  begin
    i:=st;j:=dr;
    m:=a[sx[(st+dr)shr 1],sy[(st+dr)shr 1]];
    repeat
      while a[sx[i],sy[i]]>m do
        inc(i);
      while a[sx[j],sy[j]]<m do
        dec(j);
      if i<=j then
        begin
          tmp:=sx[i];sx[i]:=sx[j];sx[j]:=tmp;
          tmp:=sy[i];sy[i]:=sy[j];sy[j]:=tmp;
          inc(i);dec(j);
        end;
    until i>j;
    if i<dr then
      sort(i,dr);
    if j>st then
      sort(st,j);
  end;

begin
  assign(input,fin);
    reset(input);
    readln(n,m,d);
    lg:=0;
    for i:=1 to n do
      for j:=1 to m do
        begin
          read(a[i,j]);
          inc(lg);
          sx[lg]:=i;sy[lg]:=j;
        end;
    sort(1,lg);
    for i:=0 to n+1 do
      begin
        a[0,i]:=inf;
        a[m+1,i]:=inf;
      end;
    for i:=0 to m+1 do
      begin
        a[i,0]:=inf;
        a[n+1,i]:=inf;
      end;
  close(input);
  assign(output,fout);
    rewrite(output);
    for i:=1 to n do
      for j:=1 to m do
        begin
          tatax[i,j]:=0;
          tatay[i,j]:=0;
          h[i,j]:=1;
          nr[i,j]:=1;
        end;
    sx[lg+1]:=-1;sy[lg+1]:=-1;
    start:=1;stop:=0;
    for i:=1 to lg do
      begin
        inc(stop);
        x:=sx[i];y:=sy[i];
        if (a[x-1,y]>=a[x,y]-d) then
          uneste(x-1,y,x,y);
        if (a[x,y-1]>=a[x,y]-d) then
          uneste(x,y-1,x,y);
        if (a[x+1,y]>=a[x,y]-d) then
          uneste(x+1,y,x,y);
        if (a[x,y+1]>=a[x,y]-d) then
          uneste(x,y+1,x,y);
        if a[x,y]<>a[sx[i+1],sy[i+1]] then
          begin
            for j:=start to stop do
              begin
                find(sx[j],sy[j],tx,ty);
                nrf[sx[j],sy[j]]:=nr[tx,ty];
              end;
            start:=i+1;
            stop:=i;
          end;
      end;
    for i:=1 to n do
      begin
        for j:=1 to m do
          write(nrf[i,j],' ');
        writeln;
      end;
  close(output);
end.