#include <stdio.h>

int N, v[ 128 ];

void cit() {
	int i;
	
	scanf( "%d", &N );
	for( i = 1; i <= N; i++ )
		scanf( "%d", v+i );
}

void muta( int a, int b, int c ) {
	v[a]--, v[b]--, v[c] += 2;
	printf( "%d %d %d\n", a, b, c );
}

void goleste( int b, int c, int d ) {
	while( v[b] >= 3 ) {
		muta( 1, b, c );
		muta( c, b, 1 );
		muta( c, b, 1 );
	}
	switch( v[b] ) {
		case 1:
			// v[1] >= 3
			muta( 1, b, c );
			muta( 1, c, b );
			muta( 1, b, d );
			muta( b, d, 1 );
			muta( c, d, 1 );
			break;
		case 2:
			// v[1] >= 2
			muta( 1, b, c );
			muta( 1, c, d );
			muta( b, d, 1 );
			muta( c, d, 1 );
			break;
	}
}

void rez() {
	int i, j, b, c, d;

	//first pass
	for( i = 2; i <= N; i++ )
		if( v[i] > 0 )
			for( j = i+1; j <= N; j++ )
				while( v[i]>0 && v[j]>0 )
					muta( i, j, 1 );

	if( v[1] == 0 ) {
		for( i = 2; v[i] == 0; i++ ); b = i;
		for( ++i; v[i] == 0; i++ ); c = i;
		muta( b, c, 1 );
	}
	if( v[1] == 1 ) {
		for( i = 2; v[i] == 0; i++ ); b = i;
		if( b-1 > 1 ) c = b-1; else c = b+1;

		for( ++i; i <= N; i++ )
			if( v[i] > 0 ) break;
		if( i > N ) { // nu am gasit inca unul diferit de 0
			muta( 1, b, c );
			muta( b, c, 1 );
			muta( b, c, 1 );
		}
		else
			muta( b, i, 1 );
	}
	if( v[1] == 2 ) {
		for( i = 2; v[i] == 0; i++ ); b = i;
		if( b-1 > 1 ) c = b-1; else c = b+1;
		for( ++i; i <= N; i++ )
			if( v[i] > 0 ) break;
		if( i > N ) { // nu am gasit inca unul diferit de 0
			muta( 1, b, c );
			muta( b, c, 1 );
		}
		else
			muta( b, i, 1 );
	}

	// v[1] >= 3
	for( i = 2; i <= N; i++ ) {
		if( v[i] ) {
			b = i;
			for( j = 2; j == i; j++ ); c = j;
			for( ++j; j == i; j++ ); d = j;
			goleste( b, c, d );
		}
	}
}

int main() {
	freopen( "borcane.in", "r", stdin );
	freopen( "borcane.out", "w", stdout );

	cit();
	rez();

	return 0;
}

