#include <cstdio>
#include <cmath>
#include <algorithm>
using namespace std;

const int N = 100000;

pair<int,int> v[N];

inline int min ( int a, int b ) { return (a < b) ? a : b; }
inline int abs ( int a ) { return (a < 0) ? -a : a; }
inline int dist ( int i, int j ) { return min(abs(v[i].first-v[j].first),abs(v[i].second-v[j].second)); }
bool cmp ( const pair<int,int> &a, const pair<int,int> &b ) { return (a.first == b.first) ? a.second > b.second : a.first < b.first; }

int main() {
	freopen("dist.in","rt",stdin);
	freopen("dist.out","wt",stdout);
	int n,i,j,d,max = 0;
	scanf("%d",&n);
	for (i = 0; i < n; ++i) scanf("%d %d",&v[i].second,&v[i].first);
	if (n < 2000) {
		for (i = 0; i < n; ++i) {
			for (j = i+1; j < n; ++j) {
				d = dist(i,j);
				if (max < d) max = d;
			}
		}
		printf("%d\n",max);
	} else {
		sort(v,v+n,cmp);
		int i,j,d,max;
		for (i = 1, j = 0, max = d = dist(i,j); i < n && j <= i; ) {
			if (i+1 < n && j+1 <= i) {
				if (dist(i+1,j) > dist(i,j+1)) {
					++i;
				} else {
					++j;
				}
			} else
			if (j+1 <= i) {
				++j;
			} else {
				++i;
			}
			if (i < n) {
				d = dist(i,j);
				if (max < d) max = d;
			}
		}
		printf("%d\n",max);
	}
	return 0;
}

