#include <stdio.h>
#include <time.h>
#include <vector>

using namespace std;

const int N_MAX = 100010;

int x[N_MAX], y[N_MAX];

inline int mabs(int a)
{
	return (a < 0 ? -a : a);
}

inline int MIN(int a, int b)
{
	return (a < b ? a : b);
}

int main()
{
	freopen("dist.in", "r", stdin);
#ifndef _SCREEN_
	freopen("dist.out", "w", stdout);
#endif

	int N;
	
	scanf("%d\n", &N);
	for (int i = 1; i <= N; i ++) {
		scanf("%d %d\n", &x[i], &y[i]);
	}

	int MAX = 0;

	if (N > 2500) N = 2500;
	for (int i = 1; i < N; i ++) {
		for (int j = i + 1; j <= N; j ++) {
			int d = MIN(mabs(x[i] - x[j]), mabs(y[i] - y[j]));
			if (d > MAX) MAX = d;
		}
	}
	
	printf("%d\n", MAX);
	
	return 0;
}
