#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;

#define NMAX 100010
#define INF 1000000000
#define x first
#define y second

int N, stepmax;

pair <int, int> a[NMAX];

int dst_st[2][NMAX];
int dst_dr[2][NMAX];

inline int MIN(int a, int b) { return (a < b) ? a : b; }
inline int MAX(int a, int b) { return (a > b) ? a : b; }
inline int ABS(int x) { return (x < 0) ? -x : x; }
/*
int gen(int N)
{
	freopen("dist.in", "w", stdout);

	printf("%d\n", N);

	int i;
	for (i = 1; i <= N; i++) printf("%d %d\n", rand() % 10000, rand() % 10000);

	fclose(stdout);

	return 0;
}

int get_brute()
{
	int i, j, rez = 0;

	for (i = 1; i <= N; i++)
		for (j = 1; j <= N; j++)
			rez = MAX(rez, MIN( ABS(a[i].x - a[j].x), ABS(a[i].y - a[j].y) ) );

	return rez;
}
*/
int main()
{
//	srand(12312);
//	gen(100000);
	
	int i, p1, p2;

	freopen("dist.in", "r", stdin);
	freopen("dist.out", "w", stdout);

	scanf("%d", &N);

	for (i = 1; i <= N; i++) scanf("%d %d", &a[i].x, &a[i].y);

	sort(a + 1, a + N + 1);

	dst_st[0][0] = INF;
	dst_st[1][0] = -INF;
	for (i = 1; i <= N; i++) 
		dst_st[0][i] = MIN(a[i].y, dst_st[0][i-1]),
		dst_st[1][i] = MAX(a[i].y, dst_st[1][i-1]);

	dst_dr[0][N + 1] = INF;
	dst_dr[1][N + 1] = -INF;
	for (i = N; i >= 1; i--)
		dst_dr[0][i] = MIN(a[i].y, dst_dr[0][i+1]),
		dst_dr[1][i] = MAX(a[i].y, dst_dr[1][i+1]);

	int step = 1 << 21;
	int x = 0, dc, q, e;
	for (; step; step >>= 1) {
		dc = x + step;
		p1 = 1; p2 = 1; e = 0;

		for (i = 1; i <= N; i++) {
			while (a[i].x - a[p1].x >= dc) p1++;
			while (p2 < i || a[i].x - a[p2].x < dc) p2++;

			q = 0;
			if (p1 > 1) 
	q = MAX( ABS(dst_st[0][p1 - 1] - a[i].y), ABS(dst_st[1][p1 - 1] - a[i].y) );
			if (p2 <= N)
		q = MAX( ABS(dst_dr[0][p2] - a[i].y), ABS( dst_dr[1][p2] - a[i].y) );

			if (q >= dc) { e = 1; break; }
		}

		if (e) x += step;
	}

	printf("%d\n", x);
//	printf("%d\n", get_brute());

return 0;
}

