#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

#define NMAX 100002
#define VMAX 2000002
#define pb push_back
#define sz size()
#define mp make_pair
#define ss second
#define ff first
#define INF 0x3f3f3f3f


pair<long int,long int> v[NMAX];

long int mxi[VMAX],mni[VMAX],mxs[VMAX],mns[VMAX],nr[VMAX];
long int n,sol,N;

inline int verif(long int v, long int x, long int y)
{
long int n1,n2;
if (x+v+1>N) n1=n;
   else n1=nr[x+v+1];

if (x-v<=0) n2=0;
   else n2=nr[x-v];

if (n1-n2==n) return 0;

if (x>v) if (nr[x-v])
            {
            if (mni[x-v]<y-v) return 1;
            if (mxi[x-v]>y+v) return 1;
            }

if (x+v<=N) if (nr[x+v]<n)
              {
              if (mns[x+v]<y-v) return 1;
              if (mxs[x+v]>y+v) return 1;
              }
return 0;
}

int main()
{
   freopen("dist.in","r",stdin);
   freopen("dist.out","w",stdout);

   long int i,j,k,x,y,mn;

   scanf("%ld",&n);

   for (i=1;i<=n;i++)
       {
       scanf("%ld %ld",&x,&y);

       v[i]=mp(x,y);
       }

   sort(v+1,v+n+1);

   mn=INF;
   for (i=1;i<=n;i++)
       mn=min(mn,v[i].ff);
   for (i=1;i<=n;i++) v[i].ff=v[i].ff-mn+1;

   mn=INF;
   for (i=1;i<=n;i++)
       mn=min(v[i].ss,mn);
   for (i=1;i<=n;i++) v[i].ss=v[i].ss-mn+1;

   N=0;
   for (i=1;i<=n;i++)
       N=max(N,v[i].ff);

   v[0]=mp(-1,0);
   v[n+1]=mp(N+2,0);

   mxi[0]=0;
   mni[0]=INF;
   nr[0]=0;
   for (i=1,j=0;i<=N;i++)
       {
        mxi[i]=mxi[i-1];
        mni[i]=mni[i-1];
        nr[i]=nr[i-1];

        if (v[j+1].ff<i)
           {
           j++;
           nr[i]++;
           mxi[i]=max(mxi[i],v[j].ss);
           mni[i]=min(mni[i],v[j].ss);
           }           
       }
       

   mxs[N+1]=0;
   mns[N+1]=INF;
   for (i=N,j=n+1;i;i--)
       {
        mxs[i]=mxs[i+1];
        mns[i]=mns[i+1];

        if (v[j-1].ff>i)
           {
           j--;
           mxs[i]=max(mxs[i],v[j].ss);
           mns[i]=min(mns[i],v[j].ss);
           }
       }

   long int st,mid,dr;


   sol=0;
   for (i=1;i<=n;i++)
       {
       x=v[i].ff;y=v[i].ss;

       st=0;dr=(1<<21);
       while (st<dr-1)
             {
             mid=(st+dr)/2;
             if ( verif(mid,x,y) ) st=mid;
                else dr=mid;
             }
       if ( verif(st,x,y) ) sol=max(sol,dr);
          else sol=max(sol,st);
       }
   printf("%ld",sol);
   return 0;
}
