#include<stdio.h>
#include<vector>
#include<algorithm>

using namespace std;

#define pb push_back
#define mkp make_pair
#define ff first
#define ss second
#define ppi pair <pair<int,int>, int>


const int maxl = 1000010;
const int maxn = 100100;
const int INF = 10000000;

vector <ppi > VECT;
vector <int> VECT2;
bool cmpf(const ppi a,const ppi b)
{
	return (a.ff.ss < b.ff.ss || (a.ff.ss == b.ff.ss && a.ff.ff > b.ff.ff));	
}

int DIN[maxn],VAL,NOD,ST,DR,ARB[maxn * 18][2];
int P,ANS,POZ,POZMIN,POZMAX,N,X[maxn],Y[maxn];

void update(int st,int dr,int nod)
{
//   if (ARB[nod][1] == 0) ARB[nod][1] = INF;
	int mid = (st + dr) / 2;
	if (st == dr)
	{
		ARB[nod][0] = max(ARB[nod][0],VAL);
   	ARB[nod][1] = min(ARB[nod][1],VAL);
		return ;	
	}
	if (POZ <= mid) update(st,mid,nod * 2);
	if (POZ > mid) update(mid + 1,dr,nod * 2 + 1);
	ARB[nod][0] = max(ARB[nod * 2][0],ARB[nod * 2 + 1][0]);
	ARB[nod][1] = min(ARB[nod * 2][1],ARB[nod * 2 + 1][1]);
}


int querry(int st,int dr,int nod,int tip)
{
//   if (ARB[nod][1] == 0) ARB[nod][1] = INF;

	if (ST <= st && dr <= DR) return ARB[nod][tip];
	int mid = (st + dr) / 2;
	if (DR <= mid) return querry(st,mid,nod * 2,tip);
	if (ST > mid) return querry(mid + 1,dr,nod * 2 + 1,tip);
	if (tip == 1) return min(querry(st,mid,nod * 2,tip),querry(mid + 1,dr,nod * 2 + 1,tip));
	return max(querry(st,mid,nod * 2,tip),querry(mid + 1,dr,nod * 2 + 1,tip));
}


inline int cautare(int VAL)
{
   int x = 0,p = P;
//   for(p = 1;p < N * 3; p <<= 1);
   for(;p;p >>= 1)
            if (x + p < N * 3 && VECT2[x + p] <= VAL) x += p;
   return x;

}

void solve()
{
	POZMIN = maxl;
	POZMAX = 0;
	VECT.clear();
   VECT2.clear();
	for(int i = 1;i <= N; ++i)
	{
      int ST = min(maxl + X[i] - Y[i],maxl + X[i] + Y[i]);
      int DR = max(maxl + X[i] - Y[i],maxl + X[i] + Y[i]);
		VECT.pb(mkp(mkp(ST,DR),i) );
      VECT2.pb(ST);
      VECT2.pb(DR);
	  VECT2.pb(maxl + X[i]);
//		POZMIN = min(POZMIN,maxl + X[i] - Y[i]);
//		POZMAX = max(POZMAX,maxl + X[i] + Y[i]);
	}
   POZMAX = N * 3;
	sort(VECT.begin(),VECT.end(),cmpf);
   sort(VECT2.begin(),VECT2.end());

	for(P = 1;P < N * 3;P <<= 1);

	for(int i = 1;i <= N; ++i)
	{
		int nod = VECT[i - 1].ss;
		ST = cautare(VECT[i - 1].ff.ff);
		DR = cautare(maxl + X[nod]);
		POZ = X[nod];
 		DIN[i] = POZ - querry(0,POZMAX,1,1);
		ST = cautare(maxl + X[nod]);
		DR = cautare(VECT[i - 1].ff.ss);
		DIN[i] = max(DIN[i],querry(0,POZMAX,1,0) - POZ);
		ANS = max(DIN[i],ANS);
		POZ = cautare(VECT[i - 1].ff.ff);
		VAL = X[nod];
		update(0,POZMAX,1);
	}
}

int main()
{
	freopen("dist.in","r",stdin);
	freopen("dist.out","w",stdout);
	scanf("%d",&N);
//   printf("%d\n",sizeof(ARB));
   for(int i = 1;i <= N; ++i)
	{
		scanf("%d %d",&X[i],&Y[i]);	
      X[i] += maxl;Y[i] += maxl;
   }
	for(int i = 1;i <= maxn * 18 - 10; ++i) ARB[i][1] = INF;
	solve();
    for(int i = 1;i <= N; ++i)
	{
		swap(X[i],Y[i]);
	}
   memset(ARB,0,sizeof(ARB));
   for(int i = 1;i <= maxn *  18 - 10; ++i) ARB[i][1] = INF;
   solve();
	printf("%d\n",ANS);
	
    return 0;
}


