#include <iostream>
#include <algorithm>
#include <fstream>

using namespace std;

typedef struct {
	int x, y;
} Pair;

int N;
Pair P[100001];

bool lt(const Pair &a, const Pair &b)
{
	if (a.x == b.x)
		return a.y < b.y;
	return a.x < b.x;
}

int main(int argc, char *argv[])
{
	FILE *fi = fopen("dist.in", "r");
	fscanf(fi, "%d", &N);
	for (int i(0); i < N; ++i)
		fscanf(fi, "%d %d", &P[i].x, &P[i].y);
	fclose(fi);

	sort(P, P + N, lt);

	/*cout << "Puncte: ";
	for (int i(0); i < N; ++i)
		cout << "(" << P[i].x << " " << P[i].y << ") ";
	cout << endl;*/

	int m = -1;

	//cout << N << endl;
	
	for (int i(0); (i < N) && (P[N-1].x - P[i].x > m); ++i)
		for (int j = N - 1; (j > i) && (P[j].x - P[i].x > m); --j) 
			m = max(m, min(P[j].x - P[i].x, P[j].y - P[i].y));

	ofstream fout("dist.out");
	fout << m << endl;
	fout.close();
	
	return 0;
}

