#include <cstdio>
#include <cstring>

#include <vector>
#include <stack>
using namespace std;

const int NMAX = 260;

vector<int> Neighb[NMAX], Dep[NMAX];
vector<int> Stk;
bool Used[NMAX], Check[NMAX];

int n, m, k, ans = 0;

void check() {
	int i, j, nf = 0;
	for (i = 0; i < Stk.size(); ++ i)
		Check[Stk[i]] = true;
	nf = k;
	
	for (i = 0; i < Stk.size(); ++ i)
		for (j = 0; j < Dep[Stk[i]].size(); ++ j)
			if (Check[Dep[Stk[i]][j]] == false)
				return;
				
	for (i = 0; i < k; ++ i)
		fprintf(stderr, "%d ", Stk[i]);
	fprintf(stderr, "\n");
	
	++ ans;
}

void back(int lvl) {
	int i;
	if (lvl == k - 1) {
		/*for (i = 0; i < k; ++ i)
			fprintf(stderr, "%d ", Stk[i]);
		fprintf(stderr, "\n");*/
	
		memset(Check, false, sizeof(Check));
		check();
		return;
	}
	
	int mst;
	if (lvl == -1)
		mst = n;
	else
		mst = Stk[lvl];
	
	for (i = 1; i <= mst; ++ i) {
		if (Used[i] == true)
			continue;
			
		Stk.push_back(i);
		Used[i] = true;
		back(lvl + 1);
		Used[i] = false;
		Stk.pop_back();
	}
}

void depthFirst(int src, int i) {
	vector<int>::iterator vi;
	for (vi = Neighb[i].begin(); vi != Neighb[i].end(); ++ vi)
		if (Used[*vi] == false) {
			Used[*vi] = true;
			Dep[src].push_back(*vi);
			depthFirst(src, *vi);
		}
}

int main() {
	freopen("dep.in", "r", stdin);
	freopen("dep.out", "w", stdout);
	
	scanf("%d %d %d", &n, &m, &k);
	int i, v1, v2;
	for (i = 0; i < m; ++ i) { 
		scanf("%d %d", &v1, &v2);
		Neighb[v1].push_back(v2);
	}
	
	for (i = 1; i <= n; ++ i) {
		memset(Used, false, sizeof(Used));
		Used[i] = true;
		depthFirst(i, i);
	}
	memset(Used, false, sizeof(Used));
	back(-1);
	
	int j;
	/*for (i = 1; i <= n; ++ i) {
		fprintf(stderr, "%d ", i);
		for (j = 0; j < Dep[i].size(); ++ j)
			fprintf(stderr, "%d ", Dep[i][j]);
		fprintf(stderr, "\n");
	}*/
	
	printf("%d\n", ans);

	return 0;
}
