#include <cstdio>
#include <cstring>
#include <climits>

const int NMAX = 505;

char Text[NMAX], Next[NMAX];
int n, ans = 0;

int ai, aj, al;

bool split() {
	int i, j, il, jr, len, gap;
	int minGap = INT_MAX, maxLen = 0;
	bool found = false;

	for (i = 0; i < n; ++ i)
		for (j = i; j < n; ++ j) {
			il = i; 
			jr = j;
			
			if (Text[i] != Text[j])
				continue;
			
			gap = j - i - 1;
			if (gap < 0)
				gap = 0;
				
			if (i == j)
				len = -1;
			else
				len = 0;
			while (il >= 0 && jr < n && Text[il] == Text[jr]) {
				-- il;
				++ jr;
				len += 2;
			}
			
			
			if ((i == il && j == jr) || (Text[il + 1] != Text[jr - 1]))
				continue;
			
			++ il, -- jr;
			
			if (jr - il + 1 == 1)
				continue;
			
			/*for (k = il; k <= jr; ++ k)
				fprintf(stderr, "%c", Text[k]);
			fprintf(stderr, " %d %d %d %d\n", il, jr, gap, len);*/
				
			if (len >= maxLen) {
				if (len == maxLen && gap < minGap)
					minGap = gap;
				maxLen = len;
				ai = il, aj = jr;
				found = true;
			}
			
		}
	
	if (found == false)
		return false;
		
	for (i = 0; i < ai; ++ i)
		Next[i] = Text[i];
	for (j = aj + 1; j < n; ++ j, ++ i)
		Next[i] = Text[j];
	Next[i] = 0;
	
	
	if (maxLen % 2 == 0)
		ans += 2 * maxLen + 3 * gap;
	else
		ans += 2 * ((maxLen + 1) / 2) + maxLen+ 3 * gap;
	//fprintf(stderr, "%s %d %d %d \n", Next, ai, aj, al);
	
	memmove(Text, Next, sizeof(Next));
	
	return found;
}

bool shrink() {
	int i, j, k = 0;
	bool shrunk = false;
	
	for (i = 0, k = 0; i < n;) {
		for (j = i; j < n && Text[i] == Text[j]; ++ j)
			;
		if (j - i > 1) {
			ans += 2 + (j - i);
			shrunk = true;
			i = j;
			break;
		} else
			Next[k ++] = Text[i];
	
		i = j;
	}
	
	if (shrunk == false)
		return false;
	
	for (; i < n; ++ i)
		Next[k ++] = Text[i];
	
	Next[k] = 0;
	memmove(Text, Next, sizeof(Next));
	n = strlen(Text);
	
	//fprintf(stderr, "%s\n", Text);
	
	return true;
}

int main() {

	freopen("stiva.in", "r", stdin);
	freopen("stiva.out", "w", stdout);
	
	fgets(Text, NMAX, stdin);
	n = strlen(Text);
	
	//fprintf(stderr, "%s\n", Text);
	
	while (n > 0 && shrink() == true) {
		n = strlen(Text);
	}
	while (n > 0 && split() == true) {
		n = strlen(Text);
	}
	ans += 3 * n;
	
	printf("%d\n", ans);

	return 0;
}
