#include<cstdio>
#include<cstdlib>

#define INPUT "dist.in"
#define OUTPUT "dist.out"
#define NMAX 10002
#define MIN(X,Y) (X < Y) ? X : Y

typedef struct Point
{
  long x; long y;
};

long N;
Point A[ NMAX ];

void ReadValues()
{
  scanf("%ld", &N);

  for(long i = 0; i < N; ++i)
    scanf("%ld %ld", &A[ i ].x, &A[ i ].y);
}

void BruteForce()
{
  long DMax, DMaxCur, D1, D2;
  DMax = 0;
  DMaxCur = 0;
  
  for(long i = 0; i < N; ++i)
    for(long j = 0; j < N; ++j)
    {
      D1 = abs( A[ i ].x - A[ j ].x);
      D2 = abs( A[ i ].y - A[ j ].y);
      DMaxCur = (D1 < D2) ? D1 : D2;
      DMax = (DMax < DMaxCur ) ? DMaxCur : DMax;
    }
  printf("%ld\n", DMax);
}

int main()
{
  freopen(INPUT, "r", stdin); freopen(OUTPUT, "w", stdout);

  ReadValues();

  BruteForce();

  fclose(stdin); fclose(stdout);

  return 0;
}
