#include<cstdio>
#include<cstring>

#define INPUT "stiva.in"
#define OUTPUT "stiva.out"
#define NMAX 505
#define INFI 32000

int N;
char Sir[ NMAX ];
long Total, M, MinCur, Erase, Value, cont;

void SolveFunction()
{
  Total = 0;
  long Val = 0;
  int i, j;

  while(N >= 1)
  {
    Val = 0;
  
    for(i = 1; i < N; ++i)
      if(Sir[ i ] == Sir[ i - 1 ])
      {
        for(j = i; j < N; ++j)
          Sir[ j - 1 ] = Sir[ j ];
        ++Val;
      }

    Total += Val;
    N -= Val;

    MinCur = INFI;

    for(i = 0; i < N; ++i)
    {
      cont = 0;
      while(Sir[ i - cont ] == Sir[ i + cont ] && i - cont >= 0)
        ++cont;

      M = (N - (2 * cont - 1) ) * 3;
      if(M < MinCur)
      {
        MinCur = M;
        Erase = i;
        Value = cont;
      }
    }

    for(i = Erase + Value; i < N; ++i)
      Sir[ i - 2 * Value + 1 ] = Sir[ i ];

    Total += (3 + 4 * (Value - 1));
      
    N -= (2 * Value - 1);
  }

  printf("%ld\n", Total);
}

int main()
{
  freopen(INPUT, "r", stdin); freopen(OUTPUT, "w", stdout);

  fgets(Sir, NMAX, stdin);

  N = strlen(Sir);

  if(Sir[ N - 1 ] == '\n')
    Sir[ N - 1 ] = '\0', --N;

  SolveFunction();

  fclose(stdin); fclose(stdout);

  return 0;
}
