// O(N^2)
#include <cstdio>
#include <cstring>

using namespace std;

#define FIN "stiva.in"
#define FOUT "stiva.out"
#define MAX_N 505
#define MAX_L 27
#define INF 1 << 30

unsigned char A[MAX_N][MAX_N];

int P[MAX_N];
int pr[MAX_N];

char S[MAX_N];


     inline int count (int a, int b)
     {
         if ((b - a + 1) & 1) return ((b - a + 1) << 1) + 1;
         return (b - a + 1) << 1;
     }

     void solve ()
     {
         int i, k, c, p;

         int N = strlen (S);
         
         for (i = N; i; --i) S[i] = S[i - 1];
         for (i = 1; i <= N; ++i) A[i][i] = 1;

         for (k = 1; k <= N; ++k)
            for (i = 1; i <= N; ++i)
            {
                if (S[i] == S[k] && i + 1 <= k - 1)
                   if (A[i + 1][k - 1] == 1)
                     A[i][k] = 1;
                if (S[i] == S[k] && i + 1 > k - 1) A[i][k] = 1;
            }
                     

         for (i = 1; i <= N; ++i) P[i] = INF, pr[i] = INF;
         
         for (i = 1; i <= N; ++i)
             for (k = 0; k < i; ++k)
             {
                  if (A[k + 1][i] == 1 && P[i] == P[k] + 1)
                  {
                         int ret = count (k + 1, i);
                         if (pr[i] > pr[k] + ret)
                                pr[i] = pr[k] + ret;
                  }
                  if (A[k + 1][i] == 1 && P[i] > P[k] + 1)
                     P[i] = P[k] + 1, pr[i] = pr[k] + count (k + 1, i);                  
             }

         printf ("%d", (int) pr[N]);
     }

     int main ()
     {
         freopen (FIN, "r", stdin);
         freopen (FOUT, "w", stdout);

         gets(S);
         solve ();

         return 0;
     }
         
