using namespace std;
#include <cstdio>
#include <cstring>
#include <map>
#include <set>
#include <vector>
#include <algorithm>

#define normalizare 1000000
#define Nmax 100004
#define NodMax 6000003
#define st first
#define nd second

int N,Dmax,i,x,y,limita,nr,Dmin;
//punctele
pair<int,int> P[Nmax];
//arbore cu cadranele
int A[NodMax];

inline int max(int a,int b) { return a>b?a:b; }
inline int min(int a,int b) { return a<b?a:b; }

void citire()
{
 freopen("dist.in","r",stdin);
 scanf("%d",&N);
 for (i=1;i<=N;++i)
        {
         scanf("%d %d",&x,&y);

         x+=normalizare;
         y+=normalizare;
         P[i]=make_pair(x,y);

         Dmax=max(Dmax, max(x,y));
        }
}

int query(int nod,int ls,int ld,int left,int right)
{
 int m=(ls+ld)>>1,rez=0x3f3f3f3f;

 if (A[nod]>limita) return limita+1;
 if (ls>=left && ld<=right)
         return A[nod];

 if (left<=m) rez=min(rez, query(nod<<1,ls,m,left,right) );
 if (rez<=limita) return rez;
 if (right>m) rez=min(rez, query((nod<<1)+1,m+1,ld,left,right) );
 return rez;
}

void update(int nod,int ls,int ld,int p,int v)
{
 int m=(ls+ld)>>1;

 //if (ls>=p && ld<=Dmax)
 if (ls==ld)
        {
         A[nod]=min(A[nod],v);
         return;
        }

 if (p<=m) update(nod<<1,ls,m,p,v);
 if (p>m) update((nod<<1)+1,m+1,ld,p,v);

 A[nod] = min( A[nod], min( A[nod<<1] , A[(nod<<1)+1] ));
}

int cauta(int x,int y)
{
 int p,rez,best;
 //cadranul 2
 rez=0;
 p=1;
 while (x-(p<<1)>=0 && y+(p<<1)<Dmax) p<<=1;

 if (y+nr<=Dmax && x>=nr)
 while (p && rez+(p<<1) > nr)
//while (p)
     {

      limita = x-rez-p;
      if ( query(1,Dmin,Dmax,y+rez+p,Dmax) <= limita ) rez += p;
      p >>= 1;
      while (x-rez-p<0 || y+rez+p>Dmax) p >>= 1;

     }

 best=rez;
 //cadranul 3
 rez=0;
 p=1;
 while (x-(p<<1)>=0 && y-(p<<1)>=0) p<<=1;

 if (y>=nr && x>=nr)
 while (p && rez+(p<<1) > nr)
//while (p)
     {

      limita = x-rez-p;
      if ( query(1,Dmin,Dmax,0,y-rez-p) <= limita ) rez += p;
      p >>= 1;
      while (x-rez-p<0 || y-rez-p<0) p >>= 1;

     }

 best=max(best,rez);

 return best;
}

void solve()
{
 int i,v;

 memset(A,0x3f3f3f3f,sizeof(A));

 for (i=1;i<=N;++i)
        {
         nr=max(nr,cauta(P[i].st,P[i].nd));
         update(1,Dmin,Dmax,P[i].nd,P[i].st);
        }
}

int main()
{
 freopen("dist.out","w",stdout);
 citire();

 sort(P+1,P+N+1);

 ++Dmax;
 Dmin=0;
 solve();

 printf("%d\n",nr);
 fclose(stdout);

 return 0;
}
