# include <stdio.h>
# include <fstream>
# include <cstring>
# include <map>
# include <set>
# include <vector>

using namespace std;

# define input "dist.in"
# define output "dist.out"

//# define abs(a) (a<0?-a:a)
# define maxim(a,b) (a>b?a:b)
# define minim(a,b) (a<b?a:b)

inline int abs(int a) { return a < 0 ? -a : a; }

# define ff first
# define ss second
# define max 100001

struct punct
{
        int x,y;
}a[max],b[max];


struct cmp
{
	bool operator()(punct A,punct B)
	{
		if(A.x < B.x) return 1;
		return 0;
	}
};
struct cmp2
{
	bool operator()(punct A,punct B)
	{
		if(A.y < B.y) return 1;
		return 0;
	}
};

int i,n,q,powe,ret;
int x,y;

int arb[17][max];
int arb2[17][max];

# define mij ((st+dr)>>1)

void build(int niv,int st,int dr)
{
	if(st == dr)
	{
		arb[niv][st] = a[st].y;
		arb2[niv][st] = b[st].x;
		return;
	}
	build(niv+1,st,mij);
	build(niv+1,mij+1,dr);
	int i,j,k,k1,i1,j1;
	k = st;
	i1 = st,j1 = mij+1;
	for(i = st,j = mij+1; i <= mij && j <= dr;)
	{
		if(arb[niv+1][i] < arb[niv+1][j])
			arb[niv][k++] = arb[niv+1][i++];
		else
			arb[niv][k++] = arb[niv+1][j++];
		if(arb2[niv+1][i1] < arb2[niv+1][j1])
			arb2[niv][k-1] = arb2[niv+1][i1++];
		else
			arb2[niv][k-1] = arb2[niv+1][j1++];
	}
	k1 = k;

	while(i <= mij) arb[niv][k++] = arb[niv+1][i++];
	while(j <= dr) arb[niv][k++] = arb[niv+1][j++];

	while(i1 <= mij) arb2[niv][k1++] = arb2[niv+1][i1++];
	while(j1 <= dr) arb2[niv][k1++] = arb2[niv+1][j1++];
}


int s,d;
int OK;
int dif;

void inarb(int niv,int st,int dr)
{
	if(s <= st && dr <= d)
	{
	    int x = abs(arb[niv][dr] - a[q].y);
	    if(x >= dif) OK = 1;
	    x = abs(arb[niv][st] - a[q].y);
	    if(x >= dif) OK = 1;
	    return;
	}
	if(!OK)
	{
		if(mij >= s)      inarb ( niv+1,st,mij);
		if(mij + 1 <= d)  inarb ( niv+1, mij+1, dr);
	}
}

int ok(int p,int pos)
{
	dif = abs(p - a[q].x);
	s = pos;d = n;
	OK = 0;
	inarb(0,1,n);

	if(OK) return 1;

	return 0;
}

int ok2(int p,int pos)
{
	dif = abs( p - a[q].x );
	s = 0,d = pos;
	OK = 0;

	inarb(0,1,n);

	if(OK) return 1;
	return 0;
}

void inarb2(int niv,int st,int dr)
{
	if(s <= st && dr <= d)
	{
	    int x = abs(arb2[niv][dr] - b[q].x);
	    if(x >= dif) OK = 1;

	    x = abs(arb2[niv][st] - b[q].x);
	    if(x >= dif) OK = 1;
	    return;

	}

	if(!OK)
	{
		if(mij >= s)      inarb2 ( niv+1,st,mij);
		if(mij + 1 <= d)  inarb2 ( niv+1, mij+1, dr);
	}
}


int ok1(int p,int pos)
{
	dif = abs(p - b[q].y);
	s = pos;d = n;
	OK = 0;
	inarb2(0,1,n);

	return OK;
}

int ok3(int p,int pos)
{
	dif = abs( p - b[q].y );
	s = 0,d = pos;
	OK = 0;

	inarb2(0,1,n);

	return OK;
}


int main()
{
	freopen(input,"r", stdin);
	freopen(output,"w", stdout);

	scanf("%d",&n);

	for(i = 1; i<= n; i++)
	{
		scanf("%d %d",&a[i].x,&a[i].y);
		b[i] = a[i];
	}

	sort(a+1,a+n+1,cmp());
	sort(b+1,b+n+1,cmp2());

	build(0,1,n);

	for(powe = 1; powe <= n; powe <<= 1);
		powe>>=1;

	for(q = 1; q <= n;q++)
	{
		int e = powe;
		for(i = q; e; e>>=1)
			if(i+e <= n && ok( a[i+e].x, i+e)) i+=e;

		ret = maxim (ret , abs(a[i].x - a[q].x));

                e = powe;
                for(i = 0; e; e>>=1)
                        if(i+e <= q && ok2( a[i+e].x , i+e)) i+=e;

                ret = maxim (ret , abs(a[i].x - a[q].x));

		e = powe;
		for(i = q; e; e>>=1)
			if(i+e <= n && ok1( b[i+e].y, i+e)) i+=e;
		ret = maxim (ret , abs(b[i].y - b[q].y));

                e = powe;
		for(i = 0; e; e>>=1)
			if(i+e <= q && ok3( b[i+e].y, i+e)) i+=e;
		ret = maxim (ret , abs(b[i].y - b[q].y));
                
        }

        printf("%d\n",ret);

        return 0;
}
