#include <stdio.h>
#include <vector>

using namespace std;

#define PB(x) push_back(x)
#define SZ(x) (x).size()
#define MP(a,b) make_pair((a), (b))
#define ii pair<int, int>
#define vi vector<int>
#define vii vector< ii >
#define ALL(x) (x).begin(), (x).end()
#define SORT(x) sort(ALL(x))

#define FOR(i,N) for (int (i) = 0; (i)<(N); ++(i))
#define FORE(i,N) for (int (i) = 0; (i)<=(N); ++(i))
#define FORIE(i,j,N) for (int (i) = (j); (i)<=(N); ++(i))
#define FORI(i,j,N) for (int (i) = (j); (i)<(N); ++(i))

#define FORV(i,V) for (int (i) = 0; (i)<SZ(V); ++(i))
#define FORIT(i, C) for (typeof((C).begin()) i = (C).begin(); i != (C).end(); ++(i))

#define PRINT(V) FORV(i,V) cerr << V[i] << " "; cerr << "\n";
#define PRINTV(V, i, j) FORIE(tz, i, j) cerr << V[tz] << " "; cerr << "\n";
#define PRINTC(C) FORIT(tz,C) cerr << *tz << " "; cerr << "\n";

#define NMAX 260
#define MOD 666013

int N, M, K;
int A[NMAX][NMAX];
int G[NMAX][NMAX];
int gr[NMAX];

inline bool next_posib(int nr[], int n)
{
    int a = n;
    while (nr[n] == 0)
        --n;

    if (n == 1)
        return 0;
    else
    {
        ++nr[n-1];
        nr[a] = nr[n]-1;
        if (n!=a)
            nr[n] = 0;
        return 1;
    }

}

int calc(int node, int friends)
{
    if (A[node][friends] != -1)
        return A[node][friends];

    if (friends == 0)
        return 1;
    
    if (friends == 1)
        return 1;

    if (!G[node][0])
        return friends == 1;

    vi nr(G[node][0]+1);
    
    FORI(i, 1, G[node][0])
        nr[i] = 0;

    nr[G[node][0]] = friends-1;

    int tot = 0;

    do
    {
        int aux = 1;
        FORIE(i, 1, G[node][0])
            aux = (aux * calc(G[node][i], nr[i])) % MOD;

        tot = (tot + aux) % MOD;
    } while (next_posib(&nr[0], G[node][0]));

    A[node][friends] = tot;

    return tot;
}

int main()
{
    freopen("dep.in", "r", stdin);
    freopen("dep.out", "w", stdout);

    scanf("%d %d %d", &N, &M, &K);

    FOR(i, M)
    {
        int x,y;
        scanf("%d %d", &x, &y);
        G[y][ ++G[y][0] ] = x;
        ++gr[x];
    }

    int sol = 0;

    memset(A, -1, sizeof(A));

    FORIE(i,1,N)
    {
        if (!gr[i])
        {
            G[N+1][ ++G[N+1][0] ] = i;
        }
    }

    A[N+1][K+1] = -1;
    printf("%d\n", calc(N+1, K+1));

    return 0;
}
