#include <stdio.h>
#define NM 260

int n, m, K;
int i, j, k, h;
int c[NM], nrc;
int o[NM], timp, s[NM], f[NM];
int a[NM][NM], nr[NM], d[NM][NM];
int aux[NM], nrv[NM], sol;
struct lst {
	int vf;
	lst* urm;
} *l1[NM], *l2[NM];

void Add(int i, int j);
void DF(int nod);
void DFT(int nod);
void Build();
int Solve(int nod);

int main()
{
	freopen("dep.in", "r", stdin);
	freopen("dep.out", "w", stdout);
	scanf("%d %d %d", &n, &m, &K);
	for ( h = 1; h <= m; h++ )
		scanf("%d %d", &i, &j),
		Add(i, j);

	Build();

	for ( i = 1; i <= nrc; i++ )
		if ( !nrv[i] )
			Solve(i), sol += d[i][K];
	printf("%d\n", sol);

	return 0;
}

void Add(int i, int j)
{
	lst* q= new lst;
	q->vf = j; q->urm = l1[i];
	l1[i] = q; q = new lst;
	q->vf = i; q->urm = l2[j];
	l2[j] = q;
}

void DF(int nod)
{
	if ( s[nod] ) return;
	s[nod] = 1;
	for ( lst* q = l1[nod]; q; q = q->urm )
		DF(q->vf);
	timp++; o[timp] = nod;
}

void DFT(int nod)
{
	if ( !s[nod] ) return;
	s[nod] = 0; c[nod] = nrc;
	for ( lst* q = l2[nod]; q; q = q->urm )
		if ( s[q->vf] )
			DFT(q->vf);
}

void Build()
{
	for ( i = 1; i <= n; i++ )
		if ( !s[i] )
			DF(i);

	for ( i = n; i >= 1; i-- )
		if ( s[o[i]] )
		{
			nrc++;
			DFT(o[i]);
		}
	for ( i = 1; i <= n; i++ )
	{
		nr[c[i]]++; l2[i] = 0;
		for ( lst* q= l1[i]; q; q = q->urm )
			if ( c[i] != c[q->vf] )
				a[c[i]][c[q->vf]] = 1;
	}
	for ( i = 1; i <= nrc; i++ )
		for ( j = 1; j <= nrc; j++ )
			if ( a[i][j] )
			{ lst* q = new lst; q->vf = i; q->urm = l2[j]; l2[j] = q;
			  q = new lst; q->vf = j; q->urm = l1[i]; l1[i] = q;
			  nrv[i]++; }
}

int Solve(int nod)
{
	if ( s[nod] ) return 0;
	s[nod] = 1;
	int j = 0, k = 0;
	d[nod][nr[nod]] = 1;
	for ( lst* q = l2[nod]; q; q = q->urm )
	{
		if ( !Solve(q->vf) ) continue;
		for ( k = 0; k <= K; aux[k] = d[nod][k], k++ );
		for ( j = K; j >= nr[nod]; j-- )
			for ( k = nr[nod]; k <= j; k++ )
				aux[j] = (aux[j] + d[nod][k] * d[q->vf][j-k])%6660;
		for ( k = 0; k <= K; d[nod][k] = aux[k], k++ );
	}
	return 1;
}




