#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#define NM 100001
#define abs(a) ((a) < 0 ? -(a) : (a))
#define INF 10000000

int n, i, j, k, h, sol = -INF;
struct pct {
	int x, y, d;
} p[NM], m[6];


int main()
{
	freopen("dist.in", "r", stdin);
	freopen("dist.out", "w", stdout);
	scanf("%d", &n);
	for ( i = 1; i <= n; i++ )
		scanf("%d %d", &p[i].x, &p[i].y);

	time_t t;
	srand((unsigned) time(&t));
	for ( h = 1; h <= 30; h++ )
	{
		i = rand()%n+1;
		m[1].d = m[2].d = m[3].d = m[4].d = -INF;
		for ( j = 1; j <= n; j++ )
		{
			if ( p[j].x >= p[i].x && p[j].y >= p[i].y )
			{
				k = (p[j].y - p[i].y) < (p[j].x - p[i].x) ?
					p[j].y - p[i].y : p[j].x - p[i].x;
				if ( k > m[1].d )
					m[1].d = k, m[1].x = p[j].x, m[1].y = p[j].y;
			}
			if ( p[j].x < p[i].x && p[j].y >= p[i].y )
			{
				k = (p[j].y - p[i].y) < (p[i].x - p[j].x) ?
					p[j].y - p[i].y : p[i].x - p[j].x;
				if ( k > m[2].d )
					m[2].d = k, m[2].x = p[j].x, m[2].y = p[j].y;
			}
			if ( p[j].x < p[i].x && p[j].y < p[i].y )
			{
				k = (p[i].y - p[j].y) < (p[i].x - p[j].x) ?
					p[i].y - p[j].y : p[i].x - p[j].x;
				if ( k > m[3].d )
					m[3].d = k, m[3].x = p[j].x, m[3].y = p[j].y;
			}
			if ( p[j].x >= p[i].x && p[j].y < p[i].y )
			{
				k = (p[i].y - p[j].y) < (p[j].x - p[i].x) ?
					p[i].y - p[j].y : p[j].x - p[i].x;
				if ( k > m[4].d )
					m[4].d = k, m[4].x = p[j].x, m[4].y = p[j].y;
			}
		}
		m[5].x = p[i].x, m[5].y = p[i].y; m[5].d = 1;
		for ( i = 1; i <= 5; i++ )
			for (j = 1; j <= 5; j++ )
			if ( i != j && m[i].d > 0 && m[j].d > 0 )
			{
				k = abs(m[i].y - m[j].y) < abs(m[i].x - m[j].x) ?
					abs(m[i].y - m[j].y) : abs(m[i].x - m[j].x);
				if ( k > sol ) sol = k;
            }
	}
	printf("%d\n", sol);
	return 0;
}

