#include <stdio.h>
#include <cstring>
#include <vector>
#define Max(a, b) ((a) < (b) ? (b) : (a))
#define NM 501
#define INF 100000
#define Min(a, b) ((a) < (b) ? (a) : (b))
using namespace std;

int n;
int i, j, k, l, sol;
int dmin[NM];
vector<vector<int> > c;
char s[NM];

int Cost(int i, int j);

int main()
{
	freopen("stiva.in", "r", stdin);
	freopen("stiva.out", "w", stdout);
	scanf("%s", &s);
	k = -1;
	n = strlen(s);
	for ( i = 0; i < n; i++ )
		if ( s[i] != s[k] )
			k++, s[k] = s[i];
		else     sol++;
	n = k+1;
        c.resize(n+1);
        for ( i = 1; i <= n; i++ )
                c[i].resize(n+1);
	s[n] = '\0';
	for ( j = 0; j <= n; j++ )
		for ( i = 1; i+j <= n; i++ )
			c[i][i+j] = Cost(i, i+j);


	for ( i = 1; i <= n; i++ )
	{
		dmin[i] = INF;
		for ( j = 1; j <= i; j++ )
			if ( dmin[i] > dmin[j-1] + c[j][i] )
				dmin[i] = dmin[j-1] + c[j][i];
	}
	printf("%d\n", dmin[n]+sol);


	return 0;
}

int Cost(int i, int j)
{
	if ( i+1 == j )
	{
		if ( s[i-1] == s[j-1] ) return 4;
		else                return 6;
	}
	if ( i == j ) return 3;
	if ( s[i-1] == s[j-1] ) return c[i+1][j-1] + 4;
	return Min(c[i][j-1], c[i+1][j]) + 3;
}
