#include <cstdio>
#include <cstring>

const int NMAX = 502;

int N;
char S[NMAX];
short next[NMAX], DP[NMAX][NMAX];

void read(void) {
	FILE *fin = fopen("stiva.in", "rt");

	fscanf(fin, " %s", S);

	fclose(fin);
}

void solve(void) {
	int i;
	short P[NMAX];

	memset(P, 0xff, sizeof(P));
	N = strlen(S);

	for (i = N-1; i >= 0; --i) {
		next[i] = P[ (int) S[i] ];
		P[ (int) S[i] ] = i;
	}
}

inline short min(short a, short b) { return a < b ? a : b; }

short go(int i, int j) {
	if (j < i) return -3;
	if (j == i) return 0;
	if (DP[i][j]) return DP[i][j];

	int k;
	short ret;

	ret = 3 + go(i+1, j);

	for (k = next[i]; k != -1 && k <= j; k = next[k])
		ret = min(ret, 4 + go(i+1, k-1) + go(k, j));

//	printf("%d %d => %hd\n", i, j, ret);
	return DP[i][j] = ret;
}

void write(void) {
	FILE *fout = fopen("stiva.out", "wt");

	fprintf(fout, "%hd\n", 3 + go(0, N-1));

	fclose(fout);
}

int main(void) {

	read();

	solve();

	write();

	return 0;
}
