#include<fstream.h>
#include<algorithm>
#include<vector>
using namespace std;
ifstream fin("dist.in");
ofstream fout("dist.out");
#define inf 1000000000
struct pct
{int x,y;}v[100001];

struct nod
{vector<int> y;
 int a,b;
 nod *st,*dr;
}*r;

int n,xmax,xmin,ymax,ymin;

bool cmp(pct a,pct b)
{if(a.x==b.x) return (a.y<b.y);
 return (a.x<b.x);
}

int nr(nod *p,int y1,int y2)
{int i;
 if(p->y[0]==0) return 0;
 if(p->y[1]<=y1) return 1;
 if(p->y[p->y[0]]>=y2) return 1;
 return 0;
}


int cauta(nod *p,int a,int b,int y1,int y2)
{if(p==NULL) return 0;
 if(p->a>=a && p->b<=b) return nr(p,y1,y2);
 int m=(p->a+p->b)/2;
 if(p->a+p->b<0 && (p->a+p->b)%2!=0) m--;
 if(m<a) return cauta(p->dr,a,b,y1,y2);
 if(m>=b) return cauta(p->st,a,b,y1,y2);
 int ok=cauta(p->st,a,m,y1,y2);
 if(ok) return 1;
 return cauta(p->dr,m+1,b,y1,y2);
}

void inter(nod *p)
{int i,j;
 i=j=1;
 p->y.push_back(p->st->y[0]+p->dr->y[0]);
 while(i<=p->st->y[0] && j<=p->dr->y[0])
  {if(p->st->y[i]<p->dr->y[j])
    {p->y.push_back(p->st->y[i]);
     i++;
    }
   else
    {p->y.push_back(p->dr->y[j]);
     j++;
    }
  }
 while(i<=p->st->y[0])
  {p->y.push_back(p->st->y[i]);
   i++;
  }
 while(j<=p->dr->y[0])
  {p->y.push_back(p->dr->y[j]);
   j++;
  }
}

int caut(int x,int a,int b)
{if(a>b) return 0;
 int m=(a+b)/2;
 if(v[m].x>x) return caut(x,a,m-1);
 if(v[m].x<x) return caut(x,m+1,b);
 int ok=caut(x,a,m-1);
 if(ok) return ok;
 return m;
}

nod *construieste(int a,int b)
{if(a<=b)
  {nod *p;
   p=new nod;
   p->a=a;
   p->b=b;
   if(a==b)
    {int k=caut(a,1,n);
     int i;
     p->y.push_back(0);
     if(k==0) return p;
     for(i=k;i<=n && v[i].x==v[k].x;i++)
      {p->y[0]++;
       p->y.push_back(v[i].y);
      }
     p->st=p->dr=NULL;
     return p;
    }
   int m=(a+b)/2;
   if(p->a+p->b<0 && (p->a+p->b)%2!=0) m--;
   p->st=construieste(a,m);
   p->dr=construieste(m+1,b);
   inter(p);
   return p;
  }
 return NULL;
}


int bin(int a,int b)
{int i,gasit,d,ok;
 if(a>b) return -1;
 d=(a+b)/2;
 for(i=1;i<=n;i++)
  {gasit=cauta(r,v[i].x+d,xmax,v[i].y-d,v[i].y+d);
   if(!gasit) gasit=cauta(r,xmin,v[i].x-d,v[i].y-d,v[i].y+d);
   if(gasit)
    {ok=bin(d+1,b);
     if(ok!=-1) return ok;
     return d;
    }
  }
 return bin(a,d-1);
}

int main()
{fin>>n;
 int i;
 xmin=ymin=inf;
 for(i=1;i<=n;i++)
  {fin>>v[i].x>>v[i].y;
   if(xmin>v[i].x) xmin=v[i].x;
   if(xmax<v[i].x) xmax=v[i].x;
   if(ymin>v[i].y) ymin=v[i].y;
   if(ymax<v[i].y) ymax=v[i].y;
  }
 sort(v+1,v+n+1,cmp);
 r=construieste(v[1].x,v[n].x);
 fout<<bin(0,v[n].x-v[1].x);
 fin.close();
 fout.close();
}

