#include <stdio.h>
#include <algorithm>

#define inf 2000000
#define nmax 100005
#define bmax 20

using namespace std;
typedef pair<int, int> ii;

int n, j, semn;
ii a[nmax];
char s[bmax];

inline int bun(int val)
{
	int minim = inf, maxim = -inf, last = 0;
	for(int i = 1; i <= n; i++)
	{
		while(last + 1 <= n && a[last + 1].first <= a[i].first - val)
		{
			last++;
			minim = min(minim, a[last].second);
			maxim = max(maxim, a[last].second);
		}
		if(minim <= a[i].second - val) return 1;
		if(maxim >= a[i].second + val) return 1;
	}
	return 0;
}

int main()
{
	freopen("dist.in", "r", stdin);
	freopen("dist.out", "w", stdout);

	scanf("%d\n", &n);
	if(n <= 50000) for(int i = 1; i <= n; i++) scanf("%d%d", &a[i].first, &a[i].second);
	else for(int i = 1; i <= n; i++) 
	{
		fgets(s, bmax, stdin);
		a[i].first = a[i].second = 0;
		j = 0;
		semn = 1;
		if(s[j] == '-') semn = 0, j++;
		while(s[j] >= '0' && s[j] <= '9') a[i].first = a[i].first * 10 + s[j] - '0', j++;
		if(semn == 0) a[i].first = - a[i].first;
		j++;
		semn = 1;
		if(s[j] == '-') semn = 0, j++;
		while(s[j] >= '0' && s[j] <= '9') a[i].second = a[i].second * 10 + s[j] - '0', j++;
		if(semn == 0) a[i].second = - a[i].second;
	}
	sort(a + 1, a + n + 1);

	int first = 0, last = inf, middle, rez = 0;
	while(first <= last)
	{
		middle = (first + last) / 2;
		if(bun(middle)) rez = middle, first = middle + 1;
		else last = middle - 1;
	}
	printf("%d\n", rez);

	return 0;
}
