#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define FL

#define fin  "dist.in"
#define fout "dist.out"
#define pb push_back
#define mp make_pair
#define f first
#define s second

const int Max = 20000000;

int N;
vector < pair<int,int> > v;

void readdata()
{
	int i,a,b;
	
	freopen(fin,"r",stdin);
#ifdef FL
	freopen(fout,"w",stdout);	
#endif
	scanf("%d",&N);

	for ( i = 1; i <= N; ++i )
	{
		scanf("%d%d",&a,&b);
		v.pb(mp(a,b));
	}
}

inline int absf(int a) { return (a<0)?(-1*a):(a); }
inline int maxf(int a,int b) { return (a<b) ? (b) : (a); }
inline int minf(int a,int b) { return (a<b) ? (a) : (b); }

void solve()
{
	int i,j,m,st,dr,lo,hi;
	int minst,maxst,mindr,maxdr;
	int best;
		
	sort(v.begin(),v.end());
	
	lo = 0; hi = Max;
	
	while ( lo <= hi )
	{
		m = ( lo + hi ) / 2;
		
		st = dr = 0;
		minst = Max;
		maxst = -Max;
		
		best = 0;
		
		for ( i = 0; i < N;  )
		{
			mindr = v[i].s;
			for ( dr = i; v[dr].f == v[i].f && dr < N; ++dr );
			--dr;
			maxdr = v[dr].s;

			for ( st; absf(v[st].f-v[i].f) >= m && st < N; ++st )
				minst = minf(minst,v[st].s), maxst = maxf(maxst,v[st].s);
			
			if ( minst != Max && maxst != -Max )
			{
				best = maxf(best,absf(minst-maxdr));
				best = maxf(best,absf(maxst-mindr));
			}	

			i = dr + 1;
		}

//		printf("%d %d %d %d\n",lo,hi,m,best);

		if ( best < m )
			hi = m - 1;
		else
			lo = m + 1;
	}

	printf("%d\n",lo - 1);
}

int main()
{
	readdata();
	solve();
	return 0;
}
