//Dist
#include <stdio.h>
#include <algorithm>
#define INPUT "dist.in"
#define OUTPUT "dist.out"
#define NMAX 100002

using namespace std;

int N;

struct punct
{
        int x, y;
}v[NMAX];

struct cmp
{
        bool operator() (const punct A, const punct B) const
        {
                if(A.x < B.x) return 1;
                if(A.x == B.x && A.y < B.y) return 1;
                return 0;
        }
};


inline int ab(int x)
{
        return x>0?x:-x;
}
inline int dist(int i, int j)
{
        int v1 = ab(v[i].x-v[j].x);
        int v2 = ab(v[i].y-v[j].y);
        if(v1 < v2) return v1;
        return v2;
}


int main()
{

        freopen(INPUT, "r", stdin);
        freopen(OUTPUT, "w", stdout);

        scanf("%d", &N);
        int i;
        for(i = 1; i <= N; ++i)
                scanf("%d %d", &v[i].x, &v[i].y);

        sort(v+1, v+N+1, cmp());

        int maxdist = dist(1, 2);
        int d;
        for(i = 3; i <= N; ++i)
                if((d = dist(1, i)) > maxdist) maxdist = d;

        int cin = 3;
        for(i = 2; i <= N; ++i)
        {
                while(cin < N && v[cin].x - v[i].x <= maxdist) ++cin;
                int j;
                for(j = cin; j <= N; ++j)
                        if((d = dist(i, j)) > maxdist) maxdist = d;
        }

        printf("%d\n", maxdist);

        return 0;
}
