#include <cstdio>
#include <cstring>
#include <iostream>
#include <vector>

using namespace std;

#define INF 0x3f3f3f3f
#define TIP(x) cout << #x << " = " << x << "\n";
#define pb push_back
#define MAXN 260
#define PRIM 666013

int N, M, K;
vector <int> G[MAXN];
int d[MAXN][MAXN];

void read ()
{
    scanf ("%d %d %d", &N, &M, &K);

    int i, a, b;
    for (i = 1; i <= M; ++ i)
    {
        scanf ("%d %d", &a, &b);
        G[a].pb(b);
    }
}

void solve ()
{
    int i, k, j, sz, n;

    memset (d, INF, sizeof (d));
    for (i = 1; i <= N; ++ i)
        if (!(G[i].size()))
            d[1][i] = 1;

    int verif;
    long long tmp;
    for (k = 2; k <= K; ++ k)
        for (i = 1; i <= N; ++ i)
        {
            verif = 1;
            tmp = 1;
            sz = G[i].size();
            if (k-sz >= 1)
            for (j = 0; j < sz; ++ j)
                if (d[k-sz][G[i][j]] < INF)
                {
                    tmp *= d[k-sz][G[i][j]];
                    if (tmp > PRIM) tmp %= PRIM;
                    verif = 0;
                }
            if (!verif)
                d[k][i] = tmp;
        }

    int sol = 0;
    for (i = 1; i <= N; ++ i)
        if (d[K][i] < INF)
        {
            sol += d[K][i];
            //TIP(i); TIP(d[K][i]);
            if (sol > PRIM) sol -= PRIM;
        }

    printf ("%d\n", sol);
}

int
 main ()
{
    freopen ("dep.in", "rt", stdin);
    freopen ("dep.out", "wt", stdout);

    read ();
    solve ();

    return 0;
}

