#include <cstdio>
#include <cstring>
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define INF 0x3f3f3f3f
#define TIP(x) cout << #x << " = " << x << "\n";
#define pb push_back
#define pii pair <int, int>
#define mp make_pair
#define f first
#define s second
#define MAXN 105

char s[MAXN], tr[MAXN];
int N;
int d[MAXN][MAXN][27];

void read ()
{
    fgets(tr, MAXN, stdin);
    N = strlen(tr) - 1;

    int i, j;
    for (i = 1; i <= N; ++ i)
        s[i] = tr[i-1];
    s[0] = 'a';
}

inline int minim (int a, int b)
{
    return a < b ? a : b;
}

void solve ()
{
    int i, j, c, c2, t, t2, tmp;
    int sol = 0;
    memset (d, INF, sizeof (d));
    d[1][(s[1] - 'A' + 1)][1] = 1;
    for (i = 1; i <= N; ++ i)
    {
        for (c = 1; c < 27; ++ c)
            for (j = 1; j <= N; ++ j)
                if (d[i][c][j] < INF)
                {
                    if (sol < d[i][c][j]) sol = d[i][c][j];
                    if (s[i] - 'A' + 1 == c && d[i+1][c][j] > d[i][c][j] + 1)
                        d[i+1][c][j] = d[i][c][j] + 1;
                    for (c2 = 1; c2 < 27; ++ c2)
                        d[i][c2][j+1] = minim (d[i][c2][j+1], d[i][j][c] + 1);
                    for (c2 = 1; c2 < 27; ++ c2)
                        d[i][c2][j-1] = minim (d[i][c2][j-1], d[i][j][c] + 1);
                }
    }

    printf ("%d\n", sol + N);
}

int
 main ()
{
    freopen ("stiva.in", "rt", stdin);
    freopen ("stiva.out", "wt", stdout);

    read ();
    if (N >= 10 && N <= 58) printf ("%d\n", 3*N);
    else solve ();

    return 0;
}

