#include <fstream>
#include <vector>
using namespace std;

#define FILEIN "bile.in"
#define FILEOUT "bile.out"

const int MAXN = 22;

ifstream fin(FILEIN);
ofstream fout(FILEOUT);

int N, K;
vector< vector<int> > Solutions;

int Gener(int N, int K) {
	int start, stop;

	if (N == K) {
		vector<int> v;
		for (int i = 1; i <= N; ++i)
			v.push_back(i);
		Solutions.push_back(v);
		return int(Solutions.size()) - 1;
	}
	if (K > N) return int(Solutions.size()) - 1;


	if (K == 1) {
		for (int i = 1; i <= N; ++i) {
			vector<int> v;
			v.push_back(i);
			Solutions.push_back(v);
		}
		return int(Solutions.size()) - 1;
	}

	start = Gener(N-1, K);
	stop = Gener(N-1, K-1);

	int F[MAXN] = {};
	int G[MAXN] = {};

	for (int i = 0; i < K-1; ++i) {
		F[ Solutions[start+1][i] ] = Solutions[start][i];
		G[ Solutions[start][i] ] = 1;
	}

	for (int i = 1; i < N; ++i)
		if (!F[i])
			for (int j = 1; j < N; ++j)
				if (!G[j]) {
					F[i] = j;
					G[j] = 1;
					break;
				}

	for (int i = start+1; i <= stop; ++i) {
		for (int j = 0; j < K - 1; ++j)
			Solutions[i][j] = F[ Solutions[i][j] ];
		Solutions[i].push_back(N);
	}
	return int(Solutions.size()) - 1;
}

int main() {
	fin >> N >> K;
	Gener(N, K);

	for (int i = 0; i < int(Solutions.size()); ++i) {
		for (int j = 0; j < K; ++j)
			fout << Solutions[i][j] << " ";
		fout << endl;
	}
}