#include <stdio.h>
#include <algorithm>

using namespace std;

#define maxn 210
#define maxl 310
#define maxx 610

#define min(a,b) (a < b ? a : b)
#define max(a,b) (a > b ? a : b)

int n, m, l, sol;
int best, last;
char a[maxn][maxl];
int len[maxl];
char v[maxx];
int x[maxx], y[maxx], p[maxx], aux[maxx];
int MIN[maxl], MAX[maxl];
int nw[maxl];

void concat(int x, int y)
{
	l = 0;

	int i;

	for (i=1; i<=len[x]; i++) v[++l] = a[x][i];
	v[++l] = '$';
	for (i=1; i<=len[y]; i++) v[++l] = a[y][i];
}

int cmp(int i, int j)
{
	return x[i]<x[j] || (x[i]==x[j] && y[i]<y[j]);
}

int LCP(int x, int y)
{
	int i;
	for (i=0; x+i<=l && y+i<=l; i++)
		if (v[x+i] != v[y+i]) break;

	return i;
}

void sa()
{
	int i, j;

	for (i=1; i<=l; i++) aux[i] = v[i] - '$';

	for (j=0; 1<<j<=l; j++)
	{
		for (i=1; i<=l; i++)
		{
			x[i] = aux[i];
			if (i+(1<<j)<=l) y[i] = aux[i+(1<<j)];
			else y[i] = -1;
		}

		for (i=1; i<=l; i++) p[i] = i;

		sort(p+1, p+l+1, cmp);

		aux[p[1]] = 1;

		for (i=2; i<=l; i++)
			if (x[p[i]] == x[p[i-1]] && y[p[i]] == y[p[i-1]]) aux[p[i]] = aux[p[i-1]];
			else aux[p[i]] = i;
	}
}

int main()
{
	freopen("sub.in", "r", stdin);
	freopen("sub.out", "w", stdout);

	scanf("%d ",&n);

	int i, j, k;

	for (i=1; i<=n; i++) 
	{
		scanf("%s ", a[i]+1);
		len[i] = strlen(a[i]+1);
	}

	scanf("%d ",&m);

	for (i=1; i<=m; i++)
	{
		scanf("%s ", a[n+i]+1);
		len[n+i] = strlen(a[n+i]+1);
	}

	best = 1;
	for (i=1; i<=n; i++) 
		if (len[i] < len[best]) best = i;

	for (i=1; i<=len[best]; i++) MAX[i] = len[best] - i + 1;

	for (i=1; i<=len[best]; i++)
		for (j=i+1; j<=len[best]; j++) 
		{
			for (k=0; k+j<=len[best]; k++)
				if (a[best][i+k] != a[best][j+k]) break;

	//		if (j+k>len[best]) k--;

			MIN[j] = max(MIN[j], k);
		}

	int pos = len[best] + 1;

	for (j=1; j<=n+m; j++) 
	{
		// scad MAX-uri
		concat(best, j);
		sa();

		for (i=1; i<=l; i++) p[aux[i]] = i;
		for (i=1; i<=l; i++) aux[i] = p[i];

		last = -1;

		memset(nw, 0, sizeof(nw));

		// primul e $
		for (i=2; i<=l; i++) 
			if (aux[i] > pos) last = aux[i];
			else if (last != -1) nw[aux[i]] = LCP(aux[i], last);

		last = -1;

		for (i=l; i>1; i--)
			if (aux[i] > pos) last = aux[i];
			else if (last != -1)
				 {
					 int v1 = LCP(aux[i], last);
					 nw[aux[i]] = max(nw[aux[i]], v1);
				 }

		if (j<=n) for (i=1; i<=len[best]; i++) MAX[i] = min(MAX[i], nw[i]);
		else for (i=1; i<=len[best]; i++) MIN[i] = max(MIN[i], nw[i]);
	}

	//for (i=1; i<=len[best]; i++) printf("%d %d\n", MAX[i], MIN[i]);

	for (i=1; i<=len[best]; i++) 
		sol += max(MAX[i]-MIN[i], 0);

	printf("%d\n", sol);

	return 0;
}
