using namespace std;
#include <cstdio>

#define Mmax 512
#define Nmax 128
#define infinit 0x3f3f3f3f

int nr;
int M,N,i,j,k;

int A[Mmax][Mmax];
int S[Mmax][Mmax];

int B[Nmax][Nmax],Sb;
int sablon[Nmax][Nmax],jump;
int T[Nmax];
int P[Mmax][Mmax];

void citire()
{
 freopen("tetris.in","r",stdin);

 scanf("%d", &M);

 for (i=1; i<=M; ++i)
    for (j=1; j<=M; ++j)
        {
         scanf("%d",&A[i][j]);
         S[i][j] = -S[i-1][j-1] + S[i-1][j] + S[i][j-1] + A[i][j];
        }

 scanf("%d", &N);

 for (i=1; i<=N; ++i)
    for (j=1; j<=N; ++j)
        {
         scanf("%d",&B[i][j]);
         Sb += B[i][j];
        }
}

void build()
{
 int s,ok;
 //construieste sablonul
 for (i=1; i<=N; ++i)
    for (j=1; j<=N; ++j)
        sablon[i][j] = infinit - B[i][j];
 //gaseste pozitiile pe care pot sari la dreapta
 for (i=2; i<=N; ++i)
    {
     ok=1;

     for (j=0; i+j<=N && j<N; ++j)
       {
        s = sablon[i][1] + B[i][1];

        for (k=1; k<=N; ++k)
            if (sablon[i+j][k] + B[i+j][k] != s)
                {
                 ok=0;
                 break;
                }

        if (!ok) break;
       }

     if (ok) { jump=i-1; break; }
    }

 if (!ok) jump=N;
}

void solve()
{
 int ii,jj,s,ok;

 jump=1;
 for (i=1; i+N-1<=M; ++i)
   {
    j=1;
    while (j+N-1<=M)
        {
         //suma pe patratzel
         s=A[i][j]+B[1][1];
         //conditii
         if ( - S[i-1][j+N-1] + S[i-1][j-1] - S[i+N-1][j-1] + S[i+N-1][j+N-1] + Sb != N*N*s ) { ++j;continue; }
         //verifica potrivirea
         ok=1;
         for (ii=1; ii<=N && ok; ++ii)
             for (jj=1; jj<=N && ok; ++jj)
                if ( A[ i+ii-1 ][ j+jj-1 ] + B[ ii ][ jj ] != s) ok=0;
         //update nr potriviri
         nr+=ok;
         //continua pattern matching
         if (ok)
          j+=jump;
//          { j+=jump;printf("%d %d\n",i,j); }
            else ++j;
        }
  }  
}

void prefix(int line)
{
 int k,s,i;

 k=0;
 T[1]=0;
 s=B[line][1] + sablon[line][1];

 for (i=2; i<=N; ++i)
    {
     while ( (k>0 && B[line][k+1] + sablon[line][i] != s) || (k==N) )
        {
         k = T[k];
//         s=B[line][k]+sablon[line][i-1];
        }
     if (k==0) { s=B[line][k+1] + sablon[line][i]; }
     if ( B[line][k+1] + sablon[line][i] == s )
        ++k;
     T[i] = k;
    }    
}

void kmp(int line,int ls)
{
 int k,s,i;

 k=0;
 s=B[line][1] + A[ls][1];

 for (i=1; i<=M; ++i)
    {
     while ( (k>0 && B[line][k+1] + A[ls][i] != s) || (k==N) )
        {
         k=T[k];
         s=B[line][k]+A[ls][i-1];
        }
     if (k==0)
        {
         s=B[line][k+1] + A[ls][i];
        }
     if ( B[line][k+1] + A[ls][i] == s)
        ++k;
     if ( k==N )
        {
         P[ls][i-N+1]=1;
        }
    }
}

void smen()
{
 int line,ls,i,k,j,s;

 for (ls==1; ls+N-1<=M; ++ls)
    {    
     for (line=1; line<=N; ++line)
       {
        prefix(line);
        kmp(line,ls+line-1);
       }
     //calculeaza aparitiile fiecarei linii din piesa in liniile din suport
     for (j=1; j<=M; ++j)
        {
         k=1;
         s=B[k][1]+A[ls+k-1][j];
         while (P[ls+k-1][j] == 1 && B[k][1] + A[ls+k-1][j] == s)
            ++k;
         if (k>N)
            nr+=k-N;
        }
     //baga zerouri la loc
     for (k=1;k<=N;++k)
         for (j=1;j<=M;++j)
            P[ls+k-1][j]=0;     
    }
}

int main()
{
 freopen("tetris.out","w",stdout);
 citire();

 build();

 if (M<=200) solve();
// printf("%d\n",nr);
 else
  smen();

 printf("%d\n",nr);
 fclose(stdout);

 return 0;
}
