#include <cstdio>
#include <cstdlib>

struct trans {
	int a, b, c;

	trans(int _a = 0, int _b = 0, int _c = 0):
	a(_a), b(_b), c(_c) {}
};


const int NMAX = 32;

int N, M;
int G[NMAX];
trans T[NMAX], sol[NMAX];
int NA, NB, A[NMAX], B[NMAX];
int nt;
int NT = NMAX, VT;

void read(void) {
	FILE *fin = fopen("datorii.in", "rt");
	int a, b, c, i;

	fscanf(fin, " %d %d", &N, &M);

	for (i = 0; i < M; ++i) {
		fscanf(fin, " %d %d %d", &a, &b, &c);

		G[a] += c; G[b] -= c;
	}

	fclose(fin);
}

void back(int k, int t) {
	if (k == NA) {
		if (nt < NT) {
			NT = nt;
			int i;
			for (i = 0; i < nt; ++i)
				sol[i] = T[i];
		}
		return;
	}

	if (t == NB) return;
	if (nt > NT) return;
	
	back(k, t+1);

	if (G[B[t]] == 0) return;

	int v;
	if (G[A[k]] > - G[B[t]]) 
		v = - G[B[t]];
	else
		v = G[A[k]];
	
	T[nt++] = trans(A[k], B[t], v);
	
	G[B[t]] += v;
	G[A[k]] -= v;
	if (G[A[k]])
		back(k, t+1);
	else
		back(k+1, 0);
	G[B[t]] -= v;
	G[A[k]] += v;
	--nt;
	
}

void solve(void) {
	int i;

	for (i = 1; i <= N; ++i)
		if (G[i] > 0)
			A[NA++] = i, VT += G[i];
		else if (G[i] < 0)
			B[NB++] = i;
	
	back(0, 0);
}

void write(void) {
	FILE *fout = fopen("datorii.out", "wt");
	int i;

	fprintf(fout, "%d %d\n", NT, VT);

	for (i = 0; i < NT; ++i)
		fprintf(fout, "%d %d %d\n", sol[i].a, sol[i].b, sol[i].c);

	fclose(fout);
}

int main(void) {

	read();

	solve();

	write();

	return 0;
}
