#include <cstdio>

const int TMAX = 90000;
const int NL = 'z' - 'a' + 1;
const int LMAX = 305;

int N, M, NT, R;
int T[TMAX][NL], E[TMAX], L[TMAX];
bool D[TMAX];
char S[LMAX];

void build(char S[]) {
	int i, j, p, v;

	for (i = 0; S[i]; ++i) {
		p = 0; 
		
		for (j = i; S[j]; ++j) {
			v = S[j] - 'a';

			if (T[p][v] == 0)
				T[p][v] = ++NT;
			p = T[p][v];
		}
	}
}

void update(char S[], int c) {
	int i, j, p, v;

	for (i = 0; S[i]; ++i) {
		p = 0;

		for (j = i; S[j]; ++j) {
			v = S[j] - 'a';
			
			if (T[p][v])
				p = T[p][v];
			else break;
			
			if (L[p] != c)
				L[p] = c, ++E[p];
		}
	}
}

void destroy(char S[]) {
	int i, j, p, v;

	for (i = 0; S[i]; ++i) {
		p = 0;

		for (j = i; S[j]; ++j) {
			v = S[j] - 'a';
			
			if (T[p][v])
				p = T[p][v];
			else break;
			
			D[p] = true;
		}
	}

}

int main(void) {
	FILE *fin = fopen("sub.in", "rt");
	FILE *fout = fopen("sub.out", "wt");
	int i;

//	printf("%d\n", sizeof(T) + sizeof(T) + sizeof(L));

	fscanf(fin, " %d %s", &N, S);

	build(S);

	for (i = 1; i < N; ++i) {
		fscanf(fin, " %s", S);
		update(S, i);
//		printf("%d %s\n", i, S);
	}

	fscanf(fin, " %d", &M);
	for (i = 0; i < M; ++i) {
		fscanf(fin, " %s", S);
		destroy(S);
	}

	for (i = 1; i <= NT; ++i) {
//		printf("%d %d\n", E[i], D[i]);
		if (E[i] == N - 1 && D[i] == false)
			++R;
	}
	
	fprintf(fout, "%d\n", R);

	fclose(fin);
	fclose(fout);

	return 0;
}
