#include <stdio.h>

#define LL long long

int M, N;

int a[510][510];
int b[110][110];


int aa[510][510];
int bb[110][110];

int c[3][510][510];
int cc[3][110];

int nc = 3;
int baza[3] = {34, 23, 123};
int mod[3] = {666013,  734543, 1012312};

void get_codes(int c[510][510], int cc[110], int baza, int mod)
{
	int bm = 1, i, j, cod, q;

	for (i = 1; i <= N - 2; i++) bm = ((LL) bm * baza) % mod;
	
	for (i = 1; i <= M; i++) {
		cod = 0;

		for (j = M - 1; j >= 1; j--) {
			q = a[i][j] - a[i][j + 1];

			if (j + N > M) cod = ((LL) cod * baza + q) % mod;
			else cod = (((LL) (cod - ((LL) (a[i][j + N - 1] - a[i][j + N]) * bm)) % mod) * baza + q) % mod;
			if (cod < 0) cod += mod;

			c[i][j] = cod;
		}
	}

	for (i = 1; i <= N; i++) {
		cod = 0;
		for (j = N - 1; j >= 1; j--) {
			q = -(b[i][j] - b[i][j + 1]);
			cod = ((LL) cod * baza + q) % mod;
			if (cod < 0) cod += mod;
		}
		cc[i] = cod;
	}
}

#include <stdlib.h>

int gen(int M, int N)
{
	freopen("tetris.in", "w", stdout);

	int i, j, q, ii, jj;

	for (i = 1; i <= N; i++)
		for (j = 1; j <= N; j++)
			b[i][j] = rand() % 10000;

	for (i = 1; i <= M; i++)
		for (j = 1; j <= M; j++) a[i][j] = rand() % 10000;

	for (q = rand() % 100; q; --q) {
		i = rand() % (M - N) + 1;
		j = rand() % (M - N) + 1;

		for (ii = 1; ii <= N; ii++)
			for (jj = 1; jj <= N; jj++)
				a[i + ii - 1][j + jj - 1] = 10000 - b[ii][jj];
	}

	printf("%d\n", M);
	for (i = 1; i <= M; i++) {
		for (j = 1; j <= M; j++) printf("%d ", a[i][j]);
		printf("\n");
	}

	printf("%d\n", N);
	for (i = 1; i <= N; i++) {
		for (j = 1; j <= N; j++) printf("%d ", b[i][j]);
		printf("\n");
	}

	fclose(stdout);

	return 0;
}

int get_brute()
{
	int i, j, ii, jj, q, rez = 0, e;

	for (i = 1; i + N - 1 <= M; i++)
		for (j = 1; j + N - 1 <= M; j++) {
			q = a[i][j] + b[1][1];

			e = 1;
			for (ii = 1; ii <= N && e; ii++)
				for (jj = 1; jj <= N && e; jj++) 
					e &= q == (a[i + ii - 1][j + jj - 1] + b[ii][jj]);

//			if (e) printf("%d %d\n", i, j);

			rez += e;
		}

	return rez;
}

int main()
{
//	srand(6661230);
//	gen(500, 100);
	
	int i, j;
	
	freopen("tetris.in", "r", stdin);
	freopen("tetris.out", "w", stdout);

	scanf("%d", &M);

	for (i = 1; i <= M; i++) 
		for (j = 1; j <= M; j++) scanf("%d", &a[i][j]);

	scanf("%d", &N);

	for (i = 1; i <= N; i++)
		for (j = 1; j <= N; j++) scanf("%d", &b[i][j]);

	if (N == 1) {
		printf("%d\n", M * M);
		return 0;
	}

	for (i = 0; i < nc; i++) get_codes(c[i], cc[i], baza[i], mod[i]);

	int e, rez = 0, q, k, jeg;
	for (i = 1; i + N - 2 <= M - 1; i++)
		for (j = 1; j + N - 2 <= M - 1; j++) {
			e = 1; jeg = a[i][j] + b[1][1];
			for (k = 0; k < N && e; k++) {
				if (a[i + k][j] + b[k + 1][1] != jeg) e = 0;
				for (q = 0; q < nc; q++)
					if (c[q][i + k][j] != cc[q][k + 1]) e = 0;
			}

//			if (e) printf("%d %d\n", i, j);

			rez += e;
		}

	printf("%d\n", rez);
//	printf("%d\n", get_brute());
	
return 0;
}

