//datorii
#include <stdio.h>
#define INPUT "datorii.in"
#define OUTPUT "datorii.out"
#define NMAX 32

int N, M;
int mat[NMAX][NMAX];

int viz[NMAX], t[NMAX];
int ult;

int ok;

int bun(int nr)
{
    int i;
    for(i = 1; i <= N; ++i)
        if(mat[nr][i]) return 0;
    return 1;
}

void parcurg(int src)
{
    int i;
    for(i = 1; i <= N; ++i)
        if(mat[src][i])
        {
            t[i] = src;
            if(bun(i))
            {
                int min = mat[t[i]][i];
                int nlat = 0;
                
                int j;
                for(j = i; t[j]; j = t[j])
                {
                    ++nlat;
                    if(mat[t[j]][j] < min) min = mat[t[j]][j];
                }
                if(nlat > 1)
                {
                    for(j = i; t[j];)
                    {
                        mat[t[j]][j] -= min;
                        int aux;
                        
                        if(!mat[t[j]][j])
                            aux = t[j],
                            t[j] = 0,
                            j = aux;
                        else j = t[j];
                    }
                    mat[j][i] += min;
                    ok = 1;
                }
            }
            else parcurg(i);
        }
}

void dfs(int src)
{
    viz[src] = 1;
    int i;
    for(i = 1; i <= N; ++i)
        if(mat[src][i])
            if(viz[i])
            {
                if(i != t[src])
                {
                    int j = src;
                    while(t[j] && j != i) j = t[j];
                    if(j == i)
                    {
                        int min = mat[src][i];
                        
                        for(j = src; t[j] && j != i; j = t[j])
                            if(mat[t[j]][j] < min) min = mat[t[j]][j];
                            
                        for(j = src; t[j] && j != i; j = t[j])
                            mat[t[j]][j] -= min;

                        mat[src][i] -= min;
                    }
                }
            }
            else
                t[i] = src,
                dfs(i);
}

void citire()
{
    freopen(INPUT, "r", stdin);
    freopen(OUTPUT, "w", stdout);

    scanf("%d %d", &N, &M);

    int i, j;
    for(i = 1; i <= M; ++i)
    {
        int A, B, C;
        scanf("%d %d %d", &A, &B, &C);
        mat[A][B] = C;
    }
}


int main()
{
    citire();

    int i;
    for(i = 1; i <= N; ++i)
        if(!viz[i]) dfs(i);

    ok = 1;
    while(ok)
    {
        ok = 0;
        for(i = 1; i <= N; ++i)
            if(!t[i]) parcurg(i);

    }

    int cost = 0, ntranz = 0;

    int j;
    for(i = 1; i <= N; ++i)
        for(j = 1; j <= N; ++j)
            if(mat[i][j])
                ++ntranz,
                cost += mat[i][j];

    printf("%d %d\n", ntranz, cost);
    
    for(i = 1; i <= N; ++i)
        for(j = 1; j <= N; ++j)
            if(mat[i][j])
                printf("%d %d %d\n",i, j, mat[i][j]);
    return 0;
}

