//tetris
#include <stdio.h>
#include <string.h>
#define INPUT "tetris.in"
#define OUTPUT "tetris.out"
#define MMAX 512
#define NMAX 128

int N, M;
int cub[MMAX][MMAX], piesa[NMAX][NMAX];

int T[NMAX][NMAX];
int ok[MMAX];

int npoz, npoz2;

int NR;

void potriv(int p)
{
    int i, k = 1;
    for(i = 2; i <= M; ++i)
    {
        while((k > 1) && (piesa[1][k+1] != cub[p][i-1] + piesa[1][k] - cub[p][i]))
            k = T[1][k];
            
        if(k == 0) k = 1;
        if(piesa[1][k+1] == cub[p][i-1] + piesa[1][k] - cub[p][i]) ++k;

        if(k == N)
            ok[++npoz] = i,
            k = T[1][k];
    }
    
}

void potriv2(int pcub, int ppies)
{
    npoz2 = 0;
    int i, k = 0;
    int sf = 1;
    
    for(i = 1; i <= M; ++i)
    {
        while((k >= 1) && (piesa[ppies][k+1] != cub[pcub][i-1] + piesa[ppies][k] - cub[pcub][i]))
            k = T[ppies][k];

        if((k == 0) && (piesa[ppies][1] + cub[pcub][i] == piesa[ppies-1][1] + cub[pcub-1][i])) k = 1;
        else if(piesa[ppies][k+1] == cub[pcub][i-1] + piesa[ppies][k] - cub[pcub][i]) ++k;

        if(k == N)
        {
            while((sf < npoz) && (ok[sf+1] <= i)) ++sf;
            if(ok[sf] == i) ok[++npoz2] = i;

            k = T[ppies][k];
        }
    }
    npoz = npoz2;
}
void prefix(int p)
{
    int i, k = 0;
    T[p][1] = 0;
    for(i = 2; i <= N; ++i)
    {
        while((k > 0) && (piesa[p][k+1] != piesa[p][i]))
            k = T[p][k];
            
        if(piesa[p][k+1] == piesa[p][i]) ++k;
        T[p][i]= k;
    }
}

void citire()
{

    freopen(INPUT, "r", stdin);
    freopen(OUTPUT, "w", stdout);

    scanf("%d", &M);
    int i, j;
    for(i = 1; i <= M; ++i)
        for(j = 1; j <= M; ++j)
            scanf("%d", &cub[i][j]);

    scanf("%d", &N);
    for(i = 1; i <= N; ++i)
        for(j = 1; j <= N; ++j)
            scanf("%d", &piesa[i][j]);
}

int main()
{

    citire();

    if(N != 1)
    {
        int i, j;
        for(i = 1; i <= N; ++i) prefix(i);


        for(i = 1; i <= M-N+1; ++i)
        {
            memset(ok, 0, sizeof(ok));
            npoz = npoz2 = 0;
            
            potriv(i);
            for(j = 2; j <= N && npoz; ++j)
                potriv2(i+j-1, j);
                
            NR += npoz;
        }
        printf("%d\n", NR);
    }
    else printf("%d\n", M*M);


    return 0;
}

