#include <stdio.h>

#define nm 401
#define mm 91

int n, m, a[nm][nm], b[mm][mm], p[nm], s[nm][nm], sol;
char c[nm][mm][nm];

void go(int x, int y)
{
	int k;
	
	k = 0;
	p[1] = 0;

	for (int i = 1; i < n; ++i) {
		while (k && a[x][i + 1] != a[x][k + 1])
			k = p[k];

		if (a[x][i + 1] == a[x][k + 1])
			++k;

		p[i + 1] = k;
	}

	k = 0;

	for (int i = 0; i < n; ++i) {
		while (k && a[x][i + 1] != b[y][k + 1])
			k = p[k];

		if (a[x][i + 1] == b[y][k + 1])
			++k;

		if (k == m)
			c[x][y][i - k + 2] = 1;
	}
}

int main()
{
	freopen("tetris.in", "r", stdin);
	freopen("tetris.out", "w", stdout);

	scanf("%d", &n);

	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= n; ++j)
			scanf("%d", &a[i][j]);

	scanf("%d", &m);

	for (int i = 1; i <= m; ++i)
		for (int j = 1; j <= m; ++j)
			scanf("%d", &b[i][j]);

	if (m == 1) {
		printf("%d\n", n * n);
		return 0;
	}

	for (int i = n; i; --i)
		for (int j = 1; j <= n; ++j)
			a[i][j] = a[i - 1][j] - a[i][j];

	for (int i = m; i; --i)
		for (int j = 1; j <= m; ++j)
			b[i][j] = b[i][j] - b[i - 1][j];

	for (int i = 2; i <= n; ++i)
		for (int j = 2; j <= m; ++j)
			go(i, j);

	

	for (int i = 2; i <= n - m + 2; ++i) {
		for (int j = 2; j <= m; ++j)
			for (int k = 1; k <= n; ++k)
				s[j][k] = s[j - 1][k] + c[i + j - 2][j][k];

		for (int j = m - 1; j <= m; ++j)
			for (int k = 1; k <= n; ++k)
				sol += (s[j][k] - s[j - m + 1][j] == m - 1);
	}

	printf("%d\n", sol);

	return 0;
}
