#include <stdio.h>
#include <algorithm>
#include <vector>

#define pb push_back
#define nmax 25
#define cmax 2000000
#define inf 0x3f3f3f3f

using namespace std;

int n, m, x, y, z, crtcalc, mareconf, stot, sou;
int a[nmax], aux[nmax], aux1[nmax];
int c[cmax], prev[cmax];

int calc()
{
	vector <int> v1, v2;
	vector <int> r1, r2;
	for(int i = 1; i <= n; i++) 
		if(aux[i] == 1) 
		{
			if(a[i] > 0) 
			{
				v1.pb(a[i]);
				if(sou) r1.pb(i);
			}
			else if(a[i] < 0) 
			{
				v2.pb(-a[i]);
				if(sou) r2.pb(i);
			}
		}

	int pasi = 0, n1 = (int)v1.size(), n2 = (int)v2.size();
	while(1)
	{
		int gata = 1;
		for(int i = 0; i < n1; i++) if(v1[i] != 0) gata = 0;
		for(int i = 0; i < n2; i++) if(v2[i] != 0) gata = 0;

		if(gata) return pasi;
		int maxim = -inf;
		for(int i = 0; i < n1; i++) maxim = max(maxim, v1[i]);
		int minim = inf;
		for(int i = 0; i < n2; i++) 
			if(v2[i] != 0) minim = min(minim, v2[i]);

		pasi++;
		int suma = min(maxim, minim);
		for(int i = 0; i < n2; i++)
			if(v2[i] == minim)
			{
				if(sou) printf("%d ", r2[i]);
				v2[i] -= suma;
				break;
			}

		for(int i = 0; i < n1; i++)
			if(v1[i] == maxim) 
			{
				if(sou) printf("%d ", r1[i]);
				v1[i] -= suma;
				break;
			}

		if(sou) printf("%d\n", suma);
	}
}

void reconst(int conf)
{
	if(conf == 0) return ;
	if(prev[conf] == -1) 
	{
		for(int i = n; i >= 1; i--)
		{
			aux[i] = conf % 2;
			conf /= 2;
		}
		sou = 1;
		calc();
	}
	else
	{
		reconst(prev[conf]);
		reconst(conf ^ prev[conf]);
	}
}
void show1(int p, int s1, int s2, int conf)
{
	if(s1 == s2 && conf != crtcalc) 
	{
		if(c[conf] + c[crtcalc ^ conf] < c[crtcalc])
		{
			c[crtcalc] = min(c[crtcalc], c[conf] + c[crtcalc ^ conf]);
			prev[crtcalc] = conf;
		}
	}
}

void back1(int p, int s1, int s2, int conf)
{
	for(int i = 0; i <= aux[p]; i++)
	{
		aux1[p] = i;
		int ns1 = s1, ns2 = s2, nconf = conf * 2 + aux1[p];
		if(aux1[p] == 1)
		{
			if(a[p] > 0) ns1 = s1 + a[p];
			if(a[p] < 0) ns2 = s2 - a[p];
		}

		if(p == n) show1(p, ns1, ns2, nconf);
		else back1(p + 1, ns1, ns2, nconf);
	}
}

void show(int p, int s1, int s2, int conf)
{
	mareconf = max(mareconf, conf);
	c[conf] == inf;
	if(s1 == s2) 
	{
		prev[conf] = -1;
		sou = 0;
		c[conf] = calc();
		crtcalc = conf;
		back1(1, 0, 0, 0);
	}
}
void back(int p, int s1, int s2, int conf)
{	
	for(int i = 0; i <= (a[p] != 0); i++)
	{
		aux[p] = i;
		int ns1 = s1, ns2 = s2, nconf = conf * 2 + aux[p];
		if(aux[p] == 1)
		{
			if(a[p] > 0) ns1 = s1 + a[p];
			if(a[p] < 0) ns2 = s2 - a[p];
		}

		if(p == n) show(p, ns1, ns2, nconf);
		else back(p + 1, ns1, ns2, nconf);
	}
}

int main()
{
	freopen("datorii.in", "r", stdin);
	freopen("datorii.out", "w", stdout);

	scanf("%d%d", &n, &m);
	for(int i = 1; i <= m; i++)
	{
		scanf("%d%d%d", &x, &y, &z);
		a[x] -= z;
		a[y] += z;
	}

	mareconf = 0;
	for(int i = 1; i <= n; i++) 
		if(a[i] > 0) stot += a[i];
	back(1, 0, 0, 0);

	printf("%d %d\n", c[mareconf], stot);
	reconst(mareconf);

	return 0;
}
