#include <stdio.h>
#include <stdlib.h>

#define nmax 512
#define hugedbg 0
#define localdbg 0
#define baza 37
#define pmax 32

int verif1 = 1, verif2 = 1, verif3 = 1, verif4 = 1;
int n, m, sol, x1, y1;
int a[nmax][nmax], b[nmax][nmax];
int sbh[nmax], sbv[nmax];
int sah[nmax][nmax], sav[nmax][nmax];
int hbh[nmax], hbv[nmax];
int hah[nmax][nmax], hav[nmax][nmax];

inline int randn(int x)
{
	return rand() % x + 1;
}

void precalc()
{
	if(verif4)
	{
		int imp, jeg;
		for(int i = 2; i <= m; i++)
		{
			hbh[i] = 0;
			for(int j = 2; j <= m; j++) hbh[i] = hbh[i] * baza + (b[i][j] - b[i][1]);
		}

		for(int i = 2; i <= m; i++)
		{
			hbv[i] = 0;
			for(int j = 2; j <= m; j++) hbv[i] = hbv[i] * baza + (b[j][i] - b[1][i]);
		}

		for(int i = 1; i <= n; i++)
			for(int j = 1; j <= n; j++)
			{
				imp = a[i][j]; jeg = 0;
				hah[i][j] = 0;
				for(int k = 2; k <= m; k++)
					if(j + k < nmax) jeg = jeg * baza + (imp - a[i][j + k - 1]);
				hah[i][j] = jeg;
			}

		for(int i = 1; i <= n; i++)
			for(int j = 1; j <= n; j++)
			{
				imp = a[i][j]; jeg = 0;
				hav[i][j] = 0;
				for(int k = 2; k <= m; k++)
					if(i + k < nmax) jeg = jeg * baza + (imp - a[i + k - 1][j]);
				hav[i][j] = jeg;
			}
	}

	for(int i = 2; i <= m; i++)
	{
		sbh[i] = 0;
		for(int j = 2; j <= m; j++) sbh[i] += b[i][j] - b[i][1];
	}

	for(int i = 2; i <= m; i++)
	{
		sbv[i] = 0;
		for(int j = 2; j <= m; j++) sbv[i] += b[j][i] - b[1][i];
	}

	for(int i = 1; i <= n; i++)
		for(int j = 1; j <= n; j++)
		{
			sah[i][j] = 0;
			for(int k = 2; k <= m; k++) 
				if(j + k < nmax) sah[i][j] += a[i][j] - a[i][j + k - 1];
		}

	for(int i = 1; i <= n; i++)
		for(int j = 1; j <= n; j++)
		{
			sav[i][j] = 0;
			for(int k = 2; k <= m; k++) 
				if(i + k < nmax) sav[i][j] += a[i][j] - a[i + k - 1][j];
		}
}

int main()
{
	freopen("tetris.in", "r", stdin);
	freopen("tetris.out", "w", stdout);

	scanf("%d", &n);
	for(int i = 1; i <= n; i++)
		for(int j = 1; j <= n; j++)
			scanf("%d", &a[i][j]);
	scanf("%d", &m);
	for(int i = 1; i <= m; i++)
		for(int j = 1; j <= m; j++)
			scanf("%d", &b[i][j]);

	if(m > 50) verif4 = 0;
	precalc();

	sol = 0;
	for(int i = 1; i <= n - m + 1; i++)
		for(int j = 1; j <= n - m + 1; j++)
		{
			int bun = 1;
			int suma = a[i][j] + b[1][1];
			if(verif1)
			{
				for(int i1 = 1; i1 <= m; i1++)
					if(a[i + i1 - 1][j] + b[i1][1] != suma)
					{
						bun = 0;
						break;
					}
				
				if(!bun) continue;
				for(int i1 = 1; i1 <= m; i1++)
					if(a[i][j + i1 - 1] + b[1][i1] != suma)
					{
						bun = 0;
						break;
					}
				if(!bun) continue;
			}

			if(verif2)
			{
				for(int k = 1; k <= 300; k++)
				{
					x1 = 1 + randn(m - 1);
					y1 = 1 + randn(m - 1);
					if(a[i + x1 - 1][j + y1 - 1] + b[x1][y1] != suma)
					{
						bun = 0;
						break;
					}
				}
				if(!bun) continue;
			}

			if(verif3)
			{
				for(int k = 2; k <= m; k++)
					if(sbh[k] != sah[i + k - 1][j]) 
					{
						bun = 0;
						break;
					}

				for(int k = 2; k <= m; k++)
					if(sbv[k] != sav[i][j + k - 1])
					{
						bun = 0;
						break;
					}
				if(!bun) continue;
			}
			
			if(verif4)
			{
				for(int k = 2; k <= m; k++)
					if(hbh[k] != hah[i + k - 1][j])
					{
						bun = 0;
						break;
					}

				for(int k = 2; k <= m; k++)
					if(hbv[k] != hav[i][j + k - 1])
					{
						bun = 0;
						break;
					}

				if(!bun) continue;
			}

			sol++;
		}

	printf("%d\n", sol);

	return 0;
}
