#include <cstdio>
#include <cstring>
#include <algorithm>

using namespace std;

#define LX 310
#define NX 60500
#define LOG 17

char S[ NX ];
int Na, Nb, N, who[ NX ];

int A[LOG][NX];

struct ent {
	int x, y, ix;
	ent( int a=0, int b=0, int c=0 ) : x(a), y(b), ix(c) {}
	bool operator== ( const ent& a ) const {
		return ( x == a.x && y == a.y );
	}

	bool operator< (const ent &a ) const {
		return (x == a.x) ? (y < a.y) : (x < a.x);
	}
};

ent L[ NX ];

void cit() {
	int i, j, l;

	scanf( "%d ", &Na );
	for( j = 1; j <= Na; j++ ) {
		fgets( S+N, LX, stdin );
		l = strlen( S+N );
		
		S[ N+l-1 ] = '#';
		for( i = 0; i < l; i++ )
			who[ N+i ] = j;
		N += l;
	}

	scanf( "%d ", &Nb );
	for( j = 1; j <= Nb; j++ ) {
		fgets( S+N, LX, stdin );
		l = strlen( S+N );
		
		S[ N+l-1 ] = '#';
		for( i = 0; i < l; i++ )
			who[ N+i ] = j+Na;
		N += l;
	}
}

void rez() {
	int i, stp, h;
	
	for( i = 0; i < N; i++ )
		A[0][i] = S[i] - 'a';

     for( stp = 1, h = 1; h < N; h <<= 1, stp++ ) {
		for( i = 0; i < N; i++ )
			L[i] = ent( A[ stp-1 ][i], (i+h <= N) ? (A[stp-1][i+h]) : -1, i );
          sort( L, L+N );
		for( i = 0; i < N; i++ ) {
			A[stp][L[i].ix] = (i == 0 || (L[i] == L[i-1]) ) ? i : A[stp][L[i-1].ix];
		}
	}
}

void scr() {
	printf( "1\n" );
}

int main() {
	freopen( "sub.in", "r", stdin );
	freopen( "sub.out", "w", stdout );

	cit();
	rez();
	scr();

	return 0;
}

