#include <cstdio>
#include <cstdlib>
#include <cstring>

using namespace std;

#define NX 128
#define MX 512

int N, M, res, a[MX][MX], b[NX][NX], T[MX][MX], P[NX][NX], pi[NX][NX];
int cnt[MX];

#define BSZ (1<<17)
char buf[BSZ];
int bp = BSZ - 1;

int get() {
	int x = 0;

	while( buf[bp] < '0' || buf[bp] > '9' )
		if( ++bp >= BSZ )
			fread( buf, 1, BSZ, stdin ), bp = 0;

     while( buf[bp] >='0' && buf[bp] <= '9' ) {
		x = x * 10 + buf[bp] - '0';
		if( ++bp >= BSZ )
			fread( buf, 1, BSZ, stdin ), bp = 0;
     }

	return x;
}

void cit() {
	int i, j;
	
	M = get();

	for( i = 0; i < M; i++ )
		for( j = 0; j < M; j++ )
			a[i][j] = get();
     N =get();

	for( i = 0; i < N; i++ )
		for( j = 0; j < N; j++ )
			b[i][j] = get();
}

void rez() {
	int i, j, k, l, beg;
	
	for( i = 0; i < M; i++ )
		for( j = 1; j < M; j++ )
			T[i][j] = a[i][j] - a[i][j-1];

     for( i = 0; i < N; i++ )
		for( j = 1; j < N; j++ )
			P[i][j] = b[i][j-1] - b[i][j];

     for( i = 0; i < N; i++ )
		for( k = pi[i][0] = -1, j = 1; j < N; pi[i][j++] = ++k )
			while( (P[i][j] != P[i][k+1]) && k >= 0 )
				k = pi[i][k];

     for( i = 0; i <= M-N; i++ ) {
		memset( cnt, 0, sizeof( cnt ) );
		for( j = 0; j < N; j++ ) {
			for( l = 1, k = 0; l < M; l++ ) {
				while( (T[i+j][l] != P[j][k+1]) && k >= 0 )
					k = pi[j][k];
                    if( ++k == N-1 ) {
					beg = l-k+1;
					if( (j==0) || ( (cnt[beg] > 0) && (b[0][0]+a[i][beg-1] == b[j][0]+a[i+j][beg-1]) ) )
						cnt[beg]++;
					k = pi[j][k];
                    }
               }
		}
		for( l = 1; l <= M-N+1; l++ )
			if( cnt[l] == N )
				res++;
	}
}

void scr() {
	printf( "%d\n", res );
}

int main() {
	freopen( "tetris.in", "r", stdin );
	freopen( "tetris.out", "w", stdout );

	cit();
	rez();
	scr();

	return 0;
}

