#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <algorithm>
using namespace std;


#define MUL1 101
#define MUL2 107
#define MOD1 100007
#define MOD2 100021

#define N 104
#define L 250


int n, m;
char a[N][L], b[N][L];
int la[N], lb[N];


struct hash { int x, y; };
hash hx[L][L], ha[N][L][L], hb[N][L][L];
int na[N][L], nb[N][L];



bool sorthash(hash a, hash b) {
if (a.x<b.x) return 1;
if (a.x>b.x) return 0;
if (a.y>b.y) return 0;
return 1; }


int comp(hash a, hash b) {
if (a.x<b.x) return -1;
if (a.x>b.x) return 1;
if (a.y<b.y) return -1;
if (a.y>b.y) return 1;
return 0; }



int ina(hash h, int l) {
int i, c;
for (i=0; i<n; i++)
   while (na[i][l]<=la[i]-l) {
      c=comp(h, ha[i][l][na[i][l]]);
      if (c==0) break;
      if (c==-1) return 0;
      na[i][l]++; }
return 1; }


int inb(hash h, int l) {
int i, c;
for (i=0; i<m; i++)
   while (nb[i][l]<=lb[i]-l) {
      c=comp(h, hb[i][l][nb[i][l]]);
      if (c==0) return 1;
      if (c==-1) break;
      nb[i][l]++; }
return 0; }



int main() {
freopen("sub.in", "rt", stdin);
freopen("sub.out", "wt", stdout);

int i, j, k, lx, p1, p2;
scanf("%d\n", &n);

int p=0;
for (i=0; i<n; i++) {
   scanf("%s\n", a[i]);
   la[i]=strlen(a[i]);
   if (la[p]>la[i]) p=i; }

for (k=0; k<n; k++)
   for (i=1; i<=la[k]; i++) {
      p1=p2=1;
      for (j=0; j<i; j++) {
         ha[k][i][0].x = (ha[k][i][0].x * MUL1 + a[k][j]) % MOD1;
         ha[k][i][0].y = (ha[k][i][0].y * MUL2 + a[k][j]) % MOD2;
         if (j) {
            p1 = (p1 * MUL1) % MOD1;
            p2 = (p2 * MUL2) % MOD2; } }
         
      for (; j<=la[k]; j++) {
         ha[k][i][j-i+1].x = (((ha[k][i][j-i].x - p1 * a[k][j-i]) % MOD1 + MOD1) * MUL1 + a[k][j]) % MOD1;
         ha[k][i][j-i+1].y = (((ha[k][i][j-i].y - p2 * a[k][j-i]) % MOD2 + MOD2) * MUL2 + a[k][j]) % MOD2; }

      sort(ha[k][i], ha[k][i]+j-i, sorthash); }


for (i=1; i<=la[p]; i++)
   for (j=0; j<=la[p]-i; j++)
      hx[i][j]=ha[p][i][j];

lx=la[p];
a[p][0]=la[p]=0;



scanf("%d\n", &m);
for (i=0; i<m; i++) {
   scanf("%s\n", b[i]);
   lb[i]=strlen(b[i]); }

for (k=0; k<m; k++)
   for (i=1; i<=lb[k]; i++) {
      p1=p2=1;
      for (j=0; j<i; j++) {
         hb[k][i][0].x = (hb[k][i][0].x * MUL1 + b[k][j]) % MOD1;
         hb[k][i][0].y = (hb[k][i][0].y * MUL2 + b[k][j]) % MOD2;
         if (j) {
            p1 = (p1 * MUL1) % MOD1;
            p2 = (p2 * MUL2) % MOD2; } }
         
      for (; j<=lb[k]; j++) {
         hb[k][i][j-i+1].x = (((hb[k][i][j-i].x - p1 * b[k][j-i]) % MOD1 + MOD1) * MUL1 + b[k][j]) % MOD1;
         hb[k][i][j-i+1].y = (((hb[k][i][j-i].y - p2 * b[k][j-i]) % MOD2 + MOD2) * MUL2 + b[k][j]) % MOD2; }

      sort(hb[k][i], hb[k][i]+j-i, sorthash); }


int sol=0;
for (i=1; i<=lx; i++)
   for (j=0; j<=lx-i; j++) {
      while (!comp(hx[i][j], hx[i][j+1])) j++;
      if (ina(hx[i][j], i))
         if (!inb(hx[i][j], i))
            sol++; }

printf("%d\n", sol);

return 0; }

