#include <stdio.h>
#include <string.h>

#define CLEAR(x) memset(x, 0, sizeof(x)) 
#define minim(a, b) ((a < b) ? a : b)

int N, M, D[32][32], uz[32], up[32], t_in[32], t_out[32], t;
int d_in[32], d_out[32];
int plata[32][32], cnt, bst; 

int stramos(int x, int y)
{ return t_in[x] <= t_in[y] && t_out[y] <= t_out[x]; }

void df(int nod)
{
	int i;

	uz[nod] = 1; t_in[nod] = ++t;
	for (i = 1; i <= N; ++i)
		if (D[nod][i] > 0 && !uz[i])
		{
			up[i] = nod;
			df(i);
		}
	t_out[nod] = ++t;
}

int main(void)
{
	int i, j, u, v, c, gasit, r = 0, max_d, si, sj;

	freopen("datorii.in", "r", stdin);
	freopen("datorii.out", "w", stdout);

	scanf("%d %d", &N, &M);
	for (; M; --M)
	{
		scanf("%d %d %d", &u, &v, &c);
		D[u][v] += c;
	}

	for (i = 1; i <= N; ++i)
		for (j = 1; j <= N; ++j)
			if (i != j)
			{
				if (D[u][v] < D[v][u])
					D[v][u] -= D[u][v], D[u][v] = 0;
				else
					D[u][v] -= D[v][u], D[v][u] = 0;
			}

	for (; ; )
	{
		CLEAR(uz); CLEAR(up); t = 0;
		for (i = 1; i <= N; ++i)
			if (!uz[i])
				df(i);

		gasit = 0;
		for (i = 1; i <= N && !gasit; ++i)
			for (j = 1; j <= N && !gasit; ++j)
				if (D[i][j] > 0 && stramos(j, i))
				{
					gasit = 1;
					r = D[i][j];
					for (u = i; u != j; u = up[u])
						r = minim(r, D[up[u]][u]);
					for (u = i; u != j; u = up[u])
						D[up[u]][u] -= r;
					D[i][j] -= r;
				}
		if (!gasit)
			break;
	}

	// graful e aciclic
	for (; ; )
	{
		gasit = 0; si = sj = -1; max_d = 0;

		CLEAR(d_in); CLEAR(d_out);
		for (i = 1; i <= N; ++i)
			for (j = 1; j <= N; ++j)
				if (D[i][j] > 0)
					++d_in[j], ++d_out[i];

		for (i = 1; i <= N && !gasit; ++i)
			if (!d_in[i] && d_out[i])
			{
				CLEAR(uz);
				df(i);
				for (j = 1; j <= N && !gasit; ++j)
					if (!d_out[j] && uz[j])
					{
						gasit = 1; r = 128;
						for (u = j; u != i; u = up[u])
							r = minim(r, D[up[u]][u]);
				                break;
					}
				if (r > max_d)
					max_d = r,
					si = i, sj = j;
			}

		if (gasit)
		{
			CLEAR(uz);
			df(si);
			for (u = sj; u != si; u = up[u])
				D[up[u]][u] -= max_d;
			plata[si][sj] += max_d;
		}
		
		if (!gasit)
			break;
	}

	for (i = 1; i <= N; ++i)
		for (j = 1; j <= N; ++j)
			if (plata[i][j])
				++cnt, bst += plata[i][j];

	printf("%d %d\n", cnt, bst);
	for (i = 1; i <= N; ++i)
		for (j = 1; j <= N; ++j)
			if (plata[i][j])
				printf("%d %d %d\n", i, j, plata[i][j]);

	return 0;
}

