#include<stdio.h>
#include<algorithm>

using namespace std;
const int maxn = 520;
typedef int matrice[maxn][maxn];
matrice N1,N2,MAT,PAT;
matrice aux;
int P[maxn];
int M,N;
matrice LIN,COL;

void match(matrice &dest,matrice &mat,matrice &pattern)
{
	for(int i = 1;i <= N; ++i)
	{
		memcpy(aux,dest,sizeof(aux));
		memset(dest,0,sizeof(dest));
		memset(P,0,sizeof(P));
		P[1] = 0;
		for(int k = 2;k < N; ++k)
		{
			P[k] = P[k - 1];
			while(pattern[i][P[k] + 1] != pattern[i][k] && P[k] >= 0)
			{
				P[k] = P[P[k]];
				if (P[k] == P[P[k]]) P[k] = P[k] - 1;
			}
			P[k] += 1;
		}

		for(int j = 1;j <= M; ++j)
		{
			int cur = 0;
			for(int k = 1;k < M; ++k)
			{
				while(cur >= 0 && pattern[i][cur + 1] != mat[j][k] )
				{
					cur = P[cur];
					if (cur == P[cur]) cur = P[cur] - 1;
				}
				cur += 1;
				if (cur == N - 1 && (aux[j - 1][k] == 1 || i == 1))
				{
					dest[j][k] = 1;
					cur = P[cur];
				}
			}
				
		}
	}
	return ;
}


int main()
{
	freopen("tetris.in","r",stdin);
	freopen("tetris.ok","w",stdout);
	scanf("%d",&M);
	for(int i = 1;i <= M; ++i)
		for(int j = 1;j <= M; ++j)
		{
			scanf("%d",&MAT[i][j]);	
		}
	scanf("%d",&N);
	for(int i = 1;i <= N; ++i)
		for(int j = 1;j <= N; ++j)
		{
			scanf("%d",&PAT[i][j]);	
		}

/*	for(int i = 1;i <= M; ++i)
		for(int j = 1;j < M; ++j)
		{
			N1[i][j] = MAT[i][j] - MAT[i][j + 1];	
		}
	for(int i = 1;i <= N; ++i)
		for(int j = 1;j < N; ++j)
		{
			N2[i][j] = PAT[i][j + 1] - PAT[i][j];
		}
	match(LIN,N1,N2);
	for(int i = 1;i < M; ++i)
		for(int j = 1;j <= M; ++j)
		{
			N1[j][i] = MAT[i][j] - MAT[i + 1][j];
		}
	for(int i = 1;i < N; ++i)
		for(int j = 1;j <= N; ++j)
		{
			N2[j][i] = PAT[i + 1][j] - PAT[i][j];
		}
	int sol = 0;
	match(COL,N1,N2);
*/	
	int sol = 0;
	for(int i = 1;i <= M; ++i)
		for(int j = 1;j <= M; ++j)
		{
			int cur = MAT[i][j] + PAT[1][1];
			for(int i1 = 1;i1 <= N; ++i1)
				for(int j1 = 1;j1 <= N; ++j1)
					if (PAT[i1][j1] + MAT[i + i1 - 1][j + j1 - 1] != cur)
					{
						cur = -1;
						break;
					}
			if (cur != -1)  ++sol;
		}
	printf("%d\n",sol);
	return 0;
}
																										 
																										 
