#include <stdio.h>
#include <vector>

using namespace std;

#define t 12
#define maxn 100010
#define pb push_back

int n, sol, rez;
vector <int> a[maxn];
int g[maxn], cost[maxn], u[maxn];

void DFS2(int nod)
{
	u[nod] = 1;

	rez += cost[nod];

	int i; 

	for (i=0; i<g[nod]; i++) 
		if (!u[a[nod][i]]) DFS2(a[nod][i]);

	if (rez > sol) sol = rez;

	rez -= cost[nod];
	u[nod] = 0;
}

void DFS(int nod)
{
	int i;

	u[nod] = 1;
	rez += cost[nod];

	for (i=0; i<g[nod]; i++) 
		if (!u[a[nod][i]]) DFS(a[nod][i]);

	for (i=1; i<=n; i++)
		if (!u[i] && g[i]==1) DFS2(i);

	rez -= cost[nod];
	u[nod] = 0;
}

int main()
{
	freopen("turism.in", "r", stdin);
	freopen("turism.out", "w", stdout);

	int T = t, i, x , y;

	while (T)
	{
		scanf("%d ", &n);

		for (i=1; i<=n; i++) scanf("%d ", &cost[i]);
		for (i=1; i<=n; i++) vector <int> ().swap(a[i]);

		for (i=1; i<n; i++)
		{
			scanf("%d %d ", &x, &y);
			a[x].pb(y);
			a[y].pb(x);
		}

		for (i=1; i<=n; i++) g[i] = a[i].size();

		sol = 0;

		for (i=1; i<=n; i++) 
			if (g[i] == 1)
			{
				memset(u, 0, sizeof(u));
				DFS(i);
			}

		printf("%d\n", sol);
		T--;
	}

	return 0;
}
