using namespace std;
#include <cstdio>
#include <cstring>
#include <map>
#include <set>
#include <algorithm>

#define Nmax 50005
#define Mmax 50005

int N,M,T,i,j;
int c,t,p,nr,a,b,x,op;
int nr1,nr2;
int tt[Mmax];

map<int, int> A[2][2*Nmax+100];

void update(int c,int t,int p,int nr)
{
 map<int, int>::iterator it;
 //baga
 it = A[p][c].find( t );
 if (it != A[p][c].end() )
	A[p][c][t] += nr;
    else
         A[p][c][t]=nr;
 //baga si complementaru
 it = A[p^1][c].find( t );
 if ( it == A[p^1][c].end() )
        A[p^1][c][t]=0;
}

void color(int c,int t)
{

 nr1 = A[0][c][t];
 nr2 = A[1][c][t];
 A[0][c][t] = nr2;
 A[1][c][t] = nr1;

}

void query(int a,int b,int p,int x)
{
 map<int,int>::iterator it;
 int t,c,nr;

 nr=0;
 for (t=1;t<=M && nr<x;++t)
        {
         for (c=a;c<=b && nr<x;++c)
                {
                 it = A[p][c].find( t );
                 if (it != A[p][c].end() )
                        nr+=A[p][c][t];                        
                }
        }

 printf("%d\n",t-1);
}

//****************
//arbore intervale
//****************

void update2(int nod,int ls,int ld,int c,int t,int p,int nr)
{
 int m=(ls+ld) >> 1;
 map<int,int>::iterator it;

 //baga
 it = A[p][nod].find( t );
 if ( it != A[p][nod].end() )
        A[p][nod][t] += nr;
    else
        A[p][nod][t] = nr;

 //baga si complementaru
 it = A[p^1][nod].find( t );
 if ( it == A[p^1][nod].end() )
        A[p^1][nod][t] = 0;

 //mergi mai departe
 if (ls == ld)
         return;

 if (c<=m) update2(nod<<1, ls, m, c, t, p, nr);
        else update2( (nod<<1) + 1, m+1, ld, c, t, p, nr);        
}

void color2(int nod,int ls,int ld,int c,int t)
{
 int m=(ls+ld) >> 1;
 map<int,int> :: iterator it;

 //schimba culori
 if (ls == ld)
       {
        nr1 = A[0][nod][t];
        nr2 = A[1][nod][t];
        A[0][nod][t] = nr2;
        A[1][nod][t] = nr1;
        return;
       }

 //avanseaza
 if (c<=m) color2(nod<<1,ls,m,c,t);
        else color2((nod<<1)+1,m+1,ld,c,t);
        
 //modifica
 A[0][nod][t] += (nr2-nr1);
 A[1][nod][t] += (nr1-nr2); 
}

void query2(int nod,int ls,int ld,int a,int b,int p)
{
 int m=(ls+ld) >> 1, i;
 map<int,int>::iterator it;

 //numara
 if (ls>=a && ld<=b)
        {
         for (i=1; i<=M; ++i)
                {
                 it = A[p][nod].find( i );
                 if ( it != A[p][nod].end() )
                        tt[ i ] += A[p][nod][t];
                }
         return;
        }

 //avanseaza
 if (a<=m) query2(nod<<1,ls,m,a,b,p);
 if (b>m) query2((nod<<1)+1,m+1,ld,a,b,p);
 
}

int main()
{
 int i,nr;

 freopen("kinder.in","r",stdin);
 freopen("kinder.out","w",stdout);

 scanf("%d %d %d",&N,&M,&T);

 if ( N*M <= 20000000 )
 while (T)
	{
	 --T;

	 scanf("%d",&op);

	 if (op==1)
		{
		 scanf("%d %d %d %d",&c,&t,&p,&nr);
                 update(c,t,p,nr);
		}
	 if (op==2)
		{
		 scanf("%d %d",&c,&t);
                 color(c,t);
		}
	 if (op==3)
		{
		 scanf("%d %d %d %d",&a,&b,&p,&x);
                 query(a,b,p,x);
                }
        }
 else
 while (T)
        {
         --T;

	 scanf("%d",&op);

	 if (op==1)
		{
		 scanf("%d %d %d %d",&c,&t,&p,&nr);
                 update2(1,1,N,c, t,p,nr);
		}
	 if (op==2)
		{
		 scanf("%d %d",&c,&t);
                 color2(1,1,N,c, t);
		}
	 if (op==3)
		{
		 scanf("%d %d %d %d",&a,&b,&p,&x);
                 
                 memset(tt,0,sizeof(tt));
                 query2(1,1,N,a,b, p);

                 nr=0;
                 for (i=1;i<=M && nr<x;++i)
                          nr+=tt[i];

                 printf("%d\n",i-1);
                }                
        }
 
 fclose(stdout);
 
 return 0;
}
