#include <stdio.h>
#include <string.h>

#define NMAX 2010

int N;

int val[NMAX];
int t1[NMAX];
int t2[NMAX];
int d[NMAX];

int send[NMAX];
int notsend[NMAX];

int beg[2][NMAX];
int end[2][NMAX];

inline int MAX(int a, int b) { return (a > b) ? a : b; }

int main()
{
	int i, j, q;
	
	freopen("senzori.in", "r", stdin);
	freopen("senzori.out", "w", stdout);

	scanf("%d", &N);

	for (i = 1; i <= N; i++) {
		scanf("%d %d %d %d", &t1[i], &t2[i], &d[i], &val[i]);

		notsend[i] = MAX(send[i - 1], notsend[i-1]);

		for (j = 0; j <= 2000; j++) {
			if (!(t1[i] <= j && j + d[i] <= t2[i])) continue;

			q = MAX(notsend[i-1], MAX(end[0][j], beg[0][j + d[i]])) + val[i];

			beg[1][j] = q;
			end[1][j + d[i]] = q;
			send[i] = MAX(send[i], q);
		}

		for (j = 1; j <= 2000; j++) end[1][j] = MAX(end[1][j], end[1][j - 1]);
		for (j = 2000; j >= 0; j--) beg[1][j] = MAX(beg[1][j], beg[1][j + 1]);

		memcpy(beg[0], beg[1], sizeof(beg[0]));
		memcpy(end[0], end[1], sizeof(end[1]));

		memset(beg[1], 0, sizeof(beg[1]));
		memset(end[1], 0, sizeof(end[1]));
	}

	printf("%d\n", MAX(send[N], notsend[N]));

return 0;
}

