#include <stdio.h>
#include <string.h>
#define INPUT "turism.in"
#define OUTPUT "turism.out"
#define NMAX 100001
#define CONST 12

int N;
int c[NMAX];

int grad[NMAX], max2[NMAX], max[NMAX], d[NMAX], lant[NMAX];

int ord;
int viz[NMAX], f[NMAX];

struct nod
{
   int vec;
   nod *leg;
}*graf[NMAX];


inline int MAXIM(int x, int y)
{
   return x>y ? x:y;
}

void df(int src)
{
   viz[src] = 1;
   nod *p;
   for(p = graf[src]; p; p = p->leg)
      if(!viz[p -> vec])
         ++grad[src],
         df(p -> vec);
   f[++ord] = src;
}

void citire()
{
      scanf("%d", &N);
      int i;
      for(i = 1; i <= N; ++i)
         scanf("%d", &c[i]);

      for(i = 1; i <= N; ++i) graf[i] = NULL;
      for(i = 1; i < N; ++i)
      {
         int a, b;
         scanf("%d %d", &a, &b);
         nod *p = new nod;
         p -> vec = b;
         p -> leg = graf[a];
         graf[a] = p;

         p = new nod;
         p -> vec = a;
         p -> leg = graf[b];
         graf[b] = p;
      }
}

int main()
{
   freopen(INPUT, "r", stdin);
   freopen(OUTPUT, "w", stdout);

   int T;
   for(T = 1; T <= CONST; ++T)
   {
      citire();
      
      memset(viz, 0, sizeof(viz));
      memset(grad, 0, sizeof(grad));
      ord = 0;
      
      df(1);

      int i;

      memset(lant, 0, sizeof(lant));
      memset(d, 0, sizeof(d));
      memset(max, 0, sizeof(max));
      memset(max2, 0, sizeof(max2));
      
      for(i = 1; i <= N; ++i)
      {
         int src = f[i];
         int aux;
         if(!grad[src])
            lant[src] = 0,
            d[src] = c[src],
            max[src] = c[src],
            max2[src] = c[src];
            
         else if(grad[src] == 1)
            aux = graf[src] -> vec,
            d[src] = d[aux] + c[src],
            max[src] = MAXIM(max[aux], d[src]),
            lant[src] = lant[aux],
            max2[src] = MAXIM(max2[aux], d[src] + lant[src]),
            max2[src] = MAXIM(max2[src], max[aux] + c[src]);
         else
         {
            nod *p;
            int maxd = 0, mmax = 0, lant2 = 0, llant = 0, mmax2 = 0, mmax3 = 0;
            for(p = graf[src]; p; p = p -> leg)
            {
               if(d[p ->vec] > maxd)
               {
                  if(max[maxd] > llant) llant = max[maxd];
                  
                  lant2 = maxd,
                  maxd = d[p -> vec];
                  
                  if(lant[maxd] > llant) llant = lant[maxd];
                  
               }
               else
               {
                  if(d[p -> vec] > lant2) lant2 = d[p -> vec];
                  if(max[p -> vec] > llant) llant = max[p -> vec];
               }
               
               if(max[p -> vec] > mmax)
                  mmax3 = mmax,
                  mmax = max[p -> vec];
               else if (max[p -> vec] > mmax3) mmax3 = max[p -> vec];
               
               if(max2[p -> vec] > mmax2) mmax2 = max2[p -> vec];
               
               
            }
            d[src] = maxd + c[src];
            max[src] =  MAXIM(mmax, d[src] + lant2);
            lant[src] = llant;
            max2[src] = MAXIM(mmax2, mmax3 + mmax);


            nod *q;
            for(p = graf[src]; p -> leg; p = p -> leg)
            {
               for(q = p -> leg; q; q = q -> leg)
               {
                  int m = 0;
                  if((max[p -> vec] != mmax) && (max[q -> vec] != mmax))
                     m = mmax;
                  else if((max[p -> vec] != mmax3) && (max[q-> vec] != mmax3))
                     m = mmax3;
                  else
                  {
                     nod *r;
                     for(r = graf[src]; r; r = r -> leg)
                        if((r -> vec != p -> vec) && (r -> vec != q -> vec) && (max[r -> vec] > m))
                           m = max[r -> vec];
                  }
                  if(lant[p -> vec] > m) m = lant[p -> vec];
                  if(lant[q -> vec] > m) m = lant[q -> vec];
                  if(d[p -> vec] + d[q -> vec] + m + c[src]> max2[src])
                     max2[src] = d[p->vec] + d[q -> vec] + m + c[src];
               }
            }

         }
      }
      printf("%d\n", max2[1]);
   }
   return 0;
}

