#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define Nmax 50015
#define Amax 131072
#define pb push_back
#define sz(a) (int)((a).size())

int n, m, t, dif, ct;
vector<int> aib[Amax][2];
vector<int> sir[Amax];
int tip[Nmax];
int a[Nmax], b[Nmax], c[Nmax], d[Nmax];
int list[Nmax];

void citire()
{
	int i;

	scanf("%d %d %d\n", &n, &m, &t);
	for (i = 1; i <= n; ++i)
	{
		scanf("%d", &tip[i]);
		if (tip[i] == 2) scanf("%d %d", &a[i], &b[i]);
		else scanf("%d %d %d %d", &a[i], &b[i], &c[i], &d[i]);
	}
}

void baga(int nod, int st, int dr, int c, int tp)
{
	if (st == dr)
		sir[nod].pb(tp);
	else
	{
		int mij = (st + dr) / 2, fs = nod * 2, fd = nod * 2 + 1;

		if (c <= mij) baga(fs, st, mij, c, tp);
		else baga(fd, mij + 1, dr, c, tp);

		sir[nod].pb(tp);
	}
}

inline int cauta(int ind, int v)
{
	int step, ret;

	for (step = 1; step < sz(sir[ind]); step <<= 1);
	for (ret = -1; step; step >>= 1)
		if (ret + step < sz(sir[ind]) && sir[ind][ret + step] <= v)
			ret += step;
	
	return ret + 1;
}

inline void aib_update(int ind, int c, int pos, int add)
{
	while (pos <= sz(sir[ind]))
	{
		aib[ind][c][pos] += add;
		pos += (pos ^ (pos - 1)) & pos;
	}
}

inline int aib_query(int ind, int c, int pos)
{
	int ret = 0;

	while (pos > 0)
	{
		ret += aib[ind][c][pos];
		pos -= (pos ^ (pos - 1)) & pos;
	}

	return ret;
}


void update1(int nod, int st, int dr, int a, int b, int c, int d)
{
	if (st == dr)
	{
		aib_update(nod, c, cauta(nod, b), d);
	}
	else
	{
		int mij = (st + dr) / 2, fs = nod * 2, fd = nod * 2 + 1;

		if (a <= mij) update1(fs, st, mij, a, b, c, d);
		else update1(fd, mij + 1, dr, a, b, c, d);

		aib_update(nod, c, cauta(nod, b), d);
	}
}

void update2(int nod, int st, int dr, int a, int b)
{
	if (st == dr)
	{
		if (sir[nod][cauta(nod, b)] == b)
			dif = aib_query(nod, 1, cauta(nod, b)) - aib_query(nod, 0, cauta(nod, b));
    	else dif = 0;

		aib_update(nod, 0, cauta(nod, b), dif);
		aib_update(nod, 1, cauta(nod, b), -dif);
	}
	else
	{
		int mij = (st + dr) / 2, fs = nod * 2, fd = nod * 2 + 1;

		if (a <= mij) update2(fs, st, mij, a, b);
		else update2(fd, mij + 1, dr, a, b);

		aib_update(nod, 0, cauta(nod, b), dif);
		aib_update(nod, 1, cauta(nod, b), -dif);
	}
}

void query(int nod, int st, int dr, int a, int b)
{
	if (a <= st && dr <= b)
		list[++ct] = nod;
	else
	{
		int mij = (st + dr) / 2, fs = nod * 2, fd = nod * 2 + 1;

		if (a <= mij) query(fs, st, mij, a, b);
		if (mij < b) query(fd, mij + 1, dr, a, b);
	}
}

void solve()
{
	int i, j, sol, step, nr;

	for (i = 1; i <= t; ++i)
		if (tip[i] <= 2)
			baga(1, 1, n, a[i], b[i]);

	for (i = 1; i < Amax; ++i)
		if (sz(sir[i]))
		{
			sort(sir[i].begin(), sir[i].end());
			sir[i].erase(unique(sir[i].begin(), sir[i].end()), sir[i].end());
			
			aib[i][0].resize(sz(sir[i]) + 1);
			aib[i][1].resize(sz(sir[i]) + 1);
		}

	for (i = 1; i <= t; ++i)
	{
		if (tip[i] == 1)
			update1(1, 1, n, a[i], b[i], c[i], d[i]);
		if (tip[i] == 2)
			update2(1, 1, n, a[i], b[i]);
		if (tip[i] == 3)
		{
			ct = 0;
			query(1, 1, n, a[i], b[i]);
			
			for (step = 1; step < m; step <<= 1);
			for (sol = 0; step; step >>= 1)
				if (sol + step <= m)
				{
					nr = 0;
					for (j = 1; j <= ct; ++j)
						nr += aib_query(list[j], c[i], cauta(list[j], sol + step));
					if (nr < d[i]) sol += step;
				}
			
			printf("%d\n", sol + 1);
		}
	}
}

int main()
{
	freopen("kinder.in", "r", stdin);
	freopen("kinder.out", "w", stdout);

	citire();
	solve();

	return 0;
}
