#include <cstdio>
#include <vector>

using namespace std;

#define Nmax 100015
#define INF 0x3f3f3f3f
#define MAX(a, b) ((a) >= (b) ? (a) : (b))
#define pb push_back
#define sz(a) (int)((a).size())

int n;
vector<int> lv[Nmax];
int D[Nmax][4];
int bst[Nmax], bdr[Nmax];
int t[Nmax];
int c[Nmax];

void citire()
{
	int i, a, b;

	for (i = 1; i <= n; ++i)
		vector<int>().swap(lv[i]);

	for (i = 1; i <= n; ++i)
		scanf("%d", &c[i]);
	
	for (i = 1; i < n; ++i)
	{
		scanf("%d %d\n", &a, &b);
		lv[a].pb(b);
		lv[b].pb(a);
	}
}

void DF(int nod)
{
	int i, m = sz(lv[nod]);

	bst[0] = bdr[m + 1] = -INF;
	
	for (i = 0; i < m; ++i)
		if (lv[nod][i] != t[nod])
		{
			t[lv[nod][i]] = nod;
			DF(lv[nod][i]);
		}
	
    D[nod][0] = D[nod][1] = c[nod];
	
	// tip 0
	for (i = 1; i <= m; ++i)
 		if (t[nod] != lv[nod][i - 1])
 		   	D[nod][0] = MAX(D[nod][0], D[lv[nod][i - 1]][0] + c[nod]);

	// tip 1

	D[nod][1] = MAX(D[nod][1], D[nod][0]);
	for (i = 1; i <= m; ++i)
		if (t[nod] != lv[nod][i - 1])
			D[nod][1] = MAX(D[nod][1], D[lv[nod][i - 1]][1]);
	for (i = 1; i <= m; ++i)
 		if (t[nod] != lv[nod][i - 1])
 		   	bst[i] = MAX(bst[i - 1], D[lv[nod][i - 1]][0]);
		else
			bst[i] = bst[i - 1];
	for (i = m; i >= 1; --i)
 		if (t[nod] != lv[nod][i - 1])
 		   	bdr[i] = MAX(bdr[i + 1], D[lv[nod][i - 1]][0]);
		else
			bdr[i] = bdr[i + 1];
	for (i = 1; i < m; ++i)
		D[nod][1] = MAX(D[nod][1], bst[i] + bdr[i + 1] + c[nod]);

	// tip 2
    for (i = 1; i <= m; ++i)
 		if (t[nod] != lv[nod][i - 1])
	    	D[nod][2] = MAX(D[nod][2], D[lv[nod][i - 1]][2] + c[nod]);

	for (i = 1; i <= m; ++i)
		if (t[nod] != lv[nod][i - 1])
			D[nod][2] = MAX(D[nod][2], D[lv[nod][i - 1]][1] + c[nod]);
	
	for (i = 1; i <= m; ++i)
 		if (t[nod] != lv[nod][i - 1])
 		   	bst[i] = MAX(bst[i - 1], D[lv[nod][i - 1]][0]);
		else
			bst[i] = bst[i - 1];
	for (i = m; i >= 1; --i)
 		if (t[nod] != lv[nod][i - 1])
    		bdr[i] = MAX(bdr[i + 1], D[lv[nod][i - 1]][1]);
		else
			bdr[i] = bdr[i + 1];
	for (i = 1; i < m; ++i)
    	D[nod][2] = MAX(D[nod][2], bst[i] + bdr[i + 1] + c[nod]);

 	for (i = 1; i <= m; ++i)
 		if (t[nod] != lv[nod][i - 1])
			bst[i] = MAX(bst[i - 1], D[lv[nod][i - 1]][1]);
		else
			bst[i] = bst[i - 1];
	for (i = m; i >= 1; --i)
 		if (t[nod] != lv[nod][i - 1])
			bdr[i] = MAX(bdr[i + 1], D[lv[nod][i - 1]][0]);
		else
			bdr[i] = bdr[i + 1];
	for (i = 1; i < m; ++i)
		D[nod][2] = MAX(D[nod][2], bst[i] + bdr[i + 1] + c[nod]);
 
	// tip 3

	D[nod][3] = MAX(D[nod][3], D[nod][2]);
	for (i = 1; i <= m; ++i)
 		if (t[nod] != lv[nod][i - 1])
			D[nod][3] = MAX(D[nod][3], D[lv[nod][i - 1]][3]);
	
	for (i = 1; i <= m; ++i)
 		if (t[nod] != lv[nod][i - 1])
			bst[i] = MAX(bst[i - 1], D[lv[nod][i - 1]][1]);
		else
			bst[i] = bst[i - 1];
	for (i = m; i >= 1; --i)
 		if (t[nod] != lv[nod][i - 1])
			bdr[i] = MAX(bdr[i + 1], D[lv[nod][i - 1]][1]);
		else
			bdr[i] = bdr[i + 1];
	for (i = 1; i < m; ++i)
		D[nod][3] = MAX(D[nod][3], bst[i] + bdr[i + 1]);
 
	for (i = 1; i <= m; ++i)
 		if (t[nod] != lv[nod][i - 1])
			bst[i] = MAX(bst[i - 1], D[lv[nod][i - 1]][0]);
		else
			bst[i] = bst[i - 1];
	for (i = m; i >= 1; --i)
 		if (t[nod] != lv[nod][i - 1])
			bdr[i] = MAX(bdr[i + 1], D[lv[nod][i - 1]][2]);
		else
			bdr[i] = bdr[i + 1];	
	for (i = 1; i < m; ++i)
		D[nod][3] = MAX(D[nod][3], bst[i] + bdr[i + 1] + c[nod]);
 
	for (i = 1; i <= m; ++i)
 		if (t[nod] != lv[nod][i - 1])
			bst[i] = MAX(bst[i - 1], D[lv[nod][i - 1]][2]);
		else
			bst[i] = bst[i - 1];
	for (i = m; i >= 1; --i)
 		if (t[nod] != lv[nod][i - 1])
			bdr[i] = MAX(bdr[i + 1], D[lv[nod][i - 1]][0]);
		else
			bdr[i] = bdr[i + 1];	
	for (i = 1; i < m; ++i)
		D[nod][3] = MAX(D[nod][3], bst[i] + bdr[i + 1] + c[nod]);

 	for (i = 1; i <= m; ++i)
 		if (t[nod] != lv[nod][i - 1])
			bst[i] = MAX(bst[i - 1], D[lv[nod][i - 1]][1]);
		else
			bst[i] = bst[i - 1];
	for (i = m; i >= 1; --i)
 		if (t[nod] != lv[nod][i - 1])
			bdr[i] = MAX(bdr[i + 1], D[lv[nod][i - 1]][0]);
		else
			bdr[i] = bdr[i + 1];
	for (i = 1; i <= m; ++i)
		if (t[nod] != lv[nod][i - 1])
			bdr[i] = bdr[i + 1] + D[lv[nod][i - 1]][0];
	for (i = m; i >= 1; --i)
		bdr[i] = MAX(bdr[i], bdr[i + 1]);

	for (i = 1; i < m; ++i)
		D[nod][3] = MAX(D[nod][3], bst[i] + bdr[i + 1] + c[nod]);
 
	for (i = 1; i <= m; ++i)
 		if (t[nod] != lv[nod][i - 1])
			bst[i] = MAX(bst[i - 1], D[lv[nod][i - 1]][0]);
		else
			bst[i] = bst[i - 1];
	for (i = m; i >= 1; --i)
 		if (t[nod] != lv[nod][i - 1])
			bdr[i] = MAX(bdr[i + 1], D[lv[nod][i - 1]][1]);
		else
			bdr[i] = bdr[i + 1];
	for (i = 1; i <= m; ++i)
		if (t[nod] != lv[nod][i - 1])
			bdr[i] = bdr[i + 1] + D[lv[nod][i - 1]][0];
	for (i = m; i >= 1; --i)
		bdr[i] = MAX(bdr[i], bdr[i + 1]);

	for (i = 1; i < m; ++i)
		D[nod][3] = MAX(D[nod][3], bst[i] + bdr[i + 1] + c[nod]);
 
 	for (i = 1; i <= m; ++i)
 		if (t[nod] != lv[nod][i - 1])
			bst[i] = MAX(bst[i - 1], D[lv[nod][i - 1]][0]);
		else
			bst[i] = bst[i - 1];
	for (i = m; i >= 1; --i)
 		if (t[nod] != lv[nod][i - 1])
			bdr[i] = MAX(bdr[i + 1], D[lv[nod][i - 1]][0]);
		else
			bdr[i] = bdr[i + 1];
	for (i = 1; i <= m; ++i)
		if (t[nod] != lv[nod][i - 1])
			bdr[i] = bdr[i + 1] + D[lv[nod][i - 1]][1];
	for (i = m; i >= 1; --i)
		bdr[i] = MAX(bdr[i], bdr[i + 1]);

	for (i = 1; i < m; ++i)
		D[nod][3] = MAX(D[nod][3], bst[i] + bdr[i + 1] + c[nod]);

	//printf("%d - %d %d %d %d\n", nod, D[nod][0], D[nod][1], D[nod][2], D[nod][3]);

	for (i = 0; i <= m; ++i)
		bst[i] = bdr[i] = 0;
}

void solve()
{
	memset(D, 0, sizeof(D));
	memset(t, 0, sizeof(t));
	DF(1);
	printf("%d\n", D[1][3]);
}

int main()
{
	freopen("turism.in", "r", stdin);
	freopen("turism.out", "w", stdout);

	while (scanf("%d\n", &n) == 1)
	{
		citire();
		solve();
	}

	return 0;
}
