#include <stdio.h>
#include <vector>

using namespace std;

#define nm 100100

int n, T = 12, v[nm], used[nm], c[nm][4];
vector<int> mat[nm];

inline int maxim(int a, int b)
{
	if (a > b)
		return a;
	return b;
}

void go(int nod)
{
	int max1[3], max2[2], max3[2], pos1[3], pos2[2], pos3[2];
	
	used[nod] = 1;

	for (int i = 0; i < 3; ++i)
		max1[i] = max2[i] = pos1[i] = pos2[i] = 0;
		
	for (int i = 0; i < 4; ++i)
		c[nod][i] = v[nod];

	for (int i = mat[nod].size() - 1; i >= 0; --i) 
		if (!used[mat[nod][i]]) {
			int f = mat[nod][i];
		
			go(f);

			if (c[f][0] > max1[0]) {
				max3[0] = max2[0], pos3[0] = pos2[0];
				max2[0] = max1[0], pos2[0] = pos1[0];
				max1[0] = c[f][0], pos1[0] = f;
			} else if (c[f][0] > max2[0]) {
				max3[0] = max2[0], pos3[0] = pos2[0];
				max2[0] = c[f][0], pos2[0] = f;
			} else if (c[f][0] > max3[0])
				max3[0] = c[f][0], pos3[0] = f;

			if (c[f][1] > max1[1]) {
				max3[1] = max2[1], pos3[1] = pos2[1];
				max2[1] = max1[1], pos2[1] = pos1[1];
				max1[1] = c[f][1], pos1[1] = f;
			} else if (c[f][1] > max2[1]) {
				max3[1] = max2[1], pos3[1] = pos2[1];
				max2[1] = c[f][1], pos2[1] = f;
			} else if (c[f][1] > max3[1])
				max3[1] = c[f][1], pos3[1] = f;

			if (c[f][2] > max1[2])
				max1[2] = c[f][2], pos1[2] = f;

			c[nod][0] = maxim(c[nod][0], c[f][0] + v[nod]);
			c[nod][1] = maxim(c[nod][1], c[f][1]);
			c[nod][2] = maxim(c[nod][2], c[f][2] + v[nod]);
			c[nod][3] = maxim(c[nod][3], c[f][3]);
		}

	c[nod][1] = maxim(c[nod][1], max1[0] + max2[0] + v[nod]);
	c[nod][1] = maxim(c[nod][1], c[nod][0]);

	if (pos1[0] == pos1[1]) {
		c[nod][2] = maxim(c[nod][2], max2[0] + max1[1] + v[nod]);
		c[nod][2] = maxim(c[nod][2], max1[0] + max2[1] + v[nod]);
	} else
		c[nod][2] = maxim(c[nod][2], max1[0] + max1[1] + v[nod]);
	c[nod][2] = maxim(c[nod][2], c[nod][0]);

	c[nod][3] = maxim(c[nod][3], max1[1] + max2[1]);
	
	if (pos1[0] == pos1[2]) {
		c[nod][3] = maxim(c[nod][3], max2[0] + max1[2] + v[nod]);
		c[nod][3] = maxim(c[nod][3], max1[0] + max2[2] + v[nod]);
	} else
		c[nod][3] = maxim(c[nod][3], max1[0] + max1[2] + v[nod]);
	
	if (pos1[1] == pos1[0]) {
		c[nod][3] = maxim(c[nod][3], max1[1] + max2[0] + max3[0] + v[nod]);
	} else if (pos1[1] == pos2[0]) {
		c[nod][3] = maxim(c[nod][3], max1[1] + max1[0] + max3[0] + v[nod]);
	} else {
		c[nod][3] = maxim(c[nod][3], max1[1] + max1[0] + max3[0] + v[nod]);
	}

	if (pos2[1] == pos1[0]) {
		c[nod][3] = maxim(c[nod][3], max2[1] + max2[0] + max3[0] + v[nod]);
	} else if (pos2[1] == pos2[0]) {
		c[nod][3] = maxim(c[nod][3], max2[1] + max1[0] + max3[0] + v[nod]);
	} else {
		c[nod][3] = maxim(c[nod][3], max2[1] + max1[0] + max3[0] + v[nod]);
	}
	
	if (pos3[1] == pos1[0]) {
		c[nod][3] = maxim(c[nod][3], max3[1] + max2[0] + max3[0] + v[nod]);
	} else if (pos3[1] == pos2[0]) {
		c[nod][3] = maxim(c[nod][3], max3[1] + max1[0] + max3[0] + v[nod]);
	} else {
		c[nod][3] = maxim(c[nod][3], max3[1] + max1[0] + max3[0] + v[nod]);
	}
	
	c[nod][3] = maxim(c[nod][3], c[nod][2]);
}

int main()
{
	freopen("turism.in", "r", stdin);
	freopen("turism.out", "w", stdout);

	for (int t = 1; t <= T; ++t) {
		scanf("%d", &n);

		for (int i = 1; i <= n; ++i) {
			scanf("%d", &v[i]);
			used[i] = 0;
			mat[i].clear();
		}

		for (int i = 1; i < n; ++i) {
			int x, y;
			
			scanf("%d%d", &x, &y);

			mat[x].push_back(y);
			mat[y].push_back(x);
		}

		go(1);

		printf("%d\n", c[1][3]);
/*
		for (int i = 0; i < 4; ++i) {
			for (int j = 1; j <= n; ++j)
				printf("%d ", c[j][i]);
			printf("\n");
		}
		printf("\n");
*/
	}

	return 0;
}
