#include <stdio.h>
#include <string.h>
#include <vector>

#define inf 0x3f3f3f3f
#define nmax 100005
#define pb push_back
#define maxt 12 // nu uita sa bagi 12 !!!
#define bmax 24

using namespace std;

int n, n1, n2, sol, p1;
int c[nmax], v[nmax], tata[nmax], b[nmax], t[nmax];
int max1[nmax], max2[nmax], max3[nmax], aux1[nmax], aux2[nmax], aux3[nmax];
int max11[nmax], max12[nmax], aux11[nmax], aux12[nmax];
int b2[nmax];
int v1[nmax];
char s[bmax];
vector <int> e[nmax];

void dfs(int x)
{
	v[x] = 1;
	max1[x] = b2[x] = max2[x] = max3[x] = 0;
	max11[x] = max12[x] = 0;
	for(int i = 0; i < (int)e[x].size(); i++)
		if(!v[e[x][i]]) 
		{
			tata[e[x][i]] = x;
			dfs(e[x][i]);
			b2[x] = max(b2[x], b2[e[x][i]]);
			if(max1[e[x][i]] + c[x] >= max1[x])
			{
				max3[x] = max2[x], aux3[x] = aux2[x];
				max2[x] = max1[x], aux2[x] = aux1[x];
				max1[x] = max1[e[x][i]] + c[x], aux1[x] = e[x][i];
			}
			else if(max1[e[x][i]] + c[x] >= max2[x])
			{
				max3[x] = max2[x], aux3[x] = aux2[x];
				max2[x] = max1[e[x][i]] + c[x], aux2[x] = e[x][i];
			}
			else if(max1[e[x][i]] + c[x] >= max3[x])
				max3[x] = max1[e[x][i]] + c[x], aux3[x] = e[x][i];

			if(b2[e[x][i]] >= max11[x])
			{
				max12[x] = max11[x], aux12[x] = aux11[x];
				max11[x] = b2[e[x][i]], aux11[x] = e[x][i];
			}
			else if(b2[e[x][i]] >= max12[x])
				max12[x] = b2[e[x][i]], aux12[x] = e[x][i];
		}

	if(max1[x] == 0) max1[x] = c[x], aux1[x] = x;

	v1[x] = 0;
	if(max2[x] != 0) v1[x] = max1[x] + max2[x] - c[x];
	else if(max2[x] == 0) v1[x] = max1[x];
	else if(max1[x] == 0) v1[x] = c[x];
	b2[x] = max(b2[x], v1[x]);
}

void dfs1(int x)
{
	v[x] = 1;
	b[x] = c[x] + b[tata[x]];
	t[x] = c[tata[x]];
	
	if(aux1[tata[x]] != x) b[x] = max(b[x], max1[tata[x]] + c[x]);
	else b[x] = max(b[x], max2[tata[x]] + c[x]);

	t[x] = max(t[x], b[tata[x]]);
	t[x] = max(t[x], t[tata[x]]);
	if(aux1[tata[x]] != x) t[x] = max(t[x], b[tata[x]] + max1[tata[x]] - c[tata[x]]);
	else t[x] = max(t[x], b[tata[x]] + max2[tata[x]] - c[tata[x]]);

	if(aux11[tata[x]] != x) t[x] = max(t[x], max11[tata[x]]);
	else t[x] = max(t[x], max12[tata[x]]);

	if(aux1[tata[x]] != x && aux2[tata[x]] != x) t[x] = max(t[x], max1[tata[x]] + max2[tata[x]] - c[tata[x]]);
	else if(aux1[tata[x]] != x && aux3[tata[x]] != x) t[x] = max(t[x], max1[tata[x]] + max3[tata[x]] - c[tata[x]]);
	else if(aux2[tata[x]] != x && aux3[tata[x]] != x) t[x] = max(t[x], max2[tata[x]] + max3[tata[x]] - c[tata[x]]);

	for(int i = 0; i < (int)e[x].size(); i++)
		if(!v[e[x][i]]) dfs1(e[x][i]);
}

int main()
{
	freopen("turism.in", "r", stdin);
	freopen("turism.out", "w", stdout);

	for(int T = 1; T <= maxt; T++)
	{
		scanf("%d\n", &n);
		for(int i = 1; i <= n; i++)
		{
			scanf("%d", &c[i]);
			e[i].clear();
		} scanf("\n");
		for(int i = 1; i < n; i++)
		{
			fgets(s, bmax, stdin);
			n1 = n2 = 0;
			p1 = 0; while(s[p1] >= '0' && s[p1] <= '9') n1 = n1 * 10 + s[p1] - '0', p1++;
			p1++; while(s[p1] >= '0' && s[p1] <= '9') n2 = n2 * 10 + s[p1] - '0', p1++;
			e[n1].pb(n2);
			e[n2].pb(n1);
	}
		memset(v, 0, sizeof(v));
		dfs(1);

		memset(v, 0, sizeof(v));
		dfs1(1);

		sol = 0;
		for(int i = 1; i <= n; i++) sol = max(sol, v1[i] + t[i]);
		printf("%d\n", sol);
	}

	return 0;
}
