#include <cstdio>
#include <vector>
#include <algorithm>

#define pii pair< int, int >
#define mp make_pair
#define fi first
#define se second
#define pb push_back

#define TR(C,it) \
	for( typeof(C.begin()) it = C.begin(); it != C.end(); it++ )

#define NX 100010

using namespace std;

vector< int > G[ NX ];
pii tma[ NX ], tmb[ NX ], tmc[ NX ];
int T, N;
int col[ NX ], pi[ NX ], a[NX], b[NX], c[NX], d[NX], val[NX], deg[NX];

struct cmp {
	bool operator() ( const pii &a, const pii &b ) const {
		return a.fi > b.fi;
	}
};

inline void umax( int &x, int y ) {
	if( x < y ) x = y;
}

void solve( int u ) {
	int k, j;
	vector< int > :: iterator vv;

	col[u] = 1;
	
	a[u] = b[u] = val[u];
	c[u] = d[u] = 0;

	if( deg[u] == 1 && pi[u] != 0 )
		return;

	TR( G[u], v )
		if( col[ *v ] == 0 ) {
			pi[ *v ] = u;
			solve( *v );
		}

	k = 0; tma[0] = tmb[0] = mp( 0, 0 );

	TR( G[u], v ) if( *v != pi[u] ) {
		k++;
		tma[ k ] = mp( a[ *v ], *v );
		tmb[ k ] = mp( b[ *v ], *v );
		tmc[ k ] = mp( c[ *v ], *v );
	}

	k++;
	sort( tma, tma+k, cmp() );
	sort( tmb, tmb+k, cmp() );
	sort( tmc, tmc+k, cmp() );

	umax( a[u], val[u] + tma[0].fi );

	umax( b[u], tmb[0].fi );
	umax( b[u], val[u] + tma[0].fi + tma[1].fi );

	umax( c[u], val[u] + tmc[0].fi );
	
	TR( G[u], v ) if( *v != pi[u] ) {
		for( j = 0; j < k; j++ )
			if( tmb[j].se != *v ) break;
		umax( c[u], val[u] + a[*v] + tmb[j].fi );
	}

	TR( G[u], v ) if( *v != pi[u] ) {
		umax( d[u], d[ *v ] );
		
		for( j = 0; j < k; j++ ) // cel mult 1 incrementare
			if( tma[j].se != *v ) break;
			
		umax( d[u], val[u] + c[*v] + tma[j].fi );

		for( vv = v + 1; vv != G[u].end(); vv++ ) if( *vv != pi[u] ) {
			for( j = 0; j < k; j++ ) // cel mult 2 incrementari
				if( *v != tmb[j].se && *vv != tmb[j].se )
					break;
			umax( d[u], a[*v] + val[u] + a[*vv] + tmb[j].fi );
		}
	}
	umax( d[u], val[u] + tmb[0].fi );
	umax( d[u], tmb[0].fi + tmb[1].fi );
}

void clean() {
	int i;

	for( i = 1; i <= N; i++ )
		val[i] = col[i] = deg[i] = a[i] = b[i] = c[i] = d[i] = tma[i].fi = tma[i].se = tmb[i].fi = tmb[i].se = tmc[i].fi = tmc[i].se = 0;
		
	for( i = 1; i <= N; i++ )
		G[i].clear();
}

void cit() {
	int i, u, v;
	
	T = 12;

	while( T-- ) {
		clean();

		scanf( "%d", &N );
		for( i = 1; i <= N; i++ )
			scanf( "%d", &val[i] );


		for( i = 1; i < N; i++ ) {
			scanf( "%d%d", &u, &v );
			G[u].pb(v), G[v].pb(u);
			deg[u]++, deg[v]++;
		}

		solve( 1 );
		printf( "%d\n", d[1] );
	}
}

int main() {
	freopen( "turism.in", "r", stdin );
	freopen( "turism.out", "w", stdout );

	cit();

	return 0;
}

