#include <stdio.h>
#include <string.h>

#define MAXN 2048
#define MAXT 2048

int N;
int T1[MAXN], T2[MAXN], V[MAXN], D[MAXN];

int bst[2][MAXT];

inline int MAX( int a, int b )
{
	return (a > b) ? a : b;
}

int main()
{
	freopen("senzori.in", "rt", stdin);
	freopen("senzori.out", "wt", stdout);
	scanf("%d", &N);
	for (int i = 0; i < N; i++)
	{
		scanf("%d %d %d %d", T1 + i, T2 + i, D + i, V + i);
		T1[i]++;		//in dinamica daca T == 0 atunci nu iau segmentul
		D[i]--;
		//T2[i]++; T2[i]--;
	}

	memset( bst, -1, sizeof(bst) );
	bst[0][0] = 0;
	for (int i = T1[0]; i + D[0] <= T2[0]; i++)
		bst[0][i] = V[0];

	int step = 1;
	for (int i = 1; i < N; i++, step ^= 1)
	{
		memset( bst[step], -1, sizeof(bst[step]) );
		
		int Max = bst[1 ^ step][0];
		for (int j = T1[i - 1]; j + D[i - 1] <= T2[i - 1]; j++)
			if (bst[1 ^ step][j] > Max)
				Max = bst[1 ^ step][j];
		bst[step][0] = Max;

		int MaxL = -1;
		for (int j = T1[i - 1]; j + D[i - 1] < T1[i] && j + D[i - 1] <= T2[i - 1]; j++)
			if (bst[1 ^ step][j] > MaxL)
				MaxL = bst[1 ^ step][j];
		for (int j = T1[i]; j + D[i] <= T2[i]; j++)
		{
			int k = j - D[i - 1] - 1;
			if (k >= T1[i - 1] && k + D[i - 1] <= T2[i - 1] && bst[1 ^ step][k] > MaxL)
				MaxL = bst[1 ^ step][k];

			if (MaxL != -1)
				bst[step][j] = V[i] + MaxL;
			if (V[i] + bst[1 ^ step][0] > bst[step][j])
				bst[step][j] = V[i] + bst[1 ^ step][0];
		}
	
		int MaxR = -1;
		for (int j = T2[i - 1] - D[i - 1]; j >= T2[i] + 1 && j >= T1[i - 1]; j--)
			if (bst[1 ^ step][j] > MaxR)
				MaxR = bst[1 ^ step][j];
		for (int j = T2[i] - D[i]; j >= T1[i]; j--)
		{
			int k = j + D[i] + 1;
			if (k >= T1[i - 1] && k + D[i - 1] <= T2[i - 1] && bst[1 ^ step][k] > MaxR)
				MaxR = bst[1 ^ step][k];
			
			if (MaxR != -1 && V[i] + MaxR > bst[step][j])
				bst[step][j] = V[i] + MaxR;
		}
	}

	int Max = -1;
	for (int i = T1[N - 1]; i + D[N - 1] <= T2[N - 1]; i++)
		if (bst[1 ^ step][i] > Max)
			Max = bst[1 ^ step][i];
	printf("%d\n", Max);

	return 0;
}
