#include <cstdio>
#include <vector>

using namespace std;

#define MAXN 100005

int N;
vector<int> con[MAXN];
int cst[MAXN], p[MAXN];
int bst[MAXN][2];		//bst[i][j] = drumul de cost maxim pentru subarborele i
						//            daca drumul poate continua in sus (j == 0)
						//            sau nu (j == 1)
int bst2[MAXN][2];

inline void dfs( int k )
{
	vector<int> :: iterator it;

	int Max0 = 0, sMax0 = 0;
	int Max1 = 0;
	for (it = con[k].begin(); it != con[k].end(); it++)
	{
		if (*it == p[k])
			continue;

		p[*it] = k;
		dfs( *it );
		if (bst[*it][0] > Max0)
			sMax0 = Max0,
			Max0 = bst[*it][0];
		else
			if (bst[*it][0] > sMax0)
				sMax0 = bst[*it][0];

		if (bst[*it][1] > Max1)
			Max1 = bst[*it][1];
	}

	bst[k][0] = cst[k] + Max0;

	bst[k][1] = Max1;
	if (Max0 + sMax0 + cst[k] > bst[k][1])
		bst[k][1] = Max0 + sMax0 + cst[k];
}

//nu prea intra pe stiva atata :)
int Max10, Max10I, Max11, Max11I;
int Max20, Max20I, Max21;
int sMax10, sMax10I, sMax11;
int sMax20;
int tMax10, tMax10I;
inline void dfsBoth( int k )
{
	vector<int> :: iterator it;
	for (it = con[k].begin(); it != con[k].end(); it++)
	{
		if (*it == p[k])
			continue;

		dfsBoth( *it );
	}

	Max10 = 0; Max10I = -1; Max11 = 0; Max11I = -1;
	Max20 = 0; Max20I = -1; Max21 = 0;
	sMax10 = 0; sMax10I = -1; sMax11 = 0;
	sMax20 = 0;
	tMax10 = 0; tMax10I = -1;
	for (it = con[k].begin(); it != con[k].end(); it++)
	{
		if (*it == p[k])
			continue;
		
		if (bst[*it][0] > Max10)
		{
			tMax10 = sMax10; tMax10I = sMax10I;
			sMax10 = Max10; sMax10I = Max10I;
			Max10 = bst[*it][0]; Max10I = *it;
		}
		else
			if (bst[*it][0] > sMax10)
			{
				tMax10 = sMax10; tMax10I = sMax10I;
				sMax10 = bst[*it][0]; sMax10I = *it;
			}
			else
				if (bst[*it][0] > tMax10)
				{
					tMax10 = bst[*it][0]; tMax10I = *it;
				}
		
		if (bst[*it][1] > Max11)
			sMax11 = Max11,
			Max11 = bst[*it][1],
			Max11I = *it;
		else
			if (bst[*it][1] > sMax11)
				sMax11 = bst[*it][1];

		if (bst2[*it][0] > Max20)
			sMax20 = Max20,
			Max20 = bst2[*it][0],
			Max20I = *it;
		else
			if (bst2[*it][0] > sMax20)
				sMax20 = bst2[*it][0];
		
		if (bst2[*it][0] > Max21)
			Max21 = bst2[*it][1];
	}

	//iau din un subarbore ambele drumuri
	bst2[k][0] = Max20 + cst[k];
	//iau drumurile din subarbori diferiti
	if (Max10I == Max11I)
	{
		if (Max10 + sMax11 + cst[k] > bst2[k][0])
			bst2[k][0] = Max10 + sMax11 + cst[k];
		if (sMax10 + Max11 + cst[k] > bst2[k][0])
			bst2[k][0] = sMax10 + Max11 + cst[k];
	}
	else
		if (Max10 + Max11 + cst[k] > bst2[k][0])
			bst2[k][0] = Max10 + Max11 + cst[k];

	//nu includ si nodul k
	bst2[k][1] = Max21;
	if (Max11 + sMax11 > bst2[k][1])
		bst2[k][1] = Max11 + sMax11;
	//includ nodul k -> shit
	//Max10 + sMax10
	int MAX = 0;
	for (it = con[k].begin(); it != con[k].end(); it++)
		if (*it != p[k] && *it != Max10I && *it != sMax10I && bst[*it][1] > MAX)
			MAX = bst[*it][1];
	if (Max10 + sMax10 + MAX + cst[k] > bst2[k][1])
		bst2[k][1] = Max10 + sMax10 + MAX + cst[k];
	//Max10 + tMax10
	MAX = 0;
	for (it = con[k].begin(); it != con[k].end(); it++)
		if (*it != p[k] && *it != Max10I && *it != tMax10I && bst[*it][1] > MAX)
			MAX = bst[*it][1];
	if (Max10 + tMax10 + MAX + cst[k] > bst2[k][1])
		bst2[k][1] = Max10 + tMax10 + MAX + cst[k];
	//sMax10 + tMax10
	MAX = 0;
	for (it = con[k].begin(); it != con[k].end(); it++)
		if (*it != p[k] && *it != sMax10I && *it != tMax10I && bst[*it][1] > MAX)
			MAX = bst[*it][1];
	if (sMax10 + tMax10 + MAX + cst[k] > bst2[k][1])
		bst2[k][1] = sMax10 + tMax10 + MAX + cst[k];

	//Max20 + Max10
	if (Max10I == Max20I)
	{
		if (sMax10 + Max20 + cst[k] > bst2[k][1])
			bst2[k][1] = sMax10 + Max20 + cst[k];
		if (Max10 + sMax20 + cst[k] > bst2[k][1])
			bst2[k][1] = Max10 + sMax20 + cst[k];
	}
	else
		if (Max20 + Max10 + cst[k] > bst2[k][1])
			bst2[k][1] = Max20 + Max10 + cst[k];
}

int main()
{
	freopen("turism.in", "rt", stdin);
	freopen("turism.out", "wt", stdout);

	for (; scanf("%d", &N) == 1; )
	{
		for (int i = 1; i <= N; i++)
		{
			con[i].clear();
			scanf("%d", cst + i);
		}

		for (int i = 1; i < N; i++)
		{
			int x, y;
			scanf("%d %d", &x, &y);
			con[x].push_back(y);
			con[y].push_back(x);
		}

		p[1] = 0;
		dfs(1);
		dfsBoth(1);
		printf("%d\n", bst2[1][1]);
	}
	
	return 0;
}
