#include <cstdio>
#include <cstdlib>
#include <cstring>

#define next(p) (p & (-p))

#define N 50176


int n, m, *c0[N], *c1[N], *aib0[N], *aib1[N];


void update(int *aib, int tip, int nr) {
for (; tip<=m; tip+=next(tip))
   aib[tip]+=nr; }


int query(int *aib, int tip) {
int nr=0;
for (; tip; tip-=next(tip))
   nr+=aib[tip];
return nr; }


int numara(int a, int b, int c, int tip) {
int r=0;

if (c==0)
   for (int i=a; i<=b; i++)
      if (aib0[i])
         r+=query(aib0[i], tip);
else
   for (int i=a; i<=b; i++)
      if (aib1[i])
         r+=query(aib1[i], tip);

return r;}


int raspuns(int a, int b, int c, int x) {
int i, step;
for (step=1; step<m; step<<=1);

for (i=m; step; step>>=1)
   if (i-step>=0)
      if (numara(a, b, c, i-step) >= x)
         i-=step;

return i; }


int main() {
freopen("kinder.in", "rt", stdin);
//freopen("kinder.out", "wt", stdout);

int t;
scanf("%d%d%d", &n, &m, &t);

for (int o, a, b, c, d, i=0; i<t; i++) {
   scanf("%d", &o);
   if (o == 1) {
      scanf("%d%d%d%d", &a, &b, &c, &d);
      if (!c0[a]) {
         c0[a] = (int *)malloc((n+1)*sizeof(int));
         c1[a] = (int *)malloc((n+1)*sizeof(int));
         memset(c0[a], 0, (n+1)*sizeof(int));
         memset(c1[a], 0, (n+1)*sizeof(int));

         aib0[a] = (int *)malloc((m+1)*sizeof(int));
         aib1[a] = (int *)malloc((m+1)*sizeof(int));
         memset(aib0[a], 0, (m+1)*sizeof(int));
         memset(aib1[a], 0, (m+1)*sizeof(int)); }

      if (c==0) {
         c0[a][b]+=d;
         update(aib0[a], b, d); }
      else {
         c1[a][b]+=d;
         update(aib1[a], b, d); } }
   else
      if (o == 2) {
         scanf("%d%d", &a, &b);
         c = c0[a][b];
         d = c1[a][b];

         update(aib0[a], b, d-c);
         update(aib1[a], b, c-d);

         c0[a][b] = d;
         c1[a][b] = c; }
      else {
         scanf("%d%d%d%d", &a, &b, &c, &d);
         printf("%d\n", raspuns(a, b, c, d)); } }

return 0; }


