#include <cstdio>
#include <map>
#include <functional>

using namespace std;

struct X {
	unsigned int copil,nr;
	bool culoare;
	X (unsigned int _copil, unsigned int _nr, bool _culoare)
		: copil(_copil), nr(_nr), culoare(_culoare) { }
};

int main (void)
{
	freopen("kinder.in", "r", stdin);
	freopen("kinder.out", "w+", stdout);

	unsigned int nrNepotei, nrTipuriOua, nrOperatii;
	scanf("%u %u %u\n", &nrNepotei, &nrTipuriOua, &nrOperatii);

	typedef	multimap<unsigned int, X> M;
	M info;
	
	for (unsigned int i=0; i<nrOperatii; ++i) {
		unsigned int tipOp;
		scanf("%u ", &tipOp);
		unsigned int copil, tipOu, culoare, nrOua,
					start, end, ordin;
		bool gonext;
		pair<M::iterator, M::iterator> iterpair;
		switch (tipOp) {
			case 1:
				scanf("%u %u %u %u\n", &copil, &tipOu, &culoare, &nrOua);
				/* */
				info.insert(
						make_pair( tipOu, X(copil,nrOua,culoare?true:false) )
							);
				/* */
				break;
			case 2:
				scanf("%u %u\n", &copil, &tipOu);
				/* */
				iterpair = info.equal_range(tipOu);
				for (M::iterator &iter=iterpair.first;
						iter != iterpair.second;++iter) {
					if (iter->second.copil == copil)
						iter->second.culoare = !iter->second.culoare;
				}
				/* */
				break;
			case 3:
				scanf("%u %u %u %u\n", &start, &end, &culoare, &ordin);
				/* */
				unsigned int parcurs=0;
				gonext = true;
				for (M::const_iterator iter = info.begin();
						iter != info.end() && gonext; ++iter) {
					if (start<=iter->second.copil && iter->second.copil<=end &&
							iter->second.culoare==culoare)
						parcurs += iter->second.nr;
					if (parcurs >= ordin) {
						printf("%u\n", iter->first);
						gonext = false;
					}
				}
				/* */
				break;
		}
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
