#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

#define PII pair< pair<int, int>, int >
#define x first.first
#define y first.second
#define z second
#define mp make_pair

int N, M, T;
vector< PII > G[65536];

int check(int a, int b, int color, int X)
{
	int i, num = 0, sz, j;

	for (i = a; i <= b; ++i)
		for (sz = G[i].size(), j = 0; j < sz; ++j)
		{
			if (G[i][j].x > X) break;
			if (G[i][j].y == color)
				num += G[i][j].z;
		}
	return num;
} 

int main(void)
{
	int i, tip, c, t, nr, a, b, p, xx, sz, j;
	int l, r, m, ok, Res = 0;
	
	freopen("kinder.in", "r", stdin);
	freopen("kinder.out", "w", stdout);

	scanf("%d %d %d", &N, &M, &T);
	for (i = 1; i <= T; ++i)
	{
		scanf("%d", &tip);
		if (tip == 1)
		{
			scanf("%d %d %d %d", &c, &t, &p, &nr);
			G[c].push_back( mp( mp(t, p), nr) );
			sort(G[c].begin(), G[c].end());
		}
		else if (tip == 2)
		{
			scanf("%d %d", &c, &t);
			for (sz = G[c].size(), j = 0; j < sz; ++j)
				if (G[c][j].x == t)
					G[c][j].y = 1 - G[c][j].y;
		}
		else
		{
			scanf("%d %d %d %d", &a, &b, &p, &xx);
			for (l = 1, r = M; l <= r; )
			{
				m = (l + r) / 2;
				ok = check(a, b, p, m);
				if (ok >= xx) Res = m, r = m-1;
				else l = m+1;
			}
			printf("%d\n", Res);
		}
			
	}	

	return 0;
}

