#include <stdio.h>

#define maxim(a, b) ((a > b) ? a : b)

#define INF 999999999

int N;
int T1[2048], T2[2048], d[2048], v[2048], TMAX;
int A[2][2048], B[2][2048];

int main(void)
{
	int i, j, crt = 1, prev = 0;

	freopen("senzori.in", "r", stdin);
	freopen("senzori.out", "w", stdout);

	scanf("%d", &N);
	for (i = 1; i <= N; ++i)
	{
		scanf("%d %d %d %d", &T1[i], &T2[i], &d[i], &v[i]);
		TMAX = maxim(TMAX, T2[i]);
		T1[i]++; d[i]--;
	}

	for (i = 0; i <= TMAX; ++i)
		A[prev][i] = B[prev][i] = -INF;

	for (i = 1; i <= N; ++i)
	{
		crt ^= 1; prev ^= 1;
		for (j = 0; j < TMAX+2; ++j)
			A[crt][j] = B[crt][j] = -INF;
		
		// construim A
		for (j = TMAX-1; j >= 0; --j)
		{
			if (T1[i] <= j+1 && j+1+d[i] <= T2[i] && A[crt][j] < v[i])
				A[crt][j] = v[i];
			if (A[crt][j] < A[prev][j])
				A[crt][j] = A[prev][j];
			if (A[crt][j] < A[crt][j+1])
				A[crt][j] = A[crt][j+1];
			if (T1[i] <= j+1 && j+1+d[i] <= T2[i] && A[crt][j] < B[prev][j+1] + v[i])
				A[crt][j] = B[prev][j+1] + v[i];
			if (T1[i] <= j+1 && j+1+d[i] <= T2[i] && A[crt][j] < A[prev][j+1+d[i]] + v[i])
				A[crt][j] = A[prev][j+1+d[i]] + v[i];

			if (A[crt][j] < 0)
				A[crt][j] = -INF;
		}

		// construim B
		for (j = 2; j <= TMAX; ++j)
		{
			if (T1[i] <= j-1-d[i] && j-1 <= T2[i] && B[crt][j] < v[i])
				B[crt][j] = v[i];
			if (B[crt][j] < B[crt][j-1])
				B[crt][j] = B[crt][j-1];
			if (B[crt][j] < B[prev][j])
				B[crt][j] = B[prev][j];
			if (T1[i] <= j-1-d[i] && j-1 <= T2[i] && B[crt][j] < B[prev][j-1-d[i]] + v[i])
				B[crt][j] = B[prev][j-1-d[i]] + v[i];
			if (T1[i] <= j-1-d[i] && j-1 <= T2[i] && B[crt][j] < A[prev][j-1] + v[i])
				B[crt][j] = A[prev][j-1] + v[i];
			
			if (B[crt][j] < 0)
				B[crt][j] = -INF;
		}
	}

	printf("%d\n", maxim(A[crt][0], B[crt][TMAX]));

	return 0;
}

