#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

vector<int> v[1001], G[1001];
int c[1001], t[1001], used[1001], n, lant[1001], sol, pos, cnt, s[1001];

void dfs1(int);
void dfs2(int);
void dfs3(int);
void dfs4(int);
bool cmp(int one, int two)
{
	return t[one] < t[two];
}

int main()
{
	freopen("turism.in", "r", stdin);
	freopen("turism.out", "w", stdout);

	int i, a, b, sz, j;

	while(!feof(stdin))
	{
		sol = 0;
		cnt = 0;
		memset(s, 0, sizeof(s));
		memset(t, 0, sizeof(t));
		scanf("%d ", &n);
		for(i = 1; i <= n; ++i)
		{
			scanf("%d", &c[i]);
		}
		for(i = 1; i < n; ++i)
		{
			scanf("%d %d ", &a, &b);
			v[a].push_back(b);
			v[b].push_back(a);
		}
		memset(used, 0, sizeof(used));
		dfs1(1);
		for(i = 1; i <= n; ++i)
		{
		//	printf("%d %d\n", i, t[i]);
			sort(G[i].begin(), G[i].end(), cmp);
		}
		memset(used, 0, sizeof(used));
		dfs2(1);
	//	printf("%d %d\n", pos, sol);
		dfs3(G[pos][0]);
		lant[++cnt] = pos;
		if(G[pos].size() >= 2)
		{
			dfs4(v[pos][1]);
		}
		/*
		for(i = 1; i <= cnt; ++i)
		{
			printf("%d ", lant[i]);
		}
		*/
		for(i = 1; i <= cnt; ++i)
		{
			s[i] = s[i - 1] + c[lant[i]];
		}
		for(i = 1; i <= cnt; ++i)
		{
			if(i != pos)
			{
				sz = G[i].size();
				if(sz >= 2 && sol < s[cnt] + t[G[i][1]])
				{
					sol = s[cnt] + t[G[i][1]];
				}
				for(j = i + 1; j <= cnt; ++j)
				{
					if(sz >= 2 && G[j].size() >= 2)
					{
						if(sol < s[i] + t[G[i][1]] + s[cnt] - s[j - 1] + t[G[i][1]])
						{
							sol = s[i] + t[G[i][1]] + s[cnt] - s[j - 1] + t[G[i][1]];
						}
					}
				}
			}
		}
		printf("%d\n", sol);
		for(i = 1; i <= n; ++i)
		{
			vector<int> ().swap(v[i]);
			vector<int> ().swap(G[i]);
		}
	}

	return 0;
}

void dfs1(int nod)
{
	used[nod] = 1;

	int i, sz = v[nod].size();

	for(i = 0; i < sz; ++i)
	{
		if(!used[v[nod][i]])
		{
			G[nod].push_back(v[nod][i]);
			dfs1(v[nod][i]);
			if(t[v[nod][i]] > t[nod])
			{
				t[nod] = t[v[nod][i]];
			}
		}
	}
	t[nod] += c[nod];
}

void dfs2(int nod)
{
	used[nod] = 1;
	
	int i, sz = G[nod].size();
	if(sz >= 2)
	{
		if(t[G[nod][0]] + t[G[nod][1]] + c[nod] > sol)
		{
			sol = t[G[nod][0]] + t[G[nod][1]] + c[nod];
			pos = nod;
		}
	}
	else
	{
		if(t[nod] > sol)
		{
			sol = t[nod];
			pos = nod;
		}
	}
	for(i = 0; i < sz; ++i)
	{
		if(!used[G[nod][i]])
		{
			dfs2(G[nod][i]);
		}
	}
}

void dfs3(int nod)
{
	used[nod] = 1;
	int sz = G[nod].size();
	if(sz)
	{
		dfs3(G[nod][0]);
	}
	lant[++cnt] = nod;
}

void dfs4(int nod)
{
	int sz = G[nod].size();
	lant[++cnt] = nod;
	if(sz)
	{
		dfs4(G[nod][0]);
	}
}

