using namespace std;
#include <cstdio>
#include <vector>
#include <string>
#define DIM 8192
#define N 100001
#include <algorithm>
#define pb push_back

int x[N];
int n;
vector<vector<int> >a;
vector<vector<int> >A;
int dp[N];
int d[N];
int t[N];
int t2[N];
char ax[DIM];
int pz;
bool used[N];

struct cmp{
	bool operator()(const int &a, const int &b)const
	{
		if(dp[a]>dp[b])return 1;
		return 0;
	}
};


inline void cit(int &x)
{
	x=0;
	while(ax[pz]<'0' || ax[pz]>'9')
		if(++pz==DIM)fread(ax, 1, DIM, stdin), pz=0;

	while(ax[pz]>='0' && ax[pz]<='9')
	{
		x=x*10+ax[pz]-'0';
		if(++pz==DIM)fread(ax, 1, DIM, stdin), pz=0;
	}
}
bool use[N];

inline void orient(int n)
{
	if(use[n])return;
	use[n]=1;

	vector<int>::iterator it;
	for(it=a[n].begin();it!=a[n].end();++it)
		if(!use[*it])
		{
			A[n].pb(*it);
			t[*it]=n;
			orient(*it);
		}
}
			

inline int memo(int n)
{
	if(dp[n]!=-1)return dp[n];

	dp[n]=0;

	vector<int>::iterator it;

	int mx=0;
	for(it=A[n].begin();it!=A[n].end();++it)
		mx=max(mx, memo(*it));
	mx+=x[n];
	dp[n]=mx;
	return dp[n];
}
int s,nd;


inline void df(int n)
{
	if(A[n].size()>2)
	{
		for(int i=2;i<A[n].size();++i)
			s=max(s, d[nd]+d[A[n][i]]);
		
		return;
	}
	vector<int>::iterator it;
	for(it=A[n].begin();it!=A[n].end();++it)
		df(*it);
}

int cost;
int nd2;
inline void DF(int n, int c)
{
	vector<int>::iterator it;

	if(c+x[n]>cost) cost=c+x[n],nd=n; 
	
	for(it=A[n].begin();it!=A[n].end();++it)
		DF(*it, c+x[n]);
}


inline void DF2(int n, int c)
{
	if(use[n])return ;
	use[n]=1;
	vector<int>::iterator it;

	if(c+x[n]>cost) cost=c+x[n], nd=n;	
	for(it=a[n].begin();it!=a[n].end();++it)
	{
		t2[*it]=n;
		DF2(*it, c+x[n]);
	}
}
	
void solve()
{
	vector<int>::iterator it;
	int i;
	memset(dp,-1, sizeof(dp));
	for(i=1;i<=n;++i)
		if(a[i].size()==1)
			dp[i]=x[i];

	dp[1]=-1;
	memset(d, 0, sizeof(d));
	memset(use, 0, sizeof(use));
	orient(1);
/*
	for(i=1;i<=n;++i)
	{
		for(it=A[i].begin();it!=A[i].end();++it)printf("%d ", *it);
		printf("\n");
	}
printf("\n");	
*/
memo(1);
	//for(i=1;i<=n;++i)printf("%d ", dp[i]);
	//printf("\n");

	for(i=1;i<=n;++i)
		sort(A[i].begin(), A[i].end(), cmp());

	for(i=1;i<=n;++i)
	{
		d[i]=x[i];
		if(A[i].size()>=2)
		{
			d[i]+=dp[A[i][0]];
			d[i]+=dp[A[i][1]];
		}
		if(A[i].size()==1)
			d[i]+=dp[A[i][0]];
	}

//	printf("%d\n", n);
	//for(i=1;i<=n;++i)printf("%d ", d[i]);
	//printf("\n");


	int sol=0;
	int tata,j;
	for(i=2;i<=n;++i)
	{
		s=d[i];
		tata=t[i];
		if(A[tata].size()>=3)
		{
			if(A[tata][0]==i)
			{
				s+=max(x[tata]+dp[A[tata][1]]+dp[A[tata][3]], max(d[A[tata][1]], d[A[tata][3]]));
			}
			else if(A[tata][1]==i)
			{
				s+=max(x[tata]+dp[A[tata][0]]+dp[A[tata][3]],max(d[A[tata][0]], d[A[tata][3]]));
			}
			else
			{	s+=max(dp[A[tata][0]]+x[tata], d[A[tata][0]]);
				
			}
		}

		if(A[tata].size()<=2)
		{
			if(A[tata][0]==i)
				s+=max(x[tata]+dp[A[tata][1]], d[A[tata][1]]) ;
			else
				if(A[tata][1]==i)
					s+=max(x[tata]+dp[A[tata][0]],d[A[tata][0]]);

		}

		for(j=2;j<A[i].size();++j)
			s=max(s, d[i]+d[A[i][j]]);

		for(j=0;j<A[tata].size();++j)
			if(i!=A[tata][j])
			s=max(s, d[i]+d[A[tata][j]]);
			
		nd=i;
		//df(i);
		if(sol<s)sol=s;

	

	}
			
	
//	for(i=1;i<=n;++i)printf("%d ", d[i]);
//printf("\n");	

	cost=0;
	DF(1, 0);
	nd2=nd;
//	printf("(%d %d)\n", nd,cost);
	cost=0;
	memset(use, 0, sizeof(use));
	
	int Q[N], D[N];
	memset(D, 0, sizeof(D));
	D[nd]=x[nd];
	
	int p=0, q=0;
	Q[0]=nd;
	int u;
	use[nd]=1;
	
	while(p<=q)
	{
		u=Q[p++];

		for(it=a[u].begin();it!=a[u].end();++it)
			if(!use[*it])
			{
				Q[++q]=*it;
				t2[*it]=u;
				D[*it]=D[u]+x[*it];
				use[*it]=1;
			}
	}

	int cost=0, ps=0;
	memset(used, 0, sizeof(used));
	used[nd]=1;
	for(i=1;i<=n;++i)if(D[i]>cost)cost=D[i], ps=i;

	
	for(i=ps;i!=nd;i=t2[i])used[i]=1;//printf("%d ", i);


//	printf("%d ", cost);	
	
//	for(i=1;i<=n;++i)
//		if(!used[i])
//		printf("%d ", cost+d[i]);
//	printf("\n");

	for(i=1;i<=n;++i)
		if(!used[i])
			sol=max(sol, cost+d[i]);
	sol=max(sol,cost);

//	printf("%d %d ", nd, nd2);
//	printf("__%d\n", cost);
	//freopen("turism.out","w",stdout);
	printf("%d\n", sol);

	/*
	DF2(nd2, 0);
	printf("%d %d\n", nd, cost);
	printf("%d\n", d[1]);
	printf("%d\n", sol);

	
	//or(i=nd;i!=nd2;i=t2[i]);
	*/
		
	
}

int main()
{
	freopen("turism.out","w",stdout);
	int nrtst=12;
	int i,p,q;
	freopen("turism.in","r",stdin);
	while(nrtst--)
	{
		cit(n);
		a.clear();
		a.resize(n+1);
		A.clear();
		A.resize(n+1);
		
		for(i=1;i<=n;++i) cit(x[i]);
		for(i=1;i<n;++i)
		{
			cit(p);cit(q);
			a[p].pb(q);
			a[q].pb(p);
		}
		solve();

	}

	return 0;
}


