#include<stdio.h>
#include<vector>
#include<set>
#include<algorithm>
#define ss second
#define ff first
#define pb push_back
#define mkp make_pair

using namespace std;

const int maxn = 51000;

vector<int> VECT,AIB[maxn * 6][2],AINT[maxn * 6][2];
vector<pair<pair<int,int>,int > > CO[maxn];
int N,M,T,A[maxn],B[maxn],C[maxn],D[maxn];
int TIP,CUL,ST,DR,NOD,VAL;
int NR[maxn],OP[maxn],NRN[maxn * 6][2];

int cautarepair(vector<pair<pair < int,int>,int > > &vect, pair<int,int> v,int n)
{
	int x = 0,p = 0;
	pair<pair<int,int> ,int> val = mkp(v,1000000000);
	for(p = 1;p <= n;p <<= 1);
	for(;p;p >>= 1)
		if (x + p < n && vect[x + p] <= val) x += p;
   if (val < vect[x]) --x;
   return x;
}

int cautare(vector<int> &vect, int val,int n)
{
    if (n == 0) return -1;
    int x = 0,p = 0;
    for(p = 1;p <= n;p <<= 1);
    for(;p;p >>= 1)
	    if (x + p < n && vect[x + p] <= val) x += p;
    if (val < vect[x]) x--;
    return x;
}


inline int lsb(int a)
{
	return (a ^ (a - 1)) & a;	
}

void updateaib(int nod,int poz,int cul,int val,int n)
{
	++poz;
   if (poz == 0) return ;
	while(poz <= n )
	{
		AIB[nod][cul][poz - 1] += val;
		poz += lsb(poz);
	}
}

int querryaib(int nod,int cul,int poz)
{
	int nrtot = 0;
	++poz;
	while(poz)
	{
		nrtot += AIB[nod][cul][poz - 1];
		poz -= lsb(poz);
	}
   return nrtot;
}

void push(int st,int dr,int nod)
{
	AIB[nod][CUL].pb(0);
	AINT[nod][CUL].pb(TIP);
   if (st == dr) return ;
	int mid = (st + dr) / 2;
	if (mid >= NOD) push(st,mid,nod * 2);
	if (mid < NOD) push(mid + 1,dr,nod * 2 + 1);
}

void update(int st,int dr,int nod)
{
	updateaib(nod,cautare(AINT[nod][CUL],TIP,NRN[nod][CUL]),CUL,VAL,NRN[nod][CUL]);
   if (st == dr) return ;
   int mid = (st + dr) / 2;
	if (mid >= NOD) update(st,mid,nod * 2);
	if (mid < NOD) update(mid + 1,dr,nod * 2 + 1);
}


void querry(int st,int dr,int nod)
{
	if (ST <= st && dr <= DR) {VECT.pb(nod);return ;}
	int mid = (st + dr) / 2;
	if (mid >= DR){querry(st,mid,nod * 2);return ;}
	if (mid < ST) {querry(mid + 1,dr,nod * 2 + 1);return ;}
	querry(st,mid,nod * 2);querry(mid + 1,dr,nod * 2 + 1);
}


int main()
{
	freopen("kinder.in","r",stdin);
	freopen("kinder.out","w",stdout);
	scanf("%d %d %d\n",&N,&T,&M);
	for(int i = 1;i <= M; ++i)
	{
		int tip;
		scanf("%d",&tip);
		OP[i] = tip;
		if (tip == 1)
		{
			scanf("%d %d %d %d",&A[i],&B[i],&C[i],&D[i]);
			CO[A[i]].pb( mkp ( mkp(B[i],C[i]),0 ) );
			NR[A[i]]++;
			NOD = A[i];
			TIP = B[i];
			CUL = C[i];
   		push(1,N,1);
		}
		if (tip == 2)
		{
			scanf("%d %d",&A[i],&B[i]);	
			CO[A[i]].pb(mkp(mkp(B[i],0), 0) );
			CO[A[i]].pb(mkp(mkp(B[i],1), 0) );
			NR[A[i]]++;
			TIP = B[i];
			CUL = 0;
			push(1,N,1);
			CUL = 1;
			push(1,N,1);
		}
		if (tip == 3)
		{
			scanf("%d %d %d %d",&A[i],&B[i],&C[i],&D[i]);	
		}
	}
//	printf("caca\n");
	for(int i = 1;i <= N; ++i)
	{
   	sort(CO[i].begin(),CO[i].end() );
      int l = CO[i].size();
      if (l == 0) continue;
      int last = 0;
      CO[i][last] = CO[i][0];
		for(int j = 1;j < l; ++j)
              if (CO[i][j] != CO[i][j - 1]){CO[i][++last] = CO[i][j];}
      for(;l > last + 1;--l)CO[i].pop_back();
//      int pipi = CO[i].size();
//      pipi++;
	}
	for(int i = 1;i <= N * 6; ++i)
	{
		for(int cul = 0;cul <= 1; ++cul)
		{
			sort(AINT[i][cul].begin(),AINT[i][cul].end());
//         int nrn = AINT[i][cul].size();
		//	AINT[i][cul].resize(AINT[i][cul].end() - unique(AINT[i][cul].begin(),AINT[i][cul].end()));
         int l = AINT[i][cul].size(),last = 0;
         if (l == 0) continue;
         AINT[i][cul][last] = AINT[i][cul][0];
		   for(int j = 1;j < l; ++j)
              if (AINT[i][cul][j] != AINT[i][cul][j - 1]){AINT[i][cul][++last] = AINT[i][cul][j];}
         for(;l > last + 1;--l)AINT[i][cul].pop_back();
         NRN[i][cul] = AINT[i][cul].size();
		}
	}
	for(int i = 1;i <= M; ++i)
	{
		if (OP[i] == 1)
		{
			NOD = A[i];VAL = D[i];TIP = B[i];CUL = C[i];
			update(1,N,1);
			CO[A[i]][cautarepair(CO[A[i]], mkp(TIP,CUL),NR[A[i]])].ss += VAL;
		}
		if (OP[i] == 2)
		{
			NOD = A[i];
			TIP = B[i];
			CUL = 0;
			int AUX1 = CO[A[i]][cautarepair(CO[A[i]],mkp(TIP,CUL),NR[A[i]] ) ].ss;
			CUL = 1;
			int AUX2 = CO[A[i]][cautarepair(CO[A[i]],mkp(TIP,CUL),NR[A[i]] ) ].ss;
			CUL = 0;VAL = -AUX1;
			update(1,N,1);
			CUL = 1;VAL = AUX1;
			update(1,N,1);
			CUL = 1;VAL = AUX2;
			update(1,N,1);
			CUL = 0;VAL = -AUX2;
			update(1,N,1);
			CO[A[i]][cautarepair(CO[A[i]],mkp(TIP,CUL),NR[A[i]] ) ].ss = AUX2;
			CUL = 1;
			CO[A[i]][cautarepair(CO[A[i]],mkp(TIP,CUL),NR[A[i]] ) ].ss = AUX1;
		}
		if (OP[i] == 3)
		{
			ST = A[i];
			DR = B[i];
			CUL = C[i];
			VECT.clear();
			querry(1,N,1);
			int p = 0,x = 0,nrint = VECT.size();
			for( p = 1;p <= T;p <<= 1);
			for(;p;p >>= 1)
			{
				int nrt = 0;
				for(int j = 0;j < nrint; ++j)
				{
					nrt += querryaib(VECT[j],CUL,cautare(AINT[VECT[j]][CUL],x + p,NRN[VECT[j]][CUL]));
				}
				if (nrt < D[i]) x += p;
			}
			printf("%d\n",x + 1);
		}
	}
	
	return 0;
}




