#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

#define MAX_N 100005
#define SQRT_M 150
#define FIN "rev.in"
#define FOUT "rev.out"
#define pb push_back
#define f first
#define s second
#define E(x, y, z) make_pair(make_pair(x, y), z)
#define len(x) ((x).f.s-(x).f.f+1)

typedef pair<pair<int, int>, char> entry;

int N, M, P[MAX_N], Q[MAX_N];
vector<entry> A;

entry split(entry &e, int x)
{
    entry ret;
    
    if (e.s == 0)
    {
        ret = E(e.f.f, e.f.f+x-1, 0);
        e.f.f += x;
    }
    else
    {
        ret = E(e.f.s-x+1, e.f.s, 1);
        e.f.s -= x;
    }
    return ret;
}

int main(void)
{
    int i, a, b, c, cnt, idx;
    vector<entry>::iterator it, l, r;

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    scanf("%d %d", &N, &M);
    A.reserve(3*SQRT_M);
    A.pb(E(1, N, 0)); 
    for (i = 1; i <= N; ++i) P[i] = i;
    for (i = 1; M; --M, ++i)
    {
        scanf("%d %d %d", &a, &b, &c);
        
        cnt = 0;
        for (it = A.begin(); it != A.end(); ++it)
        {
            cnt += len(*it);
            if (cnt >= a && cnt-len(*it) < a)
            {
                idx = a-cnt+len(*it);
                if (idx > 1)
                    A.insert(it, split(*it, idx-1)), ++it;
                l = it;
            }
            if (cnt >= b)
            {
                idx = b-cnt+len(*it);
                if (idx < len(*it))
                    A.insert(it, split(*it, idx));
                r = ++it;
                break;
            }
        }
        reverse(l, r);
        for (; l != r; ++l) l->s ^= 1;
        
        cnt = 0;
        for (it = A.begin(); it != A.end(); ++it)
        {
            cnt += len(*it);
            if (cnt < c) continue;
            idx = c-cnt+len(*it);
            printf("%d\n", it->s ? P[it->f.s-idx+1] : P[it->f.f+idx-1]);
            break;
        }

        if (i < SQRT_M) continue;
        i = 1;
        for (it = A.begin(); it != A.end(); ++it)
        {
            a = it->s ? it->f.s : it->f.f;
            b = it->s ? it->f.f-1 : it->f.s+1;
            c = it->s ? -1 : +1;
            for (; a != b; a += c)
                Q[i++] = P[a];
        }
        copy(Q+1, Q+N+1, P+1);
        A.clear();
        A.pb(E(1, N, 0));
        i = 1;
    }

    return 0;
}
