#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>
#include <vector>
#include <time.h>
using namespace std;

#define MAXN 1000003
#define pb push_back
#define INF 2000000002
#define MOD 30011

long long res, sum;
int N, H[MAXN], Nr[MAXN], B[MAXN], st[MAXN], ans[MAXN];
vector<int> A[MAXN];

void solve(void)
{
    int i, j, k, p, nt = N % MOD;
    long long val;
    for(st[p = 1] = N, i = N-1; i >= 1; i--)
    {
        while(p >= 1 && H[i] > H[st[p]]) p--;
        Nr[i] = p, st[++p] = i;
    }
    for(st[p = 1] = 0, i = 1; i <= N; i++)
    {
        while(p >= 1 && H[i] > H[st[p]]) p--;
        A[st[p]].pb(i), st[++p] = i, sum += ans[i] = (i-(st[p-1]?st[p-1]:1));
    }
    for(st[p = 1] = 0, i = 1; i <= N; i++)
    {
        for(j = 0; p >= 1 && H[i] > H[st[p]];)
        {
            while(j < A[i].size() && H[st[p]] > H[A[i][j]])
                B[A[i][j++]] = st[p];
            p--;
        }
        while(j < A[i].size() && H[st[p]] > H[A[i][j]]) B[A[i][j++]] = st[p];
        st[++p] = i;
    }
    for(i = 1; i <= N; i++)
    {
        for(val = sum-Nr[i], j = 0; j < A[i].size(); j++)
        {
            val = val-(A[i][j]-i);
            if(B[A[i][j]] == 0)
                val = val+A[i][j]-2;
            else
                val = val+A[i][j]-B[A[i][j]]-1;
        }
        val -= ans[i], res += val;
    }
}

//vector<int> X;

void read_data(void)
{
    int i, j;
    char sir[128];
    scanf("%d\n", &N);
    for(H[0] = INF, i = 1; i <= N; i++)
	scanf("%d", &H[i]), assert(H[i] >= 1 && H[i] <= 2000000000);
//	X.pb(H[i]);
//    sort(X.begin(), X.end());
//    for(i = 1; i < N; i++) assert(X[i] != X[i-1]);
}
void write_data(void)
{
    printf("%lld\n", res);
}

int main(void)
{
    freopen("turnuri.in", "rt", stdin);
    freopen("turnuri.out", "wt", stdout);
    
    read_data();
    solve();
    write_data();
    
    return 0;
}
