#include <cstdio>

const int NMAX = 128;

int R[NMAX];

int ask(int l, int c) {
	int ans;

	printf("ASK %d %d\n", l, c);
	fflush(stdout);

	scanf(" %d", &ans);

	return ans;
}

void work(int st, int dr, int pmin, int pmax) {
	if (st > dr) return;

	if (pmin == pmax) {
		int i;

		for (i = st; i <= dr; ++i)
			R[i] = pmin;

		return;
	}

	int mij = (st + dr) >> 1;
	int mx, px, i, t;
	px = pmin;
	mx = ask(mij, pmin);

	for (i = pmin + 1; i <= pmax; ++i) {
		t = ask(mij, i);
		if (t > mx) mx = t, px = i;
	}

	R[mij] = px;
	work(st, mij-1, pmin, px);
	work(mij+1, dr, px, pmax);
}

int main(void) {
	int N, i;

	scanf(" %d", &N);

	work(0, N-1, 0, N-1);

	printf("DONE");

	for (i = 0; i < N; ++i)
		printf(" %d", R[i]);
	printf("\n");
	fflush(stdout);

	return 0;
}
