#include <stdio.h>
#include <string.h>

#define NMAX 100010
#define MMAX 5010

int N, M;

int nb = 0;
int xx[2 * MMAX];
int yy[2 * MMAX];

int nnb;
int xx1[2 * MMAX];
int yy1[2 * MMAX];

inline int ABS(int x) { return (x < 0) ? -x : x; }

inline int get_val(int x, int y, int poz)
{
	if (x < y) return x + poz - 1;
	else return x - poz + 1;
}

inline void SWAP(int &x, int &y)
{
	int aux = y;
	y = x;
	x = aux;
}

int main()
{
	int i, j, x, y, k, ant, cur, p1 = 0, p2 = 0, q;

	freopen("rev.in", "r", stdin);
	freopen("rev.out", "w", stdout);

	scanf("%d %d", &N, &M);

	nb = 1;

	xx[1] = 1; yy[1] = N;

	for (i = 1; i <= M; i++) {
		scanf("%d %d %d", &x, &y, &k);

		// caut sa vad unde e x

		ant = 0; nnb = 0;
		for (j = 1; j <= nb; j++) {
			ant++;
			cur = ant + ABS(xx[j] - yy[j]);

			if (ant <= x && x <= cur && ant <= y && y <= cur) {
				if (x != ant) {
					nnb++;
					xx1[nnb] = xx[j];
					yy1[nnb] = get_val(xx[j], yy[j], x - ant);
				}

				nnb++;
				xx1[nnb] = get_val(xx[j], yy[j], x - ant + 1);
				yy1[nnb] = get_val(xx[j], yy[j], y - ant + 1);
				p1 = p2 = nnb;

				if (y != cur) {
					nnb++;
					xx1[nnb] = get_val(xx[j], yy[j], y - ant + 2);
					yy1[nnb] = yy[j];
				}
			} else
			if (ant <= x && x <= cur) {
				if (x != ant) {
					nnb++;
					xx1[nnb] = xx[j];
					yy1[nnb] = get_val(xx[j], yy[j], x - ant);
				}

				nnb++;
				xx1[nnb] = get_val(xx[j], yy[j], x - ant + 1);
				yy1[nnb] = yy[j];
				p1 = nnb;
			} else
			if (ant <= y && y <= cur) {
				nnb++;
				xx1[nnb] = xx[j];
				yy1[nnb] = get_val(xx[j], yy[j], y - ant + 1);
				p2 = nnb;

				if (y != cur) {
					nnb++;
					xx1[nnb] = get_val(xx[j], yy[j], y - ant + 2);
					yy1[nnb] = yy[j];
				}
			} else {
				nnb++;
				xx1[nnb] = xx[j];
				yy1[nnb] = yy[j];
			}

			ant = cur;
		}

		nb = nnb;
		memcpy(xx, xx1, sizeof(xx));
		memcpy(yy, yy1, sizeof(yy));

		for (j = p1, q = 1; j <= p2; j++, q++) {
			xx[j] = xx1[p2 - q + 1];
			yy[j] = yy1[p2 - q + 1];
			SWAP(xx[j], yy[j]);
		}

		ant = 0;
		for (j = 1; j <= nb; j++) {
			ant++;
			cur = ant + ABS(xx[j] - yy[j]);

			if (ant <= k && k <= cur) {
				printf("%d\n", get_val(xx[j], yy[j], k - ant + 1));	
				break;
			}

			ant = cur;
		}
	}
	
return 0;
}

