#include <cstdio>
#include <cstring>

#define Nmax 128

int n;
int mat[Nmax][Nmax];
int best[Nmax];

void citire()
{
	scanf("%d", &n);
}

void solve()
{
	int i, j, st, dr, mij, last, next, ind;
	
	memset(mat, -1, sizeof(mat));
	for (i = 1; i <= n; ++i)
		best[i] = n;

	for (i = n - 1; i >= 1; --i)
	{
		st = 1;
		dr = n;
		ind = 0;
		while (st <= dr)
		{
			mij = (st + dr) / 2;
			
			if (mat[mij][best[mij]] == -1)
			{
				printf("ASK %d %d\n", mij - 1, best[mij] - 1);
				fflush(stdout);
				scanf("%d", &mat[mij][best[mij]]);
			}

			last = mat[mij][best[mij]];
			
			printf("ASK %d %d\n", mij - 1, i - 1);
			fflush(stdout);
            scanf("%d", &mat[mij][i]);

			next = mat[mij][i];
			
			if (next > last)
			{
				st = mij + 1;
				ind = mij;
			}
			else
				dr = mij - 1;
		}

		for (j = 1; j <= ind; ++j)
			best[j] = i;
	}

	printf("DONE ");
	for (i = 1; i <= n; ++i)
		printf("%d ", best[i] - 1);
	printf("\n");
	fflush(stdout);
}

int main()
{
	citire();
	solve();

	return 0;
}
