#include <cstdio>
#include <algorithm>

using namespace std;

#define Nmax 500015
#define Amax 1048567
#define ll long long

int n, q;
int sir[Nmax];
int s[Nmax];
int ind[Nmax];
int best[Amax];
int viz[Nmax];
int st[Nmax];
int pos[Nmax];
ll dif[Nmax];
char str[32], *buf;

int get()
{
	int ret = 0;

	while ('0' <= *buf && *buf <= '9')
	{
		ret = ret * 10 + *buf - '0';
		++buf;
	}

	return ret;
}

void citire()
{
	int i;
	
	scanf("%d\n", &n);
	for (i = 1; i <= n; ++i)
	{
		fgets(str, 32, stdin);
		buf = str;
		s[i] = get();
	}
}

void init(int nod, int st, int dr)
{
	if (st == dr)
		best[nod] = st;
	else
	{
		int mij = (st + dr) / 2, fs = nod * 2, fd = nod * 2 + 1;

		init(fs, st, mij);
		init(fd, mij + 1, dr);

		if (sir[best[fs]] > sir[best[fd]])
			best[nod] = best[fs];
		else
			best[nod] = best[fd];
	}
}

int cmp(const int a, const int b)
{
	return s[a] > s[b];
}

void query(int nod, int st, int dr, int a, int b, int val)
{
	if (a <= st && dr <= b)
	{
		if (st == dr)
			if (sir[st] > val)
				q = st;
			else;
		else
		{
			int mij = (st + dr) / 2, fs = nod * 2, fd = nod * 2 + 1;
			if (sir[best[fd]] > val)
				query(fd, mij + 1, dr, a, b, val);
			else
				query(fs, st, mij, a, b, val);
		}
	}
	else
	{
		int mij = (st + dr) / 2, fs = nod * 2, fd = nod * 2 + 1;
 
		if (mij < b && !q) query(fd, mij + 1, dr, a, b, val);    	
		if (a <= mij && !q) query(fs, st, mij, a, b, val);
	}
}

void update(int nod, int st, int dr, int a)
{
	if (st == dr)
		best[nod] = st;
	else
	{
		int mij = (st + dr) / 2, fs = nod * 2, fd = nod * 2 + 1;

		if (a <= mij) update(fs, st, mij, a);
		else update(fd, mij + 1, dr, a);

		if (sir[best[fs]] > sir[best[fd]])
			best[nod] = best[fs];
		else
			best[nod] = best[fd];
	}
}

void solve()
{
	int i, poz, vf;
	ll suma = 0, sol = 0;
	
	
	init(1, 1, n);
	
	for (i = 1; i <= n; ++i)
		ind[i] = i;
	sort(ind+1, ind+n+1, cmp);

	for (i = 1; i <= n; ++i)
	{
		q = 0;
		query(1, 1, n, 1, ind[i], s[ind[i]]);
		if (sir[q] < s[ind[i]]) q = 0;

		poz = q;
		q = 0;
		if (poz)
		{
			if (poz > 1) query(1, 1, n, 1, poz - 1, s[ind[i]]);
			if (!q) ++q;
			if (sir[q] < s[ind[i]]) q = 1;
			
			dif[poz] += poz - q;
		}
		
		sir[ind[i]] = s[ind[i]];
		update(1, 1, n, ind[i]);
	}
	
	st[vf = 0] = 0;
	pos[vf] = 1;

	for (i = 1; i <= n; ++i)
	{
		while (vf > 0 && sir[i] > st[vf]) --vf;
		viz[i] = i - pos[vf];
		
		st[++vf] = sir[i];
		pos[vf] = i;
		suma += viz[i];
	} 

    vf = 0;
	for (i = n; i >= 1; --i)
	{
        sol += suma - viz[i] - vf + dif[i];
		while (vf > 0 && sir[i] > st[vf]) --vf;
		st[++vf] = sir[i];
	}
	
	printf("%lld\n", sol);
}

int main()
{
	freopen("turnuri.in", "r", stdin);
	freopen("turnuri.out", "w", stdout);

	citire();
	solve();

	return 0;
}
