#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

#define nm 1048576
#define inf 2000000001

int n, a[nm], st[nm], c1[nm], c2[nm];
long long sol;
vector< pair<int, int> > v;

int main()
{
	freopen("turnuri.in", "r", stdin);
	freopen("turnuri.out", "w", stdout);

	scanf("%d", &n);

	a[0] = inf;
	for (int i = 1; i <= n; ++i)
		scanf("%d", &a[i]);

	st[++st[0]] = 0;

	for (int i = 1; i <= n + 1; ++i) {
		while (a[i] > a[st[st[0]]])
			--st[0];

		c1[i] = st[st[0]];

		st[++st[0]] = i;
	}

	for (int i = 1; i <= n; ++i)
		v.push_back(make_pair(c1[i], i));

	sort(v.begin(), v.end());

	int crt = 0;

	st[0] = 1;
	st[st[0]] = 0;

	for (int i = 0; i < n; ++i) {
		for (; crt < v[i].first - 1; ++crt) {
			while (a[crt + 1] > a[st[st[0]]])
				--st[0];

			st[++st[0]] = crt + 1;
		}

		while (a[v[i].second] > a[st[st[0]]])
			--st[0];

		c2[v[i].second] = st[st[0]];
	}
		
	for (int i = 1; i <= n; ++i) {
		if (c1[i] == 0) {
			sol = (long long)sol + ((long long)i - 1) * (i - 2) + 
				   ((long long)n - i) * (i - 1);
		} else {
			sol = (long long)sol + ((long long)c1[i] - 1) * (i - c1[i]) + 
				   ((long long)i - c1[i] - 1) * (i - c1[i] - 1) +
				   ((long long)n - i) * (i - c1[i]);

			if (c2[i] == 0)
				sol = (long long)sol + i - 2;
			else
				sol = (long long)sol + i - c2[i] - 1;
		}
	}

	printf("%lld\n", sol);
		
	return 0;
}
