#include <cstdio>
#include <algorithm>
#include <vector>

#define NX 100010

using namespace std;

#define BSZ (1<<16)
char buf[ BSZ ];
int bp = BSZ - 1;

int M, N, v[ NX ];

int get() {
	int x = 0;

	while( buf[bp] <= '0' || buf[bp] >= '9' )
		if( ++bp >= BSZ )
			fread( buf, 1, BSZ, stdin ), bp = 0;

	while( buf[bp] >= '0' && buf[bp] <= '9' ) {
		x = x*10 + buf[bp] - '0';
		if( ++bp >= BSZ )
			fread( buf, 1, BSZ, stdin ), bp = 0;
	}

	return x;
}

void cit() {
	int i, x, y, z;

	N = get(); M = get();
	
	for( i = 1; i <= N; i++ )
		v[i] = i;

	while( M-- ) {
		x = get(); y = get(); z = get();

		reverse( v + x, v + y + 1 );
		printf( "%d\n", v[z] );
	}
}

int main() {
	freopen( "rev.in", "r", stdin );
	freopen( "rev.out", "w", stdout );

	cit();

	return 0;
}

