#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define MAXN 1000005

int N, x[MAXN];
int left[MAXN], stopL[MAXN];

int st[MAXN];
vector<int> v[MAXN];

inline int binSearch( int val )
{
	int rez = 1, step = 1;
	for (; step <= st[0]; step <<= 1);
	for (; step; step >>= 1)
		if (rez + step <= st[0] && x[ st[rez + step] ] >= val)
			rez += step;
	return rez;
}

int main()
{
	freopen("turnuri.in", "rt", stdin);
	freopen("turnuri.out", "wt", stdout);

	scanf("%d", &N);
	for (int i = 0; i < N; i++)
		scanf("%d", x + i);
	
	long long TOT = 0, INIT = 0;
	left[0] = 0;
	v[0].push_back(0);
	st[ st[0] = 1 ] = 0;
	for (int i = 1; i < N; i++)
	{
		for (; st[0] && x[ st[ st[0] ] ] < x[i]; st[0]--);
		
		if (st[0])
			left[i] = st[ st[0] ];
		else
			left[i] = 0;
		v[ left[i] ].push_back(i);
		st[ ++st[0] ] = i;

		INIT += i - left[i];
	}
	for (int i = 0; i < N; i++)
	{
		stopL[i] = (int)v[i].size();
		if (i)
			stopL[i] += stopL[i - 1];
	}

	st[ st[0] = 1 ] = 0;
	TOT = INIT - (0 - left[0]) - (stopL[0] - 1);
	for (int i = 1; i < N; i++)
	{
		long long CUR = INIT - (i - left[i]) - (stopL[i] - (i + 1));
		for (size_t k = 0; k < v[i].size(); k++)
		{
			int newLeft;
			if (x[ v[i][k] ] > x[ st[1] ])
				newLeft = 0;
			else
			   	newLeft = st[ binSearch( x[ v[i][k] ] ) ];
			CUR += left[ v[i][k] ] - newLeft;
		}

		TOT += CUR;
		for (; st[0] && x[ st[ st[0] ] ] < x[i]; st[0]--);
		st[ ++st[0] ] = i;
	}

	printf("%lld\n", TOT);
	
	return 0;
}
