#include <stdio.h>
#define InFile "pitici.in"
#define OutFile "pitici.out"
#define NMax 2048
#define INF 1000000000

struct pitic {int h, L, nr;} P[NMax];

int p[NMax], way[NMax];
int n, sum, c, D;
FILE * fout;

void citire(void)
{int i;
 FILE * fin=fopen(InFile,"r");
 fscanf(fin,"%d",&n);
 for (i=1; i<=n; i++)
     {fscanf(fin,"%d %d",&P[i].h, &P[i].L);
      P[i].nr=i;
      sum+=P[i].h;
      p[i]=INF;
     }
 fscanf(fin,"%d",&D);
}

void sort(int st, int dr)
{int i=st, j=dr;
 struct pitic x=P[st];
 while (i<j)
       {while (i<j && P[j].h+P[j].L>=x.h+x.L) j--;
        P[i]=P[j];
        while (i<j && P[i].h+P[i].L<=x.L+x.h) i++;
        P[j]=P[i];
       }
 P[i]=x;
 if (st<i-1) sort(st, i-1);
 if (i+1<dr) sort(i+1,dr);
}


void rezolvare()
{int i, j;
 p[0]=0;
 way[0]=0;
 c=0;   //numarul de pitici care pot iesi
 for (j=1; j<=n; j++) //consider piticii 1, 2, ..., j
     {
      for (i=c; i>=0; i--) //pot iesi i pitici
           //p[i]=inaltimea turnului format din cei i pitici care ies
           //la baza turnul are inaltimea sum-p[i]
            if (sum - p[i] + P[j].L >= D)//piticul j poate iesi
               {
                if (p[i+1] > p[i] + P[j].h)
                   {
                    p[i+1]=p[i] + P[j].h;
                    way[i+1]=P[j].nr;
                   }
               }
     if (p[c+1] !=INF) c++;
    }
}

void afisare()
{
fout=fopen(OutFile,"w");
fprintf(fout,"%d\n",c);
fclose(fout);
}

int main()
{
citire();
sort(1,n);
rezolvare();
afisare();
return 0;
}

