//Mugurel

#include <stdio.h>
#include <string.h>

#define NMAX 2010

long H[NMAX], L[NMAX];
int out[NMAX], Hidx[NMAX], HLidx[NMAX];
int N, cnt;
long D, sumH, sH;

void read_input(void)
{
	int i, j, k;

	scanf("%d", &N);
	for (i = 1; i <= N; i++)
		scanf("%ld %ld", &H[i], &L[i]);
	scanf("%ld", &D);
}

void sort_H(void)
{
	int i, j, k;


	for (i = 1; i <= N; i++)
		Hidx[i] = i;

	for (i = 1; i < N; i++)
		for (j = i + 1; j <= N; j++)
			if (H[Hidx[i]] > H[Hidx[j]])
			{
				k = Hidx[i]; Hidx[i] = Hidx[j]; Hidx[j] = k;
			}
}

void sort_HL(void)
{
	int i, j, k;


	for (i = 1; i <= N; i++)
		HLidx[i] = i;

	for (i = 1; i < N; i++)
		for (j = i + 1; j <= N; j++)
			if (H[HLidx[i]] + L[HLidx[i]] < H[HLidx[j]] + L[HLidx[j]])
			{
				k = HLidx[i]; HLidx[i] = HLidx[j]; HLidx[j] = k;
			}
}


int checkAll(long D)
{
	int i, j, k;

	for (i = 1; i <= N; i++)
		if (out[HLidx[i]])
		{
			if (H[HLidx[i]] + L[HLidx[i]] < D)
				return 0;
			D -= H[HLidx[i]];
		}

	return 1;
}

int main()
{
	int i, j;

	freopen("pitici.in", "r", stdin);

	read_input();
	sort_H();
	sort_HL();

	memset(out, 0, sizeof(out));

	sumH = 0;
	for (i = 1; i <= N; i++)
		sumH += H[i];

	cnt = 0;
	for (i = 1; i <= N; i++)
	{
		out[Hidx[i]] = 1;
		sumH -= H[Hidx[i]];

		if (checkAll(D - sumH))
			cnt++;
		else
		{
			out[Hidx[i]] = 0;
			sumH += H[Hidx[i]];
		}
	}

	freopen("pitici.out", "w", stdout);
	printf("%d\n", cnt);

	return 0;
}
