
{ DMIH 2001 - Prvi dan natjecanja        }
{ Srednjoskolska skupina - I. podskupina }
{ Zadatak BARKOD                         }
{ Autor rjesenja Ante Djerek             }
{ Nesluzbeno rjesenje                    }

PROGRAM kod;
CONST
    maxdulj=100;
    sirina=5;
VAR
    n:integer;
    barkod:STRING[maxdulj];

PROCEDURE citaj_ulaz;
VAR i, j:integer;
    fin:text;
    tmp:STRING[maxdulj];
BEGIN
    assign(fin, 'BARCODE.in');
    reset(fin);
    readln(fin, n);
    readln(fin, barkod);
    FOR i:=2 TO sirina DO
    BEGIN
        readln(fin, tmp);
        FOR j:=1 TO n DO
            IF tmp[j]<>'?' THEN barkod[j]:=tmp[j];
    END;
    close(fin);
END;

FUNCTION suprotni(c:char):char;
BEGIN
    IF c='X' THEN suprotni:='.';
    IF c='.' THEN suprotni:='X';
END;

FUNCTION sredi(a, b, c:integer):boolean;
BEGIN
    sredi:=TRUE;
    IF barkod[a]<>barkod[b] THEN sredi:=FALSE
    ELSE IF barkod[c]<>'?' THEN sredi:=FALSE
    ELSE barkod[c]:=suprotni(barkod[a]);
END;

PROCEDURE rijesi;
VAR i:integer;
    gotovo:boolean;
BEGIN
    gotovo:=FALSE;
    WHILE NOT gotovo DO
    BEGIN
        gotovo:=TRUE;
        FOR i:=1 TO n-2 DO
        BEGIN
            IF sredi(i, i+1, i+2) THEN gotovo:=FALSE;
            IF sredi(i, i+2, i+1) THEN gotovo:=FALSE;
            IF sredi(i+1, i+2, i) THEN gotovo:=FALSE;
        END;
    END;
END;

PROCEDURE ispisi_rjesenje;
VAR i:integer;
    fout:text;
    neod:boolean;
BEGIN
    assign(fout, 'BARCODE.out');
    rewrite(fout);
    neod:=FALSE;
    FOR i:=1 TO n DO
        IF barkod[i]='?' THEN
            neod:=TRUE;
    IF neod THEN
        writeln(fout, 'UNDETERMINABLE')
    ELSE
    BEGIN
        i:=1;
        WHILE i<=n DO
            IF barkod[i]=barkod[i+1] THEN
            BEGIN
                write(fout, '1');
                i:=i+2;
            END
            ELSE
            BEGIN
                write(fout, '0');
                i:=i+1;
            END;
        writeln(fout);
    END;
    close(fout);
END;

{ Glavni program }
BEGIN
    citaj_ulaz;
    rijesi;
    ispisi_rjesenje;
END.
