
// DMIH 2001 - Prvi dan natjecanja
// Srednjoskolska skupina - I. podskupina
// Zadatak SOBE
// Autor rjesenja Zvonimir Bujanovic
// Nesluzbeno rjesenje

#include<stdio.h>

#define MAXSOBA      100
#define MAXGRUPA     100
#define INFILE       "ROOMS.in"
#define OUTFILE      "ROOMS.out"

int brsoba, brgrupa;
int sobe[MAXSOBA];

void load_data_and_solve ( void )
{
 int i, brljudi, tren_soba=0, puno=0;
 FILE *f=fopen (INFILE, "rt");

 fscanf (f, "%d %d", &brsoba, &brgrupa);
 for (i=0; i<brgrupa; i++)
     {
      fscanf (f, "%d", &brljudi);

      while (brljudi)
        {
         switch (puno)
           {
            case 0  : if (brljudi==1) { sobe[tren_soba]=1; brljudi=0; }
                                 else { sobe[tren_soba]=2; brljudi-=2; }
                      while (sobe[tren_soba] && tren_soba<brsoba) tren_soba++;
                      if (tren_soba==brsoba)
                         {
                          puno=1; tren_soba=0;
                          while (sobe[tren_soba]==2) tren_soba++;
                         }
                      break;

            case 1  : sobe[tren_soba]++; brljudi--;
                      while (sobe[tren_soba]==2) tren_soba++;
                      break;
            default : ;
           }
         }
     }
}

void write_output ( void )
{
 int i;
 FILE*f=fopen (OUTFILE, "wt");

 for (i=0; i<brsoba; i++) fprintf (f, "%d\n", sobe[i]);
 fclose (f);
}

int main ( void )
{
 load_data_and_solve();
 write_output();
 return 0;
}
