
{ DMIH 2001 - Drugi dan natjecanja       }
{ Srednjoskolska skupina - I. podskupina }
{ Zadatak PIVA                           }
{ Autor rjesenja Ante Djerek             }
{ Nesluzbeno rjesenje                    }

PROGRAM piva;
CONST
    maxboca=10;
VAR n:integer;
    tablica:ARRAY[1..maxboca, 1..maxboca] OF integer;

FUNCTION broj (c:char):integer;
BEGIN
    CASE c OF
        'U':broj:=0;
        'R':broj:=1;
        'D':broj:=2;
        'L':broj:=3;
    END;
END;

PROCEDURE citaj_ulaz;
VAR i, j:integer;
    fin:text;
    c:char;
BEGIN
    assign(fin, 'BEER.in');
    reset(fin);
    readln(fin, n);
    FOR i:=1 TO n DO
    BEGIN
        FOR j:=1 TO i DO
        BEGIN
            read(fin, c);
            tablica[i, j]:=broj(c);
        END;
        readln(fin);
    END;
    close(fin);
END;

FUNCTION dobra (r, s:integer):boolean;
BEGIN
    dobra:=TRUE;
    IF (r<1) OR (r>n) THEN dobra:=FALSE;
    IF (s<1) OR (s>r) THEN dobra:=FALSE;
END;

PROCEDURE okreni (r, s:integer);
BEGIN
    tablica[r, s]:=(tablica[r, s]+1) MOD 4;
    IF dobra(r-1, s-1) THEN  tablica[r-1, s-1]:=(tablica[r-1, s-1]-1+4) MOD 4;
    IF dobra(r-1, s) THEN  tablica[r-1, s]:=(tablica[r-1, s]-1+4) MOD 4;
END;

PROCEDURE rijesi;
VAR i, j:integer;
    fout:text;
BEGIN
    assign(fout, 'BEER.out');
    rewrite(fout);
    FOR i:=n DOWNTO 1 DO
        FOR j:=1 TO i DO
            WHILE tablica[i, j]<>0 DO
            BEGIN
                okreni(i, j);
                writeln(fout, n-i+1, ' ', j);
            END;
    close(fout);
END;

{ Glavni program }
BEGIN
    citaj_ulaz;
    rijesi;
END.
