
// DMIH 2001 - Drugi dan natjecanja
// Srednjoskolska skupina - I. podskupina
// Zadatak BURAZI
// Autor rjesenja Bojan Antolovic
// Nesluzbeno rjesenje

// Algoritam: Isprobavanje svih kombinacija parova

#include <stdio.h>
#include <mem.h>
#define MAX 20

long tarifa_par, tarifa_ostali;
int n;
long vrijeme[MAX][MAX];

int par[MAX];
int isproban[MAX];
long min_cijena;

long broj_kombinacija;
int naj_parovi[MAX];
long broj_istih;

void citaj_input(void)
{
	int i, r, a, b, v;
	FILE *f;
  f = fopen("FRIENDS.in", "rt");
	fscanf(f, "%ld%ld", &tarifa_par, &tarifa_ostali);
	fscanf(f, "%d%d", &n, &r);
	for (a=0; a<n; a++)
		for (b=0; b<n; b++)
			vrijeme[a][b] = 0;
	for (i=0; i<r; i++)
	{
		fscanf(f, "%d%d%d", &a, &b, &v);
		vrijeme[a-1][b-1] += v;
		vrijeme[b-1][a-1] += v;
	}
	fclose(f);
}

void ocijeni_parove(void)
{
	int a, b;
	long cijena;
	broj_kombinacija++;
	cijena = 0;
	for (a=0; a<n-1; a++)
	 for (b=a+1; b<n; b++)
	  if (a!=b)
		if (a==par[b])
			cijena += (long)vrijeme[a][b]*tarifa_par;
		else
			cijena += (long)vrijeme[a][b]*tarifa_ostali;
	if (cijena<min_cijena || min_cijena==-1)
	{
		min_cijena = cijena;
		memcpy(naj_parovi, par, sizeof(naj_parovi));
		broj_istih = 1;
	}
	else
	if (cijena==min_cijena)
	{
		broj_istih++;
	}
}

void isprobaj_kombinacije(int broj_parova, int osoba1)
{
	int osoba2;
	if (broj_parova<n/2)
	{
		while (isproban[osoba1]) osoba1++;
		isproban[osoba1] = 1;
		for (osoba2=osoba1+1; osoba2<n; osoba2++)
			if (!isproban[osoba2])
			{
				par[osoba1] = osoba2;
				par[osoba2] = osoba1;
				isproban[osoba2] = 1;
				isprobaj_kombinacije(broj_parova+1, osoba1+1);
				isproban[osoba2] = 0;
			}
		isproban[osoba1] = 0;
	}
	else
	{
		ocijeni_parove();
	}
}

void zapisi_output(void)
{
	int a;
	FILE *f;
  f = fopen("FRIENDS.out", "wt");
	fprintf(f, "%ld\n", min_cijena);
	for (a=0; a<n; a++)
		if (!isproban[a])
		{
			fprintf(f, "%d %d\n", a+1, naj_parovi[a]+1);
			isproban[naj_parovi[a]] = 1;
		}
	fclose(f);
}

int main(void)
{
	int i;

	citaj_input();

	for (i=0; i<n; i++) isproban[i] = 0;
	min_cijena = -1;
	broj_kombinacija = 0;
	isprobaj_kombinacije(0, 0);

	zapisi_output();
	return 0;
}
