
// DMIH 2001 - Prvi dan natjecanja
// Srednjoskolska skupina - II. podskupina
// Zadatak DEKOD
// Autor rjesenja Zvonimir Bujanovic
// Nesluzbeno rjesenje

#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#define MAXN     100
#define INFILE   "DECODE.in"
#define OUTFILE  "DECODE.out"

int klj_broj, bio[27];
char s[MAXN+1], klj_rij[27], tableux[27], inv_tableux[27];

void load_data ( void )
{
 FILE *f=fopen (INFILE, "rt");

 fscanf (f, "%s\n", klj_rij);
 fscanf (f, "%d\n", &klj_broj);
 fscanf (f, "%s", s);
}

void gen_tableux ( void )
{
 int i, j=klj_broj-1;
 char ch;

 for (i=0; i<strlen(klj_rij); i++)
     {
      tableux[j]=klj_rij[i];
      j=(j+1)%26;
      if (bio[klj_rij[i]-'A'])
         {
          printf ("Dva ista slova u klj. rijeci.\n");
          exit (0);
         }
      bio[klj_rij[i]-'A']=1;
     }

 ch='A';
 while (ch<='Z')
   {
    if (!bio[ch-'A']) { tableux[j]=ch;
                        j=(j+1)%26;
                        bio[ch-'A']=1; }
    ch++;
   }

 for (i=0; i<26; i++) inv_tableux[tableux[i]-'A']=i+'A';
}

void write_output ( void )
{
 int i;
 FILE *f=fopen (OUTFILE, "wt");

 for (i=0; i<strlen(s); i++) fprintf (f, "%c", inv_tableux[s[i]-'A']);
 fprintf (f, "\n");
 fclose (f);
}

int main ( void )
{
 load_data();
 gen_tableux();
 write_output();

 return 0;
}
