
{ Rjesenje napisali Kresimir Malnar, Ante Djerek i Bojan Antolovic }

program palin;
const
  MAX_ZNAKOVA = 100;
var
  niz_znakova : string[MAX_ZNAKOVA];
  rjesenje : integer;
  f : text;

procedure ucitaj_podatke;
begin
  assign(f,'PALIN.IN');
  reset(f);
  read(f,niz_znakova);
  close(f);
end;

procedure rijesi;
var
  i,j : integer;
  duljina_niza : integer;
  polje : array [1..MAX_ZNAKOVA] of integer;
  minimalno : integer;

function palindrom(pocetak,kraj : integer) : boolean;
begin
  while true do
    begin
      if niz_znakova[pocetak] <> niz_znakova[kraj] then
        begin
          palindrom := false;
          exit;
        end;

      inc(pocetak);
      dec(kraj);

      if pocetak >= kraj then
        break;
    end;

  palindrom := true;
end;

begin
  duljina_niza := length(niz_znakova);

  for i := 1 to duljina_niza do
    begin
      if palindrom(1,i) then
        begin
          polje[i] := 1;
          continue;
        end;

      minimalno := 0;

      for j := 1 to i - 1 do
        if palindrom(j + 1,i) and ((minimalno = 0) or (polje[j] < minimalno)) then
          minimalno := polje[j];

      polje[i] := minimalno + 1;
    end;

  rjesenje := polje[duljina_niza];
end;

procedure ispisi_rjesenje;
begin
  assign(f,'PALIN.OUT');
  rewrite(f);
  writeln(f,rjesenje);
  close(f);
end;

begin
  ucitaj_podatke;
  rijesi;
  ispisi_rjesenje;
end.
