
// Rjesenje napisali Kresimir Malnar, Ante Djerek i Bojan Antolovic

/*

Program ide od pocetka do kraja poruke i radi sljedece:

1. Trazi sljedecu rijec u poruci (rijeci su odvojene znakom '1').

2. Trazi tu rijec u rjecniku. Za svaku rijec iz rjecnika provjerava
da li se moze dobiti zadanim tipkama.

3. Ako je nasao odgovarajucu rijec u rjecniku, ispisuje ju, inace
ispisuje niz zvijezdica.

*/

#include <stdio.h>
#include <string.h>

//

#define MAX_RIJECI 100
#define MAX_DULJINA_RIJECI 100
#define MAX_DULJINA_PORUKE 100

//

int broj_rijeci;
char rijeci[MAX_RIJECI][MAX_DULJINA_RIJECI + 1];

int duljina_poruke;
int poruka[MAX_DULJINA_PORUKE];

char *raspored = "22233344455566677778889999";

FILE *file;

//

void ucitaj_podatke(void)
{
  int i;

  //

  file = fopen("T9.IN","rt");

  fscanf(file,"%d",&broj_rijeci);

  for (i = 0;i < broj_rijeci;++i)
    fscanf(file,"%s",rijeci[i]);

  fscanf(file,"%d",&duljina_poruke);

  for (i = 0;i < duljina_poruke;++i)
    fscanf(file,"%d",poruka + i);

  fclose(file);
}

//

void nadji(char *rijec)
{
  int i,j;
  int ima;
  int dobra;

  //

  ima = 0;

  for (i = 0;i < broj_rijeci;++i)
  {
    if (strlen(rijec) != strlen(rijeci[i]))
      continue;

    dobra = 1;

    for (j = 0;j < strlen(rijec);++j)
      if (rijec[j] != raspored[rijeci[i][j] - 'A'])
      {
        dobra = 0;
        break;
      }

    if (dobra)
    {
      fprintf(file,"%s ",rijeci[i]);
      ima = 1;
      break;
    }
  }

  if (!ima)
  {
    for (i = 0;i < strlen(rijec);++i)
      fprintf(file,"*");

    fprintf(file," ");
  }
}

//

void rijesi_i_ispisi(void)
{
  int brojac1,brojac2;
  char rijec[MAX_DULJINA_RIJECI + 1];

  //

  file = fopen("T9.OUT","wt");

  brojac1 = brojac2 = 0;

  while (1)
  {
    rijec[brojac2++] = poruka[brojac1++] + '0';

    if (brojac1 == duljina_poruke || poruka[brojac1] == 1)
    {
      rijec[brojac2] = '\0';

      nadji(rijec);

      ++brojac1;
      brojac2 = 0;
    }

    if (brojac1 > duljina_poruke)
      break;
  }

  fprintf(file,"\n");

  fclose(file);
}

//

int main(void)
{
  ucitaj_podatke();
  rijesi_i_ispisi();

  //

  return 0;
}
