
/*
HIO 2002
Zadatak STOKA, Programski jezik C
*/

#include <stdio.h>
#include <string.h>

#define MAX_STOKE 1000
#define MAXVEL 1000000

int ostalo[MAX_STOKE][MAX_STOKE];
int ubiti[MAX_STOKE][MAX_STOKE];
int zastita[MAX_STOKE][MAX_STOKE];
int kol[MAX_STOKE];
int stoka, vagoni, maxstok;
int trojke;
int rje;

void proc()
{
  int i, j, k, z;
  int ubio;
  int ziv[MAX_STOKE];

  for ( i = 0; i < stoka; ++i )
   for ( j = i; j < i + maxstok && j < stoka; ++j )
    {
      ubio = 1;
      memset( ziv, 1, MAX_STOKE * sizeof(int) );
      for( ; ubio ; )
        {
          ubio = 0;
          for ( k = i; k <= j; ++k)
          	for ( z = 0; z < kol[k]; ++z)
              {
                if ( ziv[k] && ubiti[k][z]>=i && ubiti[k][z]<=j && ziv[ubiti[k][z]] )
                  if (zastita[k][z]<i || zastita[k][z]>j || !ziv[zastita[k][z]] )
                    {
                      ziv[ubiti[k][z]] = 0;
                      ubio = 1;
                    }
              }
        }
     for ( k = i; k <=j; ++k) if (ziv[k]) ++ostalo[i][j];
    }
}

int rac()
{
  int cur[MAX_STOKE], pre[MAX_STOKE];
  int i, j, k;

  for ( i = 0; i < maxstok; ++i)
    {
      pre[i] = ostalo[0][i];
      cur[i] = 0;
    }
  for ( i = maxstok; i < stoka; ++i)
    {
      pre[i] = -1;
      cur[i] = 0;
    }

  for( k = 1; k < vagoni; ++k)
  {
   for( i = k; i < (k+1) * maxstok && i < stoka; ++i)
    for ( j = i - maxstok + 1; j <= i; ++j)
     {
       if ( j - 1 < k - 1) continue;
       if ( pre[j-1] == -1 )  continue;
       if ( cur[i] < pre[j-1] + ostalo[j][i] )
         cur[i] = pre[j-1] + ostalo[j][i];
     }
   for ( i = 0; i < stoka; ++i )
     {
       pre[i] = cur[i];
       cur[i] = 0;
     }
  }

  return pre[stoka-1];
}


int main()
{
  FILE *fin = fopen("cattle.in", "r"), *fout = fopen("cattle.out", "w");
  int i;

  fscanf(fin, "%d %d %d", &stoka, &vagoni, &maxstok);
  fscanf(fin, "%d", &trojke);
  for ( i = 0; i < trojke; ++i)
    {
      int x, y, z;
      fscanf(fin, "%d %d %d", &x, &y, &z);
      ubiti[x - 1][kol[x - 1]] = y - 1;
      zastita[x - 1][kol[x - 1]] = z - 1;
      kol[x - 1]++;
    }

  proc();
  rje = rac();
  fprintf(fout, "%d\n", rje);

  fclose(fout);
  fclose(fin);
  return 0;
}
