
(*
Regional Competition 2002, Juniors
Problem JANICA, Solution in Pascal
*)

program janica;
const
  INPUT_FILE  = 'janica.in';
  OUTPUT_FILE = 'janica.out';
  MAX_N = 100;
var
  i,j : integer;
  n,m : integer;
  vrijeme : array [1..MAX_N] of double;
  najbolje_vrijeme,broj : double;
  poredak : array [1..MAX_N] of integer;
  temp : integer;
  f : text;

begin
  assign(f,INPUT_FILE);
  reset(f);
  readln(f,n,m);

  readln(f,vrijeme[1]);
  najbolje_vrijeme := vrijeme[1];
  for i := 2 to n do
    begin
      readln(f,broj);
      vrijeme[i] := najbolje_vrijeme + broj;
      if broj < 0 then
        najbolje_vrijeme := vrijeme[i];
    end;
  for i := 1 to n do
    poredak[i] := i;
  for i := 1 to n - 1 do
    for j := i + 1 to n do
      if vrijeme[poredak[i]] > vrijeme[poredak[j]] then
        begin
          temp := poredak[i];
          poredak[i] := poredak[j];
          poredak[j] := temp;
        end;

  readln(f,vrijeme[poredak[m]]);
  najbolje_vrijeme := vrijeme[poredak[m]];
  for i := m - 1 downto 1 do
    begin
      readln(f,broj);
      vrijeme[poredak[i]] := najbolje_vrijeme + broj;
      if broj < 0 then
        najbolje_vrijeme := vrijeme[poredak[i]];
    end;
  for i := 1 to m - 1 do
    for j := i + 1 to m do
      if vrijeme[poredak[i]] > vrijeme[poredak[j]] then
        begin
          temp := poredak[i];
          poredak[i] := poredak[j];
          poredak[j] := temp;
        end;

  close(f);

  assign(f,OUTPUT_FILE);
  rewrite(f);
  writeln(f,poredak[1]);
  writeln(f,poredak[2]);
  writeln(f,poredak[3]);
  close(f);
end.
