
(*
Regional Competition 2002, Seniors
Problem AIRPLANE, Solution in Pascal
*)

program airplane;
const
  INPUT_FILE  = 'airplane.in';
  OUTPUT_FILE = 'airplane.out';
  MAX_PUTNIKA = 1000;
  MAX_REDOVA  = 1000;
var
  broj_putnika,broj_redova : integer;
  cilj : array [0..MAX_PUTNIKA] of integer;
  rjesenje : integer;
  f : text;

procedure ucitaj_podatke;
var
  i : integer;
begin
  assign(f,INPUT_FILE);
  reset(f);
  readln(f,broj_putnika);
  broj_redova := 1;
  for i := 1 to broj_putnika do
    begin
      readln(f,cilj[i]);
      if cilj[i] > broj_redova then
        broj_redova := cilj[i];
    end;
  close(f);
end;

function max3(a,b,c : integer) : integer;
begin
  if (a > b) and (a > c) then
    max3 := a
  else
    if b > c then
      max3 := b
    else
      max3 := c;
end;

procedure rijesi;
var
  i,j : integer;
  redovi : array [0..MAX_REDOVA] of integer;
begin
  for i := 0 to broj_redova do
    redovi[i] := 0;

  for i := 1 to broj_putnika do
    begin
      for j := 1 to cilj[i] - 1 do
        redovi[j] := max3(redovi[j - 1] + 1,redovi[j] + 1,redovi[j + 1]);
      redovi[cilj[i]] := max3(redovi[cilj[i] - 1],redovi[cilj[i]],0) + 5;
    end;

  rjesenje := redovi[1];
  for i := 2 to broj_redova do
    if redovi[i] > rjesenje then
      rjesenje := redovi[i];
end;

procedure ispisi_rjesenje;
begin
  assign(f,OUTPUT_FILE);
  rewrite(f);
  writeln(f,rjesenje);
  close(f);
end;

begin
  ucitaj_podatke;
  rijesi;
  ispisi_rjesenje;
end.
