
/*
Regional Competition 2002, Seniors
Problem IT, Solution in C
*/

#include <stdio.h>

#define INPUT_FILE  "it.in"
#define OUTPUT_FILE "it.out"

int potez[21][2];
int ploca[7][6];
int pobjednik,u_potezu;
FILE *file;

void ucitaj_podatke(void)
{
  int i;

  file = fopen(INPUT_FILE,"r");
  for (i = 0;i < 21;++i)
  {
    fscanf(file,"%d%d",&potez[i][0],&potez[i][1]);
    --potez[i][0];
    --potez[i][1];
  }
  fclose(file);
}

int gotovo(void)
{
  int i,j,k,l;
  int stupac,redak;
  int tko,dobro;
  int smjer[4][2] = {{0,1},{1,1},{1,0},{1,-1}};

  for (i = 0;i < 7;++i)
    for (j = 0;j < 6;++j)
    {
      tko = ploca[i][j];
      if (!tko)
        continue;

      for (k = 0;k < 4;++k)
      {
        stupac = i + 3 * smjer[k][0];
        redak = j + 3 * smjer[k][1];
        if (stupac < 0 || stupac > 6 || redak < 0 || redak > 5)
          continue;

        dobro = 1;
        for (l = 1;l <= 3;++l)
          if (ploca[i + l * smjer[k][0]][j + l * smjer[k][1]] != tko)
          {
            dobro = 0;
            break;
          }
        if (dobro)
        {
          pobjednik = tko;
          return 1;
        }
      }
    }

  return 0;
}

void rijesi(void)
{
  int i,j;
  int prvo_prazno[7];

  for (i = 0;i < 7;++i)
  {
    for (j = 0;j < 6;++j)
      ploca[i][j] = 0;
    prvo_prazno[i] = 0;
  }
  pobjednik = 0;

  for (i = 0;i < 21;++i)
  {
    u_potezu = i + 1;
    for (j = 0;j < 2;++j)
    {
      ploca[potez[i][j]][prvo_prazno[potez[i][j]]] = j + 1;
      ++prvo_prazno[potez[i][j]];
      if (gotovo())
        return;
    }
  }
}

void ispisi_rjesenje(void)
{
  file = fopen(OUTPUT_FILE,"w");
  if (!pobjednik)
    fprintf(file,"remi\n");
  else
    fprintf(file,"%s %d\n",(pobjednik == 1 ? "mirko" : "slavko"),u_potezu);
  fclose(file);
}

int main(void)
{
  ucitaj_podatke();
  rijesi();
  ispisi_rjesenje();

  return 0;
}
