
(*
Regional Competition 2002, Seniors
Problem IT, Solution in Pascal
*)

program _it;
const
  INPUT_FILE  = 'it.in';
  OUTPUT_FILE = 'it.out';
var
  potez : array [1..21,1..2] of integer;
  ploca : array [1..7,1..6] of integer;
  pobjednik,u_potezu : integer;
  f : text;

procedure ucitaj_podatke;
var
  i : integer;
begin
  assign(f,INPUT_FILE);
  reset(f);
  for i := 1 to 21 do
    readln(f,potez[i][1],potez[i][2]);
  close(f);
end;

function gotovo : boolean;
const
  smjer : array [1..4,1..2] of integer = ((0,1),(1,1),(1,0),(1,-1));
var
  i,j,k,l : integer;
  stupac,redak : integer;
  tko : integer;
  dobro : boolean;
begin
  for i := 1 to 7 do
    for j := 1 to 6 do
      begin
        tko := ploca[i][j];
        if tko = 0 then
          continue;
        for k := 1 to 4 do
          begin
            stupac := i + 3 * smjer[k][1];
            redak := j + 3 * smjer[k][2];
            if (stupac < 1) or (stupac > 7) or (redak < 1) or (redak > 6) then
              continue;
            dobro := true;
            for l := 1 to 3 do
              if ploca[i + l * smjer[k][1],j + l * smjer[k][2]] <> tko  then
                begin
                  dobro := false;
                  break;
                end;
            if dobro then
              begin
                pobjednik := tko;
                gotovo := true;
                exit;
              end;
          end;
      end;
  gotovo := false;
end;

procedure rijesi;
var
  i,j : integer;
  prvo_prazno : array [1..7] of integer;
begin
  for i := 1 to 7 do
    begin
      for j := 1 to 6 do
        ploca[i,j] := 0;
      prvo_prazno[i] := 1;
    end;
  pobjednik := 0;

  for i := 1 to 21 do
    begin
      u_potezu := i;
      for j := 1 to 2 do
        begin
          ploca[potez[i,j],prvo_prazno[potez[i,j]]] := j;
          inc(prvo_prazno[potez[i,j]]);
          if gotovo then
            exit;
        end;
    end;
end;

procedure ispisi_rjesenje;
begin
  assign(f,OUTPUT_FILE);
  rewrite(f);
  if pobjednik = 0 then
    writeln(f,'remi');
  if pobjednik = 1 then
    writeln(f,'mirko ',u_potezu);
  if pobjednik = 2 then
    writeln(f,'slavko ',u_potezu);
  close(f);
end;

begin
  ucitaj_podatke;
  rijesi;
  ispisi_rjesenje;
end.
