
(*
Croatia 2003
Croatian Olympiad in Informatics
Problem MREZA, Programming language Pascal
*)

program mreza;
var
 inn,out:text;
 n,i,j,a,b,pi,pj,px,py,maxi,min:longint;
 c:char;
 x,y,x1,x2,y1,y2:array[0..8000] of longint;
begin
 assign (inn,'mreza.in');
 assign (out,'mreza.out');
 reset (inn);
 readln (inn,a,b);
 readln (inn,n);
 for i:=1 to n do
    begin
     read (inn,c);
     x[i]:=x[i-1];
     y[i]:=y[i-1];
     case c of
         'R':x[i]:=x[i-1]+1;
         'L':x[i]:=x[i-1]-1;
         'U':y[i]:=y[i-1]+1;
         'D':y[i]:=y[i-1]-1;
        end;
    end;
 close (inn);

 x1[n]:=x[n];
 x2[n]:=x[n];
 y1[n]:=y[n];
 y2[n]:=y[n];
 maxi:=n-1;
 for i:=n-1 downto 1 do
    begin
     if (x[i]>a) or (x[i]<0) or (y[i]>b) or (y[i]<0) then maxi:=i-1;

     if x[i]>x2[i+1] then x2[i]:=x[i] else x2[i]:=x2[i+1];
     if x[i]<x1[i+1] then x1[i]:=x[i] else x1[i]:=x1[i+1];
     if y[i]>y2[i+1] then y2[i]:=y[i] else y2[i]:=y2[i+1];
     if y[i]<y1[i+1] then y1[i]:=y[i] else y1[i]:=y1[i+1];
    end;

 min:=maxlongint;
 for i:=0 to maxi do for j:=i+1 to n do
    begin
     px:=x[i]-x[j];
     py:=y[i]-y[j];
     if (j=n) or ((px+x1[j+1]>=0) and (px+x2[j+1]<=a) and
        (py+y1[j+1]>=0) and (py+y2[j+1]<=b)) then if
        (a-x[n]-px+b-y[n]-py<min) then
        begin
         min:=a-x[n]-px+b-y[n]-py;
         pi:=i;
         pj:=j;
        end;
    end;

 rewrite (out);
 writeln (out,pi+1,' ',pj);
 close (out);
end.
