
/*
Croatia 2003
Final Exam - Second day
Problem TRGOVAC, Programming language C++
*/

#include <algorithm>
#include <vector>

#include "trgovac.h"

using namespace std;

int n;
int result[1000];

vector< int > order;

void output() {
   copy( order.begin(), order.end(), &result[1] );
   Gotovo( result );
}

void solve() {
   int i, l, r, m;
   order.push_back( 1 );
   for( i = 2; i <= n; ++i ) {
      if( Pitaj( i, order.front() ) == i ) {
         order.insert( order.begin(), i );
         continue;
      }
      if( Pitaj( order.back(), i ) == order.back() ) {
         order.insert( order.end(), i );
         continue;
      }
      l = 0; r = i-1;
      while( r - l > 1 ) {
         m = (l+r) / 2;
         if( Pitaj( i, order[m] ) == i ) r = m; else l = m;
      }
      order.insert( order.begin() + l + 1, i );
   }
}

int main( void ) {
   n = Init();
   solve();
   output();
   return 0;
}
