
(*
Croatia 2003
Final Exam - Second day
Problem TRGOVAC, Programming language Pascal
*)

uses trgovac;

const MAXGRADOVA = 1000;

var broj_gradova : integer;
    rjesenje : array[0..MAXGRADOVA] of integer;

procedure solve;
var odgovor, left, right, mid, i, grad : integer;
begin
  { prvo stavljamo gradove 1 i 2 u listu }
  odgovor:=Pitaj (1, 2);
  if (odgovor=1) then
    begin
    { strelica ide iz 1-->2 }
    rjesenje[0]:=1; rjesenje[1]:=2;
    end
  else
    begin
    { strelica ide iz 2-->1 }
    rjesenje[0]:=2; rjesenje[1]:=1;
    end;

  { i sada redom dodajemo gradove binary searchom }
  for grad:=3 to broj_gradova do
    begin
    { prvo provjera za gradove koji su trenutno na rubu }
    odgovor:=Pitaj (grad, rjesenje[0]);
    if (odgovor = grad) then
      begin
      { znaci strelica ide grad-->rjesenje[0], tj.
        grad moze biti novi pocetak liste }
      for i:=grad-1 downto 1 do
        rjesenje[i]:=rjesenje[i-1];
      rjesenje[0]:=grad;
      continue;
      end;

    odgovor:=Pitaj (grad, rjesenje[grad-2]);
    if (odgovor = rjesenje[grad-2]) then
      begin
      { znaci strelica ide rjesenje[grad-2]-->grad, tj.
        grad moze biti novi kraj liste }
      rjesenje[grad-1]:=grad;
      continue;
      end;

    { dakle strelice zasad idu ovako:
      rjesenje[0] --> grad i grad-->rjesenje[grad-2]
      binary searchom trazimo 2 uzastopna grada x i y t.d.
      x-->grad-->y  (x i y imaju uzastone indexe u rjesenje) }
    left:=0; right:=grad-2;
    while (right-left > 1) do
      begin
      mid:=(left+right) div 2;
      odgovor:=Pitaj (grad, rjesenje[mid]);
      if (odgovor = grad) then
        begin
        { strelice idu rjesenje[0]-->grad-->rjesenje[mid] }
        right:=mid;
        end
      else
        begin
        { // strelica ide rjesenje[mid]-->grad-->rjesenje[grad-2] }
        left:=mid;
        end;
      end;

    { gradovi rjesenje[left] i rjesenje[right] su x i y
      sad samo uguraj grad izmedju njih u listu }
    for i:=grad-1 downto left+1 do
      rjesenje[i]:=rjesenje[i-1];
    rjesenje[left+1]:=grad;
    end;
end;

begin
  broj_gradova:=Init();
  solve();
  Gotovo (rjesenje);
end.
