
/*
Croatia 2003
National Competition - First day - Juniors
Problem LUKA, Programming language C
*/

#include <stdio.h>
#include <stdlib.h>

#define INFILE          "luka.in"
#define OUTFILE         "luka.out"

int luka[2];

int main(void)
{
        FILE *in, *out;
        int i;
        char c;
        int npot;
        int x=0, y=0, bio=0;

        in=fopen (INFILE, "r");
        fscanf (in, "%d%d", luka, luka+1);
        fscanf (in, "%d", &npot);

        out=fopen (OUTFILE,"w");
        for (i=0; i<npot; i++)
        {
                if(abs (luka[0]-x)<=1 && abs (luka[1]-y)<=1)
                {
                        fprintf (out,"%d\n",i);
                        bio=1;
                }

                fscanf (in," %c",&c);
                switch (c)
                {
                        case 'S': y++; break;
                        case 'J': y--; break;
                        case 'I': x++; break;
                        case 'Z': x--; break;
                }
        }

        if (abs (luka[0]-x)<=1 && abs (luka[1]-y)<=1)
        {
                fprintf (out,"%d\n",i);
                bio=1;
        }

        if(!bio)
                fprintf (out, "-1\n");

        fclose (in);
        fclose (out);

        return 0;
}
