
/*
Croatia 2003
National Competition - First day - Juniors
Problem TRAJEKT, Programming language C++
*/

#include <cstdio>
#include <iostream>
#include <list>
#include <queue>
#include <string>
#include <vector>

#define INF 1000000

using namespace std;

int voznja, cekanje;
int n, m;
list<int> polasci_a, polasci_b;
priority_queue< int, vector<int>, greater<int> > trajekti_a, trajekti_b;

void input() {
   string tmp;
   int i, hh, mm;
   cin >> voznja >> cekanje;
   cin >> n;
   for( i = 0; i < n; ++i ) {
      cin >> tmp;
      sscanf( tmp.c_str(), "%d:%d", &hh, &mm );
      polasci_a.push_back( hh * 60 + mm );
   }
   cin >> m;
   for( i = 0; i < m; ++i ) {
      cin >> tmp;
      sscanf( tmp.c_str(), "%d:%d", &hh, &mm );
      polasci_b.push_back( hh * 60 + mm );
   }
   polasci_a.push_back( INF );
   polasci_b.push_back( INF );
   trajekti_a.push( INF );
   trajekti_b.push( INF );
}

int solve() {
   int rez = 0;
   for( int i = 0; i < n+m; ++i ) {
      if( polasci_a.front() < polasci_b.front() ) {

         if( trajekti_a.top() > polasci_a.front() ) rez++;
         else trajekti_a.pop();

         trajekti_b.push( polasci_a.front() + voznja + cekanje );

         polasci_a.pop_front();
      } else {

         if( trajekti_b.top() > polasci_b.front() ) rez++;
         else trajekti_b.pop();

         trajekti_a.push( polasci_b.front() + voznja + cekanje );

         polasci_b.pop_front();
      }
   }
   return rez;
}

int main( void ) {
   freopen( "trajekt.in", "rt", stdin );
   freopen( "trajekt.out", "wt", stdout );

   input();
   cout << solve() << endl;

   fclose( stdout );
   fclose( stdin );
   return 0;
}
