
/*
Croatia 2003
National Competition - Second day - Juniors
Problem GALERIJA, Programming language C
*/

#include <stdio.h>

#define IN_FILE                 "galerija.in"
#define OUT_FILE                "galerija.out"

#define MAX_N                   1000

int n, m;
char g[MAX_N][MAX_N + 1];
int broj_slika;

void read_input ( void )
{
	int i;
        FILE *fp = fopen (IN_FILE, "r");

        fscanf (fp, "%d %d\n", &n, &m);
        for (i=0; i<n; i++)
                fscanf (fp, "%s\n", g[i]);

        fclose (fp);
}


void find ( void )
{
	int i, j;
	int s1, s2;

        for (i=0; i<n - 1; i++)
	{
                s1=s2=0;
                for (j=0; j<m; j++)
		{
                        if (g[i][j]=='X' && g[i + 1][j]=='.')
				s1++;
			else
			{
                                broj_slika+=s1/2;
                                s1=0;
			}
                        if (g[i][j]=='.' && g[i+1][j]=='X')
				s2++;
			else
			{
				broj_slika += s2 / 2;
				s2 = 0;
			}
		}
        }

        for (j=0; j<m-1; j++)
	{
                s1=s2=0;
                for (i=0; i<n; i++)
		{
                        if (g[i][j]=='X' && g[i][j+1]=='.')
				s1++;
			else
			{
                                broj_slika+=s1/2;
                                s1=0;
			}
                        if (g[i][j]=='.' && g[i][j+1]=='X')
				s2++;
			else
			{
                                broj_slika+=s2/2;
                                s2=0;
			}
		}
        }
}


void write_output ( void )
{
        FILE *fp = fopen (OUT_FILE, "w");

        fprintf (fp, "%d\n", broj_slika);

        fclose (fp);
}


int main ( void )
{
	read_input();
	find();
	write_output();

	return 0;
}
