
/*
Croatia 2003
National Competition - Second day - Juniors
Problem GALERIJA, Programming language C++
*/

#include <cstdio>
#include <iostream>
#include <string>
#include <vector>

using namespace std;

int n, m;
int rez;
vector<string> map;

void input() {
   int i;
   scanf( "%d%d", &n, &m );
   map.resize( n );
   for( i = 0; i < n; ++i ) cin >> map[i];
}

void solve() {
   int i, j, k = 0;
   for( i = 0; i < n-1; ++i )
      for( j = 0; j < m; ++j )
         if( map[i][j] == 'X' && map[i+1][j] == '.' ) k++;
         else { rez += k/2; k = 0; }
   for( i = 1; i < n; ++i )
      for( j = 0; j < m; ++j )
         if( map[i][j] == 'X' && map[i-1][j] == '.' ) k++;
         else { rez += k/2; k = 0; }
   for( j = 0; j < m-1; ++j )
      for( i = 0; i < n; ++i )
         if( map[i][j] == 'X' && map[i][j+1] == '.' ) k++;
         else { rez += k/2; k = 0; }
   for( j = 1; j < m; ++j )
      for( i = 0; i < n; ++i )
         if( map[i][j] == 'X' && map[i][j-1] == '.' ) k++;
         else { rez += k/2; k = 0; }
}

int main( void ) {
   freopen( "galerija.in", "rt", stdin );
   freopen( "galerija.out", "wt", stdout );

   input();
   solve();
   cout << rez << endl;

   fclose( stdin );
   fclose( stdout );
   return 0;
}
