
/*
Croatia 2003
National Competition - Second day - Juniors
Problem JOKER, Programming language C++
*/

#include <algorithm>
#include <cstdio>
#include <vector>

using namespace std;

int n;
typedef pair< int, int > par;
vector< par > potezi;
vector< par > rez;

void input() {
   int i, m, a, b;
   scanf( "%d%d", &n, &m );
   for( i = 0; i < m; ++i ) {
      scanf( "%d%d", &a, &b );
      potezi.push_back( make_pair< int, int > (a, b) );
   }
   sort( potezi.begin(), potezi.end() );
   reverse( potezi.begin(), potezi.end() );
}

int ok() {
   for( vector<par>::iterator i = potezi.begin(); i != potezi.end(); i++ )
      if( n <= (*i).second ) return 0;
      else n -= (*i).second - (*i).first + 1;
   return n == 1;
}

int main( void ) {
   freopen( "joker.in", "rt", stdin );
   freopen( "joker.out", "wt", stdout );

   input();
   if( !ok() ) printf( "-1\n" );
   else for( vector<par>::iterator i = potezi.begin(); i != potezi.end(); i++ )
      printf( "%d %d\n", (*i).first, (*i).second );

   fclose( stdin );
   fclose( stdout );
   return 0;
}
