
/*
Croatia 2003
National Competition - Second day - Juniors
Problem VOKI, Programming language C++
*/

#include <cstdio>
#include <iostream>
#include <string>
#include <vector>

#define INF 1000000

using namespace std;

template< class tip >
class polje {
   private:
   typedef vector< vector< tip > > mapa;
   mapa a;
   public:
   void init( int n, int m, tip val ) {
      a.resize( n );
      for( mapa::iterator i = a.begin(); i != a.end(); ++i ) {
         (*i).resize( m );
         for( vector< tip >::iterator j = (*i).begin(); j != (*i).end(); ++j )
            (*j) = val;
      }
   }
   inline tip & operator () ( int i, int j ) { return a[i][j]; }
};

int i, j;
string voki, toki;
polje< int > p;
polje< int > opt;

int main( void ) {
   freopen( "voki.in", "rt", stdin );
   freopen( "voki.out", "wt", stdout );

   cin >> voki >> toki;
   p.init( toki.size()+1, 26, toki.size() );

   for( i = toki.size()-1; i >= 0; --i )
      for( j = 0; j < 26; ++j )
         if( toki[i] == j + 'a' ) p( i, j ) = i;
         else p( i, j ) = p( i+1, j );

   opt.init( voki.size()+1, toki.size()+2, INF );

   for( i = 0; i < voki.size(); ++i ) opt( i, toki.size() ) = 1;
   for( i = 0; i < voki.size(); ++i ) opt( i, toki.size()+1 ) = 0;

   for( i = voki.size()-1; i >= 0; --i )
      for( j = toki.size()-1; j >= 0; --j )
         opt( i, j ) = opt( i+1, j ) <? opt( i+1, p(j,voki[i]-'a')+1 ) + 1;

   cout << opt( 0, 0 ) << endl;

   fclose( stdout );
   fclose( stdin );
   return 0;
}
