
(*
Croatia 2003
National Competition - First day - Seniors
Problem SUMA, Programming language Pascal
*)

program suma_pas(input, output);
uses math;

const maxn = 31000;

type vektor =
record
	 x, y : longint;
	 kut  : double;
end;

var
	fin, fout : text;
	v			: array[0..maxn-1] of vektor;
	suma		: array[0..maxn] of vektor;
	i, n, j, k, l, tx, ty,
	nk, next, pamti_j : longint;
	curx, cury, maxx, maxy : int64;

procedure Sort(l, r: Integer);
var
	i, j: integer;
	x, y: vektor;
begin
	i := l; j := r; x := v[(l+r) DIV 2];
	repeat
		while v[i].kut < x.kut do i := i + 1;
		while x.kut < v[j].kut do j := j - 1;
		if i <= j then
		begin
			y := v[i]; v[i] := v[j]; v[j] := y;
			i := i + 1; j := j - 1;
		end;
	until i > j;
	if l < j then Sort(l, j);
	if i < r then Sort(i, r);
end;

begin
	assign(fin, 'suma.in'); assign(fout, 'suma.out');
	reset(fin); rewrite(fout);

	readln(fin, n);

	for i:=0 to n-1 do begin
		readln(fin, v[i].x, v[i].y);

	if ((v[i].x <> 0) or (v[i].y <> 0)) then
		v[i].kut := arctan2(v[i].y, v[i].x)
	else
		v[i].kut := 1000.0;
	end;

	(* sortiraj po kutu *)

	Sort (0, n - 1);
	(* sve vektore istog smjera svedi u jedan *)
	nk := 0;
	i := 0; k := 0;
	while (i < n) do begin
		if (v[i].kut = 1000.0) then break;

		pamti_j := n;
		for j:=i+1 to n-1 do
			if (v[i].kut <> v[j].kut) then begin
				pamti_j := j;
				break;
			end;

		j := pamti_j;
		tx := 0; ty := 0;

		for l:=i to j-1 do begin
			tx := tx + v[l].x;
			ty := ty + v[l].y;
		end;

		v[k].x := tx;
		v[k].y := ty;
		k := k + 1;

		if (j > i+1) then begin
			nk := nk + 1;
		end;

		i := j;
	end;
	n := k;

	(* zbrajanje *)

	suma[0].x := 0; suma[0].y := 0;

	for i:=1 to n do begin
		suma[i].x := suma[i-1].x + v[i-1].x;
		suma[i].y := suma[i-1].y + v[i-1].y;
	end;

	maxx := 0;
	maxy := 0;

	i := 0; j := 0;
	while (i < n) do begin
		if (j >= i) then begin
			curx := suma[j+1].x - suma[i].x;
			cury := suma[j+1].y - suma[i].y;
		end else begin
			curx := suma[n].x - suma[i].x + suma[j+1].x;
			cury := suma[n].y - suma[i].y + suma[j+1].y;
		end;

		if (curx*curx + cury*cury = maxx*maxx + maxy*maxy) then begin
			maxx := curx; maxy := cury;
		end
		else if (curx*curx + cury*cury > maxx*maxx + maxy*maxy) then begin
			maxx := curx; maxy := cury;
		end;

		next := (j + 1) mod n;
		if (v[i].x * v[next].y > v[i].y * v[next].x) then
			j := next
		else begin
			if (j = i) then j := next;
			i := i + 1;
		end;
	end;

	writeln(fout, maxx*maxx + maxy*maxy);

	close(fin); close(fout);
end.
