
/*
Croatia 2003
National Competition - First day - Seniors
Problem UHODE, Programming language C++
*/

#include <complex>
#include <cstdio>
#include <iostream>
#include <string>
#include <vector>

using namespace std;

int i, j, n, korak, cuo = 0;

class osoba { public: int x, y; bool cula; } kreso;

typedef vector< osoba >::iterator IT;
vector< osoba > uhode;
string put;

inline void cuje( osoba &a ) {
   if( abs( a.x - kreso.x ) > 1 ) return;
   if( abs( a.y - kreso.y ) > 1 ) return;
   a.cula = true;
   cuo = 1;
}

int main( void ) {
   freopen( "uhode.in", "rt", stdin );
   freopen( "uhode.out", "wt", stdout );

   kreso.x = kreso.y = 0;
   cin >> n;
   uhode.resize( n );
   for( i = 0; i < uhode.size(); ++i )
      cin >> uhode[i].x >> uhode[i].y;
   cin >> n >> put;

   for( IT x = uhode.begin(); x != uhode.end(); ++x ) cuje( *x );
   for( korak = 0; korak < n; ++korak ) {
      if( put[korak] == 'J' ) kreso.y--;
      if( put[korak] == 'S' ) kreso.y++;
      if( put[korak] == 'Z' ) kreso.x--;
      if( put[korak] == 'I' ) kreso.x++;
      for( IT x = uhode.begin(); x != uhode.end(); ++x ) cuje( *x );
   }
   for( i = 0; i < uhode.size(); ++i )
      if( uhode[i].cula )
         printf( "%d\n", i + 1 );

   if( !cuo ) printf( "-1\n" );

   fclose( stdout );
   fclose( stdin );
   return 0;
}
