
/*
Croatia 2003
National Competition - Second day - Seniors
Problem MRAVI, Programming language C
*/

#include <stdio.h>

#define INFILE          "mravi.in"
#define OUTFILE         "mravi.out"
#define MAXAUTO         1000000 + 1
#define MAXRUPA         1000000 + 1
#define BRZINA          1
#define BESKONACNO      1000000000

int l, m, n, broj_rupa;
int rupa[MAXRUPA];
int maxL, maxR;
int rjesenje=BESKONACNO;

void unos ( void )
{
        FILE *fin;
        int i, time;

        fin=fopen (INFILE, "r");
        fscanf (fin, "%d%d", &l, &broj_rupa);
        for (i=1; i<=broj_rupa; i++)
                fscanf (fin, "%d", rupa+i);

        fscanf (fin, "%d", &m);
        maxL=0;
        maxR=0;
        for (i=1; i<=m; i++)
	{
                fscanf (fin, "%d", &time);
                if (time>maxL) maxL=time;
	}

        fscanf (fin, "%d", &n);
        for (i=1; i<=n; i++)
	{
                fscanf (fin, "%d", &time);
                if (time>maxR) maxR=time;
	}

        rupa[0]=0;
        rupa[broj_rupa+1]=l;

        fclose (fin);
}

void kombiniraj ( void )
{
	int i;
        int vrijemeL, vrijemeR, vrijeme;

        for (i=0; i<=broj_rupa+1; i++)
	{
                vrijemeL=maxL+rupa[i];
                vrijemeR=maxR-rupa[i]+l;
                if (vrijemeL>vrijemeR)
                        vrijeme=vrijemeL;
                else
                        vrijeme=vrijemeR;
                if (rupa[i]>l-rupa[i])
                        vrijeme=vrijeme+rupa[i];
                else
                        vrijeme=vrijeme+l-rupa[i];
                if (vrijeme<rjesenje)
                        rjesenje=vrijeme;
	}
}

void ispis ( void )
{
	FILE *fout;

        fout=fopen (OUTFILE, "w");
        fprintf (fout, "%d\n", rjesenje);
        fclose  (fout);
}

int main ( void )
{
	unos();
	kombiniraj();
	ispis();

        return 0;
}
