
(*
Croatia 2003
National Competition - Second day - Seniors
Problem TOKI, Programming language Pascal
*)

program toki;

const MAXLEN = 2100;
      INFTY = 15000;

type ttbl = record
             koliko, unatrag, di_je_znak : integer;
          end;

var prvi, drugi : array[0..MAXLEN] of char;
    tbl : array[0..maxlen, 0..maxlen] of ttbl;
    len1, len2 : longint;
    di_je_zadnji : array[0..MAXLEN, 'a'..'z'] of longint;

procedure load_data;
var f : text;
begin
    assign(f, 'toki.in');
    reset(f);
    len1:=0;
    len2:=0;
    while not(eoln(f)) do
    begin
        read(f, prvi[len1]);
        len1 := len1+1;
    end;
    readln(f);
    while not(eoln(f)) do
    begin
        read(f, drugi[len2]);
        len2:=len2+1;
    end;
    close(f);
end;

procedure rek (i, j : integer);
begin

    // dinamika

	// vec sam bio tu
	if tbl[i][j].koliko<>0 then exit;

	// ako je drugi string prazan, rjesenje je bilo koji znak prvog
	if j=0 then
	begin
		tbl[i][0].koliko:=1;
        tbl[i][0].di_je_znak:=0;
        tbl[i][0].unatrag:=-1;
		exit;
	end;

	// ako se prvi string sastoji od samo jednog znaka, onda imamo rjesenje akko ga nema u drugom nizu
    if i=0 then
    begin
        if di_je_zadnji[j][prvi[0]]=0 then
		begin
			tbl[0][j].koliko:=1;
            tbl[0][j].di_je_znak:=0;
            tbl[0][j].unatrag:=-1;
            exit;
		end else
		begin
			tbl[0][j].koliko:=INFTY;
            exit;
		end;
    end;

	// ako nema tog slova uopce
	if di_je_zadnji[j][prvi[i]] = 0 then
	begin
		tbl[i][j].koliko:=1;
        tbl[i][j].unatrag:=-1;
        tbl[i][j].di_je_znak:=i;
		exit;
    end;

	// sad opceniti slucaj: i<>0 & j<>0 & di_je_zadnji<>0
	// ako je bolje ne dodati zadnje slovo
	rek(i-1, j);
    rek (i-1, di_je_zadnji[j][prvi[i]]-1);

	if tbl[i-1][j].koliko < tbl[i-1][di_je_zadnji[j][prvi[i]]-1].koliko+1 then
	begin
		// ako je bolje ostavit staru rijec
		tbl[i][j].koliko:=tbl[i-1][j].koliko;
		tbl[i][j].di_je_znak:=-1;
		tbl[i][j].unatrag:=j;
	end	else
	begin
		// ako je bolje dodat slovo prvi[i]
		tbl[i][j].koliko:=tbl[i-1][di_je_zadnji[j][prvi[i]]-1].koliko+1;
		tbl[i][j].di_je_znak:=i;
		tbl[i][j].unatrag:=di_je_zadnji[j][prvi[i]]-1; // kud se treba vrati
	end;
end;

procedure solve;
var i, j : longint;
    c : char;
begin
    for c:='a' to 'z' do di_je_zadnji[0][c]:=0;
	for i:=1 to len2 do
		for c:='a' to 'z'do
        begin
			di_je_zadnji[i][c]:=di_je_zadnji[i-1][c];
			if drugi[i-1]=c then
			begin
				di_je_zadnji[i][c]:=i;
			end;
		end;
	rek (len1-1, len2);
end;

procedure write_solution;
var f : text;
    rje: array[0..MAXLEN] of char;
    i, j, cur : longint;
begin
    assign(f, 'toki.out');
    rewrite(f);
    cur := 0;
    i:=len1-1;
    j:=len2;
    writeln(f, tbl[i][j].koliko);
	if tbl[i][j].di_je_znak<>-1 then
    begin
        rje[cur]:=prvi[tbl[i][j].di_je_znak];
        inc(cur);
    end;
	while (tbl[i][j].unatrag <> -1) do
    begin
		j:=tbl[i][j].unatrag;
        dec(i);
		if tbl[i][j].di_je_znak<>-1 then
        begin
			rje[cur]:=prvi[tbl[i][j].di_je_znak];
            inc(cur);
        end;
	end;
    dec(cur);
    while cur>=0 do
    begin
		write(f, rje[cur]);
        dec(cur);
    end;
    writeln(f);
	close(f);
end;

begin
    load_data;
	solve;
	write_solution;
end.
