
/*
Croatia 2003
Regional Competition - Juniors
Problem MO, Programming language C
*/

#include <stdio.h>

#define INPUT_FILE  "mo.in"
#define OUTPUT_FILE "mo.out"

#define MAX_POLJA 100

int broj_polja;
int polje[MAX_POLJA + 2];

void ukloni(int pozicija,int boja)
{
  int i;
  int druga_boja;
  int kraj;

  if (boja == 1)
    druga_boja = 2;
  else
    druga_boja = 1;

  if (polje[pozicija - 1] == druga_boja)
  {
    kraj = pozicija - 1;
    while (1)
    {
      if (polje[kraj - 1] != druga_boja)
        break;
      if (--kraj < 1)
        break;
    }

    if (polje[kraj - 1] == boja)
      for (i = kraj;i <= pozicija - 1;++i)
        polje[i] = 0;
  }

  if (polje[pozicija + 1] == druga_boja)
  {
    kraj = pozicija + 1;
    while (1)
    {
      if (polje[kraj + 1] != druga_boja)
        break;
      if (++kraj > broj_polja)
        break;
    }

    if (polje[kraj + 1] == boja)
      for (i = pozicija + 1;i <= kraj;++i)
        polje[i] = 0;
  }
}

int main(void)
{
  int i;
  int broj_poteza;
  int potez;
  int bijeli_igra;
  int broj_bijelih,broj_crnih;
  FILE *file;

  file = fopen(INPUT_FILE,"r");
  fscanf(file,"%d%d",&broj_polja,&broj_poteza);

  for (i = 0;i <= broj_polja + 1;++i)
    polje[i] = 0;
  bijeli_igra = 1;

  for (i = 0;i < broj_poteza;++i)
  {
    fscanf(file,"%d",&potez);

    if (bijeli_igra)
    {
      polje[potez] = 1;
      ukloni(potez,1);
    }
    else
    {
      polje[potez] = 2;
      ukloni(potez,2);
    }

    bijeli_igra = !bijeli_igra;
  }

  fclose(file);

  file = fopen(OUTPUT_FILE,"w");
  broj_bijelih = broj_crnih = 0;
  for (i = 1;i <= broj_polja;++i)
    if (polje[i] == 1)
      ++broj_bijelih;
    else if (polje[i] == 2)
      ++broj_crnih;
  fprintf(file,"%d %d\n",broj_bijelih,broj_crnih);
  fclose(file);

  return 0;
}
