
(*
Croatia 2003
Regional Competition - Juniors
Problem PIZZA, Programming language Pascal
*)

program pizza;

const maxm = 20;
      maxn = 100;

var k, m, n, ukupno, max, i, j, r : longint;
    lok : array[1..maxm] of record x, y    : longint; end;
    neb : array[1..maxn] of record x, y, s : longint; end;
    bio : array[1..maxn] of longint;
    unutra : array[1..maxn, 1..maxm] of boolean;
    f : text;

procedure postavi(zadnji, jos : longint);
var i, j : longint;
begin
    for i:=zadnji+1 to m-jos do
    begin
        for j:=1 to n do if unutra[j, i] then
        begin
            if bio[j]=0 then ukupno:=ukupno+neb[j].s;
            bio[j] := bio[j]+1;
        end;

        if jos > 0 then postavi(i, jos-1) else
        if ukupno>max then max:=ukupno;

        for j:=1 to n do if unutra[j, i] then
        begin
            bio[j] := bio[j]-1;
            if bio[j]=0 then ukupno:=ukupno-neb[j].s;
        end;
    end;
end;

begin
    assign(f, 'pizza.in');
    reset(f);
    readln(f, k, r);
    readln(f, m);
    for i:=1 to m do readln(f, lok[i].x, lok[i].y);
    readln(f, n);
    for i:=1 to n do readln(f, neb[i].x, neb[i].y, neb[i].s);
    close(f);

    for i:=1 to n do
      for j:=1 to m do
        unutra[i, j] := sqr(neb[i].x-lok[j].x)+sqr(neb[i].y-lok[j].y)<=r*r;

    for i:=1 to n do bio[i]:=0;
    max := 0;
    ukupno := 0;
    postavi(0, k-1);

    assign(f, 'pizza.out');
    rewrite(f);
    writeln(f, max);
    close(f);
end.
