
/*
Croatia 2003
Regional Competition - Juniors
Problem SPOJ, Programming language C++
*/

#include <fstream>
#include <algorithm>

#define INFILE  "spoj.in"
#define OUTFILE "spoj.out"

using namespace std;

ifstream input(INFILE);
ofstream output(OUTFILE);

int main (void)
{
        int n;
        input >> n;

        int ukupno=0;
        for (int i=0; i<n; i++)
        {
                int h, m, t;
                char c;
                input >> h >> c >> m  >> t;
                ukupno+=t*5;
                if (h>=7 && h<19) ukupno+=5*min(19*60-h*60-m, t);
                else if (h<7 && h*60+m+t>=7*60) ukupno+=5*(h*60+m+t-7*60);
        }

        output << ukupno << endl;
        input.close();
        output.close();
        return 0;
}
