
/*
Croatia 2003
Regional Competition - Seniors
Problem IVICA, Programming language C
*/

#include <stdio.h>

#define INPUT_FILE  "ivica.in"
#define OUTPUT_FILE "ivica.out"
#define MAX_N 100

int main(void)
{
  int i,j;
  int n,m;
  int trenutna_pozicija;
  int poredak_prvi[MAX_N + 1],poredak_ukupno[MAX_N + 1];
  FILE *file;

  file = fopen(INPUT_FILE,"r");
  fscanf(file,"%d%d",&n,&m);
  for (i = 1;i <= n;++i)
  {
    fscanf(file,"%d",&trenutna_pozicija);
    for (j = i;j > trenutna_pozicija;--j)
      poredak_prvi[j] = poredak_prvi[j - 1];
    poredak_prvi[trenutna_pozicija] = i;
  }
  for (i = 1;i <= m;++i)
  {
    fscanf(file,"%d",&trenutna_pozicija);
    for (j = i;j > trenutna_pozicija;--j)
      poredak_ukupno[j] = poredak_ukupno[j - 1];
    poredak_ukupno[trenutna_pozicija] = poredak_prvi[m - i + 1];
  }
  fclose(file);

  file = fopen(OUTPUT_FILE,"w");
  fprintf(file,"%d\n%d\n%d\n",
          poredak_ukupno[1],poredak_ukupno[2],poredak_ukupno[3]);
  fclose(file);

  return 0;
}
