
/*
Zupanijsko natjecanje 2004
Srednjoskolska skupina - I. podskupina
Zadatak HAKER - Programski jezik C
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_N   100
#define MAX_M   5
#define MAX_LEN 8
#define MIN_LEN 3

int n;
char sifra[MAX_N][2 * MAX_LEN + 1];

int m;
char ime[MAX_M][MAX_LEN + 1];

int sol_m;
char sol_ime[MAX_M][MAX_LEN + 1];

void ucitaj(void)
{
    int i;

    scanf("%d\n", &n);
    for(i = 0; i < n; i++)
        scanf("%s\n", sifra[i]);
}


int smije_biti()
{
	int i, j;

	for(i = 0; i < m - 1; i++)
		for(j = i + 1; j < m; j++)
            if(strcmp(ime[i], ime[j]) == 0)
				return 0;

	return 1;
}

char t[MAX_LEN + 1];

void rijesi(int k)
{
    int l, i, j, x;
    int nista_novo = 0;

    if(k >= n)
    {
        if(sol_m == 0 || m < sol_m)
        {
			if(smije_biti())
			{
				sol_m = m;
				memcpy(sol_ime, ime, m * (MAX_LEN + 1) * sizeof(char));
			}
        }
        return;
    }

    // Provjeri je li ova sifra sastavljena od vec poznatih
    for(i = 0; nista_novo == 0 && i < m; i++)
        for(j = 0; j < m; j++)
            if(i != j)
            {
                strcpy(t, ime[i]);
                strcat(t, ime[j]);
                if(strcmp(t, sifra[k]) == 0)
                {
                    nista_novo = 1;
                    break;
                }
            }

    // Ako nema nista novo...
    if(nista_novo == 1)
    {
        rijesi(k + 1);
        return;
    }

    for(i = 0; i < m; i++)
    {
        l = (int) strlen(ime[i]);
        x = (int) strlen(sifra[k]) - l;
        if(m < MAX_M && x >= MIN_LEN && x <= MAX_LEN)
        {
            // Sifra pocinje s poznatim imenom
            if(strncmp(ime[i], sifra[k], l) == 0)
            {
                strcpy(ime[m++], sifra[k] + l);
                rijesi(k + 1);
                m--;
            }

            // Sifra zavrsava s poznatim imenom
            if(strcmp(ime[i], sifra[k] + strlen(sifra[k]) - l) == 0)
            {
                strncpy(ime[m], sifra[k], strlen(sifra[k]) - l);
                ime[m++][strlen(sifra[k]) - l] = '\0';
                rijesi(k + 1);
                m--;
            }
        }
    }

    if(m + 2 <= MAX_M)
    {
        l = (int) strlen(sifra[k]);
        for(i = MIN_LEN; i <= l - MIN_LEN; i++)
            if(i <= MAX_LEN && (l - i) <= MAX_LEN)
            {
                strncpy(ime[m], sifra[k], i);
                ime[m++][i] = '\0';
                strcpy(ime[m++], sifra[k] + i);
                rijesi(k + 1);
                m -= 2;
            }
    }
}

void ispisi(void)
{
    int i;

    qsort(sol_ime, sol_m, sizeof(sol_ime[0]), strcmp);

    printf("%d\n", sol_m);
    for(i = 0; i < sol_m; i++)
        printf("%s\n", sol_ime[i]);
}

int main(void)
{
    ucitaj();
    rijesi(0);
    ispisi();

    return 0;
}
