
/*
    Zupanijsko natjecanje 2004. / 1. podskupina
    3. zadatak - HAKER
    Rjesenje napisao Luka Kalinovcic (kalinov@mioc.hr)
*/

#include <algorithm>
#include <iostream>
#include <iterator>
#include <set>

using namespace std;

typedef unsigned int uint;
const uint max_imena=5, min_slova=3, max_slova=8;
set<string> sifre, rez;

void nadji( set<string>::iterator sifra, set<string> imena ) {
  if( imena.size() > max_imena ) return;

  if( sifra == sifre.end() ) {
    if( !rez.size() ) rez = imena;
    if(  rez.size() > imena.size() ) rez = imena;
    return;
  }
  string s = *sifra++;

  for( uint i = 0; i < s.size(); ++i ) {
    if( i < min_slova || s.size()-i < min_slova ) continue;
    if( i > max_slova || s.size()-i > max_slova ) continue;
    string ime1 = s.substr( 0, i );
    string ime2 = s.substr( i );
    if( ime1 == ime2 ) continue;

    set<string> novaimena = imena;
    novaimena.insert( ime1 );
    novaimena.insert( ime2 );
    nadji( sifra, novaimena );
  }
}

int main( void ) {
  uint n;
  for( cin >> n; n; --n ) { string x; cin >> x; sifre.insert( x ); }

  nadji( sifre.begin(), set<string>() );

  cout << rez.size() << endl;
  copy( rez.begin(), rez.end(), ostream_iterator<string> (cout, "\n") );

  return 0;
}
