
(*
    Zupanijsko natjecanje 2004 / 2. podskupina
    4. zadatak - PILOTI
    Rjesenje napisao Ivan Sikiric (isikiric@hotmail.com)

Opis algoritma:
Zadatak rjesavamo dinamickim programiranjem.
Primjetimo da su piloti sortirani po starosti.
Oznacimo sa S[i, j] ukupnu placu ako prvih "j" pilota zaposlimo tako da imamo
"i" zamjenika i "j-i" kapetana. Ne smije biti vise kapetana od zamjenika.
vrijedi:
S[0, 0] = 0
za j>0:
S[j, j]=S[j-1, j-1]+Y[j]
za j/2 < i < j
S[i, j]=min( S[i-1, j-1]+Y[j], S[i, j-1]+X[j] )
za paran j: S[j/2, j]=S[j/2, j-1]+X[j]
Rjesenje je S[n div 2, n].
Primjetimo da za racunanje podataka u j-tom stupcu trebamo samo podatke iz
(j-1)-og stupca, dakle ne moramo pamtiti cijelu tablicu nego samo 2 stupca.
Slozenost algoritma
vremenska:  O(n^2)
memorijska: O(n)
*)

program piloti;
const MAXN = 10000;
var staro, novo : array[0..MAXN] of longint;
    n, i, j, x, y : longint;
begin
    readln(n);
    novo[0]:=0;
    for j:=1 to n do
    begin
        for i:=j div 2 to j-1 do staro[i]:=novo[i];
        readln(x, y);
        for i:=j div 2 + 1 to j do
            if (staro[i-1]+y<staro[i]+x)or(i=j) then novo[i]:=staro[i-1]+y
                                                else novo[i]:=staro[i]+x;
        if j mod 2 = 0 then novo[j div 2] := staro[j div 2]+x;
    end;
    writeln(novo[n div 2]);
end.
