
(*
  Croatia 2005 / Final Exam #1
  Problem ZMAJ

  Prvo na sto pomislimo kao rjesenje ovog zadatka bi bila jednostavna
  simulacija.
  No sama simulacija, koju i nije bas tako lako iskodirat, nije dovoljna da bi
  radila za sve primjere u zadanom vremenskom ogranicenju.
  Zbog toga za rjesavanje ovog zadatka je potrebno koristiti matrice, te brzo
  potenciranje istih.
*)

var mat: array[0..26, 0..26, 0..50] of integer; //varijable na 50
    n, mode: integer;
    prog: array[0..200] of string[100];
    kraj_bloka: array[0..200] of integer;

procedure reset(k: integer);
var i, j: integer;
begin
    for i := 0 to 26 do begin
       for j := 0 to 26 do
          mat[i, j, k] := 0;
       mat[i, i, k] := 1;
    end;
end;

procedure mnozi(a, b, c: integer);
var i, j, k: integer;
begin
    for i := 0 to 26 do
      for j := 0 to 26 do begin
          mat[i, j, c] := 0;
          for k := 0 to 26 do mat[i, j, c] := (((mat[i, j, c] + mat[i, k, a]*mat[k, j, b]) mod mode) + mode) mod mode;
      end;
end;

procedure potenciraj(kol, a, b: integer);
var i, j, k: integer;
begin
    if (kol > 1) then begin
       potenciraj(kol div 2, a, b);
       k := 25;
       if (kol mod 2 = 1) then k := 24;
       mnozi(b, b, k);
       if (kol mod 2 = 1) then mnozi(a, k, 25);
       k := 25;
       for i := 0 to 26 do
          for j := 0 to 26 do
             mat[i, j, b] := mat[i, j, 25];
    end else begin
       for i := 0 to 26 do
          for j := 0 to 26 do
             mat[i, j, b] := mat[i, j, a];
    end;
end;

procedure ubij_whitespace;
var i, j: integer;
    tre: string[200];
begin
    for i := 0 to n do begin
       tre := '';
       for j := 1 to length(prog[i]) do
          if (prog[i][j] <> ' ') then tre := tre+prog[i][j];
       prog[i] := tre;
    end;
end;

procedure ucitaj;
var i, k_stack: integer;
    stack: array[0..200] of integer;
begin
    mode := 10000;
    mat[26, 0, 50] := 1;
    readln(prog[n]);
    while (prog[n] <> 'STOP') do begin n:= n+1; readln(prog[n]); end;
    ubij_whitespace;
    k_stack := 1; stack[1] := 1;
    for i := 1 to n do begin
        if (prog[i][1] = 'R') then begin k_stack := k_stack+1; stack[k_stack] := i; end;
        if (prog[i][1] = 'S') then begin kraj_bloka[stack[k_stack]] := i; k_stack := k_stack-1; end;
    end;
end;

function broj(li: integer): integer;
var sol, i: integer;
begin
    sol := 0;
    for i := 7 to length(prog[li]) do sol := sol*10+ord(prog[li][i])-ord('0');
    broj := sol;
end;

procedure rek(a, b, koja: integer);
var i, x, ima_print, j, j1, k, kamo, m: integer;
    target: array[0..26] of integer;
    naredba: string[200];
begin
    reset(koja);
    for i := a to b do begin
        if (prog[i] = 'STOP') then i := b else begin
           if (prog[i][1] = 'R') then begin

              x := broj(i); ima_print := 0;
              for j := i to kraj_bloka[i] do
                 if (prog[j][1] = 'P') then ima_print := 1;
              if (ima_print = 1) then begin

                 mnozi(koja, 50, 49);
                 for j := 0 to 26 do
                    for k := 0 to 26 do
                        mat[j, k, 50] := mat[j, k, 49];
                 reset(koja);

                 for j1 := 1 to x do begin
                    rek(i+1, kraj_bloka[i], koja+1);
                    mnozi(koja+1, 50, 49);
                    for j := 0 to 26 do
                       for k := 0 to 26 do
                          mat[j, k, 50] := mat[j, k, 49];
                 end;

              end else begin
                 rek(i+1, kraj_bloka[i], koja+1);
                 potenciraj(x, koja+1, koja+2);
                 mnozi(koja+2, koja, koja+1);
                    for j := 0 to 26 do
                       for k := 0 to 26 do
                          mat[j, k, koja] := mat[j, k, koja+1];
              end;
              i := kraj_bloka[i];
           end else begin

           if (prog[i][1] = 'P') then begin

                 mnozi(koja, 50, 49);
                 for j := 0 to 26 do
                    for k := 0 to 26 do
                        mat[j, k, 50] := mat[j, k, 49];
                 reset(koja);
                 writeln(prog[i][6], ' = ', mat[ord(prog[i][6])-ord('a'), 0, 50]);

           end else begin
               naredba := prog[i];
               kamo := 26;
               for j := 0 to 26 do target[j] := 0;
               k := 0;
               for j := length(naredba) downto 1 do begin
                   if ((naredba[j] >= 'a')and((naredba[j] <= 'z'))) then kamo := ord(naredba[j])-ord('a');
                   if ((naredba[j] = '-')or((naredba[j] = '=')or(naredba[j] = '+'))) then begin
                      k := 0;
                      for m := j+1 to length(naredba) do begin
                         if ((naredba[m] < '0') or (naredba[m] > '9')) then m := length(naredba) else
                            k := k*10+ord(naredba[m])-ord('0');
                      end;
                      if (k = 0) then k := 1;
                      if (naredba[j] = '-') then k := k*(-1);
                      for m := 0 to 26 do
                         target[m] := (((target[m]+k*mat[kamo, m, koja]) mod mode)+mode) mod mode;
                      kamo := 26; k := 0;
                   end;
               end;
               for j := 0 to 26 do
                  mat[ord(naredba[1])-ord('a'), j, koja] := target[j];
           end;

           end;
        end;
    end;
end;

begin
   ucitaj;
   mat[26, 0, 50] := 1;
   rek(1, kraj_bloka[1], 0);
end.
