
(*
  Croatia 2005 / Regional Competition / Juniors
  Problem KEMIJA

  Opis algoritma:
  Iz ulaznog niza znakova procitamo koliko ukupno atoma pojedine vrste
  ima u molekulama. Zatim zavrtimo i, j, k u for-petlji od 1 do 10 i
  probamo naci neku trojku brojeva koja zadovoljava jednadzbu
  i*M1 + j*M2 = k*M3.
*)

program kemija;
const MAXULAZ = 50;
      C = 1;
      O = 2;
      H = 3;

var ulaz  : string[MAXULAZ];
    atomi : array[1..3, 1..3] of longint;
    molekula, broj, atom, i, j, k : longint;

begin
   readln(ulaz);
   for i:=1 to 3 do
      for j:=1 to 3 do atomi[i, j]:=0;
   molekula:=3;
   broj:=1;
   for i:=length(ulaz) downto 1 do
   begin
      case ulaz[i] of
         '+','=' :
         begin
            molekula:=molekula-1;
            broj:=1;
            continue;
         end;
         '2'..'9':
         begin
            broj:=ord(ulaz[i])-ord('0');
            continue;
         end;
         'C' : atom:=C;
         'O' : atom:=O;
         'H' : atom:=H;
      end;
      atomi[molekula, atom]:=atomi[molekula, atom]+broj;
      broj:=1;
   end;
   for i:=1 to 10 do
      for j:=1 to 10 do
         for k:=1 to 10 do
            if (i*atomi[1, 1]+j*atomi[2, 1]=k*atomi[3, 1])and
               (i*atomi[1, 2]+j*atomi[2, 2]=k*atomi[3, 2])and
               (i*atomi[1, 3]+j*atomi[2, 3]=k*atomi[3, 3])then
               begin
                  writeln(i, ' ', j, ' ', k);
                  exit;
               end;
   writeln('NEMOGUCE');
end.
