
/*
  Croatia 2005 / Regional Competition / Seniors
  Problem KVIZ

  Opis algoritma:
  Prema pravilima iz teksta zadatka, pazljivo generiramo sva tri hinta.
*/

#include <stdio.h>
#include <string.h>

#define MAX_ZNAKOVA 50

char niz_znakova[MAX_ZNAKOVA + 1];
int duljina;

void ucitaj(void)
{
  scanf("%[^\n]",niz_znakova);
  duljina = strlen(niz_znakova);
}

int slovo(char znak)
{
  if ((znak >= 'a' && znak <= 'z') || (znak >= 'A' && znak <= 'Z'))
    return 1;
  return 0;
}

int samoglasnik(char znak)
{
  char samoglasnici[11] = "aeiouAEIOU";
  int i;

  for (i = 0;i < 10;++i)
    if (znak == samoglasnici[i])
      return 1;
  return 0;
}

void rijesi_i_ispisi(void)
{
  int i;
  int brojac;
  int broj_slova;
  int jedna_trecina,dvije_trecine;
  int ima_neotkrivenih_samoglasnika;
  char hint1[MAX_ZNAKOVA + 1],hint2[MAX_ZNAKOVA + 1],hint3[MAX_ZNAKOVA + 1];

  strcpy(hint1,niz_znakova);
  broj_slova = 0;
  for (i = 0;i < duljina;++i)
    if (slovo(niz_znakova[i]))
    {
      ++broj_slova;
      hint1[i] = '.';
    }
  printf("%s\n",hint1);

  jedna_trecina = broj_slova / 3;
  if (broj_slova % 3 == 2)
    ++jedna_trecina;

  strcpy(hint2,hint1);
  brojac = 0;
  for (i = 0;i < duljina;++i)
  {
    if (slovo(niz_znakova[i]))
    {
      hint2[i] = niz_znakova[i];
      if (++brojac == jedna_trecina)
        break;
    }
  }
  printf("%s\n",hint2);

  strcpy(hint3,hint2);
  ima_neotkrivenih_samoglasnika = 0;
  for (i = 0;i < duljina;++i)
  {
    if (samoglasnik(niz_znakova[i]))
    {
      if (hint2[i] == '.')
        ima_neotkrivenih_samoglasnika = 1;
      hint3[i] = niz_znakova[i];
    }
  }
  if (ima_neotkrivenih_samoglasnika)
  {
    printf("%s\n",hint3);
    return;
  }

  dvije_trecine = broj_slova * 2 / 3;
  if (broj_slova % 3 == 1)
    ++dvije_trecine;

  strcpy(hint3,hint1);
  brojac = 0;
  for (i = 0;i < duljina;++i)
  {
    if (slovo(niz_znakova[i]))
    {
      hint3[i] = niz_znakova[i];
      if (++brojac == dvije_trecine)
        break;
    }
  }
  printf("%s\n",hint3);
}

int main(void)
{
  ucitaj();
  rijesi_i_ispisi();

  return 0;
}
