
/*
  DMIH 2006 - Prvi dan natjecanja
  Srednjoskolska skupina - I. podskupina
  Zadatak IZBORI

  Jednostavno radimo ono sto pise u zadatku:

  Za svaki par kandidata (A,B) kod svakog biraca X gledamo tko se od njih
  dvojice nalazi prije na listi, te onome kandidatu koji je kod vise biraca
  prije na listi dajemo bod.
*/

#include <cstdio>

#define MAX 50

int lista[MAX][MAX];
int bodovi[MAX+1];

int main( void ) {
   int m, n;
   scanf( "%d%d", &m, &n );
   for( int i = 0; i < m; ++i )
      for( int j = 0; j < n; ++j )
         scanf( "%d", &lista[i][j] );

   for( int A = 1; A <= n; ++A )
      for( int B = A+1; B <= n; ++B ) {
         // Za svaki par kandidata (A,B) ...

         int rezultat = 0;
         for( int X = 0; X < m; ++X ) {
            // ... za svakog biraca X ...

            for( int i = 0; i < n; ++i ) {
               // ... trazimo je li na njegovoj listi ...
               if( lista[X][i] == A ) { --rezultat; break; } // ... A ispred B ...
               if( lista[X][i] == B ) { ++rezultat; break; } // ... ili B ispred A ...
            }
         }

         // te dajemo bod ogovarajucem kandidatu.
         if( rezultat < 0 ) ++bodovi[A]; else ++bodovi[B];
      }

   int maksimum = 0;
   for( int i = 1; i <= n; ++i ) maksimum >?= bodovi[i];

   for( int i = 1; i <= n; ++i )
      if( bodovi[i] == maksimum )
         printf( "%d\n", i );

   return 0;
}
