
{
  DMIH 2006 - Drugi dan natjecanja
  Srednjoskolska skupina - I. podskupina
  Zadatak STOLNI

  Zadatak rjesavamo simulirajuci putanju lopte, te u svakom stupcu trazimo
  pomak rucke s igracima tako da na poziciji kojom prolazi lopta nema igraca.

  Pomak rucke mozemo traziti tako da je micemo prema gore sve dok mozemo ili
  dok ne naidjemo na pomak koji nam odgovara, a zatim isto to radimo u smjeru
  prema dolje.

  Najjednostavniji nacin da to napravimo je pomocu dvije funkcije
     int gore( int stupac ) i
     int dolje( int stupac )
  koje pomicu dani stupac u zeljenom smjeru, te vracaju 0 ako se rucka ne moze
  dalje pomicati u tom smjeru, a 1 ako je pomak izvrsen.
}

program stolni;

const MAX = 100;

var
   R, S : integer;
   stol : array[1..MAX] of string;
   redak, stupac : integer;
   delta : integer;

function gore( stupac : integer ) : boolean;
var
   redak : integer;
begin
   if stol[1][stupac] <> '.' then
      gore := false
   else begin
      for redak := 1 to R-1 do
         stol[redak][stupac] := stol[redak+1][stupac];
      stol[R][stupac] := '.';

      gore := true;
   end;
end;

function dolje( stupac : integer ) : boolean;
var
   redak : integer;
begin
   if stol[R][stupac] <> '.' then
      dolje := false
   else begin
      for redak := R downto 2 do
         stol[redak][stupac] := stol[redak-1][stupac];
      stol[1][stupac] := '.';

      dolje := true;
   end;
end;

begin
   readln( R, S );
   for redak := 1 to R do readln( stol[redak] );

   redak := 1; { redak u kojem se nalazi loptica }
   while stol[redak][1] <> 'L' do redak := redak + 1;

   delta := -1; { smjer u kojem se lopta trenutno krece }

   for stupac := 2 to S do begin;
      { pomicemo lopticu }
      if redak = 1 then delta := 1;
      if redak = R then delta := -1;
      redak := redak + delta;

      { pomicemo rucku prema gore }
      while stol[redak][stupac] <> '.' do
         if gore( stupac ) = false then
            break;

      { pomicemo rucku prema dolje }
      while stol[redak][stupac] <> '.' do
         if dolje( stupac ) = false then
            break;

      stol[redak][stupac] := 'L';
   end;

   for redak := 1 to R do writeln( stol[redak] );
end.
