
/*
  DMIH 2006 - Prvi dan natjecanja
  Srednjoskolska skupina - II. podskupina
  Zadatak PRUGE

  Zadatak se moze rjesiti na puno nacina, ovdje cemo opisati vjerojatno
  najjednostavnije koje radi unutar zadanih ogranicenja.

  Uzorak na slici mozemo rastaviti na 3 jednostavna djela:

  A) Dio ispod dijagonale ( x > y )
  B) Dio iznad dijagonale ( y > x )
  C) Dijagonala ( x = y )

  Kako je ogranicenje na koordinate pravokutnika dovoljno malo dio ispod
  dijagonale mozemo izracunati tako da za svaku neparnu x koodrinatu izmedju
  x1 i x2 izracunamo visinu stupca.
  Analogno racunamo dio iznad dijagonale, dok je dio na samoj dijagonali
  trivijalno izracunati.
*/

#include <cstdio>

typedef long long llint;

int main( void ) {
   int x1, y1, x2, y2;

   scanf( "%d%d%d%d", &x1, &y1, &x2, &y2 );

   llint broj = 0;

   // Racunamo dio ispod dijagonale
   for( int x = x1; x < x2; ++x )
      if( x%2 )
         broj += (y2 <? x) - (y1 <? x);

   // Racunamo dio iznad dijagonale
   for( int y = y1; y < y2; ++y )
      if( y%2 )
         broj += (x2 <? y) - (x1 <? y);

   // Racunamo dio na dijagonali
   for( int i = (x1 >? y1); i < (x2 <? y2); ++i )
      if( i%2 )
         broj += 1;

   printf( "%lld\n", broj );

   return 0;
}
