
(*
  Zupanijsko natjecanje 2006 - Srednjoskolska skupina - I. podskupina
  Zadatak TUNEL
  Rjesenje napisali: Ante Derek, Luka Kalinovcic, Lovro Puzar, Ivan Sikiric

  Opis algoritma:

  Ako postoji put kroz tunel, onda za svaki vodoravni brid mora
  vrijediti da je njegova y koordinata manja od y koordinata
  prethodnog, trenutnog i sljedeceg segmenta stropa, odnosno veca
  od y koordinata prethodnog, trenutnog i sljedeceg segmenta poda.
  Kako bi dobili najkraci put, potrebno je u svakom koraku izabrati
  y koji zadovoljava gornji kriterij i koji je sto je manje moguce
  udaljen od y-a prethodnog segmenta na putu.
*)

program tunel;

const MAX = 100000;

var n : longint;
    ys, yp : array[1..MAX] of longint;

procedure citaj_ulaz;
var i : longint;
begin
    readln(n);
    for i:=1 to n do read(ys[i]);
    readln;
    for i:=1 to n do read(yp[i]);
end;

procedure rijesi;
var i, y : longint;
begin
    y:=0;
    for i:=1 to n-1 do
      begin
        if y>=ys[i+1] then y:=ys[i+1]-1;
        if y<=yp[i+1] then y:=yp[i+1]+1;
        write(y, ' ');
      end;
    writeln(0);
end;

begin
    citaj_ulaz;
    rijesi;
end.
