/*
  Drzavno natjecanje 2007, srednjoskolska skupina - 1. podskupina
  1. dan natjecanja
  Zadatak VANDAL
*/

#include <cstdio>

using namespace std;

int main( void ) {
   int N, R, S, D1, D2;
   scanf( "%d", &N );
   scanf( "%d%d%d%d", &R, &S, &D1, &D2 );

   int cnt[2] = { 0, 0 };
   
   // prelazim redak R
   for( int s = 1; s <= N; ++s ) {
      int boja = (R+s)%2;
      ++cnt[boja];
   }

   // prelazim stupac S i pazim da ne ubrojim polje u retku R
   for( int r = 1; r <= N; ++r ) {
      int boja = (r+S)%2;
      if( r != R ) ++cnt[boja];
   }

   // prelazim dijagonalu D1 po recima i pazim da ne ubrojim polje u retku R ili stupcu S
   for( int r = 1; r <= N; ++r ) {
      int s = D1-r+1;
      int boja = (r+s)%2;      
      if( r != R && s != S && s >= 1 && s <= N ) ++cnt[boja];
   }

   // prelazim dijagonalu D2 po recima i pazim da ne ubrojim polje u retku R ili stupcu S ili na dijagonali D1
   for( int r = 1; r <= N; ++r ) {
      int s = D2+r-N;
      int d1 = r+s-1;
      int boja = (r+s)%2;      
      if( r != R && s != S && s >= 1 && s <= N && d1 != D1 ) ++cnt[boja];
   }

   printf( "%d\n", cnt[0] + cnt[1] );
   printf( "%d %d\n", cnt[0], cnt[1] );

   return 0;
}
