(*
  Drzavno natjecanje 2007, srednjoskolska skupina - 1. podskupina
  1. dan natjecanja
  Zadatak VANDAL
*)

program vandal;

var
   N, R, S, D1, D2   : longint;
   izlaz             : array[0..1] of longint;
   i, j, boja, koja1 : longint;

begin
   readln(N);
   readln(R, S, D1, D2);
   izlaz[0] := 0;
   izlaz[1] := 0;

   (* prelazim redak R *)
   for j:=1 to N do begin
      boja := (R+j) mod 2;
      izlaz[boja] := izlaz[boja] + 1;
   end;

   (* prelazim stupac S i pazim da ne ubrojim polje u retku R *)
   for i:=1 to N do begin
      boja := (i+S) mod 2;
      if i <> R then 
         izlaz[boja] := izlaz[boja] + 1;
   end;
      
   (* prelazim dijagonalu D1 po recima i pazim da ne ubrojim polje u retku R ili stupcu S *)
   for i:=1 to N do begin
      j := D1-i+1;
      boja := (i+j) mod 2;
      if (i <> R) and (j <> S) and (j >= 1) and (j <= N) then
         izlaz[boja] := izlaz[boja] + 1;
   end;

   (* prelazim dijagonalu D2 po recima i pazim da ne ubrojim polje u retku R ili stupcu S ili na dijagonali D1 *)
   for i:=1 to N do begin
      j := D2+i-N;
      koja1 := i+j-1;
      boja := (i+j) mod 2;      
      if (i <> R) and (j <> S) and (j >= 1) and (j <= N) and (koja1 <> D1) then
         izlaz[boja] := izlaz[boja] + 1;
   end;

   writeln(izlaz[0] + izlaz[1]);
   writeln(izlaz[0], ' ', izlaz[1]);
end.
