(*
  Drzavno natjecanje 2007, srednjoskolska skupina - 1. podskupina
  2. dan natjecanja
  Zadatak KARTA
*)

const MAX = 50;

const dx : array[1..8] of longint = (1, 1, 1, 0, -1, -1, -1, 0);
      dy : array[1..8] of longint = (-1, 0, 1, 1, 1, 0, -1, -1);

type grad = record
                x, y, num : longint;
                ime : string[50];
            end;
            
var r, s, i, j, brGradova, min : longint;
    karta : array[1..MAX] of string[MAX];
    gradovi : array[1..MAX*MAX] of grad;

procedure dodaj(y, x : longint);
begin    
    inc(brGradova);
    gradovi[brGradova].x := x;
    gradovi[brGradova].y := y;
    gradovi[brGradova].num := 0;
end;

procedure pronadji(g : longint);
var i, j, nx, ny : longint;
begin
    for i:=1 to 8 do
    begin
        nx := gradovi[g].x + dx[i];
        ny := gradovi[g].y + dy[i];
        if (nx<=0)or(nx>s)or(ny<=0)or(ny>r) then continue;
        if (karta[ny][nx]<>'.')and(karta[ny][nx]<>'x') then
        begin
            gradovi[g].ime := '';
            j := nx;
            while j>0 do 
                if (karta[ny][j]<>'.')and(karta[ny][j]<>'x') then dec(j) else break;
            inc(j);
            while j<=s do
                if (karta[ny][j]<>'.')and(karta[ny][j]<>'x') then
                begin
                    gradovi[g].ime := gradovi[g].ime + karta[ny][j];
                    karta[ny][j] := '.';
                    inc(j);                    
                end else break;
            break;
        end;
    end;
end;

procedure update(g : longint);
var x, y : longint;
begin
    gradovi[g].num := 0;
    x:=gradovi[g].x;
    y:=gradovi[g].y;
    if x>1 then if (karta[y][x-1]<>'.')and(karta[y][x-1]<>'x') then inc(gradovi[g].num);
    if x<s then if (karta[y][x+1]<>'.')and(karta[y][x+1]<>'x') then inc(gradovi[g].num);
    if gradovi[g].y<r then 
    begin
        if (karta[y+1][x]<>'x')and(karta[y+1][x]<>'.') then inc(gradovi[g].num) else
        begin
            if x>1 then if (karta[y+1][x-1]<>'.')and(karta[y+1][x-1]<>'x') then inc(gradovi[g].num);
            if x<s then if (karta[y+1][x+1]<>'.')and(karta[y+1][x+1]<>'x') then inc(gradovi[g].num);
        end;
    end;
    if gradovi[g].y>1 then 
    begin
        if (karta[y-1][x]<>'x')and(karta[y-1][x]<>'.') then inc(gradovi[g].num) else
        begin
            if x>1 then if (karta[y-1][x-1]<>'.')and(karta[y-1][x-1]<>'x') then inc(gradovi[g].num);
            if x<s then if (karta[y-1][x+1]<>'.')and(karta[y-1][x+1]<>'x') then inc(gradovi[g].num);
        end;
    end;
end;
    
begin
    readln(r, s);
    for i:=1 to r do readln(karta[i]);

    brGradova := 0;
    for i:=1 to r do
        for j:=1 to s do if karta[i][j] = 'x' then dodaj(i, j);
    
    for i:=1 to brGradova do 
    begin
        min := -1;
        for j:=1 to brGradova do if gradovi[j].num>=0 then
        begin
            update(j);
            if gradovi[j].num=1 then min := j;
        end;
        pronadji(min);
        gradovi[min].num := -1;
    end;
    
    for i:=1 to brGradova do writeln(gradovi[i].y, ' ', gradovi[i].x, ' ', gradovi[i].ime);
end.
