(*
  Drzavno natjecanje 2007, srednjoskolska skupina - 1. podskupina
  2. dan natjecanja
  Zadatak SLIKA
*)

var
	slika : array[0..999, 0..999] of char;
	MAX : array[0..1, 0..999, 0..9] of integer; (* dimenzije dobrih kvadrata *)
	N, K, r, s, z : integer;
	minR, maxR, minS, maxS, maxZ : array[0..9] of integer;
	tren, preth : integer;

function min(x, y : integer) : integer;
begin
	if (x < y) then
		min := x
	else
		min := y;
end;

function maxi(x, y : integer) : integer;
begin
	if (x > y) then
		maxi := x
	else
		maxi := y;
end;

begin
	readln (N, K);
	for r := 0 to N-1 do
	begin
		for s := 0 to N-1 do
		begin
			read (slika[r, s]);
			if (slika[r, s] = '.') then
				slika[r, s] := '0';
		end;
		readln;
	end;

	for z := 1 to K do
	begin
		minR[z] := N+1; maxR[z] := -1;
		minS[z] := N+1; maxS[z] := -1;
		maxZ[z] := 0;
	end;

	(* za svaku boju odreujemo najlijeviji, najdesniji, najdonji i najgornji pixel te boje *)
	for r := 0 to N-1 do
		for s := 0 to N-1 do
		begin
			z := ord(slika[r, s])-ord('0');
			if (r < minR[z]) then minR[z] := r;
			if (r > maxR[z]) then maxR[z] := r;
			if (s < minS[z]) then minS[z] := s;
			if (s > maxS[z]) then maxS[z] := s;
		end;

	(* dinamika za "dobre kvadrate" *)
	tren := 1; preth := 0;
	for r := 0 to N-1 do
	begin
		tren := 1 - tren; (* trenutni redak (r) *)
		preth := 1 - preth; (* prethodni redak (r-1) *)

		for s := 0 to N-1 do
			for z := 1 to K do
			begin
				if (s = 0) then (* poseban slucaj: prvi stupac u redu *)
				begin
					if (z <= ord(slika[r, s])-ord('0')) then
						MAX[tren, 0, z] := 1
					else
						MAX[tren, 0, z] := 0;
				end
				else (* rekurzivna formula *)
				begin
					if (z <= ord(slika[r, s])-ord('0')) then
						MAX[tren, s, z] := 1 + min(min(MAX[tren, s-1, z], MAX[preth, s-1, z]), MAX[preth, s, z])
					else
						MAX[tren, s, z] := 0;
				end;

				(* je li ovaj "dobri kvadrat" najveci dosad? *)
				(* nalaze li se unutar njega sve znamenke z? *)
				if
				(
					(r - MAX[tren, s, z] + 1 <= minR[z]) and (maxR[z] <= r) and
					(s - MAX[tren, s, z] + 1 <= minS[z]) and (maxS[z] <= s) and
					(maxZ[z] < MAX[tren, s, z])
				) then
					maxZ[z] := MAX[tren, s, z];
			end;
	end;

	(* ispis *)
	for z := 1 to K do
		if (maxR[z] = -1) then (* nema nijedne znamenke z? *)
			writeln ('1 ', maxZ[z])
		else
			writeln (maxi(maxR[z]-minR[z]+1, maxS[z]-minS[z]+1), ' ', maxZ[z]);
end.
