/*
  Drzavno natjecanje 2007, srednjoskolska skupina - 2. podskupina
  1. dan natjecanja
  Zadatak POTPUNI
*/

#include <cstdio>

using namespace std;

#define MAXVAL 1000000

int n, x;
int faktor[MAXVAL+1];
char parnost[MAXVAL+1];

int main( void ) {
   for( int i = 2; i <= MAXVAL; ++i ) {
      if( faktor[i] ) continue;
      faktor[i] = i;

      if( (long long)i*i >= MAXVAL ) continue;

      for( int j = i*i; j <= MAXVAL; j += i ) 
         faktor[j] = i;      
   }

   int broj_neparnih = 0;

   scanf( "%d", &n );
   for( int i = 0; i < n; ++i ) {
      for( scanf( "%d", &x ); x != 1; x /= faktor[x] ) {
         broj_neparnih += (parnost[faktor[x]]==0) - (parnost[faktor[x]]==1);
         parnost[faktor[x]] ^= 1;
      }

      if( broj_neparnih == 0 ) printf( "DA\n" );
      else printf( "NE\n" );
   }
   return 0;
}
