/*
  Drzavno natjecanje 2007, srednjoskolska skupina - 2. podskupina
  2. dan natjecanja
  Zadatak MRAVOGRAD
*/

#include <cstdio>
#include <cstdlib>

#define MAX 10

int R, S, n;
int rr[MAX], ss[MAX];
int bitova[1<<MAX];

inline int dist( int r1, int s1, int r2, int s2 ) {
   return abs(r1-r2) + abs(s1-s2);
}

int f( int r, int s ) {
   int mini = 1000000000, mask = 0;
   for( int i = 0; i < n; ++i ) {
      int d = dist( r, s, rr[i], ss[i] );
      if( d < mini ) { mini = d; mask = 0; }
      if( d == mini ) mask |= (1<<i);
   }
   return mask;
}

int rec( int r1, int s1, int r2, int s2 ) {
   if( r1 > r2 || s1 > s2 ) return 0;

   int mask = f(r1,s1);
   if( (r1==r2 && s1==s2) || mask == f(r2,s2) && mask == f(r1,s2) && mask == f(r2,s1) )
      return (r2-r1+1)*(s2-s1+1) * (bitova[mask]>1);
   
   int r = (r1+r2)/2, s = (s1+s2)/2;

   return rec(r1,s1,r,s) + rec(r+1,s1,r2,s) + rec(r1,s+1,r,s2) + rec(r+1,s+1,r2,s2);
}

int main( void ) {
   scanf( "%d%d", &R, &S );
   scanf( "%d", &n );
   for( int i = 0; i < n; ++i ) scanf( "%d%d", &rr[i], &ss[i] );
   
   for( int mask = 0; mask < (1<<n); ++mask ) bitova[mask] = bitova[mask>>1] + (mask&1);

   printf( "%d\n", rec( 1, 1, R, S ) );   

   return 0;
}
