
/*
  Zupanijsko natjecanje 2007
  Srednjoskolska skupina - 2. podskupina
  Zadatak VLAK
  Programski jezik C
*/

#include <stdio.h>

#define MAXN 10

int main()
{
   int N, K, P, put, i, j;
   int ukupno[MAXN];
   int poslovu[MAXN][26];

   scanf( "%d%d%d", &N, &K, &P );
   for ( i=0; i<N; ++i ) {
      ukupno[i] = 0;
      for ( j=0; j<26; ++j )
         poslovu[i][j] = 0;
   }

   for ( put=0; put<P; ++put ) {
      char ime[11];
      int slovo;
      int kamo = -1;
      scanf( "%s", ime );
      slovo = ime[0] - 'a';

      for ( i=0; i<N; ++i ) {
         if ( ukupno[i] == K )
            continue;

         if ( kamo == -1 ||
              poslovu[i][slovo] < poslovu[kamo][slovo] ||
              poslovu[i][slovo] == poslovu[kamo][slovo] && ukupno[i] < ukupno[kamo] )
            kamo = i;
      }

      ++ukupno[kamo];
      ++poslovu[kamo][slovo];
   }

   printf( "%d", ukupno[0] );
   for ( i=1; i<N; ++i )
      printf( " %d", ukupno[i] );
   printf( "\n" );

   return 0;
}
