#include <cmath>
#include <cstdio>

const double pi = acos( -1.0 );
const double sqrt3 = sqrt( 3.0 );

int n;
int X, Y;
int a[1024][1024];

int main( void ) {
   scanf( "%d%d", &X, &Y );
   scanf( "%d", &n );
   for( int i = 0; i < n; ++i ) {
      int x, y;
      scanf( "%d%d", &x, &y );
      a[x][y] = 1;
   }
   
   double povrsina = 0.0;

   for( int x1 = 0; x1 < X; ++x1 ) 
      for( int y1 = 0; y1 < Y; ++y1 ) {
         int x2 = x1+1, y2 = y1+1;

         if( a[x1][y1] && a[x2][y2] || a[x2][y1] && a[x1][y2] ) povrsina += 1.0;
         else if( a[x1][y1] + a[x1][y2] + a[x2][y1] + a[x2][y2] == 2 ) povrsina += pi/6 + sqrt3/4;
         else if( a[x1][y1] + a[x1][y2] + a[x2][y1] + a[x2][y2] == 1 ) povrsina += pi/4;
      }

   printf( "%.10lf\n", povrsina );

   return 0;
}
