program kljuc;

var
   n, m : longint;   
   kod, dio, key : array[0..999] of integer;
   znak : char;
   i, j, k, start : longint;
   ok : boolean;

function encode( a, b : integer ) : integer;
begin
   encode := (a + b) mod 26;
end;
function decode( c, b : integer ) : integer;
begin
   decode := (c - b + 26) mod 26;
end;

begin
   n := 0;
   repeat
      read( znak );      
      kod[n] := ord( znak ) - ord( 'a' );
      n := n + 1;
   until eoln;
   readln;  

   m := 0;
   repeat
      read( znak );      
      dio[m] := ord( znak ) - ord( 'a' );
      m := m + 1;
   until eoln;
   readln;

   for start := 0 to n-m do begin
      for i := 0 to m-1 do
         key[start+i] := decode( kod[start+i], dio[i] );
      
      for k := 1 to m div 2 do begin
         ok := true;
         for i := start to start+m-k-1 do
            if key[i] <> key[i+k] then
               ok := false;
         
         if not ok then continue;

         for i := start to start+k-1 do begin            
            j := i mod k;
            while j < n do begin
               key[j] := key[i];
               j := j + k;
            end;
         end;
         
         for i := 0 to n-1 do 
            write( chr( decode( kod[i], key[i] ) + ord('a') ) );
         writeln;
         exit;
      end;
   end;

   writeln( '???' ); 
 end.
