#include <cmath>
#include <cstdio>

#define MAX 100

int n;
int x[MAX], y[MAX], strijela[MAX];
int uputa[MAX][MAX-1];

double vrijeme[MAX];
int gori[MAX];

double udalj[MAX][MAX];

int main( void ) {
   scanf( "%d", &n );
   for( int i = 0; i < n; ++i ) {
      scanf( "%d%d%d", &x[i], &y[i], &strijela[i] );
      for( int j = 0; j < n-1; ++j ) {
         scanf( "%d", &uputa[i][j] );
         --uputa[i][j];
      }

      vrijeme[i] = 1e10;
      gori[i] = 0;
   }

   for( int i = 0; i < n; ++i ) 
      for( int j = 0; j < n; ++j ) 
         udalj[i][j] = sqrt( (double)(x[i]-x[j])*(x[i]-x[j]) + (double)(y[i]-y[j])*(y[i]-y[j]) );
   
   vrijeme[0] = 0.0;

   for( int i = 0; i < n; ++i ) {
      int prvi = -1;
      for( int j = 0; j < n; ++j ) {
         if( gori[j] ) continue;
         if( prvi == -1 || vrijeme[j] < vrijeme[prvi] ) prvi = j;
      }

      gori[prvi] = 1;

      for( int j = 0; j < n-1; ++j ) {
         int kamo = uputa[prvi][j];
         if( gori[kamo] ) continue;

         if( vrijeme[prvi] + udalj[prvi][kamo] < vrijeme[kamo] )
            vrijeme[kamo] = vrijeme[prvi] + udalj[prvi][kamo];

         if( --strijela[prvi] == 0 ) break;
      }
   }

   for( int i = 0; i < n; ++i ) printf( "%.10lf\n", vrijeme[i] );

   return 0;
}
