program slon;

uses classes;

const MM = 1000000007;
const inf = 1000000000;

type
   ppoint = ^point;
   point = record
      x, y : longint;
   end;
   
   pcvor = ^cvor;
   cvor = record
      P : point;
      suma : longint;
   end;

function cmp( A, B : pointer ) : longint;
var
   aa, bb : ppoint;
begin
   aa := A; bb := B;
   if aa^.x <> bb^.x then cmp := aa^.x - bb^.x else cmp := bb^.y - aa^.y;
end;

var
   n : longint;
   L : array[0..300000] of TList;
   suma : array[0..300000] of longint;
   points : TList;
   P : point;
   pp : ppoint;
   cc : pcvor;
   i, best : longint;
   lo, hi, mid : longint;
   A, B : longint;
   
procedure dodaj( kamo : longint; P : point; br_nacina : longint );
begin
   suma[kamo] := (suma[kamo] + br_nacina) mod MM;
   new(cc);
   cc^.P := P;
   cc^.suma := suma[kamo];
   L[kamo].add( cc );
end;

begin
   readln( n );
   
   points := TList.create;
   for i := 1 to n do begin
      new( pp );
      readln( pp^.x, pp^.y );
      points.add( pp );
   end;
   points.sort( @cmp );
   
   for i := 0 to n do begin
      L[i] := TList.create;
      new( cc );
      cc^.P.x := -inf;
      cc^.P.y := inf;
      cc^.suma := 0;
      L[i].add( cc );
      suma[i] := 0;
   end;   
           
   P.x := -inf;
   P.y := -inf;
   dodaj( 0, P, 1 );

   best := 0;
   for i := 1 to n do begin
      pp := points.items[i-1];
      P := pp^;
      
      lo := 0; 
      hi := i;
      while lo < hi do begin
         mid := (lo+hi+1) div 2;
         cc := L[mid].last;
         if cc^.P.y >= P.y then hi := mid-1 else lo := mid;
      end;
      A := lo;
      
      lo := 0;
      hi := L[A].count;
      while lo < hi do begin
         mid := (lo+hi+1) div 2;
         cc := L[A].items[mid];
         if cc^.P.y < P.y then hi := mid-1 else lo := mid;
      end;
      B := lo;

      cc := L[A].items[B];
      dodaj( A+1, P, (suma[A] - cc^.suma) mod MM );
      
      if A+1 > best then best := A+1;
   end;

   writeln( best );
   cc := L[best].last;
   writeln( (cc^.suma + MM) mod MM );
end.
   