#include <cstdio>

char a[10][10];

const int dr[8] = { -1, -1, 0, 1, 1, 1, 0, -1 };
const int ds[8] = { 0, 1, 1, 1, 0, -1, -1, -1 };

int main( void ) {
   for( int r = 1; r <= 8; ++r )
      for( int s = 1; s <= 8; ++s )
         scanf( " %c", &a[r][s] );

   int rjesenje = 0;
   for( int r = 1; r <= 8; ++r )
      for( int s = 1; s <= 8; ++s ) {
         if( a[r][s] != '.' ) continue;

         int broj = 0;
         for( int d = 0; d < 8; ++d ) {
            int rr = r + dr[d];
            int ss = s + ds[d];
            int uzastopno = 0;

            while( a[rr][ss] == 'W' ) {
               rr += dr[d];
               ss += ds[d];
               uzastopno += 1;
            }

            if( a[rr][ss] == 'B' ) broj += uzastopno;
         }

         if( broj > rjesenje ) rjesenje = broj;
      }

   printf( "%d\n", rjesenje );

   return 0;
}
