#include <cstdio>

int n, a[100001], b[100001];
int tree[1<<18];

int init( int i, int lo, int hi ) {
   if( hi-lo == 1 ) return tree[i] = 1;
   else return tree[i] = init( 2*i, lo, (lo+hi)/2 ) + init( 2*i+1, (lo+hi)/2, hi );
}

bool k_th( int i, int lo, int hi, int j ) {
   if( --tree[i] < b[j] ) { b[j] -= ++tree[i]; return false; }
   if( hi-lo == 1 ) a[j] = lo;
   else k_th( 2*i, lo, (lo+hi)/2, j ) || k_th( 2*i+1, (lo+hi)/2, hi, j );
   return true;
}

int main( void ) {
   scanf( "%d", &n );
   init( 1, n, 2*n );
   for( int i = 1; i <= n; ++i ) scanf( "%d", &b[i] );
   for( int i = n; i >= 1; --i ) k_th( 1, n, 2*n, i );   
   for( int i = 1; i <= n; ++i ) printf( "%d ", a[i] );
   return 0;
}
