#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <string>
#include <vector>
using namespace std;

string parse(const string &str) {
   size_t start = 0, end;
   string ret;

   do {
      end = str.find(':', start);
      if ( end == string::npos ) end = str.size();

      if ( ret.size() > 0 ) ret += ':';
      string tok = str.substr(start, end-start);
      ret += string(4-tok.size(), '0') + tok;
      
      start = end + 1;
   } while ( start < str.size() );
   return ret;
}

int main() {
   string str; cin >> str;

   size_t pos = str.find("::");
   string rez;
   if ( pos != str.npos ) {
      string rez1 = parse(str.substr(0, pos));
      string rez2 = parse(str.substr(pos+2));
      while ( rez1.size() + 1 + rez2.size() < 8*4 + 7 ) {
         if ( rez1 != "" ) rez1 += ":0000";
         else rez2 = "0000:" + rez2;
      }
      rez = rez1 + ":" + rez2;
   } else {
      rez = parse(str);
   }
   cout << rez << endl;
   
   return 0;
}
