program klonovi;

const
   MAXN = 50;
   MAXP = MAXN * 32;

var
   N, M, nprostih, i, x, d : longint;
   prosti                  : array[1..MAXP] of longint;
   rastav                  : array[1..MAXP, 1..MAXN] of longint;

function map(p : longint) : longint;
var i : longint;
begin
   for i:=1 to nprostih do
      if prosti[i]=p then begin
         map := i;
         exit;
      end;

   nprostih := nprostih+1;
   prosti[nprostih] := p;
   map := nprostih;
end;

procedure rijesi(faktor : longint);
var
   svi_nula   : boolean;
   i, j, maks : longint;
   vec_stavio : array[1..MAXN] of boolean;
   
begin
   while true do begin
      svi_nula := true;
      for i:=1 to N do
         svi_nula := svi_nula and (rastav[faktor, i] = 0);
      if svi_nula then break;

      write('CLONE');
      for i:=1 to N do vec_stavio[i] := false;

      for j:=1 to M do begin
         maks := 1;
         for i:=2 to N do begin
            if (not vec_stavio[i]) and (rastav[faktor, i] > rastav[faktor, maks]) then
               maks := i;
         end;
         if rastav[faktor, maks] = 0 then break;

         vec_stavio[maks] := true;
         dec(rastav[faktor, maks]);
         write(' ', maks);
      end;
      writeln;
   end;
end;

begin
   read(N);
   for i:=1 to N do begin
      read(x);
      d := 2;
      while d*d <= x do begin
         while x mod d = 0 do begin
            inc(rastav[map(d), i]);
            x := x div d;
         end;
         inc(d);
      end;
      if x > 1 then inc(rastav[map(x), i]);
   end;

   read(M);
   for i:=1 to nprostih do begin
      writeln('ENTER ', prosti[i]);
      rijesi(i);
   end;
end.
