program misolovke;

const
   MAXN = 250;
   INF  = 1000000000;

var
   N, K, i, j : longint;
   bio        : array[1..MAXN, 1..MAXN, 0..1, 0..1, 0..1] of boolean;
   memo       : array[1..MAXN, 1..MAXN, 0..1, 0..1, 0..1] of longint;
   val        : array[1..MAXN, 0..MAXN] of longint;

function min(a, b : longint) : longint; begin if a <= b then min := a else min := b; end;
function max(a, b : longint) : longint; begin if a >= b then max := a else max := b; end;

function calc(red, zadnji : longint; lijevo, desno, gore : boolean) : longint;
var
   a, ret : longint;
   spojen : boolean;
begin
   if lijevo and desno then begin calc := -INF; exit; end;
   if red > N then begin
      if gore then calc := -INF else calc := 0;
      exit;
   end;

   if bio[red, zadnji, ord(lijevo), ord(desno), ord(gore)] then begin
      calc := memo[red, zadnji, ord(lijevo), ord(desno), ord(gore)];
      exit;
   end;

   bio[red, zadnji, ord(lijevo), ord(desno), ord(gore)] := true;
   ret := -INF;
   for a:=1 to N-K+1 do begin
      spojen := max(a, zadnji) <= min(a+K-1, zadnji+K-1);

      ret := max(ret, (val[red, a+K-1] - val[red, a-1] +
                       calc(red+1, a,
                           (a=1)   or (spojen and lijevo),
                           (a+K>N) or (spojen and desno),
                           (red=1) or (spojen and gore)
                           )));
   end;

   memo[red, zadnji, ord(lijevo), ord(desno), ord(gore)] := ret;
   calc := ret;
end;

begin
   read(N, K);
   for i:=1 to N do begin
      val[i, 0] := 0;
      for j:=1 to N do begin
         read(val[i, j]);
         val[i, j] := val[i, j] + val[i, j-1];
      end;
   end;

   writeln(calc(1, 1, false, false, false));
end.
