#include <cmath>
#include <cstdio>

#define MAXN 2000

int N;
int a[MAXN];
int b[MAXN];

int P, K;
int max_smusenost = -2000000000;

int main( void ) {
   scanf( "%d", &N );
   for( int i = 0; i < N; ++i ) scanf( "%d", &a[i] );
   for( int i = 0; i < N; ++i ) scanf( "%d", &b[i] );

   for( double centar = 0; centar <= N-1; centar += 0.5 ) {
      int L = (int)floor( centar );
      int R = (int)ceil( centar );

      int smusenost = 0;
      if( L == R ) smusenost = -a[L]*b[R];

      do {
         smusenost += a[L]*b[R] + a[R]*b[L];

         if( smusenost > max_smusenost ) {
            max_smusenost = smusenost;
            P = L;
            K = N-R-1;
         }

         --L;
         ++R;
      } while( L >= 0 && R < N );
   }

   printf( "%d %d\n", P, K );
   printf( "%d\n", max_smusenost );

   return 0;
}
