Program Bomboane;

CONST MAXB = 100;
Type Borcan = Array[1..MAXB] Of LongInt;

Var Fin, Fout: Text;
    n: Integer;
    B: Borcan;

Procedure Citire;
Var i: Integer;
Begin
  Assign(Fin, 'borcane.in'); Reset(Fin);
  ReadLn(Fin, n);
  For  i := 1 To n Do
    Read(Fin,B[i]);
  Close(Fin)
End;

Procedure Muta(x, y, z: Integer);
Begin
  Dec(B[x]); Dec(B[y]); Inc(B[z], 2);
  WriteLn(Fout, x, ' ', y, ' ', z)
End;

Procedure Fa4;
Var i, DeUnde: Integer;

Function Max: Integer;
Var i, M: Integer;
Begin
  M := B[4]; Max := 4;
  For i := 3 DownTo 1 Do
    If B[i]>M Then
      Begin
        M := B[i];
        Max := i
      End;
End;

Function Min12(Var PM1: Integer): Integer;
Var i, M1, M2, PM2: Integer;
Begin
    If B[1]<B[2] Then
      Begin
        M1 := B[1]; PM1 := 1;
        M2 := B[2]; PM2 := 2;
      End
    Else
      Begin
        M1 := B[2]; PM1 := 2;
        M2 := B[1]; PM2 := 1;
      End;
  For i := 3 To 4 Do
      If B[i]<M1 Then
        Begin
          M2 := M1; PM2 := PM1;
          M1 := B[i]; PM1 := i
        End
      Else
        If B[i]<M2 Then
          Begin
            M2 := B[i]; PM2 := i
          End;
   Min12 := PM2
End;

Procedure Fa54(k: Integer);
Var Ma, Mi1, Mi2: Integer;
Begin  {in borcanul k mai sunt bomboane}
  While B[k]>0 Do
    Begin
      Ma := Max; Mi2 := Min12(Mi1);
      Muta(Ma, k, Mi1)
    End;
End;

Procedure Muta6;
Var Mi1, Mi2: Integer;
Begin
  While (B[5]>0) AND (B[6]>0) Do
    Begin
      Mi2 := Min12(Mi1);
      Muta(5, 6, Mi1)
    End;
  If B[5]>0 Then
    DeUnde := 5
  Else
    If B[6]>0 Then
      DeUnde := 6
    Else
      DeUnde := 0;
End;

Procedure Mutan_4;
Var i, Max1, Max2, Mi1, Mi2: Integer;

Function MaiSunt: Boolean;
Var Cate, i: Integer;
Begin
  Cate := 0;
  For i := 5 To n Do
    If B[i]>0 Then
      Inc(Cate);
  MaiSunt := Cate>1;
End;

Function Max(Var PM2: Integer): Integer;
Var i, M1, M2, PM1: Integer;
Begin
  If B[5]>B[6] Then
    Begin
      M1 := B[5]; PM1 := 5;
      M2 := B[6]; PM2 := 6
    End
  Else
    Begin
      M1 := B[6]; PM1 := 6;
      M2 := B[5]; PM2 := 5
    End;
  For i := 7 To n Do
    If B[i]>M1 Then
      Begin
        M2 := M1; PM2 := PM1;
        M1 := B[i]; PM1 := i
      End
    Else
      If B[i]>M2 Then
        Begin
          M2 := B[i]; PM2 := i
        End;
    Max := PM1
End;

Begin
  While MaiSunt Do
    Begin
      Max1 := Max(Max2);
      Mi2 := Min12(Mi1);
      Muta(Max1, Max2, Mi1)
    End;
  For i := 5 To n Do
    If B[i]>0 Then
      DeUnde := i;
End;

Begin
  If n=4 Then Exit
  Else
    If n=5 Then Fa54(5)
    Else
      If n=6 Then
        Begin
          Muta6;
          If DeUnde>0 Then
            Fa54(DeUnde);
        End
      Else
        Begin
          Mutan_4;
          If DeUnde>0 Then
            Fa54(DeUnde)
        End;
End;

Procedure Fa1;
Var Ma1, Ma2, Mi: Integer;
    Z1, Z2: Integer;

Function Doua_Zero: Boolean;
Var Cate0, i: Integer;
Begin
  Cate0 := 0;
  For i := 1 To 3 Do
    If B[i]=0 Then
      Inc(Cate0);
  Doua_Zero := Cate0>=2;
End;

Function Max(Var M2: Integer; Var Min: Integer): Integer;
Var M1, PM1, PM2: Integer;
Begin
  If B[1]<B[2] Then
    Begin
      M1 := B[2]; PM1 := 2;
      M2 := B[1]; PM2 := 1;
      Min := 3
    End
  Else
    Begin
      M2 := B[1]; PM1 := 1;
      M1 := B[2]; PM2 := 2;
      Min := 3
    End;
  If B[3]>M1 Then
    Begin
      Min := PM2;
      M2 := M1; PM2 := PM1;
      M1 := B[3]; PM1 := 3
    End
  Else
    If B[3]>M2 Then
      Begin
        Min := PM2;
        M2 := B[3]; PM2 := 3
      End;
  M2 := PM2;
  Max := PM1
End;

Function Exact_2_Zero(Var Z1: Integer; Var Z2: Integer): Boolean;
Var Cate0, i: Integer;
Begin
  Cate0 := 0;
  For i := 1 To 3 Do
    If B[i]=0 Then
      Begin
        Inc(Cate0);
        If Cate0=1 Then Z1 := i;
        If Cate0=2 Then Z2 := i;
      End;
  Exact_2_Zero := Cate0=2
End;

Begin
  While NOT Doua_Zero Do
    Begin
      Ma1 := Max(Ma2, Mi);
      Muta(Ma1, Ma2, 4)
    End;
  While Exact_2_Zero(Z1, Z2) Do
    Begin
      Muta(6-Z1-Z2, 4, Z1);
      Muta(Z1, 4, Z2);
      Muta(Z2, 4, 6-Z1-Z2);
      Muta(Z1, 6-Z1-Z2, 4);
      Muta(Z2, 6-Z1-Z2, 4);
    End;
End;

Begin
  Assign(Fout, 'borcane.out'); ReWrite(Fout);
  Citire;
  Fa4;
  Fa1;
  Close(Fout);
End.
