{Solution by Patcas Csaba}
{DP i,j = minimal time when subtree of i can finish
          if i reveives message at moment j}
{Best match using backtracking}
const in_file='tcast.in';
      out_file='tcast.out';
      maxN=2000;
      maxT=1000;
      inf=65535;
var fin,fout:text;
    n,t:word;
    g:array[1..maxN,1..maxN] of word;
    gr:array[1..maxN] of word;
    valid:array[1..maxN,0..maxT-1] of byte;
    dp:array[1..maxN,0..maxT+maxN] of word;
    father,sons,available:array[1..maxN] of word;
    nSons,nAvailable,bestmatch:word;
    match:array[1..maxN,1..maxN] of word;
    was:array[1..maxN] of boolean;
procedure add_edge(node1,node2:word);
begin
     inc(gr[node1]);
     g[node1][gr[node1]]:=node2;
     inc(gr[node2]);
     g[node2][gr[node2]]:=node1;
end;
procedure read_data;
var q,x,y:word;
begin
     assign(fin,in_file);
     reset(fin);
     read(fin,n,t);
     for q:=1 to n-1 do
     begin
          read(fin,x,y);
          add_edge(x,y);
     end;
     for x:=1 to n do
         for y:=0 to t-1 do read(fin,valid[x][y]);
     close(fin);
end;
function max(a,b:word):word;
begin
     if a>b
     then max:=a
     else max:=b;
end;
function min(a,b:word):word;
begin
     if a<b
     then min:=a
     else min:=b;
end;
procedure back(sp,m:word);
var q:word;
begin
     if sp>nSons
     then bestmatch:=min(bestmatch,m)
     else
         for q:=1 to nSons do
             if not was[q]
             then
             begin
                  was[q]:=true;
                  back(sp+1,max(m,match[sp][q]));
                  was[q]:=false;
             end;
end;
procedure df(node,parent:word);
var i,j,receive:word;
begin
     writeln(node);
     father[node]:=parent;
     for i:=1 to gr[node] do
         if g[node][i]<>father[node]
         then df(g[node][i],node);
     nSons:=0;
     for i:=1 to gr[node] do
         if g[node][i]<>father[node]
         then
         begin
              inc(nSons);
              sons[nSons]:=g[node][i];
         end;
     for receive:=0 to t+n do
         if nSons=0
         then dp[node][receive]:=receive
         else
         begin
              i:=receive;
              nAvailable:=0;
              repeat
                    if (i>=t) or
                       (valid[node][i]=0)
                    then
                    begin
                         inc(nAvailable);
                         available[nAvailable]:=i;
                    end;
                    inc(i);
              until nAvailable=nSons;
              for i:=1 to nSons do
                  for j:=1 to nSons do match[i][j]:=dp[sons[i]][available[j]+1];
              fillchar(was,sizeof(was),false);
              bestmatch:=inf;
              back(1,0);
              dp[node][receive]:=bestmatch;
         end;
end;
procedure solve;
var node,receive,i,j:word;
begin
     fillchar(dp,sizeof(dp),255);
          for receive:=0 to t+n do
end;
procedure write_data;
begin
     assign(fout,out_file);
     rewrite(fout);
     write(fout,dp[1][0]);
     close(fout);
end;
begin
     read_data;
     fillchar(dp,sizeof(dp),255);
     df(1,0);
     write_data;
end.