#include <cstdio>
#include <queue>
using namespace std;

const int N = 800;
const int ND = 4;
const pair<int,int> D[ND] = {pair<int,int>(0,1), pair<int,int>(1,0), pair<int,int>(0,-1), pair<int,int>(-1,0)};

int n,m,dd;
int a[N][N];
int b[N][N];
bool used[N][N];

inline bool valid ( pair<int,int> p ) { return (0 <= p.first && p.first <= n && 0 <= p.second && p.second <= m); }

void bf ( int x, int y ) {
	queue<pair<int,int> > q;
	vector<pair<int,int> > v;
	q.push(make_pair(x,y));
	v.push_back(make_pair(x,y));
    used[x][y] = true;
	pair<int,int> c;
	for (; !q.empty(); q.pop()) {
		c = q.front();
		for (int d = 0; d < ND; ++d) {
			pair<int,int> next(c.first + D[d].first, c.second + D[d].second);
			if (valid(next) && !used[next.first][next.second]) {
				if (dd == 0 && a[x][y] == a[next.first][next.second]) {
					q.push(next);
					v.push_back(next);
					used[next.first][next.second] = true;
				} else
				if (dd != 0 && a[x][y] - a[next.first][next.second] <= d) {
					q.push(next);
					v.push_back(next);
					used[next.first][next.second] = true;
				}
			}
		}
	}
	for (vector<pair<int,int> >::iterator i = v.begin(); i != v.end(); ++i) {
		b[i->first][i->second] = v.size();
	}
}

int main() {
	freopen("mexc.in","rt",stdin);
	freopen("mexc.out","wt",stdout);
	scanf("%d %d %d",&n,&m,&dd);
    for (int i = 0; i < n; ++i) {
       	for (int j = 0; j < m; ++j) {
        	scanf("%d",&a[i][j]);
        }
    }
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (!used[i][j]) {
				bf(i,j);
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			printf("%d ",b[i][j]);
		}
		printf("\n");
	}
	return 0;
}

