#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

const int N = 2000;
const int TM = 1000;

int n,T;
vector<int> g[N];
int w[N];
int chk[N][TM];

bool wcmp ( const int &a, const int &b ) { return (w[a] > w[b]); }

int weight ( int k ) {
	for (vector<int>::iterator i = g[k].begin(); i != g[k].end(); ++i) {
		w[*i] = weight(*i);
	}
	sort(g[k].begin(),g[k].end(),wcmp);
	int max = 0;
	for (int i = 0; i < g[k].size(); ++i)
		if (max < w[g[k][i]] + i)
			max = w[g[k][i]] + i;
	return max+1;
}

int time ( int k, int t ) {
	int max = t-1;
	for (int ct = 0, i = 0; i < g[k].size(); ++i, ++ct) {
		while (t+ct < T && chk[k][t+ct]) ++ct;
		int tn = time(g[k][i],t+ct+1);
		if (max < tn) max = tn;
	}
	return max;
}

int main() {
	freopen("tcast.in","rt",stdin);
	freopen("tcast.out","wt",stdout);
	scanf("%d %d",&n,&T);
	for (int i = 0, a, b; i < n-1; ++i) {
		scanf("%d %d",&a,&b);
		--a; --b;
		g[a].push_back(b);
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < T; ++j) {
			scanf("%d",&chk[i][j]);
		}
	}
	w[0] = weight(0);
	printf("%d\n",time(0,0));
	return 0;
}

