#include <iostream>
#include <algorithm>
#define FIN "borcane.in"
#define FOUT "borcane.out"
#define MAX_N 110
#define MAX_MV 70010
#define MAX_VAL 1010
using namespace std;
int b[MAX_N],N,M;
struct move{
        char x,y,z;
} mv[MAX_MV];
int nmv;
struct borcan{
        int vl,poz;
} A[MAX_N];

void iofile(void){

        freopen(FIN,"rt",stdin);
        freopen(FOUT,"wt",stdout);
        scanf("%d",&N);
        for (int i=1;i<=N;++i){
                scanf("%d",&b[i]);
        }
        fclose(stdin);
        return ;

}

void echilibrare(int target){
        int mx,mn,ok=0,pmax,pmin;
        do {
                mx=0;
                mn=MAX_VAL;
                pmax=pmin=0;
                for (int i=N;i>=1;--i){
                        if (i!=target){
                                if (b[i]>mx){
                                        mx=b[i];
                                        pmax=i;
                                }
                        }
                }
                ok=0;
                for (pmin=1;pmin<=N;++pmin){
                        if (pmin!=target && pmin!=pmax && b[pmin]){
                        for (int i=1;i<=N;++i){
                                if (i!=target && i!=pmin && i!=pmax && b[i]+2<mx){
                                --b[pmin];
                                --b[pmax];
                                ++b[i];++b[i];
                                ++nmv;
                                mv[nmv].x=pmin;
                                mv[nmv].y=pmax;
                                mv[nmv].z=i;
                                ok=1;
                                i=N;
                                pmin=N;
                                }
                        }
                        }
                }
        } while (ok);
        return ;
}

bool fcmp(const borcan &A, const borcan &B){
        return (A.vl<B.vl);
}


int verify(int target){
        borcan aux;
        for (int i=1;i<=N;++i){
                if (b[i] && i!=target){
                        ++M;
                        A[M].vl=b[i];
                        A[M].poz=i;
                }
        }
        sort(A+1,A+M+1,fcmp);
        int p=1,u=M;
        while (p<u){
                ++nmv;
                mv[nmv].x=A[p].poz;
                mv[nmv].y=A[u].poz;
                mv[nmv].z=target;
                --A[p].vl;
                --A[u].vl;
                int pz=u;
                while (pz>1 && A[pz].vl<A[pz-1].vl){
                        aux=A[pz];
                        A[pz]=A[pz-1];
                        A[pz-1]=aux;
                }
                while (p<=u && A[p].vl==0){++p;}
        }
        if (p>u){return 1;} else {return 0;}
}

void solve(void){
        int sum=0;
        for (int i=1;i<=N;++i){sum+=b[i];}
        for (int i=1;i<=N;++i)
                if (((sum-b[i])&1)==0){
                        nmv=0;
                        echilibrare(i);
                        if (verify(i)){
                                for (int i=1;i<=nmv;++i){
                                        printf("%d %d %d\n",mv[i].x,
                                        mv[i].y,mv[i].z);
                                }
                                return ;
                        }
                }
        return ;
}


int main(void){
        iofile();
        solve();
        fclose(stdout);
        return 0;
}
