#include <stdio.h>
#include <string.h>

long i, j, n, m, k, t[850][850], x[850][850];
char visited[850][850];
long dx[] = {0, 1, 0,-1, 0};
long dy[] = {0, 0,-1, 0, 1};

struct lol
{
	long x, y;
};

lol q[650000];

inline long ok(long a, long b)
{
	return (a > 0 && b > 0 && a <= n && b <= m);
}

inline void bfs(long x1, long y1)
{
	long i, beg, end, num = 1;
//	printf("entering (%ld;%ld)...\n", x1, y1);
	for (i = 1; i <= 4; ++i)
	{
		if (t[x1 + dx[i]][y1 + dy[i]] != 0 && x[x1 + dx[i]][y1 + dy[i]] == x[x1][y1])
		{
			t[x1][y1] = t[x1 + dx[i]][y1 + dy[i]];
			return;
		}
	}
	memset(visited, 0, sizeof(visited));
	
	q[1].x = x1;
	q[1].y = y1;
	beg = end = 1;
	visited[x1][y1] = 1;
//	printf("added starting position...\n");
	while (beg <= end)
	{
		for (i = 1; i <= 4; ++i)
		{
			long aux1 = q[beg].x + dx[i];
			long aux2 = q[beg].y + dy[i];
//			printf("checking (%ld;%ld) - ", aux1, aux2);
			if (ok(aux1, aux2))
			{
//				printf("they are ok\n");
//				printf("visited[%ld][%ld] = %ld\n", aux1, aux2, visited[aux1][aux2]);
//				printf("x[(%ld;%ld)] = %ld cu x[(%ld;%ld)] = %ld\n", aux1, aux2, x[aux1][aux2], x1, y1, x[x1][y1]);
				if (!visited[aux1][aux2] && x[aux1][aux2] >= x[x1][y1] - k)
				{
//					printf("reached..\n");
				/*	if (x[x1][y1] == 6)
					{
						printf("adding (%ld;%ld) to queue...\n", aux1, aux2);
						printf("x[aux1][aux2] = %ld && x[beg][beg] = %ld\n", x[aux1][aux2], x[q[beg].x][q[beg].y]);
					}*/
					visited[aux1][aux2] = 1;
					q[++end].x = aux1;
					q[end].y = aux2;
					if (x[aux1][aux2] >= x[x1][y1])
					{
//						printf("adding %ld;%ld\n coz x[%ld][%ld] = %ld && x[%ld][%ld] = %ld\n", aux1, aux2, aux1, aux2, x[aux1][aux2], x1, y1, x[x1][y1]);
						++num;
					}
				}
			}
			
		}
		++beg;
	}
	t[x1][y1] = num;
}

int main()
{
	freopen ("mexc.in", "rt", stdin);
	freopen ("mexc.out", "wt", stdout);

	scanf("%ld %ld %ld", &n, &m, &k);
	for (i = 1; i <= n; ++i)
		for (j = 1; j <= m; ++j)
			scanf("%ld", &x[i][j]);

	for (i = 1; i <= n; ++i)
		for (j = 1; j <= m; ++j)
		{
			bfs(i, j);
		}

	for (i = 1; i <= n; ++i)
	{
		for (j = 1; j <= m; ++j)
		{
			printf("%ld ", t[i][j]);
		}
		printf("\n");
	}
	
	return 0;
}
