#include <stdio.h>
#include <vector>

using namespace std;

const int N_MAX = 810;

int N, M, D;

int a[N_MAX][N_MAX], nrdest[N_MAX][N_MAX], viz[N_MAX][N_MAX];
int qx[N_MAX * N_MAX], qy[N_MAX * N_MAX];

int dx[] = {-1, 0, 1, 0};
int dy[] = {0, 1, 0, -1};

void BF(int x, int y)
{
	memset(viz, 0, sizeof(viz));
	viz[x][y] = 1;
	nrdest[x][y] = 1;

	int in = 1, sf = 2, X, Y, xx, yy;
	qx[in] = x, qy[in] = y;

	while (in != sf) {
		X = qx[in], Y = qy[in];
		in ++;

		for (int i = 0; i < 4; i ++) {
			xx = X + dx[i], yy = Y + dy[i];

			if (1 <= xx && xx <= N && 1 <= yy && yy <= M && !viz[xx][yy]) {
				if (a[xx][yy] >= (a[x][y] - D)) {

					viz[xx][yy] = 1;
					qx[sf] = xx, qy[sf ++] = yy;
					if (a[xx][yy] >= a[x][y]) nrdest[x][y] ++;
				}
			}
		}
	}
}

int main()
{
	freopen("mexc.in", "r", stdin);
#ifndef _SCREEN_
	freopen("mexc.out", "w", stdout);
#endif

	scanf("%d %d %d\n", &N, &M, &D);
	for (int i = 1; i <= N; i ++) {
		for (int j = 1; j <= M; j ++) {
			scanf("%d ", &a[i][j]);
		}
	}

	for (int i = 1; i <= N; i ++) {
		for (int j = 1; j <= M; j ++) {
			BF(i, j);
		}
	}

	for (int i = 1; i <= N; i ++) {
		for (int j = 1; j <= M; j ++) {
			printf("%d ", nrdest[i][j]);
		}
		printf("\n");
	}
	
	return 0;
}
