#include <stdio.h>

#define MAXN 128

int N, x[MAXN];
int poz[4];

inline void move( int a, int b, int c )
{
	x[a]--; x[b]--; x[c] += 2;

	printf("%d %d %d\n", a + 1, b + 1, c + 1);
}

int main()
{
	freopen("borcane.in", "rt", stdin);
	freopen("borcane.out", "wt", stdout);

	scanf("%d", &N);
	for (int i = 0; i < N; i++)
		scanf("%d", x + i);

	poz[0] = N - 4;
	poz[1] = N - 3;
	poz[2] = N - 2;
	poz[3] = N - 1;
	for (int i = 0; i < N - 4; i++)
	{
		for (int j = i + 1; j < N - 1 && x[i]; j++)
			for (; x[i] && x[j]; )
				move( i, j, N - 1 );

		if (x[i])
			poz[0] = i;
	}

	for (; 1; )
	{
		for (int i = 0; i < 4; i++)
		for (int j = i + 1; j < 4; j++)
		for (int k = 0; k < 4; k++)
		{
			if (x[ poz[i] ] && x[ poz[j] ] && i != k && j != k &&
		            x[ poz[i] ] + x[ poz[j] ] == x[ poz[k] ])
			{
				int l = 6 - (i + j + k);
	
				for (; x[ poz[i] ]; )
					move( poz[i], poz[k], poz[l] );
				for (; x[ poz[j] ]; )
					move( poz[j], poz[k], poz[l] );
			}
		}
		
		int a = -1, b = -1, c = -1, d = -1;
		for (int i = 0; i < 4; i++)
			if (a == -1 || x[ poz[i] ] < x[a])
				a = poz[i];
		for (int i = 0; i < 4; i++)
			if (a != poz[i] && (b == -1 || x[ poz[i] ] < x[b]))
				b = poz[i];
		for (int i = 0; i < 4; i++)
			if (a != poz[i] && b != poz[i] && (c == -1 || x[ poz[i] ] < x[c]))
				c = poz[i];
		for (int i = 0; i < 4; i++)
			if (a != poz[i] && b != poz[i] && c != poz[i])
				d = poz[i];
		if (x[a] == 0 && x[b] == 0 && x[c] == 0)
			return 0;

		if (x[a] && x[a] == x[b])
		{
			for (; x[a]; )
				move( a, b, d );
			continue;
		}
		if (x[b] == x[c])
		{
			for (; x[b]; )
				move( b, c, d );
			continue;
		}
		if (x[c] == x[d])
		{
			for (; x[c]; )
				move( c, d, b );
			continue;
		}

		if (x[c] && x[b] && x[c] - 1 == x[a] + 2 + x[b] - 1)
			move( c, b, a );
		else
			move( d, c, a );
	}

	return 0;
}

