#include <stdio.h>
#include <vector>
#include <queue>
#include <list>
#include <algorithm>
#define NMAX 105
struct borc {
	long cnt;
	long i;
};
struct operatie {
	long from1, from2;
};
struct comp_borc {
	bool operator() (borc x, borc y) {
		return x.cnt<y.cnt;
	};
};
long n;
std::vector<borc> v(NMAX);
std::list<operatie> operatii;
long winningto;
int main (void) {
	FILE * fi = fopen("borcane.in","rt");
	FILE * fo = fopen("borcane.out","wt");
	fscanf(fi,"%ld",&n);
	long bombsum=0;
	for (long i=1; i<=n; i++) {
		long tmp16;
		fscanf(fi,"%ld",&tmp16);
		v[i].cnt=tmp16;
		v[i].i=i;
		bombsum+=v[i].cnt;
	};
	std::priority_queue<borc,std::vector<borc>,comp_borc> pq;
	char amers=0;
	for (long i=1; (!amers) && (i<=n); i++) {
		if (bombsum%2==v[i].cnt%2) {
			while (!pq.empty()) pq.pop();
			while (!operatii.empty()) operatii.pop_back();
			for (long j=1; j<=n; j++) if (i!=j) if (v[j].cnt>0) {
				pq.push(v[j]);
			};
			while (pq.size()>=2) {
				//mai avem 2 elemente nenule
				borc tmp1, tmp2;
				tmp1=pq.top();
				pq.pop();
				tmp2=pq.top();
				pq.pop();
				operatie tmp3;
				tmp3.from1=tmp1.i;
				tmp3.from2=tmp2.i;
				operatii.push_back(tmp3);

				tmp1.cnt--; tmp2.cnt--;
				if (tmp1.cnt>0) pq.push(tmp1);
				if (tmp2.cnt>0) pq.push(tmp2);
			};
			if (pq.size()==0) {
				amers=1;
				winningto=i;
			};
		};		
	};
	if (amers) {
		for (std::list<operatie>::iterator oc=operatii.begin(); oc!=operatii.end(); oc++) {
			fprintf(fo,"%ld %ld %ld\n",oc->from1,oc->from2,winningto);
		};
	};
	fclose(fi); fclose(fo);
	return 0;
};
