#include <stdio.h>
#include <memory.h>
#include <queue>
#include <list>
#include <cassert>
#define NMAX 810
#define GRMAX NMAX*NMAX
struct pct {
	long i; long j;
};
std::queue<pct> qd;
std::queue<int> qd2;
char atins[GRMAX];

std::list<int> grupln[GRMAX];
long grupk[GRMAX];
long gruph[GRMAX];
long grupcntg[GRMAX];
long pornh, fmm;
long n,m,d;
long a[NMAX][NMAX];
char vz[NMAX][NMAX];
long ph[NMAX][NMAX];
long grup[NMAX][NMAX];
long deb_bagari_coada=0;
long curgrup, grups;
void tryGo(pct care, int offi, int offj) {
	if ((care.i+offi>=1) && (care.i+offi<=n) && (care.j+offj>=1) && (care.j+offj<=m)) 
		if ((!vz[care.i+offi][care.j+offj]) && (a[care.i+offi][care.j+offj]==pornh) && (grup[care.i+offi][care.j+offj]==0)) {
//			fprintf(stderr,"..si %ld %ld face parte\n",care.i+offi,care.j+offj);
			grupk[grup[care.i][care.j]]++;
			vz[care.i+offi][care.j+offj]=1;
			pct niu;
			niu.i=care.i+offi; 
			niu.j=care.j+offj;
			qd.push(niu);
//			deb_bagari_coada++;
//			printf("..bagat in coada %ld %ld\n",niu.i,niu.j);
			grup[care.i+offi][care.j+offj]=curgrup;
		};
};

void tryLink(pct care, int offi, int offj) {
	if ((care.i+offi>=1) && (care.i+offi<=n) && (care.j+offj>=1) && (care.j+offj<=m)) 	
		if (grup[care.i][care.j]!=grup[care.i+offi][care.j+offj]) {
			long grup1=grup[care.i][care.j];
			long grup2=grup[care.i+offi][care.j+offj];
			char nu=0;
			for (std::list<int>::iterator it=grupln[grup1].begin(); it!=grupln[grup1].end(); it++)
				if (*it==grup2) nu=1;
			if (!nu) grupln[grup1].push_back(grup2);
//			if (!nu) fprintf(stderr,"link'd: %ld cu %ld\n",grup1,grup2);
			nu=0;
			for (std::list<int>::iterator it=grupln[grup2].begin(); it!=grupln[grup2].end(); it++)
				if (*it==grup1) nu=1;
			if (!nu) grupln[grup2].push_back(grup1);
//			if (!nu) fprintf(stderr,"link'd: %ld cu %ld\n",grup2,grup1);
		};
};

int main (void) {
	FILE * fi = fopen("mexc.in","rt");
	FILE * fo = fopen("mexc.out","wt");
	fscanf(fi,"%ld %ld %ld",&n,&m,&d);
	for (long i=1; i<=n; i++)
		for (long j=1; j<=m; j++) {
			fscanf(fi,"%ld",&a[i][j]);
		};
	for (long i=1; i<=n; i++)
		for (long j=1; j<=m; j++) {
			if (grup[i][j]==0) {
//				fprintf(stderr,"uite un cacanar: %ld %ld\n",i,j);
				grups++;
				grup[i][j]=grups;
				grupk[grups]=1;
				gruph[grups]=a[i][j];
				curgrup=grups;
				pornh=a[i][j];
				pct tmp;
				tmp.i=i;
				tmp.j=j;
				qd.push(tmp);
				while (!qd.empty()) {
					tmp=qd.front();
					qd.pop();
					tryGo(tmp,1,0);
					tryGo(tmp,0,1);
					tryGo(tmp,-1,0);
					tryGo(tmp,0,-1);
				};
			};
		};
	for (long i=1; i<=n; i++) 
		for (long j=1; j<=m; j++) {
			pct tmp; tmp.i=i; tmp.j=j;
			tryLink(tmp,1,0);
			tryLink(tmp,0,1);
			tryLink(tmp,-1,0);
			tryLink(tmp,0,-1);
		};
	for (long i=1; i<=grups; i++) {
		char fnd=0;
		for (std::list<int>::iterator he=grupln[i].begin(); he!=grupln[i].end(); he++) 
			if (*he==i) fnd=1;
		if (!fnd) grupln[i].push_back(i);
	};
	
	
//	for (long i=1; i<=n; i++) {
//		for (long j=1; j<=m; j++)
//			fprintf(fo,"%ld ",grup[i][j]);
//		fprintf(fo,"\n");
//	};
//	for (long i=1; i<=n; i++) fprintf(stderr,"grup %ld are %ld\n",i,grupk[i]);
	for (long i=1; i<=grups; i++) {
//		fprintf(stderr,"grup %ld\n",i);
		long cntgoods=0;
		memset(atins,0,sizeof(atins));
		qd2.push(i);
		while (!qd2.empty()) {
			int temp=qd2.front();
			qd2.pop();
			for (std::list<int>::iterator he=grupln[temp].begin(); he!=grupln[temp].end(); he++) {
//				fprintf(stderr,"..vecin %d\n",*he);
				if ((!atins[*he]) && (gruph[*he]>=gruph[i]-d)) {
					atins[*he]=1;
					qd2.push(*he);
					if (gruph[*he]>=gruph[i]) {
//						fprintf(stderr,"grup %ld ajugne la grup %d (%ld)\n",i,*he,grupk[*he]);
						cntgoods+=grupk[*he];
					};
				}
			};
		};
//		fprintf(stderr,"grupul %ld are %ld destfins\n",i,cntgoods);
		grupcntg[i]=cntgoods;
	};
	
	for (long i=1; i<=n; i++) {
		for (long j=1; j<=m; j++) 
			fprintf(fo,"%ld ",grupcntg[grup[i][j]]);
		fprintf(fo,"\n");
	};
	
	fclose(fi); fclose(fo);
	return 0;
};
