#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;

#define NMAX 810
#define MP make_pair
#define ff first
#define ss second
#define tip pair<int, pair<int, int> > 

int N, M, D;

int na;
tip a[NMAX * NMAX];

char bagat[NMAX * NMAX];
int tata[NMAX * NMAX];
int ntot[NMAX * NMAX];
int nfin[NMAX * NMAX];

int rez[NMAX][NMAX];

int beg;
char s[NMAX * 10];

inline void GET(int &x)
{
	for (; s[beg] && !('0' <= s[beg] && s[beg] <= '9'); beg++);

	for (x = 0; '0' <= s[beg] && s[beg] <= '9'; beg++)
		x = x * 10 + s[beg] - '0';
}

int cmp(tip a, tip b) { return a > b; }

int dx[] = {0, 0, 1,-1};
int dy[] = {1,-1, 0, 0};

void print_mem()
{
	printf("%lf\n", (double) ( sizeof(a) + sizeof(bagat) + sizeof(tata) + sizeof(ntot) + sizeof(nfin) + sizeof(rez) ) / 1024 / 1024);
}

inline int MAX(int a, int b) { return (a > b) ? a : b; }

inline int get_nod(int x, int y)
{
	return (x - 1) * M + y;
}

inline int father(int x)
{
	if (tata[x] == x) return x;

	return tata[x] = father(tata[x]);
}

inline void unite(int x, int y)
{
	if (x == y) return;

	if (rand() & 1) tata[x] = y, ntot[y] += ntot[x], nfin[y] += nfin[x];
	else tata[y] = x, ntot[x] += ntot[y], nfin[x] += nfin[y];
}

inline void baga_nod(int x, int y, int e)
{
	int i, xx, yy, q = get_nod(x, y), w;

	nfin[father(q)] += e;

	if (bagat[q]) return;

	ntot[q] = 1;
	bagat[q] = 1;

	for (i = 0; i < 4; i++) {
		xx = x + dx[i]; yy = y + dy[i];

		if (xx < 1 || yy < 1 || xx > N || yy > M) continue;
		w = get_nod(xx, yy);
		if (!bagat[w]) continue;

		unite(father(q), father(w));
	}
}

/* 
int jeg[NMAX][NMAX];
int rez_b[NMAX][NMAX];
int XX[NMAX * NMAX];
int YY[NMAX * NMAX];
char viz[NMAX][NMAX];

int baga_bf(int x, int y)
{
	memset(viz, 0, sizeof(viz));
	viz[x][y] = 1;
	XX[0] = x; YY[0] = y;
	int p = 0, q = 0, xx, yy, i, xb = x, yb = y, rez = 1;

	while (p <= q) {
		x = XX[p];
		y = YY[p];
		p++;

		for (i = 0; i < 4; i++) {
			xx = x + dx[i]; yy = y + dy[i];

			if (xx < 1 || yy < 1 || xx > N || yy > M) continue;
			if (viz[xx][yy]) continue;
			if (!(jeg[xx][yy] >= jeg[xb][yb] - D)) continue;

			if (jeg[xx][yy] >= jeg[xb][yb]) rez++;

			q++;
			XX[q] = xx; YY[q] = yy;
			viz[xx][yy] = 1;
		}
	}

	return rez;
}

void get_brute()
{
	int i, j;

	for (i = 1; i <= N; i++)
		for (j = 1; j <= M; j++) 
			rez_b[i][j] = baga_bf(i, j);
}
*/


int gen(int N, int M, int D, int RND)
{
	freopen("mexc.in", "w", stdout);

	int i, j;

	printf("%d %d %d\n", N, M, D);

	for (i = 1; i <= N; i++) {
		for (j = 1; j <= M; j++) printf("%d ", rand() % RND + 1);
		printf("\n");
	}

	return 0;
}


int main()
{
//	srand(13);
//	gen(800, 800, 1000, 100000);
	
	int i, j, k, q;

//	print_mem();
	
	freopen("mexc.in", "r", stdin);
	freopen("mexc.out", "w", stdout);

	scanf("%d %d %d\n", &N, &M, &D);

	for (i = 1; i <= N; i++) {
		beg = 0;
		fgets(s, NMAX * 10, stdin);
		for (j = 1; j <= M; j++) {
			na++;
			tata[na] = na;
			GET(q);


//			jeg[i][j] = q;


			a[na] = MP(q, MP(i, j));
		}
	}

	sort(a + 1, a + na + 1, cmp);

	int vc;
	q = 0;
	for (i = 1; i <= na; ) {
		vc = a[i].ff;
		for (j = i; j <= na && vc == a[j].ff; j++);

		for (k = i; k < j; k++) baga_nod(a[k].ss.ff, a[k].ss.ss, 1);

		q = MAX(q, j + 1);
		while (q <= na && a[q].ff >= vc - D) {
			baga_nod(a[q].ss.ff, a[q].ss.ss, 0);
			q++;
		}

		for (k = i; k < j; k++) 
	rez[a[k].ss.ff][a[k].ss.ss] = nfin[father(get_nod(a[k].ss.ff, a[k].ss.ss))];

		i = j;
	}

//	get_brute();

	for (i = 1; i <= N; i++) {
		for (j = 1; j <= M; j++) {
			
/*			if (rez[i][j] != rez_b[i][j]) {
				printf("kkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkkt\n");
				while (1);
				exit(0);
			}
*/
			printf("%d ", rez[i][j]);
		}
		printf("\n");
	}

return 0;
}

