#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

int N, T;
vector<int> G[2002];
bool rep[2002][1002];
int tn[2002][4004];
int vt[2002];

void printtn()
{
	for (int i(1); i <= N; ++i) {
		for (int j(0); j <= 6; ++j)
			cout << tn[i][j] << " ";
		cout << endl;
	}
}

void initvt()
{
	for (int i(0); i < N; ++i)
		vt[i] = i+1;
}

void walk(int u, int d, int nf)
{
	if (G[u].size() == 0) {
		/*for (int i = d; i < d + nf; ++i)
			tn[u][i] = 0;*/
		//cout << "calculat " << u << " pentru t = [" << d << ".." << d + nf - 1 << "]" << endl;		
		return;
	}
	
	for (vector<int>::iterator v = G[u].begin(); v != G[u].end(); ++v)
		walk(*v, d+1, G[u].size()+nf);
	
	//cout << u << "; voi timpul necesar pentru t = [" << d << ".." << d + nf - 1 << "]" << endl;
	for (int dd = d; dd < d + nf; ++dd) {
		initvt();
		int tmin(100000),
		    tcur;
		int off = 0;
		if (rep[u][dd])
			off = 1;
		do {
			/*for (int i(0); i < (int)G[u].size(); ++i)
				cout << vt[i] << " ";*/

			/*tcur = off;
			for (int i(0); i < (int)G[u].size(); ++i)
				tcur += tn[G[u][i]][dd+vt[i]+off+1] + vt[i];*/
			tcur = 1000000;
			for (int i(0); i < (int)G[u].size(); ++i)
				if (tcur > tn[G[u][i]][dd+vt[i]+off+1] + vt[i])
					tcur = tn[G[u][i]][dd+vt[i]+off+1] + vt[i];
			
			//cout << " -> " << tcur << endl;

			tcur += off;
			if (tcur < tmin)
				tmin = tcur;
		} while (next_permutation(vt, vt + G[u].size()));

		tn[u][dd] = tmin + G[u].size() - 1;
	}
}

int main(int argc, char *argv[])
{
	FILE *fi = fopen("tcast.in", "r");
	fscanf(fi, "%d %d", &N, &T);
	int u, v;
	for (int i(0); i < N-1; ++i) {
		fscanf(fi, "%d %d", &u, &v);
		G[u].push_back(v);
	}

	int aux;
	for (int i(1); i <= N; ++i)
		for (int j(0); j < T; ++j) {
			fscanf(fi, "%d", &aux);
			if (aux) 
				rep[i][j] = true;
		}
	fclose(fi);

	walk(1, 0, 1);

	//printtn();
	//cout << tn[1][0] << endl;
	
	ofstream fout("tcast.out");
	fout << tn[1][0] << endl;
	fout.close();
	
	return 0;
}

