#include <stdio.h>
#include <string.h>

int n, m, d, a[805][805], b[805][805], v[805][805];
int dx[4] = {0,1,0,-1}, dy[4] = {1,0,-1,0}, pas;

typedef struct
{
   int x, y;
} Punct;
Punct c[640006];

void citire()
{
   freopen("mexc.in","r",stdin);
   freopen("mexc.out","w",stdout);

   int i, j, x, k, dim;
   scanf("%d %d %d\n",&n,&m,&d);
   for (i = 1; i <= n; i++)
      for (j = 1; j <= m; j++) scanf("%d",&a[i][j]);
}

void afis()
{
   int i, j;
   for (i = 1; i <= n; i++)
   {
      for (j = 1; j < m; j++) printf("%d ",b[i][j]);
      printf("%d\n",b[i][m]);
   }
}

void calcul(int x, int y, int pas)
{
   int i, j, xx, yy, p, u;
   p = u = b[x][y] = 1;
   v[x][y] = pas;
   c[1].x = x; c[1].y = y;

   while (p <= u)
   {
      for (i = 0; i < 4; i++)
      {
         xx = c[p].x + dx[i];
         yy = c[p].y + dy[i];
         if (a[xx][yy] && v[xx][yy] != pas && a[x][y] - d <= a[xx][yy])
         {
            c[++u].x = xx;
            c[u].y = yy;
            if (a[xx][yy] >= a[x][y]) b[x][y]++;
            v[xx][yy] = pas;
         }
      }
      p++;
   }
}

void vecini(int x, int y, int pas)
{
   int i, j, xx, yy, p, u;
   p = u = 1;
   v[x][y] = pas;
   c[1].x = x; c[1].y = y;

   while (p <= u)
   {
      for (i = 0; i < 4; i++)
      {
         xx = c[p].x + dx[i];
         yy = c[p].y + dy[i];
         if (a[xx][yy] && v[xx][yy] != pas && a[x][y] - d <= a[xx][yy])
         {
            c[++u].x = xx;
            c[u].y = yy;
            if (a[xx][yy] == a[x][y]) b[xx][yy] = b[x][y];
            v[xx][yy] = pas;
         }
      }
      p++;
   }
}

int main()
{
   int i, j;
   citire();
   for (i = 1; i <= n; i++)
      for (j = 1; j <= m; j++)
         if (!b[i][j])
         {
            calcul(i,j,++pas);
            vecini(i,j,++pas);
         }
   afis();
   return 0;
}

