#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int n, T, timp[2005][1005], fii[2000], viz[2000], tm;
int cnt;

typedef struct nod
{
   int x;
   nod *a;
} *pNod;
pNod v[2005];

int cmp(const void *x, const void *y)
{
   int a = *(int*)x, b = *(int*)y;
   return (fii[a] + (timp[a][T-1] - timp[a][tm])) - (fii[b] + (timp[b][T-1] - timp[b][tm]));
}

void add(pNod &p, int x)
{
   pNod q = new nod;
   q -> x = x;
   q -> a = p;
   p = q;
}

void citire()
{
   freopen("tcast.in","r",stdin);
   freopen("tcast.out","w",stdout);

   int i, j, x, y;
   scanf("%d %d",&n,&T);
   for (i = 1; i < n; i++)
   {
      scanf("%d %d",&x,&y);
      add(v[x],y); add(v[y],x);
   }
   for (i = 1; i <= n; i++)
      for (j = 0; j < T; j++)
      {
	 scanf("%d",&timp[i][j]);
	 timp[i][j] += timp[i][j-1];
      }
}

void DF(int nod)
{
   pNod p;
   viz[nod] = 1;
   for (p = v[nod]; p != NULL; p = p -> a)
      if (!viz[p -> x])
      {
         DF(p -> x);
         fii[nod]++;
      }
}

void solve(int nod, int tmp)
{
   int a[2005], nr = 0, i;
   pNod p; viz[nod] = 1;
   tm = tmp;
   for (p = v[nod]; p != NULL; p = p -> a)
      if (!viz[p->x]) a[nr++] = p ->x;

   qsort(a,nr, sizeof(int),cmp);

   for (i = nr - 1; i >= 0; i--)
   {
      if (tmp < T)
      {
	 if (timp[nod][tmp] - timp[nod][tmp-1]) tmp++, i++;
	 else
	 {
	    tmp++; solve(a[i],tmp);
	 }
      }
     else
     {
        tmp++; solve(a[i],tmp);
     }
  }
  if (tmp > cnt) cnt = tmp;
}

int main()
{
   citire();
   DF(1);
   memset(viz,0,sizeof(viz));
   solve(1,0);
   printf("%d\n",cnt);
   return 0;
}
   
   

