#include <cstdio>
#define MAX_N 1000

int A[MAX_N][MAX_N];
int U[MAX_N][MAX_N];
int lower, start;
int n, m, c, i, j, X;

int dx[] = {1, 0, 0, -1},
	dy[] = {0, 1, -1, 0};

int DFS(int x, int y) {
	int nr = 0;
	if ( A[x][y] >= start ) ++nr;
	U[x][y] = X;
	for ( int i=0; i<4; ++i ) {
		int nx = x+dx[i];
		int ny = y+dy[i];
		if ( nx>=0 && nx<n && ny>=0 && ny<m && U[nx][ny] != X && A[nx][ny]>=lower ) 
			nr += DFS(nx, ny);
	}
	return nr;
}

int main() {
	freopen("mexc.in", "r", stdin);
	freopen("mexc.out","w",stdout);
	scanf("%d %d %d", &n, &m, &c);
	for ( i=0; i<n; ++i ) 
		for ( j=0; j<m; ++j )
			scanf("%d", A[i]+j);

	for ( i=0; i<n; ++i )
		for ( j=0; j<m; ++j) {
			lower = A[i][j] - c;
			start = A[i][j];
			++X;
			printf("%d%c", DFS(i,j), j!=m-1?' ':'\n');
		}
	return 0;
}
