#include <cstdio>
#include <cstring>

using namespace std;

#define FIN "mexc.in"
#define FOUT "mexc.out"
#define MAX_N 405
#define MAX_Q 100005
#define MOD 100000

const int dx[4] = {1, 0, -1, 0};
const int dy[4] = {0, -1, 0, 1};

int A[MAX_N][MAX_N];
int N, M, D;

int C[MAX_Q];

unsigned char S[MAX_N][MAX_N];

      void readdata ()
      {
          int i, j;
          scanf ("%d %d %d\n", &N, &M, &D);
          
          for (i = 1; i <= N; ++i)
             for (j = 1; j <= M; ++j)
                scanf ("%d", A[i] + j);
      }

      int ok (int x, int y)
      {
             int ret = 1;
             if (!x || !y || x == (N + 1) || y == (M + 1)) ret = 0;
             if (S[x][y] == 1) ret = 0;
             return ret;
      }

      int BFS (int nodst, int H, int xin, int yin)
      {
          int li, lf;
          li = lf = 0;
          int ct = 1;
          S[xin][yin] = 1;
          
          C[++lf] = nodst;
          while (li < lf)
          {
                int nod = C[(++li) % MOD];
                int x, y, i;
                x = nod >> 10, y = nod & 1023;

                for (i = 0; i < 4; ++i)
                    if (ok(x + dx[i], y + dy[i]))
                        if (A[x + dx[i]][y + dy[i]] >= H - D)
                        {
                           if (A[x + dx[i]][y + dy[i]] >= A[xin][yin]) ++ct;
                           C[(++lf) % MOD] = ((x + dx[i]) << 10) + (y + dy[i]);
                           S[x + dx[i]][y + dy[i]] = 1;
                        }
          }
          return ct;
      }

      void solve ()
      {
          int i, j;

          for (i = 1; i <= N; ++i)
          {
                for (j = 1; j <= M; ++j)
                {
                     memset (S, 0, sizeof (S));
                     int p = BFS ((i << 10) + j, A[i][j], i, j);
                     printf ("%d ", p);
                }
                printf ("\n");
          }
      }

      int main ()
      {
           freopen (FIN, "r", stdin);
           freopen (FOUT, "w", stdout);

           readdata ();
           solve ();

           return 0;
      }
