#include <fstream>
#define MAX 801

using namespace std;

const int di[] = {-1, 0, 1, 0};
const int dj[] = {0, 1, 0, -1};

int a[MAX][MAX], c1[MAX+MAX][3], c2[MAX+MAX][3], rez[MAX][MAX];
bool v[MAX][MAX];
int m, n, D;

int GoDeep(int x, int y)
{
	int i, j, k = 0, k2 = 0, in, jn, sol = 1, s, d;
	memset(v, false, sizeof(v));
	
	k = 0;
	v[x][y] = 1;
	c1[++k][0] = x;
	c1[k][1] = y; 
	
	while (k)	
	{
		k2 = 0;
		for (s = 1; s <= k; s++)
		{
			i = c1[s][0];
			j = c1[s][1];
			for (d = 0; d < 4; d++)
			{
				in = i + di[d];
				jn = j + dj[d];
				if (!v[in][jn] && in >= 1 && in <= n && jn >= 1 && jn <= m && a[in][jn] >= a[x][y] - D)
				{
					if (a[in][jn] >= a[x][y]) sol++;
					c2[++k2][0] = in;
					c2[k2][1] = jn;
					v[in][jn] = 1;
				}
			}
		}	
		k = k2;
		for (s = 1; s <= k2; s++)
			c1[s][0] = c2[s][0], c1[s][1] = c2[s][1];
	}
	return sol;
}

int main()
{
	int i, j;
	ifstream fin("mexc.in");
	fin >> n >> m >> D;
	for (i = 1; i <= n; i++)
		for (j = 1; j <= m; j++)
			fin >> a[i][j];
	fin.close();
	
	for (i = 1; i <= n; i++)
		for (j = 1; j <= m; j++)
			rez[i][j] = GoDeep(i, j);
	
	ofstream fout("mexc.out");
	for (i = 1; i <= n; i++)
	{
		for (j = 1; j <= m; j++)
			fout << rez[i][j] << " ";
		fout << "\n";
	}
	fout.close();
	
	return 0;
}
