#include <fstream>
#include <vector>
#define MAXN 2001
#define MAXT 1001

using namespace std;

int a[MAXN][2*MAXT];
vector<vector<int> > v(MAXN), g(MAXN);
bool sel[MAXN], s[MAXN][MAXT];
int n, T;
	
void TSort(int nod)
{
	sel[nod] = true;
	int i, j, x = v[nod].size();
	
	for (i = 0; i < x; i++)
	{
		j = v[nod][i];
		if (!sel[j])
		{
			g[nod].push_back(j);
			TSort(j);
		}
	}
}

int GetConfig(int nod, int t, vector<int> p)
{
	int i, j, x = p.size(), rez = 0;
	
	for (i = 0; i < x; )
	{
		j = g[nod][p[i]];
		if (t > T || !s[nod][t])
		{
			rez = (rez < a[j][t]) ? a[j][t] : rez;
			t++; i++;
		}
		else t++;
	}	
	return rez;
}

int DF(int nod, int t)
{
	int x = g[nod].size(), i, j, p, rez = 99999;
	
	for (; t <= T && s[nod][t]; t++);
	
	if (a[nod][t]) return a[nod][t];
		
	if (g[nod].empty()) return t;
	
	for (j = t+1; j <= 2*T; j++)
	{
		for (p = 0; p < x; p++)	
		{
			i = g[nod][p];
			a[i][j] = DF(i, j);
		}
	}
	
	vector<int> aux;
	for (i = 0; i < x; i++) aux.push_back(i);
	
	do
	{
		i = GetConfig(nod, t+1, aux);
		if (i < rez) rez = i;
	} while (next_permutation(aux.begin(), aux.end()));	
	
	a[nod][t] = rez;
	
	return rez;
}

int main()
{
	int i, j, v1, v2;
	ifstream fin("tcast.in");
	fin >> n >> T;
	for (i = 1; i < n; i++)
	{
		fin >> v1 >> v2;
		v[v1].push_back(v2);
		v[v2].push_back(v1);
	}
	
	for (i = 1; i <= n; i++)
		for (j = 0; j < T; j++)
			fin >> s[i][j];
	fin.close();
	
	TSort(1);
	
	ofstream fout("tcast.out");
	fout << DF(1, 0) << "\n";
	fout.close();
	
	return 0;	
}
