using namespace std;

#include <cstdio>
#define nmax 807

int X[nmax*nmax], Y[nmax*nmax];

int viz[nmax][nmax], NR[nmax][nmax], V[nmax][nmax];

int N, M, D, vizite;

int dx[] = {0, -1, 0, 1};
int dy[] = {-1, 0, 1, 0};

void fill(int x, int y)
{
  int ic, sc, xx, yy, c, d, k;

  X[ic = 0] = x;
  Y[sc = 0] = y;
  viz[x][y] = ++vizite;

  NR[x][y] = 1;

  while (ic <= sc)
  {
    xx = X[ic];
    yy = Y[ic];

    for (k = 0; k < 4; ++k)
    {
      c = xx+dx[k];
      d = yy+dy[k];
      if (viz[c][d] != vizite && V[c][d] >= V[x][y]-D && V[c][d] >= 0)
      {
        viz[c][d] = vizite;
        ++sc;
        X[sc] = c;
        Y[sc] = d;

        if (V[c][d] >= V[x][y])
          ++NR[x][y];
      }
    }

    ++ic;
  }
}

int main()
{
  int i, j, ok, ii, jj, k;

  freopen("mexc.in", "r", stdin);
  freopen("mexc.out", "w", stdout);

  scanf("%d%d%d", &N, &M, &D);

  for (i = 1; i <= N; ++i)
    for (j = 1; j <= M; ++j)
      scanf("%d", &V[i][j]);

  for (i = 0; i <= N+1; ++i)
    V[i][M+1] = V[i][0] = -1;

  for (j = 0; j <= M+1; ++j)
    V[0][j] = V[N+1][j] = -1;

  for (i = 1; i <= N; ++i)
    for (j = 1; j <= M; ++j)
    {
      for (ok = k = 0; k < 2 && !ok; ++k)
        if (V[i+dx[k]][j+dy[k]] == V[i][j])
        {
          ok = 1;
          ii = i+dx[k];
          jj = j+dy[k];
        }

      if (ok)
        NR[i][j] = NR[ii][jj];
      else
        fill(i, j);
    }
    
  for (i = 1; i <= N; ++i)
  {
    for (j = 1; j < M; ++j)
      printf("%d ", NR[i][j]);
    printf("%d\n", NR[i][j]);
  }

  return 0;
}

  


