
# include <stdio.h>
# include <fstream>
# include <cstring>
# include <map>
# include <set>

using namespace std;

# define input "mexc.in"
# define output "mexc.out"

# define abs(a) (a<0?-a:a)
# define maxim(a,b) (a>b?a:b)
# define minim(a,b) (a<b?a:b)

# define max 801

int a[max][max];
bool u[max][max];
int nr,n,m,k,x;

const int dx[] = {0,1,0,-1};
const int dy[] = {-1,0,1,0};

int ok(int i,int j)
{
    if( i < 1 || j < 1 || i > n || j > m)
        return 0;
    if(a[i][j] < x-k) return 0;
    return 1;
}

void numara(int i,int j)
{
    u[i][j] = 1;
    for(int k = 0; k < 4; k++)
    {
        if(ok(i+dx[k],j+dy[k]) && !u[i+dx[k]][j+dy[k]])
        {
            if(a[i+dx[k]][j+dy[k]] >= x)
            nr++;
            numara(i+dx[k],j+dy[k]);
        }
    }
}


int main()
{
        freopen(input,"r", stdin);
        freopen(output,"w", stdout);
        
        scanf("%d %d %d",&n,&m,&k);

        int i,j;

        for(i = 1; i <= n; i++)
            for(j = 1; j <= m; j++)
                scanf("%d ",&a[i][j]);

        for(i = 1; i<= n; i++)
        {
            for(j = 1; j <= m; j++)
            {
                memset(u,0,sizeof(u));
                nr=1;
                x = a[i][j];
                numara(i,j);
                printf("%d ",nr);
            }
            printf("\n");
        }
        
        return 0;
}

