#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <algorithm>
#include <iostream>
#include <queue>

using namespace std;

#define PB(x) push_back(x)
#define SZ(x) (x).size()
#define MP(a,b) make_pair((a), (b))
#define ii pair<int, int>
#define vi vector<int>
#define vii vector< ii >
#define ALL(x) (x).begin(), (x).end()
#define SORT(x) sort(ALL(x))

#define FOR(i,N) for (int (i) = 0; (i)<(N); ++(i))
#define FORE(i,N) for (int (i) = 0; (i)<=(N); ++(i))
#define FORIE(i,j,N) for (int (i) = (j); (i)<=(N); ++(i))
#define FORI(i,j,N) for (int (i) = (j); (i)<(N); ++(i))

#define FORV(i,V) for (int (i) = 0; (i)<SZ(V); ++(i))
#define FORIT(i, C) for (typeof((C).begin()) i = (C).begin(); i != (C).end(); ++(i))

#define PRINT(V) FORV(i,V) cerr << V[i] << " "; cerr << "\n";
#define PRINTV(V, i, j) FORIE(tz, i, j) cerr << V[tz] << " "; cerr << "\n";
#define PRINTC(C) FORIT(tz,C) cerr << *tz << " "; cerr << "\n";

#define INF 0x3f3f3f3f

#define NMAX 2001
#define TMAX 1001

int N,T;
vi G[NMAX];
vi P[NMAX];
int tata[NMAX];
int tmp[NMAX];
int viz[NMAX];
int delay[NMAX], rdy[NMAX];
int st[NMAX][TMAX];
vi cand;

void preproc(int node)
{
    priority_queue< ii > *Q = new priority_queue< ii >();

    FORV(i, G[node])
    {
        int next = G[node][i];

            preproc(next);

            Q->push( MP(tmp[next], next) );
    }

    int last = 0;

    int t = 1;

    int diff = 0;

    FORV(i, G[node])
    {
        ii per = Q->top();
        Q->pop();

        if (t == 1)
        {
            t += per.first;
        }

        if (per.first == last)
        {
            --diff;
            if (diff <= 0)
                ++t;
        }
        else
            diff += per.first - last;

        last = per.first;

        
        P[node].PB(per.second);
    }

    tmp[node] = t;
}

int simulate()
{
    int t = 0;

    queue< ii > Q[2];

    Q[0].push( MP(1, 0) );

    int cur = 1, prev = 0;

    while (!Q[prev].empty())
    {
        while (!Q[prev].empty())
        {
            ii per = Q[prev].front();
            Q[prev].pop();

            int node = per.first;
            int ind = per.second;

            if (t<T && st[node][t])
            {
                Q[cur].push( MP(node,ind) );
                ++delay[node];
            }
            else
            {
                if (ind < SZ(P[node]))
                {
                    int next = P[node][ind];
                    Q[cur].push( MP(next, 0) );
                }

                ++ind;
                if (ind < SZ(P[node]))
                    Q[cur].push( MP(node, ind) );

            }
        }

        ++t;
        cur = 1 - cur;
        prev = 1 - prev;
    }

    return t-1;
}

void mutate()
{
    int node = -1;

    if (rand() % 3)
    {
        vi cands;

        int max = 0;
        int fmax = -1;
        FORIE(i,1,N)
        {
            if (delay[i]>max)
            {
                max = delay[i];
                fmax = i;
            }
        }
        

        while (fmax != -1)
        {
            if (SZ(P[fmax]) > 1)
                cands.PB(fmax);
            fmax = tata[fmax];
        }

        if (SZ(cands))
            node = cands[rand() % SZ(cands)];
        else
            node = cand[rand() % SZ(cand)];
    }
    else
        node = cand[rand() % SZ(cand)];

    random_shuffle(P[node].begin(), P[node].end());
}

int main()
{
    timeval t,t2;

    gettimeofday(&t, 0);

    freopen("tcast.in", "r", stdin);
    freopen("tcast.out", "w", stdout);

    scanf("%d %d", &N, &T);

    FOR(i, N-1)
    {
        int x,y;
        scanf("%d %d", &x, &y);

        tata[y] = x;
        G[x].PB(y);
    }

    tata[1] = -1;

    FORIE(i, 1, N)
    {
        FOR(j, T)
        {
            scanf("%d", &st[i][j]);

        }

    }

    preproc(1);

    FOR(i,N)
        if (SZ(P[i]) > 1)
            cand.PB(i);

    int min = INF;

    do
    {
        int tmp = simulate();
        if (tmp < min)
            min = tmp;
            
        mutate();

        gettimeofday(&t2, NULL);
        
    } while (t2.tv_sec == t.tv_sec || (t2.tv_usec < t.tv_usec && t2.tv_sec == t.tv_sec+1));

    printf("%d\n", min );

    return 0;
}
