using namespace std;
#include<cstdio>
#include<algorithm>
#define Nm 1024
#define Mm (Nm*Nm)
int A[Mm],T[Mm],N[Mm],I[Mm],Ans[Mm],n,m,d;

void read()
{
    char S[800*7];
    int i,j,k,x;

    freopen("mexc.in","r",stdin);
    scanf("%d%d%d ",&n,&m,&d);
    for(i=0;i<n;++i)
    {
        gets(S);
        for(k=j=0;j<m;++j,++k)
        {
            for(x=0;S[k]>='0' && S[k]<='9';++k)
                x=x*10+S[k]-'0';
            A[i*Nm+j]=x;
        }
    }
}

inline bool cmp(int a, int b)
{
    return A[a]>A[b];
}

inline int Find(int x)
{
    int t=x,y;

    while(T[t]>=0) t=T[t];
    while(x!=t)
    {
        y=T[x];
        T[x]=t;
        x=y;
    }
    return t;
}

inline void Union(int x, int y)
{
    if(T[x]<T[y])
    {
        T[y]=x;
        N[x]+=N[y];
    }
    else
    {
        if(T[x]==T[y]) --T[y];
        T[x]=y;
        N[y]+=N[x];
    }
}

void solve()
{
    int i,j,k=0,l,x,y;
    int Dx[]={0,0,-1,1},Dy[]={-1,1,0,0};

    for(i=0;i<n;++i)
        for(j=0;j<m;++j)
            I[k++]=i*Nm+j, T[i*Nm+j]=-1;
    sort(I,I+k,cmp);

    i=j=0;
    while(i<k)
    {
        for(;j<k && A[I[j]]>=A[I[i]]-d;++j)
            for(l=0;l<4;++l)
            {
                x=I[j]/Nm+Dx[l]; y=(I[j]&1023)+Dy[l];
                if(x<0 || x==n || y<0 || y==m || A[x*Nm+y]<A[I[i]]-d)
                    continue;
                x=Find(x*Nm+y); y=Find(I[j]);
                if(x!=y) Union(x,y);
            }
        for(l=i;l<k && A[I[l]]==A[I[i]];++l)
            ++N[Find(I[l])];
        for(l=i;l<k && A[I[l]]==A[I[i]];++l)
            Ans[I[l]]=N[Find(I[l])];
        i=l;
    }
}

void write()
{
    int i,j;

    freopen("mexc.out","w",stdout);
    for(i=0;i<n;++i)
    {
        for(j=0;j<m-1;++j)
            printf("%d ",Ans[i*Nm+j]);
        printf("%d\n",Ans[i*Nm+j]);
    }
}

int main()
{
    read();
    solve();
    write();
    return 0;
}

