using namespace std;
#include<cstdio>
#include<algorithm>
#define Nm 2048
#define Tm 1024
char S[Nm][Nm];
int G[Nm][Nm],M[Nm][Tm],D[Nm],N[Nm],n,t,j;

void read()
{
    int i,x,y;

    freopen("tcast.in","r",stdin);
    scanf("%d%d",&n,&t);
    for(i=1;i<n;++i)
    {
        scanf("%d%d",&x,&y);
        G[x][D[x]++]=y;
        G[y][D[y]++]=x;
    }
    scanf(" ");
    for(i=1;i<=n;++i)
        gets(S[i]);
}

inline int min(int a, int b) { return a<b?a:b; }

inline int max(int a, int b) { return a>b?a:b; }

inline bool cmp(int a, int b)
{
    return M[a][min(j+1,t)]>M[b][min(j+1,t)];
}

void DFS(int x, int tx)
{
    int i,k;

    for(i=0;i<D[x];++i)
        if(G[x][i]!=tx) DFS(G[x][i],x);

    for(j=t;j>=0;--j)
    {
        if(D[x]==1)
        {
            M[x][j]=0;
            continue;
        }
        if(j<t && S[x][j<<1]=='1')
        {
            M[x][j]=1+M[x][j+1];
            continue;
        }
        for(k=i=0;i<D[x];++i)
            if(G[x][i]!=tx) N[k++]=G[x][i];
        sort(N,N+k,cmp);
        for(i=0;i<k;++i)
            M[x][j]=max(M[x][j],M[N[i]][min(j+1,t)]+i+1);
    }
}

void write()
{
    freopen("tcast.out","w",stdout);
    printf("%d\n",M[1][0]);
}

int main()
{
    read();
    DFS(1,0);
    write();
    return 0;
}

