#include<stdio.h>

int A[128];
int arbmin[512], arbmax[512];
int pos[128];

void init(int i,int li, int lf){

    if(li==lf){
        pos[li] = i;
        return ;
    }

    int md = (li+lf) /2;
    init(2*i,li,md);
    init(2*i+1,md+1,lf);

}

void updatemin(int care, int cat){

    int j = pos[care];
    arbmin[j] = cat;

    j/=2;
    while(j){
        arbmin[j] = arbmin[2*j+1];
        if(A[arbmin[2*j]] < A[arbmin[j]])
            arbmin[j] = arbmin[2*j];
        j>>=1;
    }

}

void updatemax(int care, int cat){

    int j = pos[care];
    arbmax[j] = cat;

    j/=2;
    while(j){
        arbmax[j] = arbmax[2*j+1];
        if(A[arbmax[2*j]] > A[arbmax[j]])
            arbmax[j] = arbmax[2*j];
        j>>=1;
    }

}

int main(){

    FILE *fin = fopen("borcane.in","r");
    FILE *fout = fopen("borcane.out","w");

    int N,sum=0,fin1,fin2;
    fscanf(fin,"%d",&N);
    for(int i=1;i<=N;i++){
        fscanf(fin,"%d",&A[i]);
        sum+=A[i];
    }
    A[0] = -1;
    A[N+1] = 1000000000;

    fin1 = fin2 = sum/N;
    if(sum%N == 1)
        fin1 ++;
    else
        if(sum % N >= 2)
            fin1++, fin2++;

    //echilibrare
    init(1,1,N);

    //initializare
    for(int i=1;i<=N;i++){
        updatemin(i,i);
        updatemax(i,i);
    }

    //pasi
    while(A[arbmax[1]] - A[arbmin[1]] > 2){

        int a = arbmax[1];
        updatemax(a,0);
        updatemin(a,N+1);

        int b = arbmax[1];
        updatemax(b,0);
        updatemin(b,N+1);

        int c = arbmin[1];

        if(A[a] == fin1 && A[b] == fin2)
            break;

        fprintf(fout,"%d %d %d\n",a,b,c);

        A[a]--;
        A[b]--;
        A[c]+=2;

        updatemin(a,a);
        updatemax(a,a);

        updatemin(b,b);
        updatemax(b,b);

        updatemin(c,c);
        updatemax(c,c);

    }

    //incep de la spate
    int ult, ant;
    ult = N;
    ant = N-1;

    while(ant > 2 && ult > 2){

        if(A[ant] < A[ult]){
            for(int i=1;i<=A[ant];i++){
                if(A[1] < A[2]){
                    A[1] += 2;
                    fprintf(fout,"%d %d %d\n",ant,ult,1);
                }
                else{
                    A[2] += 2;
                    fprintf(fout,"%d %d %d\n",ant,ult,2);
                }
            }
            int min = A[ant];
            A[ant] -= min;
            A[ult] -= min;


            while(A[ant] == 0) ant--;
        }
        else{
            for(int i=1;i<=A[ult];i++){
                if(A[1] < A[2]){
                    A[1] += 2;
                    fprintf(fout,"%d %d %d\n",ant,ult,1);
                }
                else{
                    A[2] += 2;
                    fprintf(fout,"%d %d %d\n",ant,ult,2);
                }
            }

            int min = A[ult];
            A[ant] -= min;
            A[ult] -= min;

            if(A[ant] == 0 && A[ult] == 0){

                while(A[ant]==0) ant--;
                while(A[ult]==0) ult--;

                if(ant==ult){
                    ant--;
                    while(A[ant] == 0) ant--;
                }
            }
            else{
                while(A[ult] == 0) ult--;
                if(ult == ant){
                    ant--;
                    while(A[ant] == 0) ant--;
                }
                
            }
                
        }
        

    }


    //cazurile ramase
    int ramase = 0;
    for(int i=1;i<=N;i++)
        if(A[i]) ramase ++;

    if(ramase == 2){
        if(A[1] - A[2] == 2 || A[2] - A[1] == 2){
            //cazul N+2 N
            int min = A[1],poz=2;
            if(A[2] < min) min = A[2],poz=1;

            for(int i=1;i<=min;i++)
                if(i%2){
                    fprintf(fout,"1 2 3\n");
                    A[3] += 2;
                    A[1] --; A[2] --;
                }
                else{
                    fprintf(fout,"1 2 4\n");
                    A[4] += 2;
                    A[1] --; A[2] --;
                }

             if(min % 2){
                //cazul 2 N+2 N
                fprintf(fout,"%d 3 4\n",poz);
                A[4] += 2; A[poz] --; A[3] --;

                for(int i=1;i<=A[3];i++)
                    fprintf(fout,"3 4 %d\n",2);
             }
             else{
                //cazul 2 N N
                fprintf(fout,"3 4 %d\n",poz);
                fprintf(fout,"4 3 %d\n",poz);
                A[poz] = 0;
                A[3] ++; A[4] ++;

                for(int i=1;i<=A[3];i++)
                    fprintf(fout,"1 3 4\n");
             }

             

        }
        else
            if(A[1] - A[2] == 1 || A[2] - A[1] ==1 ){
                while(!(A[3] == A[1] || A[3] == A[2])){
                    A[3] += 2;
                    A[1] --; A[2] --;
                    fprintf(fout,"1 2 3\n");
                }

                if(A[3] == A[2])
                    for(int i=1;i<=A[3];i++)
                        fprintf(fout,"3 2 1\n");
                else
                    for(int i=1;i<=A[2];i++)
                        fprintf(fout,"3 1 2\n");

            }
            else{
                //sunt egale
                for(int i=1;i<=A[1];i++)
                    fprintf(fout,"1 2 3\n");
            }

            ramase = 0;
    }
    else{
        int t=3;
        while(A[t] == 0) t++;
        
        //au ramas 3
        if(A[1] == A[2]){
            for(int i=1;i<=A[1];i++)
                fprintf(fout,"1 2 %d\n",t);
            ramase = 0;
        }
        else{
            //e diferenta de 1 sau de 2
            ramase = 2;
            
            while(A[t]){
                if(A[1] < A[2]){
                    fprintf(fout,"%d 2 1\n",t);
                    A[1] +=2; A[t] --; A[2] --;
                }
                else{
                    fprintf(fout,"%d 1 2\n",t);
                    A[2] += 2; A[1]--; A[t]--;
                }
                
            }

        }

    //raman doua din 3
    if(ramase == 2){
        if(A[1] - A[2] == 2 || A[2] - A[1] == 2){
            //cazul N+2 N
            int min = A[1],poz=2;
            if(A[2] < min) min = A[2],poz=1;

            for(int i=1;i<=min;i++)
                if(i%2){
                    fprintf(fout,"1 2 3\n");
                    A[3] += 2;
                    A[1] --; A[2] --;
                }
                else{
                    fprintf(fout,"1 2 4\n");
                    A[4] += 2;
                    A[1] --; A[2] --;
                }

             if(min % 2){
                //cazul 2 N+2 N
                fprintf(fout,"%d 3 4\n",poz);
                A[4] += 2; A[poz] --; A[3] --;

                for(int i=1;i<=A[3];i++)
                    fprintf(fout,"3 4 %d\n",2);
             }
             else{
                //cazul 2 N N
                for(int i=1;i<=A[3];i++)
                    fprintf(fout,"3 4 %d\n",poz);
             }

             

        }
        else
            if(A[1] - A[2] == 1 || A[2] - A[1] ==1 ){
                while(!(A[3] == A[1] || A[3] == A[2])){
                    A[3] += 2;
                    A[1] --; A[2] --;
                    fprintf(fout,"1 2 3\n");
                }

                if(A[3] == A[2])
                    for(int i=1;i<=A[3];i++)
                        fprintf(fout,"3 2 1\n");
                else
                    for(int i=1;i<=A[2];i++)
                        fprintf(fout,"3 1 2\n");

            }
            else{
                //sunt egale
                for(int i=1;i<=A[1];i++)
                    fprintf(fout,"1 2 3\n");
            }

    }
        


    }

    fclose(fin);
    fclose(fout);
    return 0;

}

