#include <stdio.h>
#define NM 801

int n, m, d;
int a[NM][NM];
int i, j, k, l;
int nr[NM*NM], hm[NM*NM];
int s[NM*NM], c[NM][NM], nrc, v[NM][NM];
struct punct {
	int x, y, c;
} o[NM*NM], aux;
const int di[] = {-1, 0, 1, 0};
const int dj[] = {0, 1, 0, -1};

void Qsort(int st, int dr);
void Solve(int x, int y);

int main()
{
	freopen("mexc.in", "r", stdin);
	freopen("mexc.out", "w", stdout);
	scanf("%d %d %d", &n, &m, &d);
	for ( i = 1; i <= n; i++ )
		for ( j = 1; j <= m; j++ )
			scanf("%d", &a[i][j]),
			k++, o[k].x = i, o[k].y = j, o[k].c = a[i][j];

	Qsort(1, n*m);
	for ( i = 1; i <= m*n; i++ )
		if ( !c[o[i].x][o[i].y] )
		{
			for ( j = 1; j <= nrc; s[j] = 0, j++ );
			nrc++;
			Solve(o[i].x, o[i].y);
			nr[nrc] = hm[nrc] = 1;
			for ( j = 1; j <= nrc; j++ ) nr[nrc] += hm[j]*s[j];
		}
		else nr[c[o[i].x][o[i].y]]++, hm[c[o[i].x][o[i].y]]++;
	for ( i = 1; i <= n; i++ )
	{
		for ( j = 1; j <= m; j++ )
			printf("%d ", nr[c[i][j]]);
		printf("\n");
    }
	return 0;
}

void Qsort(int st, int dr)
{
	int i = st-1;
	int j = dr+1;
	do
	{
		do { i++; } while ( o[i].c > o[st].c );
		do { j--; } while ( o[st].c > o[j].c );
		if ( i <= j )
			aux = o[i], o[i] = o[j], o[j] = aux;
	} while ( i <= j );
	if ( i < dr ) Qsort(i, dr);
	if ( st < j ) Qsort(st, j);
}

void Solve(int x, int y)
{
	if ( x < 1 || x > n || y < 1 || y > m ) return;
	if ( v[x][y] == i ) return;
	if ( c[x][y] != 0 && c[x][y] == c[o[i].x][o[i].y] ) return;
	if ( a[x][y] > a[o[i].x][o[i].y] ) s[c[x][y]] = 1;
	if ( a[x][y] + d < a[o[i].x][o[i].y] ) return;
	if ( a[x][y] == a[o[i].x][o[i].y] ) c[x][y] = nrc;
    v[x][y] = i;
	for ( int dir = 0; dir < 4; dir++ )
		Solve(x+di[dir], y+dj[dir]);
}

