#include <stdio.h>
#include <algorithm>

using namespace std;

#define maxn 810
#define maxx 640010
#define maxl 4
#define maxbuff 10000

int n, m, D, N, l;
char ap[maxn][maxn];
int sol[maxn][maxn];
int a[maxx], p[maxx], c[maxx];
int nr[maxx], g[maxx], s[maxx];
int dirx[maxl] = {-1, 1, 0, 0};
int diry[maxl] = {0, 0, -1, 1};
char buff[maxbuff];

inline int cv(int x, int y)
{
	return (x-1)*m+y;
}

inline void dcv(int v, int &x, int &y)
{
 	x = v/m;
	y = v-x*m;

	if (y == 0) y = m;
	else x++;
}

inline int cmp(int x, int y)
{
	return c[x] < c[y];
}

inline int find(int x)
{
	l = 0;
	for (; x; x = g[x]) s[++l] = x;

	int i;

	for (i=l-1; i>0; i--) g[s[i]] = s[l];

	return s[l];
}

int main()
{
	freopen("mexc.in", "r", stdin);
	freopen("mexc.out", "w", stdout);

	scanf("%d %d %d ",&n, &m, &D);

	int i, j, k, x, y, cx, cy, aux;

	N = n*m;

	for (i=1; i<=n; i++) 
	{
		k = 0;
		fgets(buff, maxbuff, stdin);
		for (j=1; j<=m; j++) 
		{
			x = cv(i, j);
			a[x] = p[x] = x;
			while (buff[k]>='0' && buff[k]<='9') c[x] = c[x]*10 + buff[k++]-'0';
			k++;
		}
	}

    sort(p+1, p+N+1, cmp);

	j = N;

	for (i=N; i>0; )
	{
		for (;j>0 && c[p[j]]+D>=c[p[i]]; j--)
		{
			dcv(a[p[j]], x, y);
			ap[x][y] = 1;

			for (k=0; k<maxl; k++)
			{
				cx = x + dirx[k];
				cy = y + diry[k];

				if (cx>0 && cy>0 && cx<=n && cy<=m && ap[cx][cy]) 
				{
					aux = cv(cx, cy);
					aux = find(aux);

					if (aux != a[p[j]])
					{
						g[aux] = a[p[j]];
						nr[a[p[j]]] += nr[aux];
					}
				}
			}
		}

		for (k=i; i>0 && c[p[i]]>=c[p[k]]; i--) 
		{
			aux = find(a[p[i]]);
			nr[aux]++;
		}

		for (i=k; i>0 && c[p[i]]>=c[p[k]]; i--) 
		{
			dcv(a[p[i]], x, y);
			aux = find(a[p[i]]);
			sol[x][y] = nr[aux];
		}
	}

	for (i=1; i<=n; i++)
	{
		for (j=1; j<m; j++) printf("%d ", sol[i][j]);
		printf("%d\n", sol[i][m]);
	}

	return 0;
}
