#include <stdio.h>

int n, sum, b[128], hmin[128], hmax[128], phmin[128], phmax[128];

void min_up(int);
void min_down(int);
void max_up(int);
void max_down(int);

int main()
{
	freopen("borcane.in", "r", stdin);
	freopen("borcane.out" ,"w", stdout);

	int i, max, j;

	scanf("%d", &n);
	max = 0;
	for(i = 1; i <= n; ++i)
	{
		scanf("%d", &b[i]);
		if(b[i] > b[max])
		{
			max = i;
		}
		sum += b[i];
	}
	for(i = 1; i <= n; ++i)
	{
		if(i != max)
		{
			hmin[++hmin[0]] = i;
			phmin[i] = hmin[0];
			min_up(hmin[0]);
			hmax[++hmax[0]] = i;
			phmax[i] = hmax[0];
			max_up(hmax[0]);
		}
	}
	if(b[max] % 2 != sum % 2)
	{
		for(i = 1; i <= n; ++i)
		{
			if(i != max && i != hmax[1])
			{
				printf("%d %d %d\n", max, hmax[1], i);
				--b[max];
				--b[hmax[1]];
				b[i] += 2;
				max_down(1);
				min_up(phmin[hmax[1]]);
				max_up(phmax[i]);
				min_down(phmin[i]);
				break;
			}
		}
	}

	sum -= b[max];

	while(b[hmax[1]] > sum / 2)
	{
		if(b[hmax[2]] > b[hmax[3]])
		{
			printf("%d %d %d\n", hmax[1], hmax[2], hmin[1]);
			--b[hmax[1]];
			--b[hmax[2]];
			b[hmin[1]] += 2;
			max_down(1);
			max_down(2);
			min_up(phmin[hmax[1]]);
			min_up(phmin[hmax[2]]);
			max_up(phmax[hmin[1]]);
			min_down(1);
		}
		else
		{
			printf("%d %d %d\n", hmax[1], hmax[3], hmin[1]);
			--b[hmax[1]];
			--b[hmax[3]];
			b[hmin[1]] += 2;
			max_down(1);
			max_down(3);
			min_up(phmin[hmax[1]]);
			min_up(phmin[hmax[3]]);
			max_up(phmax[hmin[1]]);
			min_down(1);
		}
	}

	while(b[hmax[1]])
	{
		if(b[hmax[2]] > b[hmax[3]])
		{
			printf("%d %d %d\n", hmax[1], hmax[2], max);
			--b[hmax[1]];
			--b[hmax[2]];
			max_down(2);
			max_down(1);
		}
		else
		{
			printf("%d %d %d\n", hmax[1], hmax[3], max);
			--b[hmax[1]];
			--b[hmax[3]];
			max_down(3);
			max_down(1);
		}
	}

	return 0;
}

void min_up(int nod)
{
	if(nod != 1)
	{
		int dad = nod / 2, temp;
		if(b[hmin[nod]] < b[hmin[dad]])
		{
			temp = hmin[nod];
			hmin[nod] = hmin[dad];
			hmin[dad] = temp;
			phmin[hmin[nod]] = nod;
			phmin[hmin[dad]] = dad;
			min_up(dad);
		}	
	}
}

void min_down(int nod)
{
	int l = 2 * nod, r = 2 * nod + 1, best = nod, temp;

	if(l <= n - 1 && b[hmin[l]] < b[hmin[best]])
	{
		best = l;
	}
	if(r <= n - 1 && b[hmin[r]] < b[hmin[best]])
	{
		best = r;
	}
	if(best != nod)
	{
		temp = hmin[nod];
		hmin[nod] = hmin[best];
		hmin[best] = temp;
		phmin[hmin[nod]] = nod;
		phmin[hmin[best]] = best;
		min_down(best);
	}
}

void max_up(int nod)
{
	if(nod != 1)
	{
		int dad = nod / 2, temp;
		if(b[hmax[nod]] > b[hmax[dad]])
		{
			temp = hmax[nod];
			hmax[nod] = hmax[dad];
			hmax[dad] = temp;
			phmax[hmax[nod]] = nod;
			phmax[hmax[dad]] = dad;
			max_up(dad);
		}
	}
}

void max_down(int nod)
{
	int l = 2 * nod, r = 2 * nod + 1, best = nod, temp;

	if(l <= n - 1 && b[hmax[l]] > b[hmax[best]])
	{
		best = l;
	}
	if(r <= n - 1 && b[hmax[r]] > b[hmax[best]])
	{
		best = r;
	}
	if(best != nod)
	{
		temp = hmax[nod];
		hmax[nod] = hmax[best];
		hmax[best] = temp;
		phmax[hmax[nod]] = nod;
		phmax[hmax[best]] = best;
		max_down(best);
	}
}

