#include <stdio.h>
#include <algorithm>

#define nmax 128

using namespace std;
typedef pair<int, int> ii;

int n, val;
ii b[nmax];

void rezolva(int i, int j, int k)
{
	int minim = i;
	if(b[j].first < b[minim].first) minim = j;
	if(b[k].first < b[minim].first) minim = k;

	int maxim = i;
	if(b[j].first >= b[maxim].first) maxim = j;
	if(b[k].first >= b[maxim].first) maxim = k;

	int midle = i + j + k - minim - maxim;

	while(b[minim].first != 0)
	{
		printf("%d %d %d\n", b[minim].second, b[maxim].second, b[midle].second);
		b[minim].first --;
		b[maxim].first --;
		b[midle].first += 2;
	}
}

void muta(int i, int j, int k)
{
	b[i].first --;
	b[j].first --;
	b[k].first += 2;
	printf("%d %d %d\n", b[i].second, b[j].second, b[k].second);
}

int gata()
{
	int ret = 0;
	for(int i = 1; i <= n; i++) if(b[i].first != 0) ret++;
	if(ret <= 1) return 1;
	return 0;
}

int main()
{
	freopen("borcane.in", "r", stdin);
	freopen("borcane.out", "w", stdout);

	scanf("%d", &n);
	for(int i = 1; i <= n; i++) 
	{
		scanf("%d", &val);
		b[i].first = -val, b[i].second = i;
	}

	sort(b + 1, b + n + 1);
	while(b[3].first != 0)
	{
		for(int i = 1; i <= n; i++) b[i].first = -b[i].first;
		rezolva(1, 2, 3);
		for(int i = 1; i <= n; i++) b[i].first = -b[i].first;
		sort(b + 1, b + n + 1);
	}
	
	for(int i = 1; i <= n; i++) b[i].first = -b[i].first;
	while(b[2].first >= 2)
	{
		muta(1, 2, 3);
		muta(1, 2, 4);
		muta(3, 4, 1);
		muta(3, 4, 1);
	}
	if(gata()) return 0;
	if(b[2].first == 1)
	{
		muta(1, 2, 3);
		for(int i = 1; i <= n; i++) b[i].first = -b[i].first;
		sort(b + 1, b + n + 1);
		for(int i = 1; i <= n; i++) b[i].first = -b[i].first;
	}
	if(gata()) return 0;
	while(b[2].first >= 2)
	{
		muta(1, 2, 3);
		muta(1, 2, 4);
		muta(3, 4, 1);
		muta(3, 4, 1);
	}

	return 0;
}
