#include <cstdio>
#include <set>

using namespace std;

#define pii pair<int, int>
#define mp make_pair
#define x first
#define y second

int n, last, suma;
set<pii> S;

void citire()
{
	int i, a;

	scanf("%d\n", &n);
	for (i = 1; i <= n; ++i)
	{
		scanf("%d", &a);
		suma += a;
		S.insert(mp(a, i));
	}
}

void scoate2()
{
	set<pii>::iterator it;
	int c1, v1, c2, v2;

	it = S.end(), --it;
	c1 = it -> y;
	v1 = it -> x;
	S.erase(it);

	it = S.end(), --it;
	c2 = it -> y;
	v2 = it -> x;
	S.erase(it);

	S.insert(mp(v1 - 1, c1));
	S.insert(mp(v2 - 1, c2));

	printf("%d %d ", c1, c2);
}

void scoate1()
{
	set<pii>::iterator it;
	int c1, v1;

	it = S.end(), --it;
	v1 = it -> x;
	c1 = it -> y;
	S.erase(it);

	S.insert(mp(v1 - 1, c1));

	printf("%d ", c1);
}

void baga()
{
	set<pii>::iterator it;
	int c1, v1;

	it = S.begin();
	v1 = it -> x;
	c1 = it -> y;
	S.erase(it);

	S.insert(mp(v1 + 2, c1));

	printf("%d\n", c1);
}

void echilibru()
{
	set<pii>::iterator it;
	int ok = 1, c1, v1;

	while (ok)
	{
		ok = 0;
		
		it = S.end(), --it;
		if (it -> x > suma / 2)
		{
			ok = 1;
			scoate2();
			baga();
		}
	}
}

void solve()
{
	set<pii>::iterator it;

	it = S.end(), --it;
	last = it -> y;
	suma -= it -> x;
	S.erase(it);

    if (suma & 1)
	{
		scoate1();
		printf("%d ", last);
		baga();
		suma += 1;
	}
	
	echilibru();
	
	//printf("%d\n", suma);
	
	while (suma > 0)
	{
		scoate2();
		suma -= 2;
		printf("%d\n", last);
	}
}

int main()
{
	freopen("borcane.in", "r", stdin);
	freopen("borcane.out", "w", stdout);

	citire();
	solve();

	return 0;
}
