#include <stdio.h>

#define NMAX 808

int A[NMAX][NMAX], N, M, D, Ans[NMAX][NMAX];
int Viz[NMAX][NMAX];

void read()
{
        int i, j;

        scanf("%d%d%d", &N, &M, &D);

        for (i = 0; i < NMAX; i++)
                for (j = 0; j < NMAX; j++) A[i][j] = -(1+D);

        for (i = 1; i <= N; i++)
                for (j = 1; j <= M; j++)
                        scanf("%d", &A[i][j]);
}

int stl, stc;

void dfs(int l, int c)
{
        if (Viz[l][c]) return;
        Viz[l][c] = 1;

        if (A[l][c]>=A[stl][stc]) Ans[stl][stc]++;

        if (A[l+1][c]>=(A[stl][stc]-D)) dfs(l+1,c);
        if (A[l][c+1]>=(A[stl][stc]-D)) dfs(l,c+1);
        if (A[l-1][c]>=(A[stl][stc]-D)) dfs(l-1,c);
        if (A[l][c-1]>=(A[stl][stc]-D)) dfs(l,c-1);
}

void solve()
{
        int i, j;

        for (i = 1; i <= N; i++)
                for (j = 1; j <= M; j++)
                {
                        stl = i; stc = j;
                        memset(Viz,0,sizeof(Viz));
                        dfs(i,j);
                }

}

void write()
{
        int i, j;

        for (i = 1; i <= N; i++)
        {
                for (j = 1; j <= M; j++)
                        printf("%d ", Ans[i][j]);
                printf("\n");
        }
}

int main()
{
        freopen("mexc.in", "r", stdin);
        freopen("mexc.out", "w", stdout);

        read();
        solve();
        write();

        return 0;
        
}

