#include <stdio.h>
#include <string.h>
#include <algorithm>
#include <vector>

using namespace std;

#define maxim(a, b) ((a > b) ? a : b)

int N, T, uz[2048], sz[2048], bst, D[2048];
char can[1024][1024];
vector<int> G[2048];

int cmp(const int &a, const int& b)
{ return sz[a] < sz[b]; }

void df(int nod)
{
	int i, s, x;

	uz[nod] = 1; sz[nod] = 1;
	for (s = G[nod].size(), i = 0; i < s; ++i)
		if (!uz[x = G[nod][i]])
		{
			df(x);
			sz[nod] += sz[x];
		}
}

void pd(int nod, int timp)
{
	int i, s, x;
	
	uz[nod] = 1;
	for (s = G[nod].size(), i = 0; i < s; ++i)
	{
		for (; timp < T && can[nod][timp]; ++timp);
		if (!uz[x = G[nod][i]])
        {
			pd(x, timp+1);
            ++timp;
        }
	}
    D[nod] = timp;
}

int main(void)
{	
	int i, j, u, v;

	freopen("tcast.in", "r", stdin);
	freopen("tcast.out", "w", stdout);

	scanf("%d %d", &N, &T);
	for (i = 1; i < N; ++i)
	{
		scanf("%d %d", &u, &v);
		G[u].push_back(v);
		G[v].push_back(u);
	}

	for (i = 1; i <= N; ++i)
		for (j = 0; j < T; ++j)
		{
			scanf("%d", &u);
			can[i][j] = u;
		}	

	df(1);
	for (i = 1; i <= N; ++i)
		if (G[i].size() > 1)
			sort(G[i].begin(), G[i].end(), cmp);
	memset(uz, 0, sizeof(uz));
	pd(1, 0);

	bst = D[1];
	for (i = 2; i <= N; ++i)
		bst = maxim(bst, D[i]);
	printf("%d\n", bst);

	return 0;
}
