#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define FL

#define fin  "tcast.in"
#define fout "tcast.out"

#define pb push_back
#define sz(c) (int)((c).size())
#define mp make_pair
#define f first
#define s second

const int Nmax = 2012;

int N,T,stare[Nmax][1024],nrnods[Nmax];
vector <int> g[Nmax];

int viz[Nmax];

int timp;

void readdata()
{
	int i,j,a,b;
	
	freopen(fin,"r",stdin);
#ifdef FL
	freopen(fout,"w",stdout);
#endif
	
	scanf("%d%d",&N,&T);

	for ( i = 1; i < N; ++i )
	{
		scanf("%d%d",&a,&b);
		g[a].pb(b);
		g[b].pb(a);
	}

	for ( i = 1; i <= N; ++i )
	for ( j = 1; j <= T; ++j )
		scanf("%d",&stare[i][j]);
}

void df(int x)
{
	int i;

	viz[x] = 1;
	nrnods[x] = 1;

	for ( i = 1; i <= T; ++i )
		nrnods[x] += stare[x][i];
	
	for ( i = 0; i < sz(g[x]); ++i )
		if ( !viz[g[x][i]] )
		{
			df(g[x][i]);
			nrnods[x] += nrnods[g[x][i]];
		}
}

void df2(int x,int timehere)
{
	int i,maxn = 0;
	vector < pair<int,int> > stupid;
	
	viz[x] = 1;

	timp = max(timp,timehere);
	
	while ( stare[x][timehere+1] && timehere <= T ) ++timehere;
	
	for ( i = 0; i < sz(g[x]); ++i )
		if ( !viz[g[x][i]] )
			stupid.pb( mp( nrnods[g[x][i]], g[x][i] ) );	
	
	sort(stupid.rbegin(),stupid.rend());

	for ( i = 0; i < sz(stupid); ++i )
		df2(stupid[i].s,++timehere);
	
}

void solve()
{
	int i;

	df(1);

	memset(viz,0,sizeof(viz));
	df2(1,0);
	
	printf("%d\n",timp);
}

int main()
{
	readdata();
	solve();
	return 0;
}
