//tcast
#include <stdio.h>
#include <string.h>
#define INPUT "tcast.in"
#define OUTPUT "tcast.out"
#define NMAX 2001
#define TMAX 3001
#define INF 0x3f3f3f3f

int N, T;

int graf[NMAX][NMAX];

int ver[NMAX][TMAX];

int nr;
int viz[NMAX], f[NMAX];


int tm[NMAX];

int posibil(int t)
{
    memset(tm, 0, sizeof(tm));
    
    int i = 1;
        
    for(; i <= N; ++i)
    {
        int src = f[i];

        if(src != 1 && graf[src][0] == 1) tm[src] = t;
        else
        {
        int nvec = graf[src][0];
        int tmin = INF, nr = 1;
        int j;
        for(j = 1; j <= nvec; ++j)
            if(viz[src] != graf[src][j])
            {
                int vec = graf[src][j];
                if(tmin > tm[vec]) tmin = tm[vec];
                else if(tmin == tm[vec]) ++nr;
            }

        if(tmin - nr < 0) return 0;
        int p = tmin - nr;
        for(;p >= 0 && ver[src][p];) --p;
        
        if(p < 0) return 0;
        if(ver[src][p]) return 0;

        tm[src] = p;
        }
    }
    
    return 1;
}
int cautbinar()
{
    int a = 0, b = N + T, mij;
    while(a < b)
    {
        mij = (a+b)/2;
        if(posibil(mij)) b = mij;
        else a = mij+1;
    }
    return a;
}

void DF(int src)
{
    int j;
    for(j = graf[src][0]; j; --j)
        if(!viz[graf[src][j]])
            viz[graf[src][j]] = src,
            DF(graf[src][j]);
    f[++nr] = src;
}


void citire()
{

    freopen(INPUT, "r", stdin);
    freopen(OUTPUT, "w", stdout);

    scanf("%d %d", &N, &T);
    
    int i;
    for(i = 1; i < N; ++i)
    {
        int a, b;
        scanf("%d %d", &a, &b);
        graf[a][++graf[a][0]] = b;
        graf[b][++graf[b][0]] = a;
    }
    
    int j;
    for(i = 1; i <= N; ++i)
        for(j = 0; j < T; ++j)
            scanf("%d", &ver[i][j]);
}

int main()
{
    citire();
    
    viz[1] = 1;
    DF(1);
    viz[1] = 0;

    printf("%d\n", cautbinar());
//    printf("%d\n", posibil(2));
    
    return 0;
}

