#include <stdio.h>
#include <algorithm>
#include <queue>
using namespace std;

struct pt{int x,y; pt(){} pt(int xp,int yp){x=xp,y=yp;}};

#define maxN 810
#define maxD 100100
#define inf 0x7f7f7f7f
int n,m,d,mat[maxN][maxN],res[maxN][maxN],mn,mx;
int hs[maxD];
int dn[maxN][maxN],viz[maxN][maxN];

int const dx[]={1,0,-1, 0},dy[]={0,1, 0,-1};

void inputFunc(){
	FILE*fi=fopen("mexc.in","r");
	fscanf(fi,"%d %d %d",&n,&m,&d);mn=inf;
	for(int i=0;i<n;i++)for(int j=0;j<m;j++){
		int a;fscanf(fi,"%d",&a);
		mat[i][j]=a;
		if(a<mn)mn=a;
		hs[a]++;
	}
	mx=mn+d;
	fclose(fi);
	for(int i=1;i<100010;i++)hs[i]+=hs[i-1];
}

void outputFunc(){FILE*fi=fopen("mexc.out","w");for(int i=0;i<n;i++){for(int j=0;j<m;j++)fprintf(fi,"%d ",res[i][j]);fprintf(fi,"\n");}fclose(fi);}

void algnaspa(int x,int y,int vsg){
	queue<pt> qu;
	qu.push(pt(x,y)); int h=mat[x][y],h2=h-d; viz[x][y]=vsg;
	int sol=0;
	while(!qu.empty()){
		int x2=qu.front().x,y2=qu.front().y; qu.pop();
		int ch=mat[x2][y2];
		if(ch>=h)sol++;
		if(ch==h)if(res[x2][y2]){res[x][y]=res[x2][y2];return;}
		
		for(int i=0;i<4;i++){
			int nx=x2+dx[i],ny=y2+dy[i];
			if(nx>=0 && ny>=0 && nx<n && ny<m && viz[nx][ny]!=vsg && mat[nx][ny]>=h2){
				qu.push(pt(nx,ny));viz[nx][ny]=vsg;
			}
		}
	}

	res[x][y]=sol;
}

int algbun(int x,int y){
	int h=mat[x][y];
	res[x][y]=n*m-hs[h-1];
}

int main(){
	inputFunc();
	int k=1;

	for(int i=0;i<n;i++)for(int j=0;j<m;j++){
		if(mat[i][j]>mx){
			algnaspa(i,j,k++);
		}else{
			algbun(i,j);
		}
	}

	outputFunc();
	return 0;
}

