#include <cstdio>
#include <cstring>
#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define INF 0x3f3f3f3f
#define pii pair <int, int>
#define mp make_pair
#define f first
#define s second
#define MAXN 505

int N, M, D;
int A[MAXN][MAXN];
int cd[MAXN*MAXN], ended;
int viz[MAXN*MAXN];
int sol[MAXN][MAXN];
set <int> S[MAXN*MAXN];
pii val[MAXN*MAXN];
int Nr, iter;
const int dx[4] = {1, -1, 0, 0};
const int dy[4] = {0, 0, 1, -1};

int cmp (const pii a, const pii b)
{
    return a.f > b.f;
}

void read ()
{
    scanf ("%d %d %d\n", &N, &M, &D);

    int i, j;
    for (i = 0; i < N; ++ i)
        for (j = 0; j < M; ++ j)
        {
            scanf ("%d ", &A[i][j]);
            val[Nr].s = Nr;
            val[Nr++].f = A[i][j];
        }

    sort (val, val + Nr, cmp);
    /*for (i = 0; i < Nr; ++ i)
        printf ("%d %d\n", val[i].f, val[i].s);*/
}

int gaseste (int nr)
{
    int pas;
    int ans = 1;
    cd[ended = 0] = nr;
    viz[nr] = iter;
    S[nr].insert(nr);
    int i, j, dir, ii, jj, n, sti, stj;
    sti = nr / M; stj = nr % M;

    for (pas = 0; pas <= ended; ++ pas)
    {
        i = cd[pas]/M; j = cd[pas]%M;
        for (dir = 0; dir < 4; ++ dir)
        {
            ii = i + dx[dir]; jj = j + dy[dir];
            if (ii < 0 || jj < 0) continue;
            if (ii >= N || jj >= M) continue;
            n = ii*M + jj;
            if (A[ii][jj] >= A[sti][stj] && viz[n] != iter)
                if (S[nr].find(n) == S[nr].end())
                 {
                    if (!S[n].size() && A[ii][jj] == A[sti][stj])
                    {
                        ++ ans;
                        S[nr].insert(n);
                        //printf ("%d\n", n);
                        cd[++ended] = n;
                        viz[n] = iter;
                        continue;
                    }
                    for (set <int> :: iterator it = S[n].begin(); it != S[n].end(); ++ it)
                        if (S[nr].find(*it) == S[nr].end())
                        {
                            ++ ans;
                            S[nr].insert(*it);
                            //cd[++ended] = *it;
                            //printf ("%d\n", *it);
                            viz[*it] = iter;
                        }
                }
                else;
            else if (A[ii][jj] + D >= A[sti][stj] && viz[n] != iter)
            {
                cd[++ended] = n;
                viz[n] = iter;
            }
        }
    }

    return ans;
}

void solve ()
{
    int k, i, j;

    for (k = 0; k < Nr; ++ k)
    {
        ++iter;
        i = (val[k].s)/M; j = (val[k].s)%M;
        sol[i][j] = gaseste (val[k].s);
        /*printf ("%d %d %d   ", i, j, A[i][j]);
        for (set <int> :: iterator it = S[val[k].s].begin(); it != S[val[k].s].end(); ++ it)
            printf ("%d ", *it);
        printf ("\n");*/
    }

    for (i = 0; i < N; ++ i)
    {
        for (j = 0; j < M; ++ j)
            printf ("%d ", sol[i][j]);
        printf ("\n");
    }
}

int gaseste2 (int i, int j)
{
    int pas, nr = i*M + j;
    int ans = 1;
    cd[ended = 0] = nr;
    viz[nr] = iter;
    int dir, ii, jj, n, sti = i, stj = j;

    for (pas = 0; pas <= ended; ++ pas)
    {
        i = cd[pas]/M; j = cd[pas]%M;
        for (dir = 0; dir < 4; ++ dir)
        {
            ii = i + dx[dir]; jj = j + dy[dir];
            if (ii < 0 || jj < 0) continue;
            if (ii >= N || jj >= M) continue;
            n = ii*M + jj;
            //printf ("%d %d %d %d\n", ii, jj, n, A[ii][jj]);
            if (A[ii][jj] >= A[sti][stj] && viz[n] != iter)
                    {
                        ++ ans;
                        //printf ("%d\n", n);
                        cd[++ended] = n;
                        viz[n] = iter;
                    }
            else if (A[ii][jj] + D >= A[sti][stj] && viz[n] != iter)
            {
                cd[++ended] = n;
                viz[n] = iter;
            }
        }
    }

    return ans;
}

void solve2 ()
{
    int k, i, j;

    for (i = 0; i < N; ++ i)
        for (j = 0; j < M; ++ j)
        {
            ++iter;
            sol[i][j] = gaseste2 (i, j);
        }

    for (i = 0; i < N; ++ i)
    {
        for (j = 0; j < M; ++ j)
            printf ("%d ", sol[i][j]);
        printf ("\n");
    }
}

int
 main ()
{
    freopen ("mexc.in", "rt", stdin);
    freopen ("mexc.out", "wt", stdout);

    read ();

    if (N*M <= 10000)
        solve2 ();
    else
        solve ();
    
    return 0;
}

