//#include <iostream>
#include <fstream>
#define MIN(x,y) (x < y ? x : y)
#define ABS(x) (x < 0 ? -(x) : x)
#define NMAX 2500
using namespace std;

void citire(int &n, int pctx[], int pcty[])
{
	int i;
	ifstream f1("dist.in");
	f1 >> n;
	if (n > NMAX) n = NMAX;
	for (i = 1; i <= n; ++i)
		f1 >> pctx[i] >> pcty[i];
	f1.close();
}

inline int dist(int x1, int y1, int x2, int y2) 
{
//	cout << ABS(x1 - x2) << " " << ABS(y1 - y2) << " ";
//	cout << MIN(ABS(x1 - x2),ABS(y1 - y2)) << endl;
	return MIN(ABS(x1 - x2),ABS(y1 - y2));
}

int main()
{
	int n, pctx[NMAX + 5], pcty[NMAX + 5], i, j, d, max = 0;
	citire(n, pctx, pcty);
	for (i = 1; i <= n; ++i)
		for (j = i + 1; j <= n; ++j) {
			d = dist(pctx[i], pcty[i], pctx[j], pcty[j]);
			if (d > max) max = d;
		}
	ofstream f2("dist.out");
	f2 << max << endl;
	f2.close();
	return 0;
}

