#include <iostream>
#include <algorithm>
#include <cmath>
#define FIN "dist.in"
#define FOUT "dist.out"
#define MAX_N 100010
#define INFINIT 1000010
#define min(a,b) a<b?a:b
#define max(a,b) a>b?a:b
using namespace std;
typedef long it;
it N;
struct punct{
        it x,y;
} v[MAX_N];
it vmx[MAX_N],vmn[MAX_N];
it pozcbin,pminim,pmaxim,lpcbin;



void iofile(void){

        freopen(FIN,"rt",stdin);
        freopen(FOUT,"wt",stdout);

        scanf("%ld",&N);

        for (it i=1;i<=N;++i){scanf("%ld%ld",&v[i].x,&v[i].y);}

        fclose(stdin);

        return ;
}


bool fcmp(const punct &A, const punct &B){
        return ((A.x<B.x) || (A.x==B.x && A.y<B.y));
}


void brut(void){

        int dmax=0;

        sort(v+1,v+N+1,fcmp);

        for (it i=1;i<N;++i){
                it j=N;
                while (j>i && (v[j].x-v[i].x>dmax)){
                        if (labs(v[j].y-v[i].y)>dmax
                             ){
                                dmax=min(labs(v[j].x-v[i].x),
                                labs(v[j].y-v[i].y));
                        }
                        --j;
                }
        }

        printf("%ld\n",dmax);

        fclose(stdout);

        return ;
}



it dmiruna(it x,it y){
        return min(labs(v[x].x-v[y].x),labs(v[x].y-v[y].y));
}


void cbin(it p,it u,it val){
        if (p<=u){
                it m=(p+u)/2;
                if (v[m].x>val){pozcbin=m;cbin(p,m-1,val);} else
                {cbin(m+1,u,val);}
        }
}



void optimizare(void){

        sort(v+1,v+N+1,fcmp);

        vmx[N]=N;
        for (it i=N-1;i>=1;--i){
                if (v[i].y>v[vmx[i+1]].y){
                        vmx[i]=i;} else {vmx[i]=vmx[i+1];}
        }

        vmn[N]=N;
        for (it i=N-1;i>=1;--i){
                if (v[i].y<v[vmn[i+1]].y){
                        vmn[i]=i;} else {vmn[i]=vmn[i+1];}
        }


        it i,dmax=0;
        for (it i=1;i<N;++i){
                lpcbin=0;
                pozcbin=N+1;
                cbin(i+1,N,v[i].x+dmax);
                while (pozcbin!=lpcbin && pozcbin<=N){

                        
                        pmaxim=vmx[pozcbin];
                        pminim=vmn[pozcbin];
                        

                        dmax=max(dmax,dmiruna(i,pmaxim));
                        dmax=max(dmax,dmiruna(i,pminim));

                        lpcbin=pozcbin;
                        pozcbin=N+1;
                        cbin(i+1,N,v[i].x+dmax);

                }
        }

        printf("%ld\n",dmax);

        fclose(stdout);

        return ;
}


int main(void){

        iofile();

        if (N<=3000){brut();}else
        optimizare();

        return 0;

}

