#include <fstream>
#define DIM 100000
using namespace std;

int n;
long int max = -1;


struct punct
{
	long int x, y;
};

punct a[DIM];

void Read();
ofstream fout("dist.out");
void Solve();
int Min(int, int);


int main()
{
	Read();
	Solve();

	fout.close();
	return 0;
}


void Read()
{
	ifstream fin("dist.in");
	fin >> n;

	for (int i = 1; i<= n; i++)
		fin >> a[i].x >> a[i].y;

	fin.close();
}

int Min(int x, int y)
{
	if (x > y) return y;
	return x;

}

void Solve()
{
	int i, j;
	int t1, t2;

	for (i = 1; i < n; i++)
		for (j = i+1; j <= n; j++)
		{
			if (a[i].x - a[j].x >= 0) t1 = a[i].x-a[j].x;
			else t1 = a[j].x-a[i].x;

			if (a[i].y - a[j].y >= 0) t2 = a[i].y-a[j].y;
			else t2 = a[j].y-a[i].y;

			if (max < Min(t1, t2)) max = Min(t1, t2);
		}
	fout << max << "\n";
}


