#include <cstdio>
#include <vector>
#include <algorithm>

#define modulo 666013

using namespace std;

int n,m,k,p=0;
int viz[257],ext[257];
vector <int> v[257],s[257];

void citire()
{
    freopen("dep.in","r",stdin);
    scanf("%d%d%d", &n, &m, &k);
    int x,y;
    for (int i=1; i<=n; i++)
        v[i].push_back(i);
    for (int i=0; i<m; i++)
    {
        scanf("%d%d", &x, &y);
        v[x].push_back(y);
    }
}

void adaugare(int w, int q)
{
    for (vector <int> ::iterator it=v[w].begin(); it!=v[w].end(); it++)
    {
        int e=*it;
        if (!viz[e])
        {
            s[q].push_back(e);
            viz[e]=1;
            adaugare(e,q);
        }
    }
}

int egal(int l, int k)
{
    for (int i=0; i<s[i].size(); i++)
        if (s[l][i]!=s[k][i])
            return 0;
    return 1;
}

void existenta(int e)
{
    for (int i=1; i<e; i++)
        if (s[i].size()==s[e].size() && egal(i,e))
        {
            ext[e]=1;
            return;
        }
}

void back(int l, int c)
{
    for (int i=c+1; i<=n; i++)
        if (!ext[i] && l+s[i].size()<k)
            back(l+s[i].size(),i);
        else if (!ext[i] && l+s[i].size()==k)
            ++p;

}
  
int main()
{
    citire();
    for (int i=1; i<=n; i++)
    {
        memset(viz,0,sizeof(viz));
        adaugare(i,i);        
        sort(s[i].begin(),s[i].end());
        existenta(i);
    }
    back(0,0);
    freopen("dep.out","w",stdout);
    printf("%d\n",p);
    return 0;
}
