#include <stdio.h>
#include <string.h>

#define NMAX 510
#define INF 10000

int N;

char s[NMAX];

short din[NMAX][NMAX];

inline int MIN(int a, int b) { return (a < b) ? a : b; }

int main()
{
	int i, j, k, lung;
	
	freopen("stiva.in", "r", stdin);
	freopen("stiva.out", "w", stdout);

//	printf("%lf\n", (double) (sizeof(din) + sizeof(s)) / 1024 / 1024);

	scanf("%s", s);

	N = strlen(s);

	for (i = 0; i < N; i++) din[i][i] = 2;

	for (lung = 2; lung <= N; lung++) {
		for (i = 0; i + lung <= N; i++) {
			j = i + lung - 1;

			din[i][j] = INF;

			for (k = i; k < j; k++) 
				din[i][j] = MIN(din[i][j], din[i][k] + din[k + 1][j]);

			if (s[i] == s[j]) {
				din[i][j] = MIN(din[i][j], din[i+1][j - 1] + 2);

				for (k = i + 1; k < j; k++) {
					if (s[k] != s[i]) continue;

					din[i][j] = MIN(din[i][j], din[i][k] + din[k][j] - 2);
				}
			}
		}
	}

	printf("%d\n", din[0][N - 1] + N);

return 0;
}

