#include <algorithm>
#include <cstdio>
#include <vector>

using namespace std;

#define pb push_back
#define mp make_pair

#define ff first
#define ss second

#define MAXN 100011

int N;
int St[MAXN];

vector < pair <int, int> > V;

int Prod(pair <int, int> p0, pair <int, int> p1, pair <int, int> p2)
{
    return
        (((p1.ss - p0.ss) * (p2.ff - p0.ff)) - ((p2.ss - p0.ss) * (p1.ff - p0.ff)));
}

void Ch()
{
    St[0] = 1;
    St[1] = 0;

    int i, flag = 1;

    for(i=1; i>=0; i+=flag)
    {
        if(i == N - 1) flag = -1;

        while(St[0] > 1 && Prod(V[St[St[0]-1]], V[St[St[0]]], V[i]) > 0)
            -- St[0];

        St[++St[0]] = i;
    }
}

inline int Min(int i, int j)
{
    return
        i < j ? i : j;
}

inline int Max(int i, int j)
{
    return
        i > j ? i : j;
}

int Mod(int x)
{
    return
        x < 0 ? -x : x;
}

int main()
{
    freopen("dist.in", "rt", stdin);
    freopen("dist.out", "wt", stdout);

    scanf("%d", &N);

    int i, x, y;

    for(i=1; i<=N; ++i)
    {
        scanf("%d %d", &x, &y);
        V.pb(mp(y, x));
    }

    sort(V.begin(), V.end());

    Ch();

    int j, ret = -0x3f3f3f3f;

    for(i=1; i<=St[0]; ++i)
        for(j=0; j<N; ++j)
        {
            int x = Mod(V[St[i]].ff - V[j].ff);
            int y = Mod(V[St[i]].ss - V[j].ss);

            x = Min(x, y);
            ret = Max(ret, x);

        }

    printf("%d", ret);

    fclose(stdin);
    fclose(stdout);

    return 0;
}

