#include<stdio.h>
#include<algorithm>
#include<vector>
#define pb push_back
#define vi vector<int>
#define vii vector<int> :: iterator

using namespace std;

const int MOD = 666013;
const int maxn = 500;

int ST[maxn],GR[maxn],NOD,D[3][maxn],POS[maxn][maxn];
vi VECTG[maxn],VECT[maxn],VECTINV[maxn];
int N;
int M;
int K;
int POZ[maxn],NR[maxn],INT[maxn],VER[maxn];


void dfs(int i)
{
	if (VER[i]) return ;
	VER[i] = 1;
	for(vii it = VECT[i].begin();it != VECT[i].end(); ++it)
	{
		dfs(*it);	
	}
	ST[++ST[0]] = i;
}

void dfsinv(int i)
{
	if (VER[i]) return ;
	VER[i] = 1;
	GR[i] = NOD;
	for (vii it = VECTINV[i].begin();it != VECTINV[i].end();++it)
	{
   		dfsinv(*it); 	
	}	
}

void dfsg(int i)
{
	if (VER[i])	return;
	VER[i] = 1;
	for(vii it = VECTG[i].begin();it != VECTG[i].end(); ++it) dfsg(*it);
	ST[++ST[0]] = i;
	POZ[i] = ST[0];
}


int main()
{
	freopen("dep.in","r",stdin);
	freopen("dep.out","w",stdout);
	scanf("%d %d %d",&N,&M,&K);
	for(int i = 1;i <= M; ++i)
	{
		int x,y;
        scanf("%d %d",&x,&y);
		VECT[x].pb(y);
		VECTINV[y].pb(x);
	}	

	memset(VER,0,sizeof(VER));

	for(int i = 1;i <= N; ++i)
		dfs(i);
	memset(VER,0,sizeof(VER));
	for(;ST[0];--ST[0])
	{
		NOD = ST[ST[0]];
		dfsinv(ST[ST[0]]);
	}
	for(int i = 1;i <= N; ++i)
	{
		for(vii it = VECT[i].begin();it != VECT[i].end(); ++it)
		{
         if (GR[i]  == GR[*it]) continue;
			VECTG[GR[i]].pb(GR[*it]);	
			INT[GR[*it]] = 1;
		}		
		++NR[GR[i]];
	}
	memset(VER,0,sizeof(VER));
    for(int i = 1;i <= N; ++i)
		dfsg(i);
	for(int i = 1;i <= ST[0]; ++i)
	{
//		if (INT[ST[i]] == 0) VECTG[ST[0]].pb(ST[ST[i]]);
//		D[i][0] = 1;

      POS[ST[i]][0] = 1;
		int act = 0;
      sort(VECTG[ST[i]].begin(),VECTG[ST[i]].end());
		for(vii it = VECTG[ST[i]].begin();it != VECTG[ST[i]].end(); ++it)
		{
		   	if (POZ[*it] > act) act = POZ[*it]; 	
		}
      int prev = -1;
		for(vii it = VECTG[ST[i]].begin();it != VECTG[ST[i]].end(); ++it)
		{
			if (POZ[*it] == act)
			{
				for(int j = 1;j <= N; ++j) POS[ST[i]][j] = POS[*it][j];

            NR[ST[i]] += NR[*it];
            NR[*it] = 0;
         }
         
         prev = *it;
		}
		POS[ST[i]][NR[ST[i]]] += 1;
      
	}
   D[0][0] = 1;
   int aux = 0;
   for(int i = 1;i <= ST[0]; ++i)
   {
      if (INT[ST[i]] == 0)
      {
         for(int k = 0;k <= K; ++k)
                 for(int j = 1;j +k <= K; ++j)
                 {
                       D[aux][k + j] += D[aux ^ 1][k] * POS[ST[i]][j];
                       D[aux][k + j] %= MOD;
                 }
         aux ^= 1;
      }
   }
   printf("%d\n",D[aux][K]);
	return 0;
	
}

