#include<stdio.h>
#include<string.h>

const int maxn = 510,lemax = 1000;
const unsigned short INF = 10000;

unsigned short D[maxn][maxn];
char S[maxn];
int NEXT[maxn],PREV[maxn];
int N;


inline int min(int i,int j){return i > j ? j : i;}

int solve(int i,int j)
{
	if (i > j) return 0;
	if (i == j) return 3;
    if (D[i][j]) return D[i][j];
	D[i][j] = INF;
   int k = i;
	for(k = NEXT[k];k <= j; k = NEXT[k])
	{
		D[i][j] = min(solve(i + 1,k - 1) + 4 + solve(k + 1,j),D[i][j]);	
		D[i][j] = min(solve(i,k - 1) + 1 + solve(k + 1,j),D[i][j]);
      if (!NEXT[k]) break;
   }	
	D[i][j] = min( solve(i + 1, j) + 3,D[i][j]);
//	printf("%d %d -> %d\n",i,j,D[i][j]);
	return D[i][j];
}

int main()
{
	freopen("stiva.in","r",stdin);
	freopen("stiva.out","w",stdout);
	fgets(S + 1,lemax,stdin);
	N = strlen(S + 1);
//	printf("%d\n",sizeof(D));
	while(!(S[N] >= 'A' && S[N] <= 'Z') ) --N;
	for(int i = 1;i <= N; ++i)
	{
		NEXT[PREV[S[i]]] = i;
		PREV[S[i]] = i;
	}
	printf("%d\n",solve(1,N));
	return 0;
}



	
