#include <iostream>
#include <fstream>
#include <string>
#include <algorithm>

using namespace std;

string S;
int len;

int C[501][501];

int normcalc(int i, int j)
{
	if (i > j)
		return 0;
	return C[i][j];
}

void calculeaza_cost(int p, int r)
{
	if (p == r)
		C[p][r] = 3;
	
	int m = C[p][r-1] + 3;

	int primul;
	for (primul = p; (primul < r) && (S[primul] != S[r]); ++primul)
		;
	
	if (primul < r) {
		int s = 4;
		if (p < primul) 
			s += C[p][primul-1];
		for (int i = primul + 1; i < r; ++i)
			if (S[i] == S[r])
				if ((normcalc(primul+1, i-1) + 3 + normcalc(i+1, r-1) == normcalc(primul+1, r-1)) || 
				    (normcalc(primul+1, i-1) + 1 + normcalc(i+1, r-1) == normcalc(primul+1, r-1)))
					s -= 2;
		s += normcalc(primul+1, r-1);
		if (s < C[p][r-1]) {
			s = 4;
			if (p < primul) 
				s += C[p][primul-1];
			for (int i = primul + 1; i < r; ++i)
				if (S[i] == S[r])
					if (normcalc(primul+1, i-1) + 3 + normcalc(i+1, r-1) == normcalc(primul+1, r-1))
						       s -= 2;
			s += normcalc(primul+1, r-1);
		}			
		m = min(m, s);
	}
		
	C[p][r] = m;
}

int main(int argc, char *argv[])
{
	ifstream fin("stiva.in");
	fin >> S;
	len = S.size();
	fin.close();

	for (int l(0); l < len; ++l)
		for (int i(0); i + l < len; ++i)
			calculeaza_cost(i, i+l);

	/*for (int i(0); i < len; ++i)
		cout << S[i] << "\t";
	cout << endl;
	for (int i(0); i < len; ++i) {
		for (int j(0); j < len; ++j)
			cout << C[i][j] << "\t";
		cout << endl;
	}*/

	ofstream fout("stiva.out");
	fout << C[0][len-1] << endl;
	fout.close();
	
	return 0;
}

