#include <cstdio>

const int NMAX = 100005;

int n;
int X[NMAX], Y[NMAX];

inline int abs(int x) {
	if (x > 0)
		return x;
	return - x;
}

inline int min(int a, int b) {
	if (a < b)
		return a;
	return b;
}

int main() {
	
	freopen("dist.in", "r", stdin);
	freopen("dist.out", "w", stdout);
	
	scanf("%d", &n);
	int i;
	for (i = 0; i < n; ++ i)
		scanf("%d %d", &X[i], &Y[i]);
	
	int ans = 0, val, j;
	for (i = 0; i < n; ++ i)
		for (j = 0; j < n; ++ j) {
			val = min(abs(X[i] - X[j]), abs(Y[i] - Y[j]));
			if (val > ans)
				ans = val;
		}
	
	printf("%d\n", ans);
	
	return 0;
}
