#include<cstdio>
#include<cstring>

#define INPUT "dep.in"
#define OUTPUT "dep.out"
#define NMAX 300
#define MODULO 666013
#define CL(x) memset(x, 0, sizeof(x))

typedef struct Graph
{
  long node;
  Graph *next;
};

long N, M, K, PStart, PFin;
long Queue[ NMAX * NMAX ], Final[ NMAX ][ NMAX ];
int Util[ NMAX ];
Graph *List[ NMAX ];

void ReadValues()
{
  Graph *adr;

  scanf("%ld %ld %ld", &N, &M, &K);

  long V1, V2;

  for(long i = 0; i < M; ++i)
  {
    scanf("%ld %ld", &V1, &V2);

    adr = new Graph;
    adr -> node = V2;
    adr -> next = List[ V1 ];
    List[ V1 ] = adr;
  }
}

long BFS(long node)
{
  long Nod;
  Graph *adr;

  CL(Util);

  Util[ node ] = 1;


  Queue[ 1 ] = node;
  PStart = 1;
  PFin = 1;

  while(PStart <= PFin)
  {
    Nod = Queue[ PStart ];

    adr = List[ Nod ];
    
    while(adr != NULL)
    {
      if(!Util[ adr -> node ])
      {
        Util[ adr -> node ] = 1;
        Queue[ ++PFin ] = adr -> node;
      }

      adr = adr -> next;
    }
    ++PStart;
  }

  for(long i = 1; i <= PFin; ++i)
    Final[ node ][ Queue[ i ] ] = 1;
  Final[ node ][ 0 ] = PFin;

  return PFin;
}

void SolveFunction()
{
  long nrTotal = 0, cont, j, i;
  int Valid = 0, Incorect = 0;
  
  for(i = 1; i <= N; ++i)
  {
    cont = BFS(i);

    if(cont == K)
    {
      Valid = 0;
      Incorect = 0;
      
      for(j = 1; j < i; ++j)
      
        if(Final[ j ][ 0 ] == K)
        {
          Valid = 0;
          
          for(long k = 1; k <= PFin && !Valid; ++k)
          {
            if(Final[ j ][ Queue[ k ] ] == 0)
              Valid = 1;
          }

          if(!Valid)
          {
            Incorect = 1;
            break;
          }
        }

      nrTotal = (Incorect) ? nrTotal : ((nrTotal + 1) % MODULO) ;
      
    }
  }

  printf("%ld\n", nrTotal);
}

int main()
{
  freopen(INPUT, "r", stdin); freopen(OUTPUT, "w", stdout);

  ReadValues();

  SolveFunction();

  fclose(stdin); fclose(stdout);

  return 0;
}
