#include <stdio.h>
#include <stdlib.h>

int n, maxim, ord[100005];
typedef struct
{
  int x, y;
} Punct;
Punct a[100005], b[100005];

int cmp1(const void *i, const void *j)
{
   int x = *(int*)i, y = *(int*)j;
   return b[x].x - b[y].x;
}

int cmp2(const void *i, const void *j)
{
   int x = *(int*)i, y = *(int*)j;
   return b[x].y - b[y].y;
}

int ab(int x)
{
   if (x < 0) return (-x);
   return x;
}

int min(int x, int y) { return x < y ? x : y; };
int max(int x, int y) { return x > y ? x : y; };

int distanta(Punct x, Punct y)
{
   return min(ab(x.x - y.x), ab(x.y - y.y));
}

int main()
{
   freopen("dist.in","r",stdin);
   freopen("dist.out","w",stdout);

   int i, j, x;
   Punct v[10];
   scanf("%d",&n);


   for (i = 0; i < n; i++)
   {
      scanf("%d %d",&b[i].x,&b[i].y);
      ord[i] = i;
   }

   qsort(ord,n,sizeof(int),cmp1);
   for (i = 1; i <= n; i++)
   {
      a[i] = b[ord[i-1]];
      ord[i - 1] = i - 1;
   }

   maxim = distanta(a[1],a[n]);

   for (i = 1, j = n; ab(a[i].x - a[j].x) >= maxim; i++)
   {
      for (j = n; ab(a[i].x - a[j].x) >= maxim; j--)
      {
         x = distanta(a[i],a[j]);
         if (x > maxim) maxim = x;
      }
      j = n;
   }

   qsort(ord,n,sizeof(int),cmp2);
   for (i = 1; i <= n; i++)
   {
      a[i] = b[ord[i-1]];
      ord[i - 1] = i - 1;
   }

   for (i = 1, j = n; ab(a[i].y - a[j].y) >= maxim; i++)
      for (j = n; ab(a[i].y - a[j].y) >= maxim; j--)
      {
         x = distanta(a[i],a[j]);
         if (x > maxim) maxim = x;
      }

   printf("%d\n",maxim);
   return 0;
}
