#include <fstream>
#include <vector>
#define MAX 257
#define MOD 666013

using namespace std;

int n, m, K;
int a[MAX][MAX];
vector<vector<int> > v(MAX);
bool isdep[MAX];

int DF(int nod, int k)
{
	a[nod][1] = 1;
	if (a[nod][k]) return a[nod][k];
		
	int x = v[nod].size(), p, j, i;
	
	for (p = 2; p <= k; p++)
	{
		a[nod][p] = (x >= p);
		for (j = 0; j < x; j++) 
		{
			i = v[nod][j];
			a[nod][p] += a[i][p-1];
			a[nod][p] %= MOD;
		}
	}
	a[nod][k] %= MOD;
	return a[nod][k];
}

int main()
{
	int i, v1, v2, rez = 0;
	
	ifstream fin("dep.in");
	fin >> n >> m >> K;
	for (; m; m--)
	{
		fin >> v1 >> v2;
		isdep[v1] = 1;
		v[v2].push_back(v1);
	}
	fin.close();
	
	for (i = 1; i <= n; i++)
		if (!isdep[i])
			rez += DF(i, K), rez %= MOD;
	
	ofstream fout("dep.out");
	fout << rez % MOD;
	fout.close();
	
	return 0;
}
