#include <stdio.h>

#define PB(x) push_back(x)
#define SZ(x) (x).size()
#define MP(a,b) make_pair((a), (b))
#define ii pair<int, int>
#define vi vector<int>
#define vii vector< ii >
#define ALL(x) (x).begin(), (x).end()
#define SORT(x) sort(ALL(x))

#define FOR(i,N) for (int (i) = 0; (i)<(N); ++(i))
#define FORE(i,N) for (int (i) = 0; (i)<=(N); ++(i))
#define FORIE(i,j,N) for (int (i) = (j); (i)<=(N); ++(i))
#define FORI(i,j,N) for (int (i) = (j); (i)<(N); ++(i))

#define FORV(i,V) for (int (i) = 0; (i)<SZ(V); ++(i))
#define FORIT(i, C) for (typeof((C).begin()) i = (C).begin(); i != (C).end(); ++(i))

#define PRINT(V) FORV(i,V) cerr << V[i] << " "; cerr << "\n";
#define PRINTV(V, i, j) FORIE(tz, i, j) cerr << V[tz] << " "; cerr << "\n";
#define PRINTC(C) FORIT(tz,C) cerr << *tz << " "; cerr << "\n";

#define NMAX 100001
#define NUMBER_OF_POINTS 500

int N;
int A[NMAX][2];
int B[NMAX][2];
long long cx,cy;
int pts[2][2];
int ind[2][2];
int nr[2][2];
int dx, dy;

void brut()
{
    FOR(i,N)
    {
        scanf("%d %d", &A[i][0], &A[i][1]);
    }

    int max = 0;
    FOR(i, N-1)
    {
        FORI(j, i+1, N)
        {
            int a = A[i][0] - A[j][0];
            if (a < 0)
                a = -a;

            int b = A[i][1] - A[j][1];
            if (b < 0)
                b = -b;

            if (b < a)
                a = b;

            if (a > max)
                max = a;
        }
    }

    printf("%d\n", max);

}

int imparte(int pts[][2], int nr)
{
    if (nr < NUMBER_OF_POINTS)
        return nr;
        
    long long cx = 0;
    long long cy = 0;

    FOR(i, nr)
    {
        cx += pts[i][0];
        cy += pts[i][1];
    }

    cx /= nr;
    cy /= nr;

    int k = 0;

    if (dx == 0 && dy == 0)
    {
        FOR(i, nr)
        {
            if (pts[i][0] < cx && pts[i][1] < cy)
            {
                pts[k][0] = pts[i][0];
                pts[k++][1] = pts[i][1];
            }
        }
    }
    else if (dx == 0 && dy == 1)
    {
        FOR(i, nr)
        {
            if (pts[i][0] < cx && pts[i][1] > cy)
            {
                pts[k][0] = pts[i][0];
                pts[k++][1] = pts[i][1];
            }
        }
    }
    else if (dx == 1 && dy == 0)
    {
        FOR(i, nr)
        {
            if (pts[i][0] > cx && pts[i][1] < cy)
            {
                pts[k][0] = pts[i][0];
                pts[k++][1] = pts[i][1];
            }
        }
    }
    else if (dx == 1 && dy == 1)
    {
        FOR(i, nr)
        {
            if (pts[i][0] > cx && pts[i][1] > cy)
            {
                pts[k][0] = pts[i][0];
                pts[k++][1] = pts[i][1];
            }
        }
    }

    if (k > NUMBER_OF_POINTS)
        return imparte(pts, k);
    else
        return k;
}

int main()
{
    freopen("dist.in", "r", stdin);
    freopen("dist.out", "w", stdout);

    scanf("%d", &N);

    if (N <= 800)
    {
        brut();
        return 0;
    }

    FOR(i,N)
    {
        scanf("%d %d", &A[i][0], &A[i][1]);
        cx += A[i][0];
        cy += A[i][1];
    }

    cx /= N;
    cy /= N;

    int i1, i2;

    FOR(i,N)
    {
        if (A[i][0] < cx)
            i1 = 0;
        else
            i1 = 1;

        if (A[i][1] < cy)
            i2 = 0;
        else
            i2 = 1;

        ++pts[i1][i2];
    }

    ind[0][0] = 0;
    ind[0][1] = pts[0][0];
    ind[1][0] = pts[0][0] + pts[0][1];
    ind[1][1] = pts[0][0] + pts[0][1] + pts[1][0];

    FOR(i,N)
    {
        if (A[i][0] < cx)
            i1 = 0;
        else
            i1 = 1;

        if (A[i][1] < cy)
            i2 = 0;
        else
            i2 = 1;

        B[ind[i1][i2]][0] = A[i][0];
        B[ind[i1][i2]++][1] = A[i][1];
    }

    dx = 0; dy = 0;
    nr[dx][dy] = imparte(B, pts[dx][dy]);

    dx = 0; dy = 1;
    nr[dx][dy] = imparte(B+pts[0][0], pts[dx][dy]);

    dx = 1; dy = 0;
    nr[dx][dy] = imparte(B+pts[0][0]+pts[0][1], pts[dx][dy]);

    dx = 1; dy = 1;
    nr[dx][dy] = imparte(B+pts[0][0]+pts[0][1]+pts[1][1], pts[dx][dy]);


    int max = 0;

    FOR(i, nr[0][0])
    {
        FORI(j, pts[0][0]+pts[0][1]+pts[1][0], pts[0][0]+pts[0][1]+pts[1][0]+nr[1][1])
        {
            int a = B[i][0] - B[j][0];
            if (a < 0)
                a = -a;

            int b = B[i][1] - B[j][1];
            if (b < 0)
                b = -b;

            if (b < a)
                a = b;

            if (a > max)
                max = a;
        }
    }

    FORI(i, pts[0][0], pts[0][0]+nr[0][1])
    {
        FORI(j, pts[0][0]+pts[0][1], pts[0][0]+pts[0][1]+nr[1][0])
        {
            int a = B[i][0] - B[j][0];
            if (a < 0)
                a = -a;

            int b = B[i][1] - B[j][1];
            if (b < 0)
                b = -b;

            if (b < a)
                a = b;

            if (a > max)
                max = a;
        }
    }

    printf("%d\n", max);

    return 0;
}
