#include<stdio.h>
#include<string.h>
#define Nm 257
#define Mod 666013
int G[Nm][Nm],D[Nm],Gt[Nm][Nm],Dt[Nm],n,k;
int A[Nm][Nm],M[Nm][Nm],C[Nm],N[Nm],St[Nm],Pre[Nm],Nr[Nm],t,c;

void read()
{
    int m,x,y;

    freopen("dep.in","r",stdin);
    scanf("%d%d%d",&n,&m,&k);
    while(m--)
    {
        scanf("%d%d",&x,&y);
        G[x][D[x]++]=y;
        Gt[y][Dt[y]++]=x;
    }
}

void DFS(int x)
{
    int i;

    C[x]=1;
    for(i=0;i<D[x];++i)
        if(!C[G[x][i]]) DFS(G[x][i]);
    St[++t]=x;
}

void DFST(int x)
{
    int i;

    C[x]=c; ++N[c];
    for(i=0;i<Dt[x];++i)
        if(!C[Gt[x][i]]) DFST(Gt[x][i]);
}

void DFSC(int x)
{
    int i;

    C[x]=1;
    for(i=1;i<=c;++i)
        if(!C[i] && A[x][i]) DFSC(i);
    St[++t]=x;
}

void solve()
{
    int i,j;

    for(i=1;i<=n;++i)
        if(!C[i]) DFS(i);

    memset(C,0,sizeof(C));
    for(i=n;i;--i)
        if(!C[St[i]]) ++c, DFST(St[i]);

    for(i=1;i<=n;++i)
        for(j=0;j<D[i];++j)
            A[C[i]][C[G[i][j]]]=1;
    for(i=1;i<=c;++i) A[i][i]=0;

    memset(C,0,sizeof(C)); t=0;
    for(i=1;i<=c;++i)
        if(!C[i]) DFSC(i);

    for(i=1;i<=c;++i)
        if(i>1 && A[St[i]][St[i-1]])
        {
            Pre[i]=Pre[i-1];
            Nr[i]=N[St[i]]+Nr[i-1];
        }
        else
        {
            Pre[i]=i-1;
            Nr[i]=N[St[i]];
        }

    M[0][0]=1;
    for(i=1;i<=c;++i)
        for(j=0;j<=k;++j)
        {
            M[i][j]=M[i-1][j];
            if(Nr[i]<=j)
                M[i][j]=(M[i][j]+M[Pre[i]][j-Nr[i]])%Mod;
        }
}

void write()
{
    freopen("dep.out","w",stdout);
    printf("%d\n",M[c][k]);
}

int main()
{
    read();
    solve();
    write();
    return 0;
}

