using namespace std;
#include<cstdio>
#include<algorithm>
#define Nm (1<<17)
#define point pair<int,int>
#define x first
#define y second
#define Inf (1<<21)
#define min(a,b) ((a)<(b)?(a):(b))
#define max(a,b) ((a)>(b)?(a):(b))
int n;
point P[Nm];

void read()
{
    int i;

    freopen("dist.in","r",stdin);
    scanf("%d",&n);
    for(i=0;i<n;++i)
        scanf("%d%d",&P[i].x,&P[i].y);
}

bool ok(int m)
{
    int i,j=0,ymin=Inf,ymax=-Inf;

    for(i=0;i<n;++i)
    {
        for(;j<n && P[j].x<=P[i].x-m;++j)
        {
            ymin=min(ymin,P[j].y);
            ymax=max(ymax,P[j].y);
        }
        if(P[i].y-ymin>=m || ymax-P[i].y>=m) return 1;
    }
    return 0;
}

int solve()
{
    int l=0,r=Inf,m;

    sort(P,P+n);
    while(l<r)
    {
        m=l+r+1>>1;
        if(ok(m)) l=m;
        else r=m-1;
    }
    return l;
}

void write(int ans)
{
    freopen("dist.out","w",stdout);
    printf("%d\n",ans);
}

int main()
{
    read();
    write(solve());
    return 0;
}

