#include<stdio.h>
#include<fstream>
using namespace std;
#define Nmax 260
#define MOD 666013

int vec[Nmax][Nmax], Nvec[Nmax];
int Q[Nmax],cc[Nmax],dep[Nmax];
char viz[Nmax];
int cat[Nmax][Nmax];
char is_dest[Nmax];
int ruxac[Nmax], aux[Nmax];

int main(){

    FILE *fin = fopen("dep.in","r");
    FILE *fout = fopen("dep.out","w");

    int N,M,K,ncc=0;
    fscanf(fin,"%d%d%d",&N,&M,&K);

    for(int i=1;i<=M;i++){
        int x,y;
        fscanf(fin,"%d%d",&x,&y);
        vec[x][++Nvec[x]] = y;
    }

    for(int i=1;i<=N;i++){
        //bfs cu sursa in i
        memset(viz,0,sizeof viz);
        int li,lf,dest;
        li=lf=1;
        Q[li] = i;
        viz[i] = 1;

        while(li<=lf){
            int crt = Q[li];
            int cati = 0;
            for(int p=1;p<=Nvec[crt];p++)
                if(viz[vec[crt][p]]==0){
                    Q[++lf] = vec[crt][p];
                    viz[vec[crt][p]] = 1;
                }
            if(Nvec[crt]==0)
                dest = crt;
                
            li++;
        }

        is_dest[dest] = 1;
        cat[dest][lf] ++;
        
    }

    //ruxac
    ruxac[0] = 1;
    for(int d=1;d<=N;d++)
        if(is_dest[d]){
            cat[d][0] = 1;
            memset(aux,0,sizeof aux);
        
            for(int c=0;c<=N;c++)
                if(cat[d][c] > 0){
                    for(int i=N-c;i>=0;i--)
                        if(ruxac[i]>0){
                            aux[i+c] += ruxac[i] * cat[d][c];
                            aux[i+c] %= MOD;
                        }
                }

            for(int c=0;c<=N;c++)
                ruxac[c] = aux[c];

        }

    fprintf(fout,"%d\n",ruxac[K]);

    fclose(fin);
    fclose(fout);
    return 0;

}

