#include <stdio.h>
#include <algorithm>

using namespace std;

#define maxn 100010
#define mil 1000000
#define N 1000
#define ll long long

int n, l, sol;
int a[maxn], b[maxn], p[maxn];
int sx[maxn], sy[maxn];

int cmp(int x, int y)
{
	return a[x] < a[y];
}

int cmp2(int x, int y)
{
	return b[x] < b[y];
}

int cmp3(int x, int y)
{
	return 1LL*(b[x]-b[1])*(a[y]-a[1]) < 1LL*(a[x]-a[1])*(b[y]-b[1]);
}

ll cp(int x1, int x2, int x3, int y1, int y2, int y3)
{
	return 1LL*(x2-x1)*(y3-y1) - 1LL*(x3-x1)*(y2-y1);	
}

int main()
{
	freopen("dist.in", "r", stdin);
	freopen("dist.out", "w", stdout);

	scanf("%d ",&n);

	int i, j, v1, v2, aux;

	for (i=1; i<=n; i++) 
	{
		scanf("%d %d ",&a[i], &b[i]);
		p[i] = i;
	}

	if (n <= 4000) 
	{
		for (i=1; i<=n; i++) 
			for (j=i+1; j<=n; j++) 
			{
				v1 = abs(a[i]-a[j]);
				v2 = abs(b[i]-b[j]);

				if (v1 < v2) aux = v1;
				else aux = v2;
				
				if (aux > sol) sol = aux;
			}
	}
	else {
		     sort(p+1, p+n+1, cmp);

			 for (i=1; i<=N; i++)
				 for (j=n; j>n-N && i<j; j--)
				 {
					 v1 = abs(a[p[i]]-a[p[j]]);
					 v2 = abs(b[p[i]]-b[p[j]]);

					 if (v1 < v2) aux = v1;
					 else aux = v2;

					 if (aux > sol) sol = aux;
				 }

			 for (i=1; i<=n; i++) p[i] = i;

			 sort(p+1, p+n+1, cmp2);

			 for (i=1; i<=N; i++)
				 for (j=n; j>n-N && i<j; j--)
					{
						v1 = abs(a[p[i]]-a[p[j]]);
						v2 = abs(b[p[i]]-b[p[j]]);

						if (v1 < v2) aux = v1;
						else aux = v2;

						if (aux > sol) sol = aux;
					}

			  if (n <= 40000)
			  {
		      int best = 1;

			  for (i=1; i<=n; i++) 
				  if (a[i] < a[best] || (a[i]==a[best] && b[i]<b[best])) best = i;

			  aux = a[1];
			  a[1] = a[best];
			  a[best] = aux;

			  aux = b[1];
			  b[1] = b[best];
			  b[best] = aux;

			  for (i=1; i<=n; i++) p[i] = i;

			  sort(p+2, p+n+1, cmp3);

			  l = 2;
			  sx[1] = a[1];
			  sy[1] = b[1];
			  sx[2] = a[p[2]];
			  sy[2] = b[p[2]];

			  ll semn;

			  for (i=3; i<=n; i++)
			  {
				  semn = cp(sx[l-1], sx[l], a[p[i]], sy[l-1], sy[l], b[p[i]]);
					
				  while (l>2 && semn <= 0)
				  {
					  l--;
					  semn = cp(sx[l-1], sx[l], a[p[i]], sy[l-1], sy[l], b[p[i]]);
				  }

				  l++;
				  sx[l] = a[p[i]];
				  sy[l] = b[p[i]];
			  }


			  int l1, l2;

			  if (l <= N) 
			  {
				  l1 = l;
				  l2 = 0;
			  }
			  else {
				  	   l1 = N;
					   l2 = l-N;
			       }

			  for (i=1; i<=l1; i++)
				  for (j=l; i<j && j>l2; j--) 
				  {
					  v1 = abs(sx[i]-sx[j]);
					  v2 = abs(sy[i]-sy[j]);
					  
					  if (v1 < v2) aux = v1;
					  else aux = v2;

					  if (aux > sol) sol = aux;
				  }
			  }
	     }

	printf("%d\n", sol);

	return 0;
}
