#include <stdio.h>
#include <vector>
#include <algorithm>

const int modul = 666013;

using namespace std;

int c[257][257], n, m, k, mat[257][257], used[257], nr[257], din[257][257], cnt, comp[257], gin[257], last, pos[257];
vector<int> v[257], G[257];

void dfs(int nod);
void tsort(int nod);
bool cmp(int a, int b)
{
	return pos[a] < pos[b];
}

int main()
{
	freopen("dep.in", "r", stdin);
	freopen("dep.out" ,"w", stdout);

	int i, j, l, a, b, sz;

	scanf("%d %d %d", &n, &m, &k);

	for(i = 1; i <= m; ++i)
	{
		scanf("%d %d", &a, &b);
		c[b][a] = 1;
	}

	for(l = 1; l <= n; ++l)
	{
		for(i = 1; i <= n; ++i)
		{
			for(j = 1; j <= n; ++j)
			{
				if(c[i][l] && c[l][j])
				{
					c[i][j] = 1;
				}
			}
		}
	}

	for(i = 1; i <= n; ++i)
	{
		if(!used[i])
		{
			used[i] = 1;
			++cnt;
			comp[i] = cnt;
			v[cnt].push_back(i);
			nr[cnt] = 1;
			for(j = 1; j <= n; ++j)
			{
				if(i != j && c[i][j] && c[j][i])
				{
					comp[j] = cnt;
					++nr[cnt];
					used[j] = 1;
					v[cnt].push_back(j);
				}
			}
		}
	}

	for(i = 1; i <= cnt; ++i)
	{
		sz = v[i].size();
		for(j = 0; j < sz; ++j)
		{
			for(l = 1; l <= n; ++l)
			{
				if(comp[l] != i && c[v[i][j]][l] && !mat[i][comp[l]])
				{
					G[i].push_back(comp[l]);
					mat[i][comp[l]] = 1;
					++gin[comp[l]];
				}
			}
		}
		din[i][nr[i]] = 1;
	}
	for(i = 1; i <= cnt; ++i)
	{
		if(!gin[i])
		{
			G[0].push_back(i);
		}
	}
	
	din[0][0] = 1;
	memset(used, 0, sizeof(used));
	last = cnt;
	tsort(0);
	memset(used, 0, sizeof(used));
	for(i = 1; i <= cnt; ++i)
	{
	//	printf("%d:", i);
		sort(G[i].begin(), G[i].end(), cmp);
		/*
		for(j = 0; j < G[i].size(); ++j)
		{
			printf(" %d", G[i][j]);
		}
		printf("\n");
		*/
	}
	dfs(0);
/*
	for(i = 1; i <= n; ++i)
	{
		printf("%d %d\n", i, pos[i]);
	}
*/	
	printf("%d\n", din[0][k]);

	return 0;
}

void dfs(int nod)
{
	used[nod] = 1;
	int i, sz = G[nod].size(), j, l;

	for(i = 0; i < sz; ++i)
	{
		if(!used[G[nod][i]])
		{
			dfs(G[nod][i]);
		
			for(j = k; j >= 0; --j)
			{
				for(l = 0; l <= j; ++l)
				{
					din[nod][j] += ((long long)din[nod][j - l] * din[G[nod][i]][l]) % modul;
					if(din[nod][j] >= modul)
					{
						din[nod][j] -= modul;
					}
				}
			}
		}
	}
}

void tsort(int nod)
{
	int i, sz = G[nod].size();
	used[nod] = 1;

	for(i = 0; i < sz; ++i)
	{
		if(!used[G[nod][i]])
		{
			tsort(G[nod][i]);
		}
	}
	pos[nod] = last;
	--last;
}
