#include <stdio.h>
#include <algorithm>

#define x first
#define y second

using namespace std;

int n, m[18][100001], M[18][100001], log[100001], D, sol;
pair<int, int> p[100001];

inline int min(int a, int b)
{
	if(a < b)
		return a;
	return b;
}
inline int max(int a, int b)
{
	if(a > b)
		return a;
	return b;
}
inline int bs(int, int);

int main()
{
	freopen("dist.in", "r", stdin);
	freopen("dist.out", "w", stdout);

	int i, cnt, left, ok;
	
	scanf("%d", &n);

	for(i = 1; i <= n; ++i)
	{
		scanf("%d %d", &p[i].x, &p[i].y);
	}
	sort(p + 1, p + n + 1);

	for(i = 1; i <= n; ++i)
	{
		m[0][i] = p[i].y;
		M[0][i] = p[i].y;
	}

	for(cnt = 1; (1 << cnt) <= n; ++cnt)
	{
		for(i = 1; i + (1 << cnt) - 1 <= n; ++i)
		{
			m[cnt][i] = min(m[cnt - 1][i], m[cnt - 1][i + (1 << (cnt - 1))]);
			M[cnt][i] = max(M[cnt - 1][i], M[cnt - 1][i + (1 << (cnt - 1))]);
		}
	}
	for(i = 2; i <= n; ++i)
	{
		log[i] = log[i / 2] + 1;
	}
	D = min(p[n].x - p[1].x, max(M[log[n]][1], M[log[n]][n - (1 << log[n]) + 1]) - min(m[log[n]][1], m[log[n]][n - (1 << log[n]) + 1]));

	int lo = 0, hi = D, mid;
/*
	for(i = 1; i <= n; ++i)
	{
		printf("%d %d\n", p[i].x, p[i].y);
	}
*/	
	while(lo <= hi)
	{
		mid = (lo + hi) / 2;
		ok = 0;
		for(i = 1; i <= n; ++i)
		{
			left = bs(i, mid);
			//printf("%d %d(%d) %d(%d)\n", mid, i, p[i].x, left, p[left].x);
			if(left != 0)
			{
				if(max(M[log[left]][1], M[log[left]][left - (1 << log[left]) + 1]) >= p[i].y + mid)
				{
					ok = 1;
					break;
				}
	//			printf("%d %d %d\n", log[left], m[log[left]][1], m[log[left]][left - (1 << log[left]) + 1]);
				if(min(m[log[left]][1], m[log[left]][left - (1 << log[left]) + 1]) <= p[i].y - mid)
				{
					ok = 1;
					break;
				}
			}
		}
		if(ok)
		{
			sol = mid;
			lo = mid + 1;
		}
		else
		{
			hi = mid - 1;
		}
	}
	printf("%d\n", sol);

	return 0;
}

inline int bs(int pos, int val)
{
	int lo = 1, hi = pos, mid, res = 0;

	while(lo <= hi)
	{
		mid = (lo + hi) / 2;
		if(p[mid].x + val <= p[pos].x)
		{
			res = mid;
			lo = mid + 1;
		}
		else
		{
			hi = mid - 1;
		}
	}
	return res;
}

