#include <cstdio>
#include <vector>
#include <algorithm>
#include <bitset>

using namespace std;

#define Nmax 260
#define MOD 666013
#define pb push_back
#define sz(a) (int)((a).size())
#define ll long long

int n, m, k, ct, N;
vector<int> lv[Nmax], lvt[Nmax];
vector<int> LV[Nmax];
int v[Nmax];
int list[Nmax];
int nr[Nmax][Nmax];
bitset<Nmax> mask[Nmax];
vector< bitset<Nmax> > V[Nmax];
int D[Nmax][Nmax];

void citire()
{
	int i, a, b;

	scanf("%d %d %d\n", &n, &m, &k);
	for (i = 1; i <= m; ++i)
	{
		scanf("%d %d\n", &a, &b);
		lv[a].pb(b);
		lvt[b].pb(a);
	}
}

void DFt(int nod)
{
	int i;

	v[nod] = 1;
	
	for (i = 0; i < sz(lvt[nod]); ++i)
		if (!v[lvt[nod][i]])
			DFt(lvt[nod][i]);

	list[++ct] = nod;
}

void DF(int nod)
{
	int i;

    v[nod] = ct;
	
	for (i = 0; i < sz(lv[nod]); ++i)
		if (!v[lv[nod][i]])
			DF(lv[nod][i]);
}

void DF1(int nod)
{
	int i;

	v[nod] = 1;
	for (i = 0; i < sz(LV[nod]); ++i)
		if (!v[LV[nod][i]])
			DF1(LV[nod][i]);

	list[++ct] = nod;
}

void scrie(bitset<Nmax> a)
{
	for (int i = 1; i <= n; ++i)
		if (a[i]) printf("1");
		else printf("0");
	printf("\n");
}

int cmp(const bitset<Nmax> a, const bitset<Nmax> b)
{
	for (int i = 1; i <= n; ++i)
		if (!a[i] && b[i])
			return 1;
		else if (a[i] && !b[i])
			return 0;
	return 0;
}

void solve()
{
	int i, j, l, cnt;

	for (i = 1; i <= n; ++i)
		if (!v[i])
			DFt(i);
	reverse(list+1, list+n+1);

	ct = 0;
	memset(v, 0, sizeof(v));
	for (i = 1; i <= n; ++i)
		if (!v[list[i]])
		{
			++ct;
			DF(list[i]);
		}

	for (i = 1; i <= n; ++i)
		mask[v[i]][i] = 1;

	for (i = 1; i <= n; ++i)
		for (j = 0; j < sz(lv[i]); ++j)
			if (v[i] != v[lv[i][j]])
				LV[v[i]].pb(v[lv[i][j]]);

	/*
    for (i = 1; i <= n; ++i)
		printf("%d - %d\n", i, v[i]);
	printf("\n");
	*/
	
	N = ct;
	ct = 0;
	memset(v, 0, sizeof(v));
	
	for (i = 1; i <= N; ++i)
		if (!v[i])
			DF1(i);

	ct = 0;
	memset(v, 0, sizeof(v));
	for (i = 1; i <= N; ++i)
	{
		if (sz(LV[list[i]]) == 0)
		{
			v[list[i]] = ++ct;
			V[ct].pb(mask[list[i]]);
		}
		else
		{
			for (j = 0; j < sz(LV[list[i]]); ++j)
			{
				v[list[i]] = v[LV[list[i]][j]];
				mask[list[i]] |= mask[LV[list[i]][j]];
			}
			V[v[list[i]]].pb(mask[list[i]]);
		}
	}

    for (i = 1; i <= ct; ++i)
	{
		sort(V[i].begin(), V[i].end(), cmp);
		V[i].erase(unique(V[i].begin(), V[i].end()), V[i].end());
	}
	
	//printf("%d\n", ct);
	for (i = 1; i <= ct; ++i)
	{
		for (j = 0; j < sz(V[i]); ++j)
		{
			cnt = 0;
			for (int k = 1; k <= n; ++k)
				if (V[i][j][k])
				{
					//printf("1");
					++cnt;
				}
				else;
					//printf("0");
			//printf("\n");

			nr[i][cnt] += 1;
			if (nr[i][cnt] >= MOD) nr[i][cnt] -= MOD;
		}
		//printf("\n");
	}

	D[0][0] = 1;
	for (i = 1; i <= ct; ++i)
		for (l = 0; l <= k; ++l)
			if (nr[i][l])
				for (j = l; j <= k; ++j)
					D[i][j] += ((ll)D[i - 1][j - l] * nr[i][l]) % MOD;

	printf("%d\n", D[ct][k]);
}

int main()
{
	freopen("dep.in", "r", stdin);
	freopen("dep.out", "w", stdout);

	citire();
	solve();

	return 0;
}
