#include <cstdio>
#include <cstring>

#define Nmax 512
#define INF 0x3f3f3f3f
#define MIN(a,b) ((a) <= (b) ? (a) : (b))

int n;
char sir[Nmax];
int next[Nmax];
int last[256];
int D[Nmax][Nmax];

void citire()
{
	scanf("%s\n", sir+1);
	n = strlen(sir+1);
}

void solve()
{
	int i, j, k, d, cost, prev;

	memset(last, 0x3f, sizeof(last));
    for (i = n; i >= 1; --i)
	{
		next[i] = last[(int)sir[i]];
		last[(int)sir[i]] = i;
	}
	
	for (i = 1; i <= n; ++i)
		D[i][i] = 3;
	for (i = 1; i < n; ++i)
		if (sir[i] == sir[i + 1])
			D[i][i + 1] = 2 + 2;
		else
			D[i][i + 1] = 4 + 2;

	for (d = 2; d <= n; ++d)
		for (i = 1; i + d <= n; ++i)
		{
			j = i + d;
            D[i][j] = D[i + 1][j] + 3;
			
            if (sir[i] == sir[j])
				D[i][j] = MIN(D[i][j], D[i + 1][j - 1] + 4);
			
            for (k = next[i]; k < j; k = next[k])
				D[i][j] = MIN(D[i][j], D[i][k] + D[k][j] - 3);
			
			//printf("%d %d - %d\n", i, j, D[i][j]);
		}

	printf("%d\n", D[1][n]);
}

int main()
{
	freopen("stiva.in", "r", stdin);
	freopen("stiva.out", "w", stdout);

	citire();
	solve();

	return 0;
}
