#include <stdio.h>
#include <string.h>
#define NMAX 300
#define MOD 666013

int N, M, K, A[NMAX][NMAX], G[NMAX];
int S[NMAX], F[NMAX], Ans;

void read()
{
        int i, j, k;

        scanf("%d %d %d", &N, &M, &K);

        for (k = 0; k < M; k++)
        {
                scanf("%d %d", &i, &j);
                A[i][ G[i]++ ] = j;
        }
}

void dfs(int i)
{
        int j, n = G[i];

        F[i] = 1;
        for (j = 0; j < n; j++)
                if (!F[ A[i][j] ])
                        dfs(A[i][j]);
}

void solve()
{
        int i, j, n = (1<<N), s, ok;

        for (i = 0; i < n; i++)
        {
                s = 0;
                for (j = 0; j < N; j++)
                        if ((i>>j)&1)
                           S[s++] = j+1;
                if (s!=K) continue;
                for (j = 0; j < NMAX; j++) F[j] = 0;
                for (j = 0; j < s; j++)
                        dfs(S[j]);
                for (j = 0, ok = 1; ok && j < s; j++)
                        if (!F[S[j]]) ok = 0;
                        else F[S[j]] = 0;
                if (ok)
                {
                        for (j = 1; ok && j <= N; j++)
                                if (F[j]) ok = 0;
                        Ans = (Ans+ok)%MOD;
                }
        }
}

void write()
{
        printf("%d\n", Ans);
}

int main()
{
        freopen("dep.in", "r", stdin);
        freopen("dep.out", "w", stdout);

        read();
        solve();
        write();

        return 0;
        
}

