#include <cstdio>
#include <set>
#include <vector>
#include <algorithm>
#include <ctime>
using namespace std;

const char iname[] = "dist.in";
const char oname[] = "dist.out";

#define FOR(i, a, b)  for (int i = (a); i < (b); ++ i)
#define FORI(i, V) for (__typeof(V.begin()) i = V.begin(); i != V.end(); ++ i)
#define MIN(a, b) ((a) < (b) ? (a) : (b))
#define MAX(a, b) ((a) > (b) ? (a) : (b))
#define ABS(a)    ((a) < 0 ? (-(a)) : (a))

#define MAXN  100005

vector <pair <int, int> > points;

int n;

int sgn;

set <pair <int, int> > myset;

inline void getnumber(char* &p, int &n) {
    for (; *p == ' '; ++ p);
    if (*p == '-')
        sgn = -1, p ++;
    else
        sgn = +1;
    for (n = 0; '0' <= *p && *p <= '9'; ++ p)
        n = n * 10 + (*p - '0');
    n *= sgn;
}

void read_in(void)
{
    FILE *fi = fopen(iname, "r");
    char buffer[32], *p;

    fscanf(fi, "%d\n", &n);
    points.resize(n);
    FORI (i, points) {
        fgets(buffer, 32, fi), p = buffer;
        getnumber(p, i->first);
        getnumber(p, i->second);
    }

    fclose(fi);
}

void write(const int n, const int mod)
{
    FILE *fo = fopen(iname, "w");
    srand((unsigned)time(0));

    fprintf(fo, "%d\n", n);
    FOR (i, 0, n) {
        int a = ((rand() & 1) ? -1 : +1) * (rand() % mod);
        int b = ((rand() & 1) ? -1 : +1) * (rand() % mod);
        fprintf(fo, "%d %d\n", a, b);
    }
    fclose(fo);
}

int work(void)
{
    int Res = 0;
    FOR (i, 0, points.size())
        FOR (j, i + 1, points.size())
            Res = MAX(Res, MIN(ABS(points[i].first - points[j].first),
                               ABS(points[i].second - points[j].second)));
    return Res;
}

int main(void)
{
//  write(5, 4);
    read_in();
/*  sort(points.begin(), points.end());

    int x = points[0].first;
    int ymin = points[0].second, ymax = points[0].second;
    FORI (i, points)
       if (i->first == x) {
           ymin = MIN(ymin, i->second);
           ymax = MAX(ymax, i->second);
       } else
           break ;

    int Res = 0;

    FORI (i, points) {
        if (i->first == x)  continue ;
        int d = i->first - x;
        bool acoperit = true;

        if ((ymin - d <= i->second && i->second <= ymin + d) == 0)
            acoperit = false;
        if ((ymax - d <= i->second && i->second <= ymax + d) == 0)
            acoperit = false;

        if (!acoperit)
            Res = MAX(Res, d);
        else
            Res = MAX(Res, MAX(ABS(i->second - ymin), ABS(i->second - ymax)));
    }
    printf("%d\n", Res);  */

    FILE *fo = fopen(oname, "w");
    
    fprintf(fo, "%d\n", work());
    fclose(fo);

    return 0;
}
