#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

const char iname[] = "stiva.in";
const char oname[] = "stiva.out";

#define FOR(i, a, b)  for (int i = (a); i <= (b); ++ i)
#define FORR(i, b, a) for (int i = (b); i >= (a); -- i)
#define MAXL  505
#define MAXCh 26

char str[MAXL];  int n;

int  left[MAXL][MAXCh], right[MAXL][MAXCh];

int  dp[MAXL][MAXL];


int main(void)
{
    fscanf(fopen(iname, "r"), "%s", str + 1);
    n = (int)strlen(str + 1);

    FOR (i, 1, n) FOR (j, 0, 25)
       left[i][j] = (str[i] == (j + 'A'))  ? i : left[i - 1][j];
    FORR (i, n, 1) FOR (j, 0, 25)
       right[i][j] = (str[i] == (j + 'A')) ? i : right[i + 1][j];

    FOR (d, 1, n - 1) FOR (i, 1, n - d) {
       int j = i + d;
       if (str[i] == str[j]) {
          int ret = 0;
          FOR (c, 0, 25) {
             int l = right[i + 1][c], r = left[j - 1][c];
             ret = max(ret, dp[l][r]);
          }
          dp[i][j] = ret + 2;
       }
    }

    int ret = 0;
    FOR (c, 0, 25) {
        int l = right[1][c], r = left[n][c];
        ret = max(ret, dp[l][r]);
    }
    fprintf(fopen(oname, "w"), "%d\n", 3 * n - ret);
       
    fcloseall();
    return 0;
}
