#include <stdio.h>
#include <string.h>
#include <vector>
#include <algorithm>

using namespace std;

#define maxim(a, b) ((a > b) ? a : b)
#define CLEAR(x) memset(x, 0, sizeof(x))
#define MOD 666013

int N, M, K, G[257][257], GT[257][257], GC[257][257], uz[257], timp[257], t, cnt, dim[257];
vector<int> Graf[257], viz[257];
int comp[257], ctc;

int cmp_nodes(const int & a, const int & b)
{
	return timp[a] > timp[b];
}

void df1(int nod)
{
	int i;

	uz[nod] = 1;
	for (i = 1; i <= N; ++i)
		if (G[nod][i] && !uz[i])
			df1(i);
	timp[++t] = nod;
}

void df2(int nod)
{
	int i;

	uz[nod] = 1; comp[nod] = ctc; dim[ctc]++;
	for (i = 1; i <= N; ++i)
		if (GT[nod][i] && !uz[i])
			df2(i);
}

int st[257], sel[257];
void back(int nivel, int pers)
{
	int i, sz, aft;

	if (nivel == ctc+1)
	{
		cnt += (pers == K);
		if (cnt == MOD) cnt = 0;
		return ;
	}	

	if (!sel[nivel])
	{
		st[nivel] = 0; back(nivel+1, pers);
	}
    
	if (sel[nivel]) { st[nivel] = 1; back(nivel+1, pers); return; }
	st[nivel] = 1; aft = 0;
	for (sz = viz[nivel].size(), i = 0; i < sz; ++i)
	{
		if (!sel[ viz[nivel][i] ])
			aft += dim[viz[nivel][i]];
		++sel[viz[nivel][i]];
	}
	back(nivel+1, pers+aft);
	for (sz = viz[nivel].size(), i = 0; i < sz; ++i)
		--sel[viz[nivel][i]];
}

void df3(int nod)
{
	int i, sz, x;

	uz[nod] = 1;
	for (sz = Graf[nod].size(), i = 0; i < sz; ++i)
		if (!uz[x = Graf[nod][i]])
			df3(x);
}

int main(void)
{
	int i, j;

	freopen("dep.in", "r", stdin);
	freopen("dep.out", "w", stdout);

	scanf("%d %d %d", &N, &M, &K);
	for (; M; --M)
	{
		scanf("%d %d", &i, &j);
		G[i][j] = 1;
		GT[j][i] = 1;
	}

	for (i = 1; i <= N; ++i)
		if (!uz[i])
			df1(i);
	
	CLEAR(uz);
	for (i = N; i; --i)
	{
		j = timp[i];
		if (uz[j]) continue;
		++ctc;
		df2(j);
	}

	for (i = 1; i <= N; ++i)
		for (j = 1; j <= N; ++j)
			if (G[i][j] && comp[i] != comp[j])
			{
				if (GC[comp[i]][comp[j]]) continue;
				GC[comp[i]][comp[j]] = 1;
				Graf[comp[i]].push_back(comp[j]);
			}
	
	for (i = 1; i <= ctc; ++i)
	{
		CLEAR(uz);
		df3(i);
		for (j = 1; j <= ctc; ++j)
			if (uz[j])
				viz[i].push_back(j);
	}
	back(1, 0);

	printf("%d\n", cnt);

	return 0;
}

