#include <cstdio>

#define fin  "dep.in"
#define fout "dep.out"

const int Nmax = 257;
const int Mod  = 666013;

int N,M,K,cnt;
int g[Nmax][Nmax],newg[Nmax][Nmax];

int x[Nmax],used[Nmax];

int comb(int last,int lev)
{
	int i,j,flag = 0;

	if ( lev == K + 1 )
	{
		for ( i = 1; i <= K; ++i )
			for ( j = 1; j <= N; ++j )
				if ( newg[ x[i] ][ j ] && !used[ j ] )
					return 0;
		++cnt;
		if ( cnt == Mod )
			cnt = 0;
		return 1;
	}
	
	for ( i = last + 1; i <= N; ++i )
	{
		used[ i ] = 1;
		x[ lev ] = i;
		comb(i,lev+1);
		used[ i ] = 0;
	}

	return 0;
}

int main()
{
	int i,j,k,x,y;
	
	freopen(fin,"r",stdin);
	freopen(fout,"w",stdout);

	scanf("%d%d%d",&N,&M,&K);

	for ( i = 1; i <= M; ++i )
	{
		scanf("%d%d",&x,&y);
		newg[x][y] = g[x][y] = 1;
		
	}
	
	for ( k = 1; k <= N; ++k )
	for ( i = 1; i <= N; ++i )
	for ( j = 1; j <= N; ++j )
		if ( newg[i][k] && newg[k][j] )
			newg[i][k] = 1;
	
	comb(0,1);
	
	printf("%d\n",cnt);

	return 0;
}
