#include <stdio.h>
#include <algorithm>
using namespace std;

#define maxN 100010
#define maxX 1000000
#define inf 0x7f7f7f7f

struct pt{int x,y;pt(){}pt(int xp,int yp){x=xp,y=yp;}
	bool operator <(pt const & r)const{
		return x<r.x;
	}
};

int n,res,dmin,dmax;
pt vec[maxN];

void inputFunc(){
	FILE*fi=fopen("dist.in","r");
	fscanf(fi,"%d",&n);

	int minx=inf,maxx=-inf,miny=inf,maxy=-inf;
	for(int i=0;i<n;i++){
		int a,b;fscanf(fi,"%d %d",&a,&b);
		vec[i].x=a,vec[i].y=b;
		if(a>maxx)maxx=a;
		if(a<minx)minx=a;
		if(b>maxy)maxy=b;
		if(b<miny)miny=b;
	}
	dmax=min(maxx-minx,maxy-miny);
	sort(vec,vec+n);
	fclose(fi);
}

void outputFunc(){FILE*fi=fopen("dist.out","w");fprintf(fi,"%d",res);fclose(fi);}



int main(){
	inputFunc();

	for(int i=0;i<n;i++){
		int x=vec[i].x,y=vec[i].y;

		
		for(int j=n-1;j>i;j--){
			int o=abs(x-vec[j].x),p=abs(y-vec[j].y);
			
			if(o<dmin)break;
			
			int cd=min(o,p);
			if(cd>dmin)dmin=cd;
		}

		
	}


	res=dmin;
	outputFunc();
	return 0;
}

