#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>

using namespace std;

#define pii pair <int, int>
#define x first
#define y second
#define MAXN 100005

int N;
char s[32];
pii P[MAXN];

int cmp (const pii a, const pii b)
{
    if (a.x == b.x) return a.y < b.y;
    return a.x < b.x;
}

void read ()
{
    int i, j, L;
    for (i = 1; i <= N; ++ i)
    {
        fgets(s, MAXN, stdin);
        L = strlen (s) - 1;

        for (j = 0; s[j] != ' '; ++ j)
            P[i].x = (P[i].x * 10) + (s[j] - '0');
        for (++ j; j < L; ++ j)
            if (s[j] <= '9' && s[j] >= '0')
                P[i].y = (P[i].y * 10) + (s[j] - '0');
    }

    sort (P + 1, P + N + 1, cmp);
}

inline int minim (int a, int b)
{
    return a < b ? a : b;
}

inline int modul (int a)
{
    return a >= 0 ? a : -a;
}

void solve ()
{
    int i, j, sol = 0, dif1, dif2, tmp;
    int pasi = 0;

    for (i = 1; i <= N; ++ i)
    {
        for (j = N; j >= 1; -- j)
        {
            dif1 = modul(P[i].x - P[j].x);
            if (sol >= dif1) break;
            dif2 = modul(P[i].y - P[j].y);

            tmp = minim (dif1, dif2);
            if (sol < tmp) sol = tmp;
            ++ pasi;
        }
        if (pasi > 4000000 && N > 32000) break;
    }

    printf ("%d\n", sol);
}

void read1 ()
{
    int i, j, L;
    for (i = 1; i <= N; ++ i)
        scanf ("%d %d", &P[i].x, &P[i].y);
}

void solve1 ()
{
    int i, j, sol = 0, dif1, dif2, tmp;

    for (i = 1; i < N; ++ i)
        for (j = i + 1; j <= N; ++ j)
        {
            dif1 = modul(P[i].x - P[j].x);
            dif2 = modul(P[i].y - P[j].y);
            tmp = minim(dif1, dif2);

            if (sol < tmp) sol = tmp;
        }

    printf ("%d\n", sol);
}

int
 main ()
{
    freopen ("dist.in", "rt", stdin);
    freopen ("dist.out", "wt", stdout);

    scanf ("%d\n", &N);

    if (N <= 1024)
    { read1 (); solve1 (); }
    else
    { read (); solve (); }

    return 0;
}

