#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define X first
#define Y second
#define ALL(C) C.begin(), C.end()

#define NX 100010

typedef pair< int, int > point;
point v[ NX ];
int N, Max, S[ NX ], k;
point piv;

inline int ABS( int x ) {
	return (x>0) ? x : -x;
}

bool cmp( const point &a, const point &b ) {
	return (a.Y == b.Y) ? ( a.X < b.X ) : ( a.Y < b.Y );
}

struct polar {
	bool operator() ( const point &a, const point &b ) const {
		return ( atan2( (double)a.Y, a.X ) < atan2( (double)b.Y, b.X ) );
	}
};

bool dreapta( int i, int j, int k ) {
	return ( ( v[i].X*(v[j].Y-v[k].Y) + v[j].X*(v[k].Y-v[i].Y) + v[k].X*(v[i].Y-v[j].Y) ) < 0 );
}

void cit() {
	int i, a, b;
	
	scanf( "%d", &N );

	for( i = 0; i < N; i++ ) {
		scanf( "%d%d", &a, &b );
		v[i] =  mp( a, b );
		if( cmp( v[i], piv ) )
			piv = v[i];
	}


}

void rez() {
	int dx, dy, i, j, dst, M;
	
	dx = piv.X, dy = piv.Y;
	for( i = 0; i < N; i++ )
		v[i].X -= dx, v[i].Y -= dy;

	sort( v, v+N, polar() );

	S[ ++k ] = 0; S[ ++k ] = 1;
	
	for( i = 2; i < N; i++ ) {
		while( dreapta( S[k-1], S[k], i ) )
			k--;
		S[++k] = i;
	}

	M = k;
	for( i = 1; i < M; i++ )
		for( j = i+1; j <= M; j++ ) {
			dst = min( ABS( v[S[i]].X - v[S[j]].X ), ABS( v[S[i]].Y - v[S[j]].Y ) );
			if( dst > Max )
				 Max = dst;
		}
}

void rez1() {
	int i, j, dst;
	
	for( i = 0; i < N-1; i++ )
		for( j = i+1; j < N; j++ ) {
			dst = min( ABS( v[i].X - v[j].X ), ABS( v[i].Y - v[j].Y ) );
			if( dst > Max )
				Max = dst;
		}
}

void scr() {
	printf( "%d\n", Max );
}

int main() {
	freopen( "dist.in", "r", stdin );
	freopen( "dist.out", "w", stdout );

	cit();
	if( N <= 1024 )
		rez1();
	else
		rez();
	scr();

	return 0;
}

