#include <stdio.h>

#define maxn 510
#define maxm 110
#define mod 123456781
#define baza 19
#define min(a,b) (a < b ? a : b)
#define max(a,b) (a > b ? a : b)

int n, m, sol;
short a[maxn][maxn], c[maxn][maxn];
short b[maxm][maxm], d[maxm][maxm];
short vmax[maxm];
int h[maxm];
int hash[maxn][maxn];

int main()
{
	freopen("tetris.in", "r", stdin);
	freopen("tetris.out", "w", stdout);

	scanf("%d ", &n);

	int i, j, k;

	for (i=1; i<=n; i++)
		for (j=1; j<=n; j++) scanf("%hd ", &a[i][j]);

	scanf("%d ", &m);

	for (i=1; i<=m; i++)
		for (j=1; j<=m; j++) 
		{
			scanf("%hd ", &b[i][j]);
			d[i][j] = b[i][j];
		}

	for (i=1; i<=m; i++)
	{
		vmax[i] = b[1][i];
		for (j=1; j<=m; j++) vmax[i] = max(vmax[i], b[j][i]);

		for (j=1; j<=m; j++) b[j][i] = vmax[i] - b[j][i];
	}

	for (i=1; i<=m; i++)
		for (j=1; j<=m; j++)
		{
			h[i] = (1LL*h[i]*baza) % mod;
			h[i] = (h[i] + b[j][i]) % mod;
		}

	int y = 1;
	for (i=1; i<m; i++) y = (1LL*y*baza) % mod;

	for (i=1; i<=n-m+1; i++)
		for (j=1; j<=n; j++) 
		{
			//bagam hash

			c[i][j] = c[i-1][j];

			if (a[i+m-1][j] < c[i][j]) c[i][j] = a[i+m-1][j];
			else if (i==1 || c[i][j] == a[i-1][j])
				 {
					 c[i][j] = a[i][j];
	 				 for (k=0; k<m; k++) c[i][j] = min(c[i][j], a[i+k][j]);
				 }

			if (i==1 || c[i][j] != c[i-1][j])
				for (k=0; k<m; k++) 
				{
					hash[i][j] = (1LL*hash[i][j]*baza + (a[i+k][j]-c[i][j])) % mod;
				}
			else {
				     hash[i][j] = hash[i-1][j];
					 hash[i][j] = (hash[i][j] - 1LL * y * (a[i-1][j]-c[i][j])) % mod;
					 if (hash[i][j] < 0) hash[i][j] += mod;
					 hash[i][j] = (1LL*hash[i][j]*baza + a[i+m-1][j]-c[i][j]) % mod;
			  	 }
				
		}

	for (i=1; i<=n-m+1; i++)
		for (j=1; j<=n-m+1; j++) 
		{
			int sum = a[i][j]+d[1][1], found = 0;

			for (k=0; k<m; k++)
				if (hash[i][j+k]!=h[k+1] || d[1][k+1]+a[i][j+k]!=sum) 
				{
					found = 1;
					break;
				}

			sol += !found;
		}

	printf("%d\n", sol);

	return 0;
}
