#include <stdio.h>
#include <string.h>
#include <algorithm>
using namespace std;

#define INF 1000000

int N, M, tbeg;

int orda[25];
int ordb[25];

int na, nb, rzc = 100000;

int a[23], b[23], aa[23], bb[23];

int out[25], in[25];

int xx[500];
int yy[500];
int cc[500];

int xxf[500];
int yyf[500];
int ccf[500];

int NR = 0;
int LIM = 20000000;

int back(int k)
{
	if (k >= rzc) return 0;

	NR++;

	if (NR == LIM) return 1;
	

	int mna = INF, ma = 0;
	int mnb = INF, mb = 0, q;

	int i, j, w;

	for (i = 1; i <= na; i++) {
		if (!a[i]) continue;
		for (j = 1; j <= nb; j++) {
			if (!b[j]) continue;

			if (a[i] == b[j]) {
				q = a[i];
				a[i] = 0; b[j] = 0;
				xx[k] = aa[i]; yy[k] = bb[j]; cc[k] = q;
				if (back(k + 1)) return 1;
				a[i] = q; b[j] = q;

				return 0;
			}
		}
	}

	for (i = 1; i <= na; i++)
		if (a[i] && a[i] < mna) mna = a[i], ma = i;
	
	for (i = 1; i <= nb; i++) 
		if (b[i] && b[i] < mnb) mnb = b[i], mb = i;

	if (mna == INF && mnb == INF) {
		rzc = k;
		memcpy(xxf, xx, sizeof(xx));
		memcpy(yyf, yy, sizeof(yy));
		memcpy(ccf, cc, sizeof(cc));
		
		return 0;
	}

	if (mna < mnb) {
		for (w = 1; w <= nb; w++) {
			i = ordb[w];
			if (!b[i]) continue;

			b[i] -= mna; a[ma] -= mna;
			xx[k] = aa[ma]; yy[k] = bb[i]; cc[k] = mna;
			if (back(k + 1)) return 1;
			b[i] += mna; a[ma] += mna;
		}
	} else {
		for (w = 1; w <= na; w++) {
			i = orda[w];
			if (!a[i]) continue;

			a[i] -= mnb; b[mb] -= mnb;
			xx[k] = aa[i]; yy[k] = bb[mb]; cc[k] = mnb;
			if (back(k + 1)) return 1;
			a[i] += mnb; b[mb] += mnb;
		}
	}
	
	return 0;
}

#include <stdlib.h>
int gen(int N, int M)
{
	freopen("datorii.in", "w", stdout);

	printf("%d %d\n", N, M);

	for (int i = 1; i <= M; i++)
		printf("%d %d %d\n", rand() % N + 1, rand() % N + 1, rand() % 100 + 1);

	fclose(stdout);

	return 0;
}

int main()
{
//	gen(20, 100);
	
	int i, x, y, c, s = 0, s1 = 0;

	freopen("datorii.in", "r", stdin);
	freopen("datorii.out", "w", stdout);

	scanf("%d %d", &N, &M);

	for (i = 1; i <= M; i++) {
		scanf("%d %d %d", &x, &y, &c);

		out[x] += c; in[y] += c;
	}

	for (i = 1; i <= N; i++) {
		if (out[i] == in[i]) continue;

		if (out[i] > in[i]) a[++na] = out[i] - in[i], s += a[na], aa[na] = i;
		else b[++nb] = in[i] - out[i], bb[nb] = i, s1 += in[i] - out[i];
	}

	for (i = 1; i <= na; i++) orda[i] = i;
	for (i = 1; i <= nb; i++) ordb[i] = i;
	random_shuffle(orda + 1, orda + na + 1);
	random_shuffle(ordb + 1, ordb + nb + 1);

	back(0);

	printf("%d %d\n", rzc, s);

	for (i = 0; i < rzc; i++) printf("%d %d %d\n", xxf[i], yyf[i], ccf[i]);

return 0;
}

