#include <stdio.h>
#include <algorithm>
#include <vector>
using namespace std;

#define ff first
#define ss second
#define MP make_pair

int N, M;

int P[10][60010];

pair <pair<int, int>, int> sf[60010];

int ns = 0;
char s[100010];

char a[110][310];
int lena[110];
int poza[110];

char b[110][310];
int lenb[110];
int pozb[110];

vector <pair< pair<int, int>, int> > sa;

inline pair <int, int> get_cod(int x, int y, int k, int lg)
{
	return MP( P[k][x], P[k][y - lg + 1] );
}

inline int srch(vector <pair<int, int> > &a, int na, pair <int, int> val)
{
	int step, x = -1;

	for (step = 1; step <= na; step <<= 1);

	for (; step; step >>= 1)
		if (x + step < na && a[x + step] <= val) x += step;

	if (x >= 0 && a[x] == val) return x;

	return -1;
}

int gen(int N, int M)
{
	FILE *f = fopen("sub.in", "w");

	fprintf(f, "%d\n", N);

	int i, j, q;

	for (i = 1; i <= N; i++) {
		q = rand() % 100 + 200;

		for (j = 0; j < q; j++) fprintf(f, "%c", rand() % 26 + 'a');
		fprintf(f, "\n");
	}

	fprintf(f, "%d\n", M);

	for (i = 1; i <= N; i++) {
		q = rand() % 300 + 1;

		for (j = 0; j < q; j++) fprintf(f, "%c", rand() % 26 + 'a');
		fprintf(f, "\n");
	}

	fclose(f);

	return 0;
}

int main()
{
//	gen(1, 1);
	
	int i, j, lg;
	
	freopen("sub.in", "r", stdin);
	freopen("sub.out", "w", stdout);

	scanf("%d", &N);

	int mn = 300;

	for (i = 1; i <= N; i++) {
		scanf("%s", a[i]);

		poza[i] = ns + 1;
		for (j = 0; a[i][j]; j++) s[++ns] = a[i][j];
		lena[i] = j;

		if (lena[i] < mn) mn = lena[i];
	}

	scanf("%d", &M);

	for (i = 1; i <= M; i++) {
		scanf("%s", b[i]);

		pozb[i] = ns + 1;
		for (j = 0; b[i][j]; j++) s[++ns] = b[i][j];
		lenb[i] = j;
	}

	// bag suffix array-u pentru sirul mare sa pot sa codific jegurile

	for (i = 1; i <= ns; i++) P[0][i] = s[i];

	for (j = 1, lg = 1; lg <= ns && j <= 9; j++, lg <<= 1) {
		for (i = 1; i <= ns; i++) {
			sf[i].ff.ff = P[j - 1][i];
			sf[i].ff.ss = (i + lg <= ns) ? P[j - 1][i + lg] : 0;
			sf[i].ss = i;
		}

		sort(sf + 1, sf + ns + 1);

		P[j][sf[1].ss] = 1;
		for (i = 2; i <= ns; i++) 
			P[j][sf[i].ss] = P[j][sf[i-1].ss] + (sf[i-1].ff != sf[i].ff);
	}

	int lung, k = 0, na, e; lg = 1;

	pair <int, int> cd;

	long long rez = 0;
	
	for (lung = 1; lung <= mn; lung++) {
		sa.clear();

		while ((lg << 1) <= lung) lg <<= 1, k++;

		// pentru a
		for (i = 1; i <= N; i++) {
			for (j = 1; j + lung - 1 <= lena[i]; j++) 
		sa.push_back( MP( get_cod(poza[i] + j - 1, poza[i] + j + lung - 2, k, lg), i) );
		}

		// pentru b
		for (i = 1; i <= M; i++) {
			for (j = 1; j + lung - 1 <= lenb[i]; j++) {
				sa.push_back( MP( get_cod(pozb[i] + j - 1, pozb[i] + j + lung - 2, k, lg), -1) );
			}
		}

		sort(sa.begin(), sa.end());
		sa.resize( unique(sa.begin(), sa.end()) - sa.begin() );
		na = sa.size();

		for (i = 0; i < na; ) {
			cd = sa[i].ff;
			e = 1;
			for (j = i; j < na && sa[j].ff == cd; j++)
				if (sa[j].ss == -1) e = 0;
			rez += (j - i == N) && e;

			i = j;
		}
	}

	printf("%lld\n", rez);

return 0;
}

