program sub;
type    trieb=^nodb;
        nodb=record
                v:array['a'..'z'] of trieb;
        end;
        triea=^noda;
        noda=record
                v:array['a'..'z'] of triea;
                freq:array[1..101] of longint;
        end;
        triesol=^nodsol;
        nodsol=record
                fn:boolean;
                v:array['a'..'z'] of triesol;
        end;

var     f,g:text;
        trie_a:triea;
        trie_b:trieb;
        na,nb:longint;
        sa:array[0..110] of ansistring;
        len,nsol:longint;
        toadd:array[0..310] of char;
        tosearch:array[0..310] of char;
        tsol:triesol;
        lowlimit,uplimit:longint;
        str:ansistring;





procedure add_trie_sol(var t:triesol;poz:longint);
var i:longint;
        c:char;
begin
        if poz<=uplimit then
                begin
                        if t^.v[toadd[poz]]=nil then
                                begin
                                        new(t^.v[toadd[poz]]);
                                        if poz>=lowlimit then
                                        t^.v[toadd[poz]]^.fn:=true else
                                        t^.v[toadd[poz]]^.fn:=false;
                                        for c:='a' to 'z' do t^.v[toadd[poz]]^.v[c]:=nil;
                                end;
                        add_trie_sol(t^.v[toadd[poz]],poz+1);
                end;
end;




procedure add_trieb(var t:trieb;poz:longint);
var c:char;
begin
        if poz<=len then
                begin
                        if t^.v[toadd[poz]]=nil then
                                begin
                                        new(t^.v[toadd[poz]]);
                                        for c:='a' to 'z' do t^.v[toadd[poz]]^.v[c]:=nil;
                                end;
                        add_trieb(t^.v[toadd[poz]],poz+1);
                end;
end;
procedure add_triea(var t:triea;poz:longint;ind:byte);
var c:char;i:longint;
begin
        if poz<=len then
                begin
                        if t^.v[toadd[poz]]=nil then
                                begin
                                        new(t^.v[toadd[poz]]);
                                        for c:='a' to 'z' do t^.v[toadd[poz]]^.v[c]:=nil;
                                        for i:=1 to na do
                                                t^.v[toadd[poz]]^.freq[i]:=0;
                                end;
                        t^.v[toadd[poz]]^.freq[ind]:=1;
                        add_triea(t^.v[toadd[poz]],poz+1,ind);
                end;
end;







procedure iofile;
var c:char;
        i,j:longint;
begin

        assign(f,'sub.in');reset(f);
        assign(g,'sub.out');rewrite(g);

        readln(f,na);
        trie_a:=nil;
        new(trie_a);
        for c:='a' to 'z' do trie_a^.v[c]:=nil;
        for i:=1 to na do trie_a^.freq[i]:=0;
        for i:=1 to na do
                begin
                        readln(f,sa[i]);
                        len:=length(sa[i]);
                        for j:=1 to len do toadd[j]:=sa[i][j];
                        for j:=1 to len do add_triea(trie_a,j,i);
                end;

        readln(f,nb);
        trie_b:=nil;
        new(trie_b);
        for c:='a' to 'z' do trie_b^.v[c]:=nil;
        for i:=1 to nb do
                begin
                        readln(f,str);
                        len:=length(str);
                        for j:=1 to len do toadd[j]:=str[j];
                        for j:=1 to len do
                                add_trieb(trie_b,j);
                end;

        close(f);
end;


function search_triea(t:triea;poz:longint):longint;
var i:longint;
begin
        if poz<=len then
                begin
                        if t^.v[tosearch[poz]]=nil then
                                begin
                                        search_triea:=poz-1;
                                        exit;
                                end;
                        for i:=1 to na do
                                if t^.v[tosearch[poz]]^.freq[i]=0  then
                                begin
                                        search_triea:=poz-1;
                                        exit;
                                end;
                         search_triea:=search_triea(t^.v[tosearch[poz]],poz+1);
                end else search_triea:=poz-1;
end;

function search_trieb(t:trieb;poz:longint):longint;
begin
        if poz<=len then
                begin
                        if t^.v[tosearch[poz]]=nil then
                                begin
                                        search_trieb:=poz-1;
                                        exit;
                                end;
                        search_trieb:=search_trieb(t^.v[tosearch[poz]],poz+1);
                end else search_trieb:=poz-1;
end;



procedure get_sol(t:triesol);
var c:char;
begin
        if t^.fn then
        inc(nsol);
        for c:='a' to 'z' do
                if t^.v[c]<>nil then get_sol(t^.v[c]);
end;


procedure solve;
var num,i,j,pa,pb:longint;
        c:char;
begin
        len:=length(sa[1]);
        for i:=1 to len do begin toadd[i]:=sa[1][i];tosearch[i]:=sa[1][i];end;
        tsol:=nil;
        new(tsol);
        for c:='a' to 'z' do tsol^.v[c]:=nil;
        tsol^.fn:=false;
        for j:=1 to len do
                begin
                        pa:=search_triea(trie_a,j);
                        pb:=search_trieb(trie_b,j);
                        if pa>pb then
                                begin
                                        lowlimit:=pb+1;
                                        uplimit:=pa;
                                        add_trie_sol(tsol,j);
                                end;
                end;
        nsol:=0;
        get_sol(tsol);
        writeln(g,nsol);
        close(g);
end;



begin
        iofile;
        solve;
end.
