#include <cstdio>
#include <algorithm>

using namespace std;

#define Nmax 256
#define INF 0x3f3f3f3f

int n, m, n1, n2, sol = INF, suma;
int d[Nmax];
int sir1[Nmax], sir2[Nmax], tmp[Nmax];
int x[Nmax], y[Nmax], z[Nmax];
int x0[Nmax], y0[Nmax], z0[Nmax];
int r[Nmax];

void citire()
{
	int i, a, b, c;

	scanf("%d %d\n", &n, &m);
	for (i = 1; i <= m; ++i)
	{
		scanf("%d %d %d\n", &a, &b, &c);
		d[a] += c;
		d[b] -= c;
	}
}

void back(int p, int nod)
{
	int i, dif;

	if (p > sol) return;
	if (nod > n1)
	{
		sol = p - 1;
		for (i = 1; i <= sol; ++i)
			x0[i] = x[i], y0[i] = y[i], z0[i] = z[i];
		
		return;
	}

	for (i = 1; i <= n2; ++i)
		if (r[sir2[i]] > 0)
		{
			dif = min(r[sir2[i]], r[sir1[nod]]);
			r[sir1[nod]] -= dif;
			r[sir2[nod]] -= dif;

			x[p] = sir1[nod];
			y[p] = sir2[i];
			z[p] = dif;

			if (r[sir1[nod]] > 0) back(p + 1, nod);
			else back(p + 1, nod + 1);

			r[sir1[nod]] += dif;
			r[sir2[i]] += dif;
		}
}

int cmp(const int a, const int b)
{
	return d[a] > d[b];
}

void solve()
{
	int i, caz;

	for (i = 1; i <= n; ++i)
	{
		if (d[i] > 0) sir1[++n1] = i;
		else if (d[i] < 0) sir2[++n2] = i;

		if (d[i] < 0) d[i] = -d[i];
		else suma += d[i];
	}
		
	if (n1 < n2) caz = 1;
	else
	{
		caz = 2;
		
		swap(n1, n2);
		memcpy(tmp, sir1, sizeof(tmp));
		memcpy(sir1, sir2, sizeof(sir1));
		memcpy(sir2, tmp, sizeof(sir2));
	}

    for (i = 1; i <= n; ++i)
		r[i] = d[i];

    sort(sir1+1, sir1+n1+1, cmp);
	sort(sir2+1, sir2+n2+1, cmp);
	
	back(1, 1);

	printf("%d %d\n", sol, suma);
	for (i = 1; i <= sol; ++i)
	{
		if (caz == 1) printf("%d %d %d\n", x0[i], y0[i], z0[i]);
		else printf("%d %d %d\n", y0[i], x0[i], z0[i]);
	}
}

int main()
{
	freopen("datorii.in", "r", stdin);
	freopen("datorii.out", "w", stdout);

	citire();
	solve();

	return 0;
}
