#include <cstdio>
#include <algorithm>

using namespace std;

#define Nmax 128
#define Lmax 65536
#define Log 18

int n1, n2, ct, niv;
int sir[Lmax];
char s[315];
int P[Log][Lmax];
int B[Lmax], C[Lmax], D[Lmax];
int ord[Lmax];
int tip[Lmax];
int last[Lmax], next[Lmax];
int count[Nmax];
int lung[Lmax];

void citire()
{
	int i, j, l, sf;
	
	scanf("%d\n", &n1);
	for (i = 1; i <= n1; ++i)
	{
		scanf("%s\n", s + 1);
		l = strlen(s + 1);
		sf = ct + l;
		for (j = 1; j <= l; ++j)
		{
			sir[++ct] = 300 + s[j];
			tip[ct] = i;
			lung[ct] = sf;
		}
		sir[++ct] = i;
	}

	scanf("%d\n", &n2);
	for (i = 1; i <= n2; ++i)
	{
		scanf("%s\n", s + 1);
		l = strlen(s + 1);
		sf = ct + l;
		for (j = 1; j <= l; ++j)
		{
			sir[++ct] = 300 + s[j];
			tip[ct] = i + n1;
			lung[ct] = sf;
		}
		sir[++ct] = n1 + i;
	}
}

int cmp(const int a, const int b)
{
	return sir[a] < sir[b];
}

void suffix()
{
	int put, i, cnt, next1, next2;

	for (i = 1; i <= ct; ++i)
		B[i] = i;
	
	sort(B+1, B+ct+1, cmp);
	
	cnt = 0;
	for (i = 1; i <= ct; ++i)
	{
		if (i == 1 || (sir[B[i]] != sir[B[i - 1]])) ++cnt;
		P[0][B[i]] = cnt;
	}

	for (niv = 1, put = 1; cnt < ct; ++niv, put <<= 1)
	{
		memset(C, 0, sizeof(C));
		for (i = 1; i <= ct; ++i)
			++C[i + put <= ct ? P[niv - 1][i + put] : 0];
		for (i = 1; i <= ct; ++i)
			C[i] += C[i - 1];
		for (i = ct; i >= 1; --i)
			B[C[i + put <= ct ? P[niv - 1][i + put] : 0]--] = i;

		memset(C, 0, sizeof(C));
		for (i = 1; i <= ct; ++i)
			++C[P[niv - 1][B[i]]];
		for (i = 1; i <= ct; ++i)
			C[i] += C[i - 1];
		for (i = ct; i >= 1; --i)
			D[C[P[niv - 1][B[i]]]--] = B[i];

		cnt = 0;
		for (i = 1; i <= ct; ++i)
		{
			next1 = D[i] + put <= ct ? P[niv - 1][D[i] + put] : 0;
			next2 = D[i - 1] + put <= ct ? P[niv - 1][D[i - 1] + put] : 0;

			if (i == 1 || !(P[niv - 1][D[i]] == P[niv - 1][D[i - 1]] && next1 == next2)) ++cnt;
			P[niv][D[i]] = cnt;
		}
	}
	--niv;
}

int lca(int a, int b)
{
	int k, ret = 0;

    if (a == b) return lung[a] - a + 1;
	
	for (k = niv; k >= 0 && a <= ct && b <= ct; --k)
		if (P[k][a] == P[k][b])
		{
			ret += 1 << k;
			a += 1 << k;
			b += 1 << k;
		}

	return ret;
}

void solve()
{
	int i, j, sol = 0, cnt = 0, lng, lastok = 0;
	
	suffix();

	memset(C, 0, sizeof(C));
    for (i = 1; i <= ct; ++i)
		++C[P[niv][i]];
	for (i = 1; i <= ct; ++i)
		C[i] += C[i - 1];
	for (i = ct; i >= 1; --i)
		ord[C[P[niv][i]]--] = i;
	
	last[0] = -1;
	for (i = 1; i <= ct; ++i)
		if (tip[ord[i]] > n1)
			last[i] = i;
		else
			last[i] = last[i - 1];
	
	next[ct + 1] = ct + 1;
	for (i = ct; i >= 1; --i)
		if (tip[ord[i]] > n1)
			next[i] = i;
		else
			next[i] = next[i + 1];
	
	j = n1 + n2 + 1;

	memset(C, 0, sizeof(C));
	cnt = 0;
	for (i = n1 + n2 + 1; i <= ct; ++i)
		if (tip[ord[i]] > n1)
		{
			while (j <= i)
				if (tip[ord[j]] <= n1)
				{
					if (C[tip[ord[j]]] == 1) --cnt;
					--C[tip[ord[j++]]];
				}
				else
					++j;
			
			cnt = 0;
		}
		else
		{
			if (C[tip[ord[i]]] == 0) ++cnt;
			++C[tip[ord[i]]];
			
			while (C[tip[ord[i]]] > 1)
			{
				if (tip[ord[j]] <= n1)
				{
					if (C[tip[ord[j]]] == 1) --cnt;
					--C[tip[ord[j++]]];
				}
				else
					++j;
			}

			if (cnt == n1)
			{
				lng = 0;
				if (last[j] >= 1)
					lng = max(lng, lca(ord[last[j]], ord[j]));
				if (next[i] <= ct)
					lng = max(lng, lca(ord[next[i]], ord[i]));
				if (lastok != 0)
					lng = max(lng, lca(lastok, ord[i]));
				sol += max(0, lca(ord[i], ord[j]) - lng);


				lastok = ord[j];
			}
		}

	printf("%d\n", sol);
}

int main()
{
	freopen("sub.in", "r", stdin);
	freopen("sub.out", "w", stdout);

	citire();
	solve();
	
	return 0;
}
