#include <stdio.h>
#include <algorithm>
#include <string>
#include <set>
using namespace std;

#define maxN 110
#define maxC 310
#define inf 0x7f7f7f7f

int n,na,nb,res;
string va[maxN],vb[maxN],prm;

int func(string const&a,string const&b ){return a.size()<b.size();}int func2(string const&a,string const&b){return a.size()>b.size();}

void inputFunc(){
	FILE*fi=fopen("sub.in","r");
	fscanf(fi,"%d",&na);
	for(int i=0;i<na;i++){
		char st[maxC]; fscanf(fi," %s ",st);
		va[i]=string(st);
	}

	fscanf(fi,"%d",&nb);
	for(int i=0;i<nb;i++){
		char st[maxC]; fscanf(fi,"  %s ",st);
		vb[i]=string(st);
	}

	fclose(fi);
}

void outputFunc(){FILE*fi=fopen("sub.out","w");fprintf(fi,"%d",res);fclose(fi);}

int cautaA(string const&st){
	for(int i=1;i<na;i++)if(va[i].find(st) == -1 )return 0;
	return 1;
}

int cautaB(string const&st){
	for(int i=0;i<nb;i++)if(vb[i].find(st) != -1)return 0;
	return 1;
}

int main(){
	inputFunc();
	sort(va,va+na,func),sort(vb,vb+nb,func2);

	prm=va[0];n=prm.size();


	for(int i=0;i<n;i++){
		int st,en,mid,bin1,bin2;

		st=i,en=n-1;
		while(st<en){
			mid=(st+en)/2;
			string cop=prm.substr(i,mid-i+1);
			if(cautaA(cop)){
				st=mid+1;
			}else{
				en=mid;
			}
		}

		bin1=st-1;
		if(cautaA( prm.substr(i,inf) ) ){
			bin1=n-1;
		}

		st=i,en=bin1;
		while(st<en){
			mid=(st+en)/2;
			string cop=prm.substr(i,mid-i+1);
			if(!cautaB(cop)){
				st=mid+1;
			}else{
				en=mid;
			}
		}

		bin2=st;
		if(!cautaB ( prm.substr(i,bin1-i+1) )){
			bin2=bin1+1;
		}

		for(int j=bin2;j<=bin1;j++){
			string cop=prm.substr(i,j-i+1);
			if(prm.find(cop) == i)res++;
		}

	}



	outputFunc();
	return 0;
}

