#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define MAXN 21

int N, M;
int Tot[MAXN];
vector< pair<int, int> > left, right;

vector< pair< pair<int, int>, int > > sol;

int main()
{
	freopen("datorii.in", "rt", stdin);
	freopen("datorii.out", "wt", stdout);

	scanf("%d %d", &N, &M);
	for (int i = 0; i < M; i++)
	{
		int A, B, C;
		scanf("%d %d %d", &A, &B, &C);

		Tot[A] -= C;
		Tot[B] += C;
	}

	int TOT = 0;
	for (int i = 1; i <= N; i++)
	{
		if (Tot[i] < 0)
			left.push_back( make_pair( -Tot[i], i) );
		if (Tot[i] > 0)
			TOT += Tot[i],
			right.push_back( make_pair( Tot[i], i) );
	}

	sort( left.begin(), left.end() );
	reverse( left.begin(), left.end() );
	sort( right.begin(), right.end() );
	reverse( right.begin(), right.end() );

	sol.clear();
	size_t i = 0, j = 0;
	for (; i < left.size() && j < right.size(); )
	{
		if (left[i].first < right[j].first)
		{
			sol.push_back( make_pair( make_pair(left[i].second, right[j].second), left[i].first ) );
			right[j].first -= left[i].first;
			left[i].first = 0;
			i++;
		}
		else
		{
			sol.push_back( make_pair( make_pair(left[i].second, right[j].second), right[j].first ) );
			left[i].first -= right[j].first;
			right[j].first = 0;
			j++;
		}
	}

	printf("%d %d\n", (int)sol.size(), TOT);
	for (size_t k = 0; k < sol.size(); k++)
		printf("%d %d %d\n", sol[k].first.first, sol[k].first.second, sol[k].second);
	
	return 0;
}
