#include <cstdio>
#include <string>
#include <vector>

using namespace std;

//#define DBGCODE

const char *IN = "sub.in";
const char *OUT= "sub.out";

int main (void)
{
	freopen(IN, "r", stdin);
	freopen(OUT, "w+", stdout);
	
	unsigned int numEl1, numEl2;
	vector<string> mult1,mult2;
	unsigned int mult1max, mult2max;
	unsigned int mult1maxpos, mult2maxpos;
	
	scanf("%u\n", &numEl1);
	mult1.reserve(numEl1);
	for (unsigned int i=0; i<numEl1; ++i) {
		char sir[301];
		scanf("%s\n", sir);
		string str(sir);
		mult1.push_back(str);
		if (i==0 || mult1max>str.size()) {
			mult1max=str.size();
			mult1maxpos=i;
		}
	}

	scanf("%u\n", &numEl2);
	mult2.reserve(numEl2);
	for (unsigned int i=0; i<numEl2; ++i) {
		char sir[301];
		scanf("%s\n", sir);
		string str(sir);
		mult2.push_back(str);
		if (i==0 || mult2max>str.size()) {
			mult2max=str.size();
			mult2maxpos=i;
		}
	}
	unsigned int numseq=0;
	for (unsigned int size=1; size<=mult1max; ++size) {
		unsigned int maxoffset=mult1max-size+1;
		for (unsigned int offset=0; offset<maxoffset; ++offset) {
			const string &subseq = mult1[mult1maxpos].substr(offset, size);
			bool foundinallfirst=true, foundinsecond=false;
			for (vector<string>::const_iterator iter=mult1.begin();
					iter != mult1.end() && foundinallfirst; ++iter)
				if (iter->find(subseq) == string::npos) foundinallfirst=false;
			for (vector<string>::const_iterator iter=mult2.begin();
					iter != mult2.end() && !foundinsecond; ++iter) {
				if (iter->find(subseq) != string::npos) foundinsecond=true;
			}
			if (foundinallfirst && !foundinsecond) {
			   	++numseq;
#ifdef DBGCODE
				printf("%s\n", subseq.c_str());
#endif
			}
		}
	}
	printf("%u\n", numseq);
	fclose(stdin);
	fclose(stdout);
	return 0;
}

