#include <cstdio>

const char *IN = "tetris.in";
const char *OUT = "tetris.out";

using namespace std;

unsigned int dim_baza, dim_piesa;
unsigned int suprafata[510][510], piesa[110][110];

bool sepotriv (unsigned int i, unsigned int j)
{
	unsigned int corect = suprafata[i][j]+piesa[0][0];
	for (unsigned int a=0; a<dim_piesa; ++a)
		for (unsigned int b=0; b<dim_piesa; ++b)
			if (suprafata[i+a][j+b]+piesa[a][b] != corect)
				return false;
	return true;
}

int main (void)
{
	freopen(IN, "r", stdin);
	freopen(OUT, "w+", stdout);

	
	scanf("%u\n", &dim_baza);
	for (unsigned int i=0; i<dim_baza; ++i) {
		for (unsigned int j=0; j<dim_baza; ++j)
			scanf("%u ", &suprafata[i][j]);
		scanf("\n");
	}

	scanf("%u\n", &dim_piesa);
	for (unsigned int i=0; i<dim_piesa; ++i) {
		for (unsigned int j=0; j<dim_piesa; ++j)
			scanf("%u ", &piesa[i][j]);
		scanf("\n");
	}

	unsigned int val=0;
	
	for (unsigned int i=0; i<dim_baza-dim_piesa; ++i)
		for (unsigned int j=0; j<dim_baza-dim_piesa; ++j) {
			if (sepotriv(i,j)) ++val;
	}
	
	printf("%u\n", val);
	
	fclose(stdin);
	fclose(stdout);
	return 0;
}

