#include<algorithm>
#include<stdio.h>
#include<string>
#include<vector>
#define mkp make_pair
#define pb push_back
#define ss second
#define ff first

using namespace std;

const int lgmax = 20,lmax = 310;
const int maxn = 61011;

vector <pair < pair <int,int>,int > > VECT;
vector <pair< int,int> > VECT1;
pair<int,int> ST[maxn];
int A[maxn],B[maxn],N,M,P[lgmax][maxn];
int DIFF[maxn],ADD[maxn],AP[maxn],NR,SFA,POZC;
char S[maxn];
string STR;
int LAST;


void suffix_array()
{
	int n = STR.size();
	for(int i = 0;i < n; ++i)
		P[0][i] = STR[i] - 'a' + 1;
	for(int i = 1;(1 << i) <= lmax; ++i)
	{
		VECT.clear();
		for(int j = 0;j < n; ++j)
		{
			int k = j + (1 << (i - 1));
			VECT.pb(mkp(mkp(P[i - 1][j],k < n ? P[i - 1][k] : 0 ),j));
		}
		sort(VECT.begin(),VECT.end());
		for(int j = 1;j < n; ++j)
		{
			int poz = VECT[j].ss;
			int poz1 = VECT[j - 1].ss;
			P[i][poz] = P[i][poz1];
			if (VECT[j].ff != VECT[j - 1].ff) P[i][poz]++;
		}
      for(int j = 0;j < n; ++j) P[i][j]++;
		LAST = i;
	}
}

int cautare(int poz)
{
	int x = 0,p = 0;
	for(p = 1;p <= N; p <<= 1);
	for(;p; p >>= 1)
		if (x + p <= N && A[x + p] <= poz) x += p;
	return x + 1;
}

int lcp(int poz1,int poz2)
{
	int x = 0,p = 0;
	for(p = 1;(1 << p) <= lmax; ++p);
	--p;
	for(;p >= 0;p--)
		if (P[p][poz1] == P[p][poz2])
		{
			x += (1 << p);
			poz1 += (1 << p);
			poz2 += (1 << p);
		}
	return x;
}

int main()
{
	freopen("sub.in","r",stdin);
   freopen("sub.out","w",stdout);
	scanf("%d\n",&N);
	POZC = -1;
	for(int i = 1;i <= N; ++i)
	{
		fgets(S,1000,stdin);
		for(int j = 0;S[j] >= 'a' && S[j] <= 'z'; ++j)
		{
			STR += S[j];
			++POZC;
		}
		STR += (char) 122 + i;

		++POZC;
		A[i] = POZC;
	}
	SFA = POZC;
	scanf("%d\n",&M);
	for(int i = 1;i <= M; ++i)
	{
		fgets(S,1000,stdin);
		for(int j = 0;S[j] >= 'a' && S[j] <= 'z'; ++j)
		{
			STR += S[j];
			POZC++;
		}
		STR += '{';
		++POZC;
		B[i] = POZC;
	}
	
	suffix_array();

	for(int k = 0;k <= POZC; ++k)
		VECT1.pb(mkp(P[LAST][k],k) );
	sort(VECT1.begin(),VECT1.end());

	int sol = 0,n = VECT1.size();
	int l = 0,last = 0;

	for(int i = 0;i < n; ++i)
	{

		bool ver = 0;
      if (VECT1[i].ss > SFA) ver = 1;
      if (i != 0)
      {
		   int cur = lcp(VECT1[i].ss,VECT1[i - 1].ss);
         int merge = 1;
         while(merge)
		   {
            merge = 0;
            ST[l].first = cur;
            if (ST[l].second > SFA) {last = cur; break;}
//          if (ST[l].second > SFA){ver = 1;last = l; break;}
			   if (ST[l].first < ST[l - 1].first && l > 0)
            {
               if (ver && DIFF[ST[l].second] < cur) DIFF[ST[l].second] = cur;
               --l;
               merge = 1;
               if (ST[l].second > SFA)
               {
                  last = cur;
                  break;
               }
            }
         }
         ST[l].first = cur;
      }
		ST[++l] = mkp(lmax,VECT1[i].ss);
      DIFF[ST[l].second] = last;
		int poz = cautare(VECT1[i].ss);
      if (AP[poz] == 0 && poz <= N) NR++;
      if (poz <= N) AP[poz] = l;
		if (VECT1[i].ss > SFA)
      {
         memset(AP,0,sizeof(AP));
         NR = 0;
         last = lmax;
         continue;
      }
//		if (ver){memset(AP,0,sizeof(AP));NR = 0;}
//			else
//             if (VECT1[i].ss <= SFA)AP[poz]++;
//		       if (AP[poz] == 1) NR++;
      if (NR == N)
      {
         int ad = 1000000;
         for(int j = 1;j <= N; ++j)
                 ad = min(ST[AP[j]].first,ad);
         ADD[VECT1[i].ss] = ad;
         last = ad;
      }
//      if (VECT1[i].ss <= SFA)AP[poz]++;
//		if (AP[poz] == 1) NR++;
				
	}

   for(int i = 0;i <= n; ++i)
           if (DIFF[i] < ADD[i])
           {
//             printf("%s %d %d\n",STR.c_str() + i,ADD[i],DIFF[i]);
               sol += ADD[i] - DIFF[i];
           }

	printf("%d\n",sol);

	return 0;
}


