#include <stdio.h>
#include <vector>
#include <algorithm>

#define x first.first
#define y first.second
#define pos second

using namespace std;

pair<pair<int, int>, int> v[100001];
int p[17][100001], na, nb, last, col[100001], s[100001], sp[101][100001], lena, sol;
char line[128], a[128];

int bs1(int, int);
int bs2(int, int);
int maimic(int, int, int);

int main()
{
	freopen("sub.in", "r", stdin);
	freopen("sub.out", "w", stdout);

	int i, j, len, cnt, step, crt, ok, start, end, k, l;

	scanf("%d ", &na);
	fgets(a, 128, stdin);
	lena = strlen(a) - 1;
	for(j = 0; j < lena; ++j)
	{
		p[0][++last] = a[j];
		col[last] = 1;
	}
	p[0][++last] = '@';
	for(i = 2; i <= na; ++i)
	{
		fgets(line, 128, stdin);
		len = strlen(line) - 1;
		for(j = 0; j < len; ++j)
		{
			p[0][++last] = line[j];
			col[last] = i;
		}
		p[0][++last] = '@';
	}
	scanf("%d ", &nb);
	for(i = 1; i <= nb; ++i)
	{
		fgets(line, 128, stdin);
		len = strlen(line) - 1;
		for(j = 0; j < len; ++j)
		{
			p[0][++last] = line[j];
			col[last] = na + 1;
		}
		p[0][++last] = '@';
	}

	for(cnt = 1, step = 1; step <= last; ++cnt, step <<= 1)
	{
		for(i = 1; i <= last; ++i)
		{
			v[i].x = p[cnt - 1][i];
			if(i + step <= 100000)
				v[i].y = p[cnt - 1][i + step];
			else
				v[i].y = 0;
			v[i].pos = i;
		}
		sort(v + 1, v + last + 1);
		crt = 0;
		for(i = 1; i <= last; ++i)
		{
			if(v[i].x != v[i - 1].x || v[i].y != v[i - 1].y)
			{
				++crt;
			}
			p[cnt][v[i].pos] = crt;
		}
		/*
		for(i = 1; i <= last; ++i)
		{
			printf("%c ", p[0][i]);
		}
		printf("\n");
		for(i = 1; i <= last; ++i)
		{
			printf("%d ", p[cnt][i]);
		}
		*/
	}
	/*
	for(i = 1; i <= last; ++i)
	{
		printf("%d:", i);
		for(j = v[i].pos; j <= last; ++j)
		{
			printf("%c", p[0][j]);
		}
		printf("\n");
	}
*/
	for(i = 1; i <= last; ++i)
	{
		s[i] = s[i - 1];
		for(j = 1; j <= na; ++j)
		{
			sp[j][i] = sp[j][i - 1];
		}
		if(col[v[i].pos] == na + 1)
		{
			++s[i];
		}
		else
		{
			++sp[col[v[i].pos]][i];
		}
	}

	for(i = 0; i < lena; ++i)
	{
		for(j = i; j < lena; ++j)
		{
			ok = 1;
			/*
			for(k = i; k <= j; ++k)
			{
				printf("%c", a[k]);
			}
			printf("\n");
			*/
			for(k = i + 1; k < lena - j + i; ++k)
			{
				for(l = 0; l <= j - i; ++l)
				{
					if(a[k + l] != a[i + l])
					{
						break;
					}
				}
				if(l == j - i + 1)
				{
					ok = 0;
				}
			}
			start = bs1(i, j);
			end = bs2(i, j);
			//printf("%d %d\n", start, end);
			if(end - start + 1 < na || s[end] - s[start - 1] > 0)
			{
				continue;
			}
			for(k = 1; k <= na; ++k)
			{
				if(sp[k][end] - sp[k][start - 1] == 0)
				{
					ok = 0;
					break;
				}
			}
			if(ok)
			{
			//	printf("---->aici\n");
				++sol;
			}
		}
	}

	printf("%d\n", sol);

	return 0;
}

int bs1(int start, int end)
{
	int min = 1, max = last, mid, rez = 0, temp;
	while(min <= max)
	{
		mid = (min + max) / 2;
		temp = maimic(mid, start, end);
		if(temp == 0)
		{
			min = mid + 1;
		}
		else if(temp == 1)
		{
			max = mid - 1;
		}
		else
		{
			rez = mid;
			max = mid - 1;
		}
	}
	return rez;
}

int bs2(int start, int end)
{
	int min = 1, max = last, mid, rez = 0, temp;
	while(min <= max)
	{
		mid = (min + max) / 2;
		temp = maimic(mid, start, end);
		if(temp == 0)
		{
			min = mid + 1;
		}
		else if(temp == 1)
		{
			max = mid - 1;
		}
		else
		{
			rez = mid;
			min = mid + 1;
		}
	}
	return rez;
}

int maimic(int mid, int start, int end)
{
	int i;
	for(i = 0; i <= end - start; ++i)
	{
		if(p[0][v[mid].pos + i] != a[start + i])
		{
			if(p[0][v[mid].pos + i] < a[start + i])
			{
				return 0;
			}
			return 1;
		}
	}
	return 2;
}
