using namespace std;
#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>

#define Nmax 100004

int test,best;
int N,i;
int a,b;

int C[Nmax];
vector<int> G[Nmax];
vector<int> P[Nmax];
vector<int> V1[Nmax],V2[Nmax];

int F[Nmax],nrf;

int Q[Nmax],st,dr;
int T[Nmax];
char w[Nmax],w2[Nmax];

inline int max(int a,int b) { return a>b?a:b; }

void getcost(int nod,int poz_T)
{
 vector<int>::iterator it,it2;

 w2[nod]=1;
 for (it=G[nod].begin(), it2=P[nod].begin(); it<G[nod].end(); ++it,++it2)
        if (!w2[*it])
                {
                 if (V1[*it][*it2]==0) getcost(*it,*it2);

                 if (V1[*it][*it2] > V1[nod][poz_T])
                        {
                         V2[nod][poz_T] = V1[nod][poz_T];
                         V1[nod][poz_T] = V1[*it][*it2];
                        }
                  else if (V1[*it][*it2] > V2[nod][poz_T])
                         V2[nod][poz_T] = V1[*it][*it2];
                }
 V1[nod][poz_T]+=C[nod];
 V2[nod][poz_T]+=C[nod];
}

void calculeaza(int S)
{
 int nod=S;
 int cost=0,maxcost=0,total=0;
 vector<int>::iterator it,it2;
 //marcheaza drumul
 memset(w2,0,sizeof(w2));
 while (T[nod]!=nod)
        {
         w2[nod]=1;
         nod=T[nod];
        }
 w2[nod]=1;
 nod=S;
 //gaseste alt drum
 while (T[nod]!=nod)
        {
         total += C[nod];

         for (it=G[ T[nod] ].begin(), it2=P[ T[nod] ].begin(); it<G[ T[nod] ].end(); ++it,++it2)
                if (!w2[*it])
                        {
                         if (V1[*it][*it2]==0) getcost( *it, *it2 );
                         cost = V1[*it][*it2] + V2[*it][*it2] - C[*it];
                         maxcost = max( cost, maxcost );                         
                        }

         nod = T[nod];
        }
 total+=C[nod];

 best = max( best, total+maxcost );
}

void bfs(int S)
{
 vector<int>::iterator it;
 int nod;

 Q[st=dr=0] = S;
 T[S] = S;
 memset(w,0,sizeof(w));
 w[S] = 1;

 while (st<=dr)
        {
         nod = Q[st];
         
         for (it=G[nod].begin(); it<G[nod].end(); ++it)
                if (!w[*it])
                        {
                         Q[++dr]=*it;
                         T[*it]=nod;
                         w[*it]=1;
                        }
         //daca am ajuns intr-o frunza din care nu am mai plecat am un drum
         if ( nod>S && G[nod].size()==1 )
                calculeaza(nod);
         //go go go
         ++st;
        }
}

void solve()
{
 //determina toate nodurile cu grad 1
 //care vor fi capetele unui drum
 nrf=0;
 for (i=1;i<=N;++i)
       if (G[i].size() == 1)
                F[++nrf] = i;

 //pt fiecare drum gaseste alt drum de lungime maxima
 for (i=1;i<=nrf;++i)
        {
         bfs(F[i]);
        }
}

int main()
{
 freopen("turism.in","r",stdin);
 freopen("turism.out","w",stdout);
 for (test=0;test<12;++test)
        {
         scanf("%d",&N);

         for (i=1;i<=N;++i)
                scanf("%d",&C[i]);

         for (i=1;i<=N;++i)
                {
                 V1[i].push_back(0);
                 V2[i].push_back(0);
                }

         for (i=1;i<N;++i)
                {
                 scanf("%d %d",&a,&b);
                 G[a].push_back(b);
                 G[b].push_back(a);
                 P[a].push_back(G[b].size());
                 P[b].push_back(G[a].size());
                 V1[a].push_back(0);
                 V1[b].push_back(0);
                 V2[a].push_back(0);
                 V2[b].push_back(0);
                }

         best=0;
         solve();
         printf("%d\n",best);

         //curatenie
         for (i=1;i<=N;++i)
                {
                 G[i].clear();
                 P[i].clear();
                 V1[i].clear();
                 V2[i].clear();
                }
                
        }

 fclose(stdout);

 return 0;
}
