#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;

#define NMAX 100010
#define MP make_pair
#define ff first
#define ss second
#define CLR(x) memset( (x), 0, sizeof(((x))) )

int N, T = 12;

int *leg[NMAX];
int *leg1[NMAX];

int cst[NMAX];

int grad[NMAX];
int grad1[NMAX];

int xx[NMAX], yy[NMAX];

char viz[NMAX];

int tata[NMAX];
int djos[NMAX][4];
int dsub[NMAX];
pair <int, int> dsubfii[NMAX][3];
int dsus[NMAX];

int din1[NMAX];
int din2[NMAX];

int niv[NMAX];

#define LMAX 1000010
int beg;
char s[LMAX];

inline void GET(int &x)
{
	for (; s[beg] && !('0' <= s[beg] && s[beg] <= '9'); beg++);

	for (x = 0; '0' <= s[beg] && s[beg] <= '9'; beg++)
		x = x * 10 + s[beg] - '0';
}

inline int MAX(int a, int b) { return (a > b) ? a : b; }

int cmp(int a, int b) 
{
	return a > b;
}
int cmp1(pair <int, int> a, pair <int, int> b) 
{
	return a > b;
}

pair <int, int> aux;

void back(int x)
{
	viz[x] = 1;

	int i, y;
	for (i = 1; i <= grad[x]; i++) {
		y = leg[x][i];
		if (viz[y]) continue;

		tata[y] = x;
		niv[y] = niv[x] + 1;
		grad1[x]++;

		back(y);

		djos[x][3] = djos[y][0] + cst[y];

		sort(djos[x], djos[x] + 4, cmp);


		dsubfii[x][2] = MP( MAX(dsub[y], dsubfii[y][0].ff), y );
		sort(dsubfii[x], dsubfii[x] + 3, cmp1);
	}

	dsub[x] = djos[x][0] + djos[x][1] + cst[x];
}

void back1(int x)
{
	if (tata[x]) {
		int t = tata[x];
		dsus[x] = MAX(dsus[ t ] + cst[ t ], 
				(djos[t][0] == djos[x][0] + cst[x] ? djos[t][1] + cst[t] : djos[t][0] + cst[t]) );
	}

	int i;

	for (i = 1; i <= grad1[x]; i++) back1(leg1[x][i]);
}

void get_poz(int x, int val, int &p1, int &p2)
{
	if (djos[x][0] == val) p1 = djos[x][1], p2 = djos[x][2];
	else
	if (djos[x][1] == val) p1 = djos[x][0], p2 = djos[x][2];
	else p1 = djos[x][0], p2 = djos[x][1];
}


void back2(int x)
{
	// calculez pentru x

	din1[x] = MAX( dsub[x], dsubfii[x][0].ff );

	if (tata[x]) {
		int t = tata[x];
		// trece prin tata

		int lli = djos[x][0] + cst[x], p1, p2;

		get_poz(t, lli, p1, p2);

		int w = p1 + p2 + cst[t];
		w = MAX(w, p1 + dsus[t] + cst[t]);

		w = MAX(w, dsubfii[t][0].ss == x ? dsubfii[t][1].ff : dsubfii[t][0].ff);

		w = MAX(w, din2[t]);
		din2[x] = w;
	}
	
	for (int i = 1; i <= grad1[x]; i++) back2(leg1[x][i]);
}

/*
int gen(int N)
{
	freopen("turism.in", "w", stdout);

	int I;

	for (I = 1; I <= T; I++) {
		N = 100000;
		
		printf("%d\n", N);

		int i;
		for (i = 1; i <= N; i++) printf("%d ", rand() % 10000 + 1);
		printf("\n");

		for (i = 2; i <= N; i++) printf("%d %d\n", i, rand() % ((i-1) / 2 + 1) + 1);
	}

	fclose(stdout);

	return 0;
}


#define INF 1000000
char jeg[5000];

int get_drum(int x, int y, int e)
{
	int rez = 0;

	if (e && (jeg[x] || jeg[y])) return -INF;

	while (niv[x] > niv[y]) {
		rez += cst[x];
		if (!e) jeg[x] = 1;
		else if (jeg[x]) return -INF;
		x = tata[x];
	}

	while (niv[y] > niv[x]) {
		rez += cst[y];
		if (!e) jeg[y] = 1;
		else if (jeg[y]) return -INF;
		y = tata[y];
	}

	if (x == y) {
		rez += cst[x];
		if (!e) jeg[x] = 1;
		else if (jeg[x]) return -INF;

		return rez;
	}

	while (1) {
		rez += cst[x];
		if (!e) jeg[x] = 1;
		else if (jeg[x]) return -INF;

		rez += cst[y];
		if (!e) jeg[y] = 1;
		else if (jeg[y]) return -INF;

		x = tata[x]; y = tata[y];
		
		if (x == y) break;
	}

	rez += cst[x];
	if (!e) jeg[x] = 1;
	else if (jeg[x]) return -INF;

	return rez;
}

int get_brute()
{
	int i, j, ii, jj, r1, r2, rez = 0;


	for (i = 1; i <= N; i++)
		for (j = 1; j <= N; j++) {
			memset(jeg, 0, sizeof(jeg));
			r1 = get_drum(i, j, 0);
			for (ii = 1; ii <= N; ii++)
				for (jj = 1; jj <= N; jj++) {
					r2 = get_drum(ii, jj, 1);

					rez = MAX(rez, r1 + r2);
				}
		}

	return rez;
}
*/
int main()
{
//	srand(666013);
//	gen(20);
	
	int I, i, x, y;
	
	freopen("turism.in", "r", stdin);
	freopen("turism.out", "w", stdout);

	for (I = 1; I <= T; I++) {
		scanf("%d\n", &N);


		CLR(cst); CLR(grad); CLR(grad1); CLR(viz); CLR(djos);
		CLR(dsub); CLR(dsubfii); CLR(dsus); CLR(niv);
		for (i = 1; i <= N; i++) {
			free(leg[i]);
			free(leg1[i]);
		}

		fgets(s, LMAX, stdin); beg = 0;
		for (i = 1; i <= N; i++) {
			//scanf("%d", &cst[i]);
			GET(cst[i]);
		}

		for (i = 1; i < N; i++) {
			//scanf("%d %d", &x, &y);
			fgets(s, LMAX, stdin); beg = 0;
			GET(x); GET(y);
			xx[i] = x; yy[i] = y;
			grad[x]++; grad[y]++;
		}

		for (i = 1; i <= N; i++) 
			leg[i] = (int *) malloc((grad[i] + 3) * sizeof(int));

		memset(grad, 0, sizeof(grad));
		for (i = 1; i < N; i++) {
			x = xx[i]; y = yy[i];
			leg[x][ ++grad[x] ] = y;
			leg[y][ ++grad[y] ] = x;
		}

		back(1);

		for (i = 1; i <= N; i++) 
			leg1[i] = (int *) malloc((grad1[i] + 3) * sizeof(int));

		memset(grad1, 0, sizeof(grad1));
		for (i = 1; i <= N; i++) {
			if (!tata[i]) continue;
			leg1[tata[i]][ ++grad1[tata[i]] ] = i;
		}

		back1(1);

		back2(1);

		int rez = 0;

		for (i = 1; i <= N; i++) {
			if (!tata[i]) continue;

			rez = MAX(rez, din1[i] + din2[i]);
		}

/*		if (rez != get_brute()) {
			printf("jeeeeeeeeeg - %d\n", I);
			return 0;
		}
*/
		printf("%d\n", rez);
	}

return 0;
}

