//senzori
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define INPUT "senzori.in"
#define OUTPUT "senzori.out"
#define NMAX 2048
#define TMAX 2048

int N;
struct interv
{
   int ti, tf, d, v;
}sen[NMAX];

int val[TMAX], val2[TMAX];

int comp(const void *A, const void *B)
{
   interv *va = (interv*) A;
   interv *vb = (interv*) B;
   if((va->ti + va->d) > (vb->ti + vb->d)) return 1;
   if((va->ti + va->d == vb->ti + vb->d) && (va->tf > vb->tf)) return 1;
   return -1;
}
int main()
{
   freopen(INPUT, "r", stdin);
   freopen(OUTPUT, "w", stdout);

   scanf("%d", &N);
   int i;
   for(i = 1; i <= N; ++i)
      scanf("%d %d %d %d", &sen[i].ti, &sen[i].tf, &sen[i].d, &sen[i].v);

   qsort(sen + 1, N, sizeof(sen[0]), comp);
   
   int j;
   for(i = 1; i <= N; ++i)
   {
      for(j = sen[i].ti + sen[i].d; j <= sen[i].tf; ++j)
         if(val2[j] < val[j - sen[i].d] + sen[i].v)
            val2[j] = val[j - sen[i].d] + sen[i].v;
            
      for(; j < TMAX; ++j)
         if(val2[j] < val2[j-1]) val2[j] = val2[j-1];
         
      memcpy(val, val2, sizeof(val2));
   }

   printf("%d\n", val[TMAX-1]);
   return 0;
}

