#include <cstdio>
#include <cstring>

#define Nmax 2048
#define MAX(a,b) ((a) >= (b) ? (a) : (b))

int n;
int t1[Nmax], t2[Nmax];
int d[Nmax];
int c[Nmax];
int D[2][Nmax][2];

void citire()
{
	int i;

	scanf("%d\n", &n);
	for (i = 1; i <= n; ++i)
	{
		scanf("%d %d %d %d\n", &t1[i], &t2[i], &d[i], &c[i]);
		++t1[i];
	}
}

void solve()
{
	int i, j, step = 0;
	
	for (i = 1; i <= n; ++i, step = !step)
	{
		memset(D[step], 0, sizeof(D[step]));
		
		for (j = t1[i]; j <= t2[i] - d[i] + 1; ++j)
		{
			D[step][j][1] = MAX(D[!step][j - 1][0], D[!step][j + d[i]][1]) + c[i];
			D[step][j + d[i] - 1][0] = MAX(D[!step][j + d[i]][1], D[!step][j - 1][0]) + c[i];
		}

		for (j = 1; j <= 2001; ++j)
			D[step][j][0] = MAX(MAX(D[step][j][0], D[step][j - 1][0]), D[!step][2000][0]);
		for (j = 2000; j >= 0; --j)
			D[step][j][1] = MAX(MAX(D[step][j][1], D[step][j + 1][1]), D[!step][1][1]);
	}

	printf("%d\n", MAX(D[!step][2000][0], D[!step][1][1]));
}

int main()
{
	freopen("senzori.in", "r", stdin);
	freopen("senzori.out", "w", stdout);

	citire();
	solve();

	return 0;
}
