#include <cstdio>
#include <algorithm>

#define NX 2048
#define Start first.second
#define Stop first.first
#define D second.first
#define V second.second

using namespace std;

pair< pair< int, int>, pair< int, int > > a[ NX ];
int N, mxT, T[ NX ], c[ NX ];

void cit() {
	int i;
	
	scanf( "%d", &N );
	for( i = 0; i < N; i++ ) {
		scanf( "%d%d%d%d", &a[i].Start, &a[i].Stop, &a[i].D, &a[i].V );
		a[i].Start++;
	}
}

void upd( int x, int y ) {
	for( ; x <= mxT; x += x & -x )
		if( T[x] < y )
			T[x] = y;
}

int que( int x ) {
	int r;
	for( r = T[x]; x > 0; x -= x & -x )
		if( T[x] > r )
			r = T[x];
	return r;
}


void rez() {
	int i, j, x, st;
	
	sort( a, a+N );
	mxT = a[N-1].Stop;

	for( i = 0; i < N; i++ ) {
		st = a[i].Start + a[i].D - 1;
		for( j = a[i].Stop; j >= st; j-- ) {
			x = que( j-a[i].D ) + a[i].V;
			if( c[j] < x ) {
				upd( j, x );
				c[j] = x;
			}
		}
	}
}

void scr() {
	printf( "%d\n", que( mxT ) );
}

int main() {
	freopen( "senzori.in", "r", stdin );
	freopen( "senzori.out", "w", stdout);

	cit();
	rez();
	scr();

	return 0;
}

