#include<stdio.h>
#define Mm (1<<17)
#define md (l+r>>1)
#define ls (n<<1)
#define rs (n<<1|1)
int n,m;
struct node
{
    int v,nr,nrs;
    node *l,*r;
};
typedef node *bst;
bst A[Mm],B[Mm];

void insert(bst &a, int v, int nr)
{
    if(!a)
    {
        a=new node;
        a->v=v;
        a->nr=a->nrs=nr;
        a->l=a->r=NULL;
        return;
    }
    a->nrs+=v;
    if(a->v==v)
    {
        a->nr+=v;
        return;
    }
    if(v<a->v)
        if(!a->l)
        {
            a->l=new node;
            a->l->v=v;
            a->l->nr=a->l->nrs=nr;
            a->l->l=a->l->r=NULL;
        }
        else
            insert(a->l,v,nr);
    else
        if(!a->r)
        {
            a->r=new node;
            a->r->v=v;
            a->r->nr=a->r->nrs=nr;
            a->r->l=a->r->r=NULL;
        }
        else
            insert(a->r,v,nr);
}

int search(bst a, int v)
{
    if(!a) return 0;
    if(a->v==v) return a->nr;
    if(v<a->v) return search(a->l,v);
    return search(a->r,v);
}

int c,t,p,nr;

void update1(int n, int l, int r)
{
    if(p) insert(A[n],t,nr);
    else insert(B[n],t,nr);
    if(l==r) return;
    if(c<=md) update1(ls,l,md);
    else update1(rs,md+1,r);
}

int n1,n2;

void update2(int n, int l, int r)
{
    if(l==r)
    {
        n1=search(A[n],t);
        n2=search(B[n],t);
        insert(A[n],t,n2-n1);
        insert(B[n],t,n1-n2);
        return;
    }
    if(c<=md) update2(ls,l,md);
    else update2(rs,md+1,r);
    insert(A[n],t,n2-n1);
    insert(B[n],t,n1-n2);
}

int a,b,x,v,cnt=0;

int count_bst(bst a)
{
    if(!a) return 0;
    if(v<a->v) return count_bst(a->l);
    return a->nrs-(a->r?a->r->nrs:0)+count_bst(a->r);
}

void count(int n, int l, int r)
{
    if(a<=l && r<=b)
    {
        if(p) cnt+=count_bst(A[n]);
        else cnt+=count_bst(B[n]);
        return;
    }
    if(l<=md) count(ls,l,md);
    if(r>md) count(rs,md+1,r);
}

int query()
{
    int l=1,r=m;

    while(l<r)
    {
        cnt=0; v=md; count(1,1,n);
        if(cnt<x) l=v+1;
        else r=v;
    }
    return l;
}


int main()
{
    int T,d;

    freopen("kinder.in","r",stdin);
    freopen("kinder.out","w",stdout);

    scanf("%d%d%d",&n,&m,&T);
    while(T--)
    {
        scanf("%d",&d);
        if(d==1)
        {
            scanf("%d%d%d%d",&c,&t,&p,&nr);
            update1(1,1,n);
        }
        if(d==2)
        {
            scanf("%d%d",&c,&t);
            update2(1,1,n);
        }
        if(d==3)
        {
            scanf("%d%d%d%d",&a,&b,&p,&x);
            printf("%d\n",query());
        }
    }
    return 0;
}

