using namespace std;
#include<cstdio>
#include<vector>
#define Nm (1<<17)
int V[Nm],A[Nm],B[Nm],C[Nm],D[Nm],Ml[Nm],Mr[Nm],n;
vector<int> G[Nm];

void read()
{
    int i,x,y;

    for(i=1;i<=n;++i)
        G[i].clear();

    scanf("%d",&n);
    for(i=1;i<=n;++i)
        scanf("%d",V+i);
    for(i=1;i<n;++i)
    {
        scanf("%d%d",&x,&y);
        G[x].push_back(y);
        G[y].push_back(x);
    }
}

inline int max(int a, int b) { return a>b?a:b; }

void DFS(int x, int tx)
{
    int i;

    A[x]=B[x]=C[x]=D[x]=0;
    for(i=0;i<G[x].size();++i)
        if(G[x][i]!=tx) DFS(G[x][i],x);

    Ml[0]=0;
    for(i=1;i<G[x].size();++i)
        Ml[i]=max(Ml[i-1],max(A[G[x][i-1]],B[G[x][i-1]]));

    Mr[G[x].size()-1]=0;
    for(i=(int)G[x].size()-2;i>=0;--i)
        Mr[i]=max(Mr[i+1],max(A[G[x][i+1]],B[G[x][i+1]]));

    A[x]=D[x]=max(Mr[0],max(A[G[x][0]],B[G[x][0]]));
    for(i=0;i<G[x].size();++i)
    {
        if(G[x][i]==tx) continue;
        B[x]=max(B[x],B[G[x][i]]);
        C[x]=max(max(C[x],max(A[G[x][i]],B[G[x][i]])+max(Ml[i],Mr[i])),max(C[G[x][i]],D[G[x][i]]));
        D[x]=max(max(D[x],B[G[x][i]]+max(Ml[i],Mr[i])),D[G[x][i]]);
    }
    B[x]+=V[x];
    if(D[x]) D[x]+=V[x];
}

int main()
{
    int t=12;

    freopen("turism.in","r",stdin);
    freopen("turism.out","w",stdout);
    
    while(t--)
    {
        read();
        DFS(1,0);
        printf("%d\n",max(C[1],D[1]));
    }
    return 0;
}

