#include <cstdio>
#include <cstring>

#define N 4096
#define T 2000

int a[N], b[N], c[N];


inline int max(int x, int y) {
if (x>y) return x;
return y; }


void update(int *v, int n, int l, int r, int p, int x) {
if (l==r) {
   v[n]=x;
   return; }

int m=(l+r)/2;
if (p<=m)
   update(v, n*2, l, m, p, x);
else
   update(v, n*2+1, m+1, r, p, x);

v[n]=max(v[2*n], v[2*n+1]); }


int query(int *v, int n, int l, int r, int a, int b) {
if (l==r)
   return v[n];

int m=(l+r)/2, r1=0, r2=0;
if (a<=m)
   r1=query(v, n*2, l, m, a, b);
if (m<b)
   r2=query(v, n*2+1, m+1, r, a, b);

return max(r1, r2); }


int main() {
freopen("senzori.in", "rt", stdin);
freopen("senzori.out", "wt", stdout);


int n;
int at1, at2, ad, av;
int bt1, bt2, bd, bv;
int ct1, ct2, cd, cv;
scanf("%d", &n);

at1=0; at2=T; ad=0; av=0;

scanf("%d%d%d%d", &bt1, &bt2, &bd, &bv);
bt2-=bd;
for (int i=bt1; i<=bt2; i++)
   update(b, 1, 1, N, i, bv);


for (int t=1; t<n; t++) {
   scanf("%d%d%d%d", &ct1, &ct2, &cd, &cv);
   ct2-=cd;

   int m=query(a, 1, at1, at2, at1, at2);
   for (int i=ct1; i<=ct2; i++)
      update(c, 1, 1, N, i, cv + max(m, max(query(b, 1, 1, N, bt1, i-bd), query(b, 1, 1, N, i+cd, bt2))));

   memcpy(a, b, N*sizeof(int));
   memcpy(b, c, N*sizeof(int));
   memset(c, 0, N*sizeof(int));

   at1=bt1; at2=bt2; ad=bd; av=bv;
   bt1=ct1; bt2=ct2; bd=cd; bv=cv; }

printf("%d\n", query(b, 1, bt1, bt2, bt1, bt2));

return 0; }

