#include <stdio.h>
#include <string.h>
#include <vector>

using namespace std;

#define maxim(a, b) ((a > b) ? a : b)

int N, C[100005], uz[100005], up[100005], bst;
int dist_down[100005], down[100005], dist_up[100005];
int max1[100005], max2[100005], max3[100005];
int mx1[100005], mx2[100005];
vector<int> G[100005];

void df(int nod)
{
	int i, sz, x;

	uz[nod] = 1;
	for (sz = G[nod].size(), i = 0; i < sz; ++i)
		if (!uz[x = G[nod][i]])
		{
			up[x] = nod;

			df(x);
			dist_down[nod] = maxim(dist_down[nod], dist_down[x]);
			if (max1[nod] <= dist_down[x])
				max3[nod] = max2[nod], max2[nod] = max1[nod], max1[nod] = dist_down[x];
			else if (max2[nod] <= dist_down[x])
				max3[nod] = max2[nod], max2[nod] = dist_down[x];
			else if (max3[nod] < dist_down[x])
				max3[nod] = dist_down[x];

			down[nod] = maxim(down[nod], down[x]);
			if (mx1[nod] <= down[x])
				mx2[nod] = mx1[nod], mx1[nod] = down[x];
			else if (mx2[nod] < down[x])
				mx2[nod] = down[x];
		}

	dist_down[nod] += C[nod];
	down[nod] = maxim(down[nod], max1[nod]+max2[nod]+C[nod]);
}

void df2(int nod)
{
	int i, sz, x;

	uz[nod] = 1;
	for (sz = G[nod].size(), i = 0; i < sz; ++i)
		if (!uz[x = G[nod][i]])
		{
			dist_up[x] = maxim(dist_up[x], C[x] + dist_up[nod]);
			if (dist_down[x] == max1[nod])
				dist_up[x] = maxim(dist_up[x], C[x] + C[nod] + max2[nod]);
			else
				dist_up[x] = maxim(dist_up[x], C[x] + C[nod] + max1[nod]);
		}

	for (i = 0; i < sz; ++i)
		if (!uz[x = G[nod][i]])
			df2(x);
}

char s[512000];

int main(void)
{
	int T = 12;
	int i, j, k, u, v, father, len;

	freopen("turism.in", "r", stdin);
	freopen("turism.out", "w", stdout);

	for (; T; --T)
	{
		scanf("%d\n", &N);
		
		fgets(s, sizeof(s), stdin);
		for (len = strlen(s), i = 0, j = 1; i < len; ++i)
			if (s[i] >= '0' && s[i] <= '9')
				C[j] = C[j] * 10 + s[i]-'0';
			else if (s[i] == ' ')
				++j;
			else
				break;

		for (i = 1; i < N; ++i)
		{
			fgets(s, 16, stdin);

			u = v = 0;
			for (len = strlen(s), k = 0, j = 0; k < len; ++k)
				if (s[k] >= '0' && s[k] <= '9')
				{
					if (!j) u = u * 10 + s[k]-'0';
					else v = v * 10 + s[k]-'0';
				}
				else if (s[k] == ' ')
					j = 1;
				else
					break;

			G[u].push_back(v);
			G[v].push_back(u);
		}

		df(1);
		memset(uz, 0, sizeof(uz));
		df2(1);

		bst = 0;
		for (i = 1; i <= N; ++i)
		{
			father = up[i];

			bst = maxim(bst, down[i] + dist_up[ father ]);	

			if (!father) continue;

			if (down[i] == mx1[father])
				bst = maxim(bst, down[i] + mx2[father]);
			else
				bst = maxim(bst, down[i] + mx1[father]);

			if (max1[father] == dist_down[i])
				bst = maxim(bst, down[i] + dist_up[father] + max2[father]);
			else
				bst = maxim(bst, down[i] + dist_up[father] + max1[father]);
			
			if (dist_down[i] < max2[father])
				bst = maxim(bst, down[i] + max1[father] + max2[father] + C[father]);
			else if (dist_down[i] == max2[father])
				bst = maxim(bst, down[i] + max1[father] + max3[father] + C[father]);
			else if (dist_down[i] == max1[father])
				bst = maxim(bst, down[i] + max2[father] + max3[father] + C[father]);
		}

		printf("%d\n", bst);
		for (i = 1; i <= N; ++i)
		{
			G[i].clear();
			down[i] = 0;
			max1[i] = max2[i] = max3[i] = 0;
			mx1[i] = mx2[i] = 0;
			dist_down[i] = down[i] = dist_up[i] = 0;
			up[i] = uz[i] = C[i] = 0;
		}
	}

	return 0;
}

