#include <stdio.h>
#include <string.h>
#include <algorithm>

#define start first.second
#define end first.first
#define dist second.first
#define val second.second

using namespace std;


int main()
{
	freopen("senzori.in", "r", stdin);
	freopen("senzori.out", "w", stdout);

	int n, i, v[2048], tmax = 0, j;
	pair<pair<int, int>, pair<int, int> > p[2001];

	scanf("%d", &n);

	for(i = 1; i <= n; ++i)
	{
		scanf("%d %d %d %d", &p[i].start, &p[i].end, &p[i].dist, &p[i].val);
		++p[i].start;
		++p[i].end;
		if(p[i].end > tmax)
		{
			tmax = p[i].end;
		}
	}


	sort(p + 1, p + n + 1);
	
	memset(v, 0, sizeof(v));

	for(i = 1; i <= n; ++i)
	{
//		printf("%d %d %d %d\n", p[i].start, p[i].end, p[i].dist, p[i].val);
		for(j = p[i].end - 1; j - p[i].start + 1 >= p[i].dist; --j)
		{
			//printf("%d %d\n", j - p[i].dist, j);
			if(v[j] < v[j - p[i].dist] + p[i].val)
			{
				v[j] = v[j - p[i].dist] + p[i].val;
			}
		}
		for(j = 1; j <= tmax; ++j)
		{
			if(v[j] < v[j - 1])
			{
				v[j] = v[j - 1];
			}
//			printf("%d ", v[j]);
		}
//		printf("\n");
	}

	int changes = 1;
	while(changes)
	{
		changes = 0;
		for(i = 1; i <= n; ++i)
		{
			for(j = p[i].end - 1; j - p[i].start + 1 >= p[i].dist; --j)
			{
				if(!(j - p[i].dist - p[i].start + 1 >= p[i].dist))
				{
					if(v[j] < v[j - p[i].dist] + p[i].val)
					{
						v[j] = v[j - p[i].dist] + p[i].val;
						changes = 1;
					}
				}
			}
			for(j = 1; j <= tmax; ++j)
			{
				if(v[j] < v[j - 1])
				{
					v[j] = v[j - 1];
				}
			}
		}
	}
				

	printf("%d\n", v[tmax]);
	
	return 0;
}
