#include <stdio.h>
#include <algorithm>

using namespace std;

#define maxn 1000010
#define maxx 2097152
#define maxl 13
#define ll long long

int n, l;
int X, Y, v1, v2;
ll sol;
int a[maxn], p[maxn], w[maxn];
char v[maxl];
int m1[maxx], m2[maxx];

int cmp(int x, int y)
{
	return a[x] < a[y];
}

inline void update(int p, int r, int nod)
{
	if (p == r) m1[nod] = Y;
	else {
		     int q = (p+r)/2;
			 if (X <= q) update(p, q, nod*2);
			 else update(q+1, r, nod*2+1);

			 if (m1[nod*2] > m1[nod*2+1]) 
			 {
				 m1[nod] = m1[nod*2];
				 m2[nod] = m1[nod*2+1];
				 if (m2[nod*2] > m2[nod]) m2[nod] = m2[nod*2];
			 }
			 else {
				 	 m1[nod] = m1[nod*2+1];
					 m2[nod] = m1[nod*2];
					 if (m2[nod*2+1] > m2[nod]) m2[nod] = m2[nod*2+1];
			      }
		 }
}

inline void query(int p, int r, int nod)
{
	if (X<=p && r<=Y)
	{
		if (m1[nod] > v1)
		{
			v2 = v1;
			v1 = m1[nod];
		}
		else if (m1[nod] > v2) v2 = m1[nod];

		if (m2[nod] > v2) v2 = m2[nod];
	}
	else {
			 int q = (p+r)/2;

			 if (X <= q) query(p, q, nod*2);
			 if (Y > q) query(q+1, r, nod*2+1);
		 }
}

int main()
{
	freopen("turnuri.in", "r", stdin);
	freopen("turnuri.out", "w", stdout);

	scanf("%d ", &n);

	int i, j;

	for (i=1; i<=n; i++) 
	{
		fgets(v, maxl, stdin);
		for (j=0; v[j]>='0' && v[j]<='9'; j++) a[i] = a[i] * 10 + v[j] - '0';

		p[i] = i;
	}

	sort(p+1, p+n+1, cmp);

	for (l=1; l<n; l <<= 1);

	for (i=1; i<=n; i++) w[p[i]] = i;

	for (i=1; i<=n; i++) 
	{
		X = w[i];
		Y = n;

		v1 = v2 = 0;
		query(1, l, 1);

		if (v1)
		{
			sol += 1LL * (n-i+v1-1)*(i-v1) + 1LL*(i-v1-1)*(i-v1-1);
			if (!v2) v2++;
			sol += i-v2-1;
		}
		else sol += 1LL * (n-i) * (i-v1-1) + 1LL * (i-v1-1)*(i-v1-2);
		
		X = w[i]; 
		Y = i;
		update(1, l, 1);
	}

	printf("%lld\n", sol);

	return 0;
}
