#include <cstdio>

#define Nmax 1048576

int N,i;
int H[Nmax];
int A[3*Nmax];

int Vi[Nmax],Ve[Nmax];
long long total;

inline int max(int a,int b) { return a>b?a:b; }

void citire()
{
 freopen("turnuri.in","r",stdin);
 scanf("%d",&N);
 for (i=1;i<=N;++i)
    scanf("%d",&H[i]);
}

void update(int nod,int ls,int ld,int who,int v)
{
 int m=(ls+ld) >> 1;

 A[nod] = max( A[nod], v );
 if (ls==ld) return;

 //update pe [1,who]
 if (who<=m) update(nod<<1, ls, m, who, v);
    else update((nod<<1)+1, m+1, ld, who, v);
}

int query(int nod,int ls,int ld,int who,int v)
{
 int m=(ls+ld) >> 1;
 int x=0,y=0;

 if (A[nod] <= v) return 0;
 if (ls==ld)
    {
     if (H[ls] > v) return ls;
      return 0;
    }

 //query pe stanga
 if (who>m)
    {
     x=query((nod<<1)+1, m+1, ld, who, v);
     if ( H[x] > v ) return x;
    }
 //daca in stanga sunt inaltimi prea mici
 //query pe dreapta
 y=query(nod<<1, ls, m, who, v);
 if (H[y] > v) return y;
 return 0;
 
}

void build()
{
 int i;
 
 for (i=1;i <=N; ++i)
    update(1, 1,N, i,H[i]);
}

void solve()
{
 int i;
 int st,st2;

 for (i=2; i<=N; ++i)
    {
     //cauta in stanga
     st = query(1, 1,N, i-1,H[i]);

     if (H[st]<H[i])
        {
         Vi[i] = (i-1);
//         Ve[i]=1;
         continue;
        }
     Vi[i] = (i-st);

     st2 = query(1, 1,N, st-1,H[i]);
     if (H[st2] < H[i])
        {
         Ve[i] = (st-1);
         continue;
        }
     Ve[i] = (st-st2);
    }

 for (i=2; i<=N; ++i)
    {
     //daca elimin din primele
     //fara sa elimin turnul pana in care vede
     total = (long long) total + (long long) (i-Vi[i]-1) * Vi[i];
     //daca elimin turnul pana in care vede
     total = (long long) total + (long long) ((Vi[i]-1) + Ve[i]);
     //daca elimin turnuri peste care vede
     total = (long long) total + (long long) (Vi[i]-1) * (Vi[i]-1);
     //daca elimin turnuri de dupa
     total = (long long) total + (long long) (N-i)* Vi[i];
    }
}

int main()
{
 citire();

 build();

 solve();

 freopen("turnuri.out","w",stdout);
 printf("%lld\n", total);
 fclose(stdout);

 return 0;
}
