#include <cstdio>
#include <vector>

using namespace std;

const int NMAX = 1 << 20;

vector <int> T[NMAX];
vector <int> ST;

int main(void) {
	FILE *fin = fopen("turnuri.in", "rt");
	FILE *fout = fopen("turnuri.out", "wt");
	int N, i, j, v, CNT = 0;
	long long R = 0;

	fscanf(fin, " %d", &N);

	for (i = 0; i < N; ++i) {
		fscanf(fin, " %d", &v);
		
		R += (long long) ST.size() * (N - 1 - ST.size()) + 
		     (long long) ST.size() * (ST.size() - 1) + CNT;
	
		for (j = ST.size() - 1; j >= 0 && ST[j] < v; --j)
			CNT -= T[j].size();
			
		T[j+1] = vector <int> (ST.begin() + j + 1, ST.end());
		CNT += T[j+1].size();
		
		while (!ST.empty() && *ST.rbegin() < v) ST.pop_back();
		ST.push_back(v);

		for (; j >= 0 && !T[j].empty() && *T[j].rbegin() < v; --j)
			while (!T[j].empty() && *T[j].rbegin() < v)
				T[j].pop_back(), --CNT;
	}

	fprintf(fout, "%lld\n", R);

	fclose(fin);
	fclose(fout);

	return 0;
}
