#include <stdio.h>
#include <vector>
using namespace std;

#define NMAX 1000010
#define LL long long

int N;

int a[NMAX];

int st1[NMAX];

int p1[NMAX];
int p2[NMAX];

int tot[NMAX];

vector <int> jeg[NMAX];
vector <int> tata[NMAX];

inline int MAX(int a, int b) { return (a > b) ? a : b; }

int srch(vector <int> &vec, int val)
{
	int na = vec.size(), step, x = -1;

	for (step = 1; step <= na; step <<= 1);

//	for (int i = 0; i < na; i++) printf("%d ", a[vec[i]]);
//	printf("\n");

	for (; step; step >>= 1)
		if (x + step < na && a[vec[x + step]] <= val)
			x += step;

	if (x + 1 < na) return vec[x + 1];

	return 0;
}

/*
#include <algorithm>
#include <bitset>

#define JEG 10000000

bitset <JEG + 2> ap;

int b[NMAX];

int gen(int N)
{
	freopen("turnuri.in", "w", stdout);

	printf("%d\n", N);

	ap = 0;
	int i, q = 0;
	i = 0;
	while (i < N) {
		while (1) {
			q = rand() % JEG + 1;
			if (ap[q] == 1) continue;
			break;
		}

		i++; b[i] = q;
		printf("%d ", q);
		ap[q] = 1;
	}
	printf("\n");

	fclose(stdout);

	return 0;
}

int st[NMAX];

LL numara(int x)
{
	LL rez = 0;
	int i;
	st[0] = 0;
	for (i = 1; i <= N; i++) {
		if (b[i] == -1) continue;

		while (st[0] && b[st[st[0]]] < b[i]) st[0]--;

		rez += i - (st[st[0]] + (st[0] == 0));

		if (st[st[0]] <= x && x <= i) rez--;

		st[++st[0]] = i;
	}

	return rez;
}

LL get_brute()
{
	int i, q;

	LL rez = 0;

	for (i = 1; i <= N; i++) {
		q = b[i];
		b[i] = -1;

		rez += numara(i);

		b[i] = q;
	}

	return rez;
}
*/

int main()
{
//	srand(13);
//	gen(1000);
	
	int i, q;
	
	LL rezt = 0, fin = 0, rez = 0;
	
	freopen("turnuri.in", "r", stdin);
	freopen("turnuri.out", "w", stdout);

	scanf("%d", &N);

	for (i = 1; i <= N; i++) {
		scanf("%d", &a[i]);

		q = a[i];

		while (st1[0] && a[ st1[st1[0]] ] < q) {
			jeg[i].push_back(st1[st1[0]]);
			st1[0]--;
		}

		p1[i] = st1[st1[0]];

		if (!p1[i]) p1[i] = 1;

		tot[ p1[i] ]++;
		tot[ i ]--;

		tata[p1[i]].push_back(i);
		
		p2[i] = srch(jeg[p1[i]], q);
		if (st1[0] > 1) p2[i] = MAX(p2[i], st1[st1[0] - 1]);

		if (!p2[i]) p2[i] = 1;

		st1[++st1[0]] = i;
	}

	for (i = 1; i <= N; i++) {
		tot[i] += tot[i - 1];
		rezt += tot[i];
	}

//	for (i = 1; i <= N; i++) printf("%d ", tot[i]);
//	printf("\n");

	vector <int> :: iterator it;

	for (i = 1; i <= N; i++) {
		// scot i

		rez = rezt - tot[i] - (i - p1[i]);

		for (it = tata[i].begin(); it != tata[i].end(); ++it) {
			rez -= *it - i;
			rez += *it - p2[*it];
		}

		fin += rez;
	}

	printf("%lld\n", fin);

//	printf("%lld\n", get_brute());

return 0;
}

