#include <iostream>
#define FIN "turnuri.in"
#define FOUT "turnuri.out"
#define MAX 1000010
using namespace std;
typedef long long it;
struct turn {
    int h,ind;
} v[MAX];
it aint[MAX*4];
int H[MAX];
int N;
it d[MAX];


void iofile(void){

    freopen(FIN,"rt",stdin);
    freopen(FOUT,"wt",stdout);

    scanf("%d",&N);
    for (int i=1;i<=N;++i){ scanf("%d",&v[i].h);v[i].ind=i;}

    fclose(stdin);

    return ;
}


bool fcmp(const turn &A, const turn &B){

    return (A.h<B.h);
}



void  normalizare(void){

    sort(v+1,v+N+1,fcmp);

    for (int i=1;i<=N;++i){

        H[v[i].ind]=i;
    }

    return ;
}


void insert_aint(int nod,int a,int b,int p,it x){

    aint[nod]=x;
    if (a<b){

        int m=(a+b)/2;
        if (p<=m){ insert_aint(nod*2,a,m,p,x);} else
        {insert_aint(nod*2+1,m+1,b,p,x);}
        aint[nod]=max(aint[nod*2],aint[nod*2+1]);

    }

}


it query_aint(int nod,int a,int b, int p, int u ){

    if (p<=a && b<=u){ return aint[nod];} else {

        int m=(a+b)/2;
        it mx=0,vl;

        if (p<=m){
            vl=query_aint(nod*2,a,m,p,u);
            if (vl>mx){mx=vl;}
        }
        if (m<u){
            vl=query_aint(nod*2+1,m+1,b,p,u);
            if (vl>mx){mx=vl;}
        }

        return mx;
    }
}



void solve(void){

    it cv,d1,d2;
    int i;
    d[1]=0;
    insert_aint(1,1,N,H[1],1);

    for (i=2;i<=N;++i){

        it pmax=query_aint(1,1,N,H[i]+1,N);
        it pmax2;

        if (pmax){ insert_aint(1,1,N,H[pmax],0);
            pmax2=query_aint(1,1,N,H[i]+1,N);
            if (pmax2==0){pmax2=1;}
            insert_aint(1,1,N,H[pmax],pmax);
        } else {
        pmax=pmax2=1;
        }

        cv=i;

        d1=cv-pmax;
        d2=cv-pmax2;

        d[i]=(N-i+pmax-1)*d1+d2-1+(i-pmax-1)*(d1-1);

        insert_aint(1,1,N,H[i],i);

    }

    it sum=0;

    for (i=1;i<=N;++i){ sum+=d[i];}

    printf("%lld\n",sum);

    fclose(stdout);

    return ;
}

int main(void){


    iofile();
    normalizare();
    solve();

    return 0;
}
