#include <stdio.h>
#include <string.h>

#define MAXN 128

int N, x[MAXN][MAXN];
int sol[MAXN];
int st[MAXN];

inline int ask( int x, int y )
{
	printf("ASK %d %d\n", x, y);
	fflush(stdout);

	int val;
	scanf("%d", &val);
	return val;
}

inline int GET( int a, int b )
{
	if (x[a][b] != -1)
		return x[a][b];
	return x[a][b] = ask(a, b);
}

int main()
{
	scanf("%d", &N);
	memset( x, -1, sizeof(x) );
	int MAX0 = -1, MAX0i = -1;
	for (int i = 0; i < N; i++)
	{
		x[0][i] = ask(0, i);
		if (x[0][i] > MAX0)
			MAX0 = x[0][i],
			MAX0i = i;
	}
	st[ st[0] = 1 ] = MAX0i;
	for (int i = MAX0i + 1; i < N; i++)
	{
		for (; st[0] && x[0][ st[ st[0] ] ] < x[0][i]; st[0]--);
		st[ ++st[0] ] = i;
	}
	
	sol[0] = MAX0i;
	for (int i = 1; i < N; i++)
	{
		sol[i] = st[1];
		for (int j = 1; j <= st[0]; j++)
		{
			if (GET( i, st[j] ) > GET( i, sol[i] ))
				sol[i] = st[j];
		}
		
		st[ st[0] = 1 ] = sol[i];
		for (int j = sol[i] + 1; j < N; j++)
		{
			if (x[i][j] == -1)
				continue;
			for (; st[0] && x[i][ st[ st[0] ] ] < x[i][j]; st[0]--);
			st[ ++st[0] ] = j;
		}
	}

	printf("DONE");
	for (int i = 0; i < N; i++)
		printf(" %d", sol[i]);
	printf("\n");
	fflush(stdout);
	
	return 0;
}
