#include <stdio.h>
#include <string.h>
#include <algorithm>

using namespace std;

#define maxim(a, b) ((a > b) ? a : b)
#define NMax 1000005
#define ll long long

int N, v[NMax], A[NMax], f[NMax], st[NMax], ord[NMax], ql;
char uz[NMax];
ll cnt;

int cmp(const int& a, const int& b)
{ return v[a] < v[b]; }

inline void update(int x)
{
	int p = x;

	for (; x <= N; x += x^(x-1)&x)
		A[x] = maxim(A[x], p);
}

inline int query(int x)
{	
	for (; x; x -= x^(x-1)&x)
		if (A[x])
			return A[x];
	return 0;
}

char s[16];

int main(void)
{
	int i, j, x, el;
	
	freopen("turnuri.in", "r", stdin);
	freopen("turnuri.out", "w", stdout);

	scanf("%d\n", &N);
	for (i = 1; i <= N; ++i)
	{
		fgets(s, sizeof(s), stdin);
		el = 0;
		for (x = strlen(s), j = 0; j < x; ++j)
			if (s[j] >= '0' && s[j] <= '9')
				el = el * 10 + s[j]-'0';
			else
				break;
		v[i] = el;
	}
	
	for (i = 1; i <= N; ++i)
		f[i] = -1;

	for (i = 1; i <= N; ++i)
	{
		while (ql > 0 && v[st[ql]] < v[i])
			--ql;
		f[i] = st[ql];
		if (!f[i]) uz[i] = 1, f[i] = 1, cnt += (ll)(i-1)*(i-2);
		else cnt += (ll)(i-f[i]-1)*(i-f[i]-1);
		st[++ql] = i;	
	}

	for (i = 1; i <= N; ++i)
		cnt += (ll)(f[i]-1+N-i)*(i-f[i]);

	for (i = 1; i <= N; ++i)
		ord[i] = i;
	sort(ord+1, ord+N+1, cmp);
	
	for (i = N; i; --i)
	{
		x = ord[i];
		update(x);
		if (uz[x]) continue;
		
		j = query(f[x]-1);
		if (!j) j = 1;
		cnt += x-j-1;
	}
	
	printf("%lld\n", cnt);

	return 0;
}

