//astronomy, eu

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

#define MAXN 2010
#define SQRT 45

int N, M, Nrbuc, B[MAXN], A[MAXN][SQRT+6], Cap[MAXN], start[SQRT+6];
char S[MAXN], Snou[MAXN];
long long res;
inline int mod(int x) { return x >= N ? x-N : x; }

int query(int x, int y, int len)
{
    int k = 0, r = 0;
    while(k < len)
    {
        while(!Cap[x] && !Cap[y] && k < len)
	    r += S[x] != S[y], k++, x = mod(x+1), y = mod(y+1);
	if(Cap[x])
	{
	    while(k+SQRT-1 < len && Cap[x])
	        r += A[y][ B[x] ], x = mod(x+SQRT), y = mod(y+SQRT), k+=SQRT;
	}
	if(Cap[y])
	{
	    while(k+SQRT-1 < len && Cap[y])
		r += A[x][ B[y] ], x = mod(x+SQRT), y = mod(y+SQRT), k+=SQRT;
	}
	if(k < len)
	    r += S[x] != S[y], k++, x = mod(x+1), y = mod(y+1);
    }
    return r;
}																				    
void update(int x, char c)
{
    int i, j, k, p;
    Snou[x] = c;
    if(B[x])
    {
	j = x-start[B[x]];
	for(i = 0; i < N; i++)
	    A[i][B[x]] = A[i][B[x]]-(S[mod(i+j)] != S[x])
	    +(Snou[mod(i+j)] != Snou[x]);
    }
    for(i = mod(x-SQRT+1+N), p = SQRT-1; p >= 0; i = mod(i+1), p--)
     for(j = 1; j <= Nrbuc; j++)
	A[i][j] = A[i][j]-(S[mod(start[j]+p)] != S[mod(i+p)])+
		(Snou[mod(start[j]+p)] != Snou[mod(i+p)]);
    S[x] = c;
}
void preproc(void)
{
    int i, j, k, cnt;
    for(i = 0; i < N; i += SQRT)
    {
        if(i+SQRT-1 >= N) break ;
        for(++Nrbuc, start[Nrbuc] = i, Cap[i] = 1, j = i; j < i+SQRT; j++)
	    B[j] = Nrbuc;
    }
    for(i = 0; i < N; i++)
     for(j = 1; j <= Nrbuc; j++)
      for(k = 0; k < SQRT; k++)
	A[i][j] += S[mod(i+k)] != S[mod(start[j]+k)];
}

int X[5010], Y[5010], NRX, NRY, P, Q, L, A0, A1, A2, R;
int main(void)
{
    freopen("afaceri.in", "rt", stdin);
    freopen("afaceri.out", "wt", stdout);
																																							
    int i, j, k, t, x, VAL, aux; char c;
    scanf("%d %d %d %d %d %d %d %d", &N, &M, &Q, &L, &A0, &A1, &A2, &R);
    scanf("%d ", &NRX);
    for(i = 0; i < NRX; i++) scanf("%d ", &X[i]), assert(1 <= X[i] &&
    X[i] <= R);
    scanf("%d ", &NRY);
    for(i = 0; i < NRY; i++) scanf("%d ", &Y[i]), assert(1 <= Y[i] && Y[i] 
    <= R);
    scanf("%s\n", &S), N = strlen(S);
    memcpy(Snou, S, sizeof(S));
    preproc();
    assert(1 <= N && 1 <= L && L < N && N <= 2000);
    assert(1 <= M && M <= 2000000);
    assert(1 <= M/Q <= 20001);
    assert(1 <= A0 && A0 <= 1000000 && 1 <= A1 && A1 <= 1000000 &&
	1 <= A2 && A2 <= 1000000 && 1 <= R && R <= 1000000);
    assert(1 <= NRX && NRX <= 5000);
    assert(1 <= NRY && NRY <= 5000);
    /*while(M--)
    {																																													    scanf("%d ", &t);
        if(t == 0) // update
	    scanf("%d %c\n", &j, &c), update(j, c);
	else
	    scanf("%d %d %d\n", &i, &j, &k), printf("%d\n", query(i, j, k));
    }*/
    for(i = 1; i <= M; i++)
    {
	if(i % Q == 0)
	    x = A1%N, c = 'a'+(A2%26), update(x, c);
	else
	    res = res + (aux=query(A0%N, A1%N, L+A2%(N-L+1)));
	VAL = ((long long)A2*X[i%NRX]+Y[i%NRY])%R, A0 = A1, A1 = A2;
	A2 = VAL;
    }						
    printf("%lld\n", res);																																											
    fprintf(stderr, "%lld\n", res);																																											
    return 0;
}
