//Adi Vladu
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <algorithm>

#define pb push_back
#define mp make_pair

#define ABS(x) ((x) >= 0 ? (x) : -(x))
#define EPS 1E-7

using namespace std;
int N;
double D;
vector<pair<int, double> > p;
vector<double> evt;


#define NMAX 505
double a[NMAX];
int minbombs = NMAX;
double mint;

void read(void)
{
    freopen("bombe.in", "r", stdin);
	scanf("%d %lf", &N, &D);
D*=2;
	int x;
	double v;
	for (int i = 0; i < N; i++)
	{
		scanf("%d %lf", &x, &v);
		p.pb(mp(x, v));
	}
 // 	sort(p.begin(), p.end());
}

int inter(double a1, double b1, double c1, double a2, double b2, double c2, double &rx, double &ry)
{
	double r = b1*a2-b2*a1;
	if (ABS(r) < EPS) return 0;

	ry = (a1*c2-a2*c1) / r;
	rx = (b1*c2-b2*c1) / (-r);
	return 1;
}

inline void coef(int x, double &a, double &b, double &c)
{
	a = 1;
	b = -p[x].second;
	c = -p[x].first;
}

void events(void)
{
	double a1, b1, c1, a2, b2, c2, rx, ry;
	for (int i = 0; i < N; i++)
		for (int j = i+1; j < N; j++)
		{
			coef(i, a1, b1, c1);
			coef(j, a2, b2, c2);

			if (inter(a1, b1, c1, a2, b2, c2-a2*D, rx, ry))
			{
				if (0.268866 <= ry && ry <= 0.268868)
					printf("### %d %d\n", i, j);
				if (ry >= .0)
					evt.pb(ry);
			}

			if (inter(a1, b1, c1, a2, b2, c2+a2*D, rx, ry))
			{
				if (0.268866 <= ry && ry <= 0.268868)
					printf("### %d %d\n", i, j);

				if (ry >= .0)
					evt.pb(ry);
			}
		}
	evt.pb(0);
	sort(evt.begin(), evt.end());
}

void solve(void)
{

//	int cnt = 0;

	for (vector<double> :: iterator it = evt.begin(); it != evt.end(); it++)
	{
			//let's see how many bombs we need
            for (int i = 0; i < N; i++)
                a[i] = p[i].first + p[i].second * *it;
            sort(a, a+N);

			/*
			if ((++ cnt) % N == 0)
			{
				for (int i = 0; i < N; i++)
					printf("%0.3lf ", a[i]);
				printf("\n");
			}
			*/

			int nbombs = 1;
			double last = a[0];
			double cx;

			for (int i = 1; i < N; i++)
			{
				if (a[i] - last > D + EPS)
					last = a[i], ++nbombs;
			}
			//printf("fnd %d bombs\n", nbombs);

			if (nbombs < minbombs)
				minbombs = nbombs, mint = *it;
	}
}

int main(void)
{

//	freopen("bombe.out", "w", stdout);

	read();
	events();
	solve();


//	for (vector<double> :: iterator it = evt.begin(); it != evt.end(); it++)
//		printf("evt %0.3lf\n", *it);

//	printf("\n sol = %d %0.9lf\n", minbombs, mint);

    freopen("bombe.out", "w", stdout);
	printf("%d %0.3lf\n", minbombs, mint);
/*
    for (int i = 0; i < N; i++)
        a[i] = p[i].first + p[i].second * 19850.199;
    sort(a, a+N);

    int nr = 1;
    double l = a[0];
    for (int i = 1; i < N; i++)
        if (a[i] - l > D + EPS)
            l = a[i], ++nr;
    printf(">>%d\n", nr);
*/       
    
	return 0;
}
